// tcl wrapper for vtkChartBox object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkChartBox.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkChartBoxNewCommand()
{
  vtkChartBox *temp = vtkChartBox::New();
  return static_cast<ClientData>(temp);
}

int vtkChartCppCommand(vtkChart *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkChartBoxCppCommand(vtkChartBox *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkChartBoxCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkChartBoxCppCommand(static_cast<vtkChartBox *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkChartBox_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkChartBox"),vtkChartBoxNewCommand,vtkChartBoxCommand);
  return 0;
}

int VTKTCL_EXPORT vtkChartBoxCppCommand(vtkChartBox *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkChartBox",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkChartCppCommand(static_cast<vtkChart *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkChart"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkChartBox  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkChartBox");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkChartBox  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkChartBox");
    return TCL_OK;
    }
    }
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkChartBox  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkChartBox");
    return TCL_OK;
    }
  if ((!strcmp("Update",argv[1]))&&(argc == 2))
    {
    op->Update();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("Paint",argv[1]))&&(argc == 3))
    {
    vtkContext2D  *temp0;
    bool   temp20;
    error = 0;

    temp0 = (vtkContext2D *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkContext2D"),interp,error));
    if (!error)
    {
    temp20 = (op)->Paint(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetColumnVisibility",argv[1]))&&(argc == 4))
    {
    vtkIdType   temp0;
    bool   temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi ? true : false;
    if (!error)
    {
    op->SetColumnVisibility(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetColumnVisibilityAll",argv[1]))&&(argc == 3))
    {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
    {
    op->SetColumnVisibilityAll(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetColumnVisibility",argv[1]))&&(argc == 3))
    {
    vtkIdType   temp0;
    bool   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    temp20 = (op)->GetColumnVisibility(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetVisibleColumns",argv[1]))&&(argc == 2))
    {
    vtkStringArray  *temp20;
    temp20 = (op)->GetVisibleColumns();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkStringArray");
    return TCL_OK;
    }
  if ((!strcmp("GetSelectedColumn",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetSelectedColumn();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetSelectedColumn",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->SetSelectedColumn(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetPlot",argv[1]))&&(argc == 3))
    {
    vtkIdType   temp0;
    vtkPlot  *temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    temp20 = (op)->GetPlot(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPlot");
    return TCL_OK;
    }
    }
  if ((!strcmp("GetNumberOfPlots",argv[1]))&&(argc == 2))
    {
    vtkIdType   temp20;
    temp20 = (op)->GetNumberOfPlots();
    char tempResult[1024];
    sprintf(tempResult,"%lli",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetYAxis",argv[1]))&&(argc == 2))
    {
    vtkAxis  *temp20;
    temp20 = (op)->GetYAxis();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAxis");
    return TCL_OK;
    }
  if ((!strcmp("GetXPosition",argv[1]))&&(argc == 3))
    {
    int      temp0;
    float    temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    temp20 = (op)->GetXPosition(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetNumberOfVisibleColumns",argv[1]))&&(argc == 2))
    {
    vtkIdType   temp20;
    temp20 = (op)->GetNumberOfVisibleColumns();
    char tempResult[1024];
    sprintf(tempResult,"%lli",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetPlot",argv[1]))&&(argc == 3))
    {
    vtkPlotBox  *temp0;
    error = 0;

    temp0 = (vtkPlotBox *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkPlotBox"),interp,error));
    if (!error)
    {
    op->SetPlot(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetTooltip",argv[1]))&&(argc == 3))
    {
    vtkTooltipItem  *temp0;
    error = 0;

    temp0 = (vtkTooltipItem *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTooltipItem"),interp,error));
    if (!error)
    {
    op->SetTooltip(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetTooltip",argv[1]))&&(argc == 2))
    {
    vtkTooltipItem  *temp20;
    temp20 = (op)->GetTooltip();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTooltipItem");
    return TCL_OK;
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkChartBoxCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkChartCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkChartBox:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  Update\n",NULL);
    Tcl_AppendResult(interp,"  Paint\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetColumnVisibility\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  SetColumnVisibilityAll\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetColumnVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetVisibleColumns\n",NULL);
    Tcl_AppendResult(interp,"  GetSelectedColumn\n",NULL);
    Tcl_AppendResult(interp,"  SetSelectedColumn\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPlot\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfPlots\n",NULL);
    Tcl_AppendResult(interp,"  GetYAxis\n",NULL);
    Tcl_AppendResult(interp,"  GetXPosition\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfVisibleColumns\n",NULL);
    Tcl_AppendResult(interp,"  SetPlot\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetTooltip\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTooltip\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkChartCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "Update" );
    Tcl_DStringAppendElement ( &dString, "Paint" );
    Tcl_DStringAppendElement ( &dString, "SetColumnVisibility" );
    Tcl_DStringAppendElement ( &dString, "SetColumnVisibilityAll" );
    Tcl_DStringAppendElement ( &dString, "GetColumnVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetVisibleColumns" );
    Tcl_DStringAppendElement ( &dString, "GetSelectedColumn" );
    Tcl_DStringAppendElement ( &dString, "SetSelectedColumn" );
    Tcl_DStringAppendElement ( &dString, "GetPlot" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPlots" );
    Tcl_DStringAppendElement ( &dString, "GetYAxis" );
    Tcl_DStringAppendElement ( &dString, "GetXPosition" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfVisibleColumns" );
    Tcl_DStringAppendElement ( &dString, "SetPlot" );
    Tcl_DStringAppendElement ( &dString, "SetTooltip" );
    Tcl_DStringAppendElement ( &dString, "GetTooltip" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkChartCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Creates a parallel coordinates chart\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkChartBox *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: Update */
    if ( strcmp ( argv[2], "Update" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Update" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Update */
    Tcl_DStringAppendElement ( &dString, " Perform any updates to the item that may be necessary before rendering.\n The scene should take care of calling this on all items before their\n Paint function is invoked.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void Update();" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for Update */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: Paint */
    if ( strcmp ( argv[2], "Paint" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Paint" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkContext2D" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Paint */
    Tcl_DStringAppendElement ( &dString, " Paint event for the chart, called whenever the chart needs to be drawn\n" );
    Tcl_DStringAppendElement ( &dString, "virtual bool Paint(vtkContext2D *painter);" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for Paint */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetColumnVisibility */
    if ( strcmp ( argv[2], "SetColumnVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetColumnVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetColumnVisibility */
    Tcl_DStringAppendElement ( &dString, " Set the visibility of the specified column.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetColumnVisibility(vtkIdType column, bool visible);" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for SetColumnVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetColumnVisibilityAll */
    if ( strcmp ( argv[2], "SetColumnVisibilityAll" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetColumnVisibilityAll" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetColumnVisibilityAll */
    Tcl_DStringAppendElement ( &dString, " Set the visibility of all columns (true will make them all visible, false\n will remove all visible columns).\n" );
    Tcl_DStringAppendElement ( &dString, "void SetColumnVisibilityAll(bool visible);" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for SetColumnVisibilityAll */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetColumnVisibility */
    if ( strcmp ( argv[2], "GetColumnVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetColumnVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetColumnVisibility */
    Tcl_DStringAppendElement ( &dString, " Get the visibility of the specified column.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetColumnVisibility(vtkIdType column);" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for GetColumnVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetVisibleColumns */
    if ( strcmp ( argv[2], "GetVisibleColumns" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetVisibleColumns" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetVisibleColumns */
    Tcl_DStringAppendElement ( &dString, " Get a list of the columns, and the order in which they are displayed.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkStringArray *GetVisibleColumns();" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for GetVisibleColumns */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetSelectedColumn */
    if ( strcmp ( argv[2], "GetSelectedColumn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSelectedColumn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSelectedColumn */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int GetSelectedColumn();" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for GetSelectedColumn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetSelectedColumn */
    if ( strcmp ( argv[2], "SetSelectedColumn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSelectedColumn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSelectedColumn */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetSelectedColumn(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for SetSelectedColumn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetPlot */
    if ( strcmp ( argv[2], "GetPlot" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPlot" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPlot */
    Tcl_DStringAppendElement ( &dString, " Get the plot at the specified index, returns null if the index is invalid.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkPlot *GetPlot(vtkIdType index);" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for GetPlot */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetNumberOfPlots */
    if ( strcmp ( argv[2], "GetNumberOfPlots" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPlots" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfPlots */
    Tcl_DStringAppendElement ( &dString, " Get the number of plots the chart contains.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkIdType GetNumberOfPlots();" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for GetNumberOfPlots */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetYAxis */
    if ( strcmp ( argv[2], "GetYAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetYAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetYAxis */
    Tcl_DStringAppendElement ( &dString, " Get the chart Y axis\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkAxis *GetYAxis();" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for GetYAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetXPosition */
    if ( strcmp ( argv[2], "GetXPosition" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetXPosition" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetXPosition */
    Tcl_DStringAppendElement ( &dString, " Get the column X position by index in the visible set.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual float GetXPosition(int index);" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for GetXPosition */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetNumberOfVisibleColumns */
    if ( strcmp ( argv[2], "GetNumberOfVisibleColumns" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfVisibleColumns" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfVisibleColumns */
    Tcl_DStringAppendElement ( &dString, " Get the number of visible box plots in the current chart.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkIdType GetNumberOfVisibleColumns();" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for GetNumberOfVisibleColumns */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetPlot */
    if ( strcmp ( argv[2], "SetPlot" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPlot" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkPlotBox" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPlot */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetPlot(vtkPlotBox *plot);" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for SetPlot */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetTooltip */
    if ( strcmp ( argv[2], "SetTooltip" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTooltip" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTooltipItem" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTooltip */
    Tcl_DStringAppendElement ( &dString, " Set the vtkTooltipItem object that will be displayed by the chart.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetTooltip(vtkTooltipItem *tooltip);" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for SetTooltip */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetTooltip */
    if ( strcmp ( argv[2], "GetTooltip" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTooltip" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTooltip */
    Tcl_DStringAppendElement ( &dString, " Get the vtkTooltipItem object that will be displayed by the chart.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkTooltipItem *GetTooltip();" );
    Tcl_DStringAppendElement ( &dString, "vtkChartBox" );
    /* Closing for GetTooltip */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkChartCppCommand(static_cast<vtkChart *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
