#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkCardinalSpline_TclCreate(Tcl_Interp *interp);
int vtkKochanekSpline_TclCreate(Tcl_Interp *interp);
int vtkParametricBoy_TclCreate(Tcl_Interp *interp);
int vtkParametricConicSpiral_TclCreate(Tcl_Interp *interp);
int vtkParametricCrossCap_TclCreate(Tcl_Interp *interp);
int vtkParametricDini_TclCreate(Tcl_Interp *interp);
int vtkParametricEllipsoid_TclCreate(Tcl_Interp *interp);
int vtkParametricEnneper_TclCreate(Tcl_Interp *interp);
int vtkParametricFigure8Klein_TclCreate(Tcl_Interp *interp);
int vtkParametricFunction_TclCreate(Tcl_Interp *interp);
int vtkParametricKlein_TclCreate(Tcl_Interp *interp);
int vtkParametricMobius_TclCreate(Tcl_Interp *interp);
int vtkParametricRandomHills_TclCreate(Tcl_Interp *interp);
int vtkParametricRoman_TclCreate(Tcl_Interp *interp);
int vtkParametricSpline_TclCreate(Tcl_Interp *interp);
int vtkParametricSuperEllipsoid_TclCreate(Tcl_Interp *interp);
int vtkParametricSuperToroid_TclCreate(Tcl_Interp *interp);
int vtkParametricTorus_TclCreate(Tcl_Interp *interp);
int vtkParametricKuen_TclCreate(Tcl_Interp *interp);
int vtkParametricPseudosphere_TclCreate(Tcl_Interp *interp);
int vtkParametricBohemianDome_TclCreate(Tcl_Interp *interp);
int vtkParametricHenneberg_TclCreate(Tcl_Interp *interp);
int vtkParametricCatalanMinimal_TclCreate(Tcl_Interp *interp);
int vtkParametricBour_TclCreate(Tcl_Interp *interp);
int vtkParametricPluckerConoid_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkcommoncomputationalgeometrytcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkcommoncomputationalgeometrytcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkcommoncomputationalgeometrytcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkcommoncomputationalgeometrytcl_Init(interp);
}


int VTK_EXPORT Vtkcommoncomputationalgeometrytcl_Init(Tcl_Interp *interp)
{

  vtkCardinalSpline_TclCreate(interp);
  vtkKochanekSpline_TclCreate(interp);
  vtkParametricBoy_TclCreate(interp);
  vtkParametricConicSpiral_TclCreate(interp);
  vtkParametricCrossCap_TclCreate(interp);
  vtkParametricDini_TclCreate(interp);
  vtkParametricEllipsoid_TclCreate(interp);
  vtkParametricEnneper_TclCreate(interp);
  vtkParametricFigure8Klein_TclCreate(interp);
  vtkParametricFunction_TclCreate(interp);
  vtkParametricKlein_TclCreate(interp);
  vtkParametricMobius_TclCreate(interp);
  vtkParametricRandomHills_TclCreate(interp);
  vtkParametricRoman_TclCreate(interp);
  vtkParametricSpline_TclCreate(interp);
  vtkParametricSuperEllipsoid_TclCreate(interp);
  vtkParametricSuperToroid_TclCreate(interp);
  vtkParametricTorus_TclCreate(interp);
  vtkParametricKuen_TclCreate(interp);
  vtkParametricPseudosphere_TclCreate(interp);
  vtkParametricBohemianDome_TclCreate(interp);
  vtkParametricHenneberg_TclCreate(interp);
  vtkParametricCatalanMinimal_TclCreate(interp);
  vtkParametricBour_TclCreate(interp);
  vtkParametricPluckerConoid_TclCreate(interp);
  char pkgName[]="vtkCommonComputationalGeometryTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
