// tcl wrapper for vtkAMRInformation object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkAMRInformation.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkAMRInformationNewCommand()
{
  vtkAMRInformation *temp = vtkAMRInformation::New();
  return static_cast<ClientData>(temp);
}

int vtkObjectCppCommand(vtkObject *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkAMRInformationCppCommand(vtkAMRInformation *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkAMRInformationCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkAMRInformationCppCommand(static_cast<vtkAMRInformation *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkAMRInformation_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkAMRInformation"),vtkAMRInformationNewCommand,vtkAMRInformationCommand);
  return 0;
}

int VTKTCL_EXPORT vtkAMRInformationCppCommand(vtkAMRInformation *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkAMRInformation",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkObject"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkAMRInformation  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAMRInformation");
    return TCL_OK;
    }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkAMRInformation  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAMRInformation");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkAMRInformation  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAMRInformation");
    return TCL_OK;
    }
    }
  if ((!strcmp("GetGridDescription",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetGridDescription();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetGridDescription",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->SetGridDescription(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetOrigin",argv[1]))&&(argc == 5))
    {
    double temp0[3];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
    {
    op->GetOrigin(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetNumberOfLevels",argv[1]))&&(argc == 2))
    {
    unsigned int      temp20;
    temp20 = (op)->GetNumberOfLevels();
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetNumberOfDataSets",argv[1]))&&(argc == 3))
    {
    unsigned int      temp0;
    unsigned int      temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    temp20 = (op)->GetNumberOfDataSets(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetTotalNumberOfBlocks",argv[1]))&&(argc == 2))
    {
    unsigned int      temp20;
    temp20 = (op)->GetTotalNumberOfBlocks();
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetIndex",argv[1]))&&(argc == 4))
    {
    unsigned int      temp0;
    unsigned int      temp1;
    int      temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    temp20 = (op)->GetIndex(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("HasSpacing",argv[1]))&&(argc == 3))
    {
    unsigned int      temp0;
    bool   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    temp20 = (op)->HasSpacing(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetAMRBlockSourceIndex",argv[1]))&&(argc == 3))
    {
    int      temp0;
    int      temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    temp20 = (op)->GetAMRBlockSourceIndex(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetAMRBlockSourceIndex",argv[1]))&&(argc == 4))
    {
    int      temp0;
    int      temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (!error)
    {
    op->SetAMRBlockSourceIndex(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GenerateRefinementRatio",argv[1]))&&(argc == 2))
    {
    op->GenerateRefinementRatio();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("HasRefinementRatio",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->HasRefinementRatio();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetRefinementRatio",argv[1]))&&(argc == 4))
    {
    unsigned int      temp0;
    int      temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (!error)
    {
    op->SetRefinementRatio(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetRefinementRatio",argv[1]))&&(argc == 3))
    {
    unsigned int      temp0;
    int      temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    temp20 = (op)->GetRefinementRatio(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("HasChildrenInformation",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->HasChildrenInformation();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("PrintParentChildInfo",argv[1]))&&(argc == 4))
    {
    unsigned int      temp0;
    unsigned int      temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    op->PrintParentChildInfo(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GenerateParentChildInformation",argv[1]))&&(argc == 2))
    {
    op->GenerateParentChildInformation();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("Audit",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->Audit();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("DeepCopy",argv[1]))&&(argc == 3))
    {
    vtkAMRInformation  *temp0;
    error = 0;

    temp0 = (vtkAMRInformation *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAMRInformation"),interp,error));
    if (!error)
    {
    op->DeepCopy(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkAMRInformationCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkAMRInformation:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetGridDescription\n",NULL);
    Tcl_AppendResult(interp,"  SetGridDescription\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetOrigin\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfLevels\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfDataSets\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTotalNumberOfBlocks\n",NULL);
    Tcl_AppendResult(interp,"  GetIndex\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  HasSpacing\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAMRBlockSourceIndex\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetAMRBlockSourceIndex\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GenerateRefinementRatio\n",NULL);
    Tcl_AppendResult(interp,"  HasRefinementRatio\n",NULL);
    Tcl_AppendResult(interp,"  SetRefinementRatio\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetRefinementRatio\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  HasChildrenInformation\n",NULL);
    Tcl_AppendResult(interp,"  PrintParentChildInfo\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GenerateParentChildInformation\n",NULL);
    Tcl_AppendResult(interp,"  Audit\n",NULL);
    Tcl_AppendResult(interp,"  DeepCopy\t with 1 arg\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "GetGridDescription" );
    Tcl_DStringAppendElement ( &dString, "SetGridDescription" );
    Tcl_DStringAppendElement ( &dString, "GetOrigin" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfLevels" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfDataSets" );
    Tcl_DStringAppendElement ( &dString, "GetTotalNumberOfBlocks" );
    Tcl_DStringAppendElement ( &dString, "GetIndex" );
    Tcl_DStringAppendElement ( &dString, "HasSpacing" );
    Tcl_DStringAppendElement ( &dString, "GetAMRBlockSourceIndex" );
    Tcl_DStringAppendElement ( &dString, "SetAMRBlockSourceIndex" );
    Tcl_DStringAppendElement ( &dString, "GenerateRefinementRatio" );
    Tcl_DStringAppendElement ( &dString, "HasRefinementRatio" );
    Tcl_DStringAppendElement ( &dString, "SetRefinementRatio" );
    Tcl_DStringAppendElement ( &dString, "GetRefinementRatio" );
    Tcl_DStringAppendElement ( &dString, "HasChildrenInformation" );
    Tcl_DStringAppendElement ( &dString, "PrintParentChildInfo" );
    Tcl_DStringAppendElement ( &dString, "GenerateParentChildInformation" );
    Tcl_DStringAppendElement ( &dString, "Audit" );
    Tcl_DStringAppendElement ( &dString, "DeepCopy" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkObjectCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkAMRInformation *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetGridDescription */
    if ( strcmp ( argv[2], "GetGridDescription" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetGridDescription" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetGridDescription */
    Tcl_DStringAppendElement ( &dString, " returns the value of vtkUniformGrid::GridDescription() of any block\n" );
    Tcl_DStringAppendElement ( &dString, "int GetGridDescription();" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for GetGridDescription */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetGridDescription */
    if ( strcmp ( argv[2], "SetGridDescription" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetGridDescription" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetGridDescription */
    Tcl_DStringAppendElement ( &dString, " returns the value of vtkUniformGrid::GridDescription() of any block\n" );
    Tcl_DStringAppendElement ( &dString, "void SetGridDescription(int description);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for SetGridDescription */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetOrigin */
    if ( strcmp ( argv[2], "GetOrigin" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOrigin" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOrigin */
    Tcl_DStringAppendElement ( &dString, " Get the AMR dataset origin\n The origin is essentially the minimum of all the grids.\n" );
    Tcl_DStringAppendElement ( &dString, "void GetOrigin(double origin\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for GetOrigin */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetNumberOfLevels */
    if ( strcmp ( argv[2], "GetNumberOfLevels" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfLevels" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfLevels */
    Tcl_DStringAppendElement ( &dString, " Return the number of levels\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetNumberOfLevels() const;" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for GetNumberOfLevels */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetNumberOfDataSets */
    if ( strcmp ( argv[2], "GetNumberOfDataSets" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfDataSets" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfDataSets */
    Tcl_DStringAppendElement ( &dString, " Returns the number of datasets at the given levelx\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetNumberOfDataSets(unsigned int level) const;" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for GetNumberOfDataSets */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetTotalNumberOfBlocks */
    if ( strcmp ( argv[2], "GetTotalNumberOfBlocks" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTotalNumberOfBlocks" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTotalNumberOfBlocks */
    Tcl_DStringAppendElement ( &dString, " Returns total number of datasets\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetTotalNumberOfBlocks();" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for GetTotalNumberOfBlocks */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetIndex */
    if ( strcmp ( argv[2], "GetIndex" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetIndex" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetIndex */
    Tcl_DStringAppendElement ( &dString, " Returns the single index from a pair of indices\n" );
    Tcl_DStringAppendElement ( &dString, "int GetIndex(unsigned int level, unsigned int id) const;" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for GetIndex */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: HasSpacing */
    if ( strcmp ( argv[2], "HasSpacing" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HasSpacing" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HasSpacing */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "bool HasSpacing(unsigned int level);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for HasSpacing */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetAMRBlockSourceIndex */
    if ( strcmp ( argv[2], "GetAMRBlockSourceIndex" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAMRBlockSourceIndex" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAMRBlockSourceIndex */
    Tcl_DStringAppendElement ( &dString, " Get/Set the SourceIndex of a block. Typically, this is a file-type specific index\n that can be used by a reader to load a particular file block\n" );
    Tcl_DStringAppendElement ( &dString, "int GetAMRBlockSourceIndex(int index);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for GetAMRBlockSourceIndex */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetAMRBlockSourceIndex */
    if ( strcmp ( argv[2], "SetAMRBlockSourceIndex" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAMRBlockSourceIndex" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAMRBlockSourceIndex */
    Tcl_DStringAppendElement ( &dString, " Get/Set the SourceIndex of a block. Typically, this is a file-type specific index\n that can be used by a reader to load a particular file block\n" );
    Tcl_DStringAppendElement ( &dString, "void SetAMRBlockSourceIndex(int index, int sourceId);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for SetAMRBlockSourceIndex */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GenerateRefinementRatio */
    if ( strcmp ( argv[2], "GenerateRefinementRatio" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GenerateRefinementRatio" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GenerateRefinementRatio */
    Tcl_DStringAppendElement ( &dString, " This method computes the refinement ratio at each level.\n At each level, l, the refinement ratio r_l is computed by\n r_l = D_{l} / D_{l+1}, where D_{l+1} and D_{l} are the grid\n spacings at the next and current level respectively.\n\n .SECTION Assumptions\n 1) Within each level, the refinement ratios are the same for all blocks.\n 2) The refinement ratio is uniform along each dimension of the block.\n" );
    Tcl_DStringAppendElement ( &dString, "void GenerateRefinementRatio();" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for GenerateRefinementRatio */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: HasRefinementRatio */
    if ( strcmp ( argv[2], "HasRefinementRatio" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HasRefinementRatio" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HasRefinementRatio */
    Tcl_DStringAppendElement ( &dString, " Returns Wether refinement ratio has been set (either by calling\n GenerateRefinementRatio() or by calling SetRefinementRatio()\n" );
    Tcl_DStringAppendElement ( &dString, "bool HasRefinementRatio();" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for HasRefinementRatio */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetRefinementRatio */
    if ( strcmp ( argv[2], "SetRefinementRatio" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRefinementRatio" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRefinementRatio */
    Tcl_DStringAppendElement ( &dString, " Set the refinement ratio at a level. This method should be\n called for all levels, if called at all.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRefinementRatio(unsigned int level, int ratio);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for SetRefinementRatio */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetRefinementRatio */
    if ( strcmp ( argv[2], "GetRefinementRatio" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRefinementRatio" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRefinementRatio */
    Tcl_DStringAppendElement ( &dString, " Returns the refinement of a given level.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetRefinementRatio(unsigned int level) const;" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for GetRefinementRatio */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: HasChildrenInformation */
    if ( strcmp ( argv[2], "HasChildrenInformation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HasChildrenInformation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HasChildrenInformation */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "bool HasChildrenInformation();" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for HasChildrenInformation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: PrintParentChildInfo */
    if ( strcmp ( argv[2], "PrintParentChildInfo" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PrintParentChildInfo" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PrintParentChildInfo */
    Tcl_DStringAppendElement ( &dString, " Prints the parents and children of a requested block (Debug Routine)\n" );
    Tcl_DStringAppendElement ( &dString, "void PrintParentChildInfo(unsigned int level, unsigned int index);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for PrintParentChildInfo */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GenerateParentChildInformation */
    if ( strcmp ( argv[2], "GenerateParentChildInformation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GenerateParentChildInformation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GenerateParentChildInformation */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void GenerateParentChildInformation();" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for GenerateParentChildInformation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: Audit */
    if ( strcmp ( argv[2], "Audit" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Audit" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Audit */
    Tcl_DStringAppendElement ( &dString, " Checks whether the meta data is internally consistent.\n" );
    Tcl_DStringAppendElement ( &dString, "bool Audit();" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for Audit */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: DeepCopy */
    if ( strcmp ( argv[2], "DeepCopy" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DeepCopy" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DeepCopy */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void DeepCopy(vtkAMRInformation *other);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRInformation" );
    /* Closing for DeepCopy */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
