#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkAlgorithmOutput_TclCreate(Tcl_Interp *interp);
int vtkAnnotationLayersAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkArrayDataAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkCachedStreamingDemandDrivenPipeline_TclCreate(Tcl_Interp *interp);
int vtkCastToConcrete_TclCreate(Tcl_Interp *interp);
int vtkCompositeDataPipeline_TclCreate(Tcl_Interp *interp);
int vtkCompositeDataSetAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkDataObjectAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkDataSetAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkDemandDrivenPipeline_TclCreate(Tcl_Interp *interp);
int vtkDirectedGraphAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkEnsembleSource_TclCreate(Tcl_Interp *interp);
int vtkExecutive_TclCreate(Tcl_Interp *interp);
int vtkExtentSplitter_TclCreate(Tcl_Interp *interp);
int vtkExtentTranslator_TclCreate(Tcl_Interp *interp);
int vtkGraphAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkHierarchicalBoxDataSetAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkHyperOctreeAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkHyperTreeGridAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkImageAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkImageInPlaceFilter_TclCreate(Tcl_Interp *interp);
int vtkImageToStructuredGrid_TclCreate(Tcl_Interp *interp);
int vtkImageToStructuredPoints_TclCreate(Tcl_Interp *interp);
int vtkInformationDataObjectMetaDataKey_TclCreate(Tcl_Interp *interp);
int vtkInformationExecutivePortKey_TclCreate(Tcl_Interp *interp);
int vtkInformationExecutivePortVectorKey_TclCreate(Tcl_Interp *interp);
int vtkInformationIntegerRequestKey_TclCreate(Tcl_Interp *interp);
int vtkMultiBlockDataSetAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkMultiTimeStepAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkPassInputTypeAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkPiecewiseFunctionAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkPiecewiseFunctionShiftScale_TclCreate(Tcl_Interp *interp);
int vtkPointSetAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkPolyDataAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkRectilinearGridAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkScalarTree_TclCreate(Tcl_Interp *interp);
int vtkSimpleImageToImageFilter_TclCreate(Tcl_Interp *interp);
int vtkSimpleScalarTree_TclCreate(Tcl_Interp *interp);
int vtkSpanSpace_TclCreate(Tcl_Interp *interp);
int vtkStreamingDemandDrivenPipeline_TclCreate(Tcl_Interp *interp);
int vtkStructuredGridAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkTableAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkThreadedCompositeDataPipeline_TclCreate(Tcl_Interp *interp);
int vtkThreadedImageAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkTreeAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkTrivialProducer_TclCreate(Tcl_Interp *interp);
int vtkUndirectedGraphAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridBaseAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkProgressObserver_TclCreate(Tcl_Interp *interp);
int vtkSelectionAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkExtentRCBPartitioner_TclCreate(Tcl_Interp *interp);
int vtkUniformGridPartitioner_TclCreate(Tcl_Interp *interp);
int vtkUniformGridAMRAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkOverlappingAMRAlgorithm_TclCreate(Tcl_Interp *interp);
int vtkNonOverlappingAMRAlgorithm_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkcommonexecutionmodeltcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkcommonexecutionmodeltcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkcommonexecutionmodeltcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkcommonexecutionmodeltcl_Init(interp);
}


int VTK_EXPORT Vtkcommonexecutionmodeltcl_Init(Tcl_Interp *interp)
{

  vtkAlgorithm_TclCreate(interp);
  vtkAlgorithmOutput_TclCreate(interp);
  vtkAnnotationLayersAlgorithm_TclCreate(interp);
  vtkArrayDataAlgorithm_TclCreate(interp);
  vtkCachedStreamingDemandDrivenPipeline_TclCreate(interp);
  vtkCastToConcrete_TclCreate(interp);
  vtkCompositeDataPipeline_TclCreate(interp);
  vtkCompositeDataSetAlgorithm_TclCreate(interp);
  vtkDataObjectAlgorithm_TclCreate(interp);
  vtkDataSetAlgorithm_TclCreate(interp);
  vtkDemandDrivenPipeline_TclCreate(interp);
  vtkDirectedGraphAlgorithm_TclCreate(interp);
  vtkEnsembleSource_TclCreate(interp);
  vtkExecutive_TclCreate(interp);
  vtkExtentSplitter_TclCreate(interp);
  vtkExtentTranslator_TclCreate(interp);
  vtkGraphAlgorithm_TclCreate(interp);
  vtkHierarchicalBoxDataSetAlgorithm_TclCreate(interp);
  vtkHyperOctreeAlgorithm_TclCreate(interp);
  vtkHyperTreeGridAlgorithm_TclCreate(interp);
  vtkImageAlgorithm_TclCreate(interp);
  vtkImageInPlaceFilter_TclCreate(interp);
  vtkImageToStructuredGrid_TclCreate(interp);
  vtkImageToStructuredPoints_TclCreate(interp);
  vtkInformationDataObjectMetaDataKey_TclCreate(interp);
  vtkInformationExecutivePortKey_TclCreate(interp);
  vtkInformationExecutivePortVectorKey_TclCreate(interp);
  vtkInformationIntegerRequestKey_TclCreate(interp);
  vtkMultiBlockDataSetAlgorithm_TclCreate(interp);
  vtkMultiTimeStepAlgorithm_TclCreate(interp);
  vtkPassInputTypeAlgorithm_TclCreate(interp);
  vtkPiecewiseFunctionAlgorithm_TclCreate(interp);
  vtkPiecewiseFunctionShiftScale_TclCreate(interp);
  vtkPointSetAlgorithm_TclCreate(interp);
  vtkPolyDataAlgorithm_TclCreate(interp);
  vtkRectilinearGridAlgorithm_TclCreate(interp);
  vtkScalarTree_TclCreate(interp);
  vtkSimpleImageToImageFilter_TclCreate(interp);
  vtkSimpleScalarTree_TclCreate(interp);
  vtkSpanSpace_TclCreate(interp);
  vtkStreamingDemandDrivenPipeline_TclCreate(interp);
  vtkStructuredGridAlgorithm_TclCreate(interp);
  vtkTableAlgorithm_TclCreate(interp);
  vtkThreadedCompositeDataPipeline_TclCreate(interp);
  vtkThreadedImageAlgorithm_TclCreate(interp);
  vtkTreeAlgorithm_TclCreate(interp);
  vtkTrivialProducer_TclCreate(interp);
  vtkUndirectedGraphAlgorithm_TclCreate(interp);
  vtkUnstructuredGridAlgorithm_TclCreate(interp);
  vtkUnstructuredGridBaseAlgorithm_TclCreate(interp);
  vtkProgressObserver_TclCreate(interp);
  vtkSelectionAlgorithm_TclCreate(interp);
  vtkExtentRCBPartitioner_TclCreate(interp);
  vtkUniformGridPartitioner_TclCreate(interp);
  vtkUniformGridAMRAlgorithm_TclCreate(interp);
  vtkOverlappingAMRAlgorithm_TclCreate(interp);
  vtkNonOverlappingAMRAlgorithm_TclCreate(interp);
  char pkgName[]="vtkCommonExecutionModelTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
