#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkClientSocket_TclCreate(Tcl_Interp *interp);
int vtkDirectory_TclCreate(Tcl_Interp *interp);
int vtkServerSocket_TclCreate(Tcl_Interp *interp);
int vtkSocket_TclCreate(Tcl_Interp *interp);
int vtkSocketCollection_TclCreate(Tcl_Interp *interp);
int vtkThreadMessager_TclCreate(Tcl_Interp *interp);
int vtkTimerLog_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkcommonsystemtcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkcommonsystemtcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkcommonsystemtcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkcommonsystemtcl_Init(interp);
}


int VTK_EXPORT Vtkcommonsystemtcl_Init(Tcl_Interp *interp)
{

  vtkClientSocket_TclCreate(interp);
  vtkDirectory_TclCreate(interp);
  vtkServerSocket_TclCreate(interp);
  vtkSocket_TclCreate(interp);
  vtkSocketCollection_TclCreate(interp);
  vtkThreadMessager_TclCreate(interp);
  vtkTimerLog_TclCreate(interp);
  char pkgName[]="vtkCommonSystemTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
