// tcl wrapper for vtkProbeFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkProbeFilter.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkProbeFilterNewCommand()
{
  vtkProbeFilter *temp = vtkProbeFilter::New();
  return static_cast<ClientData>(temp);
}

int vtkDataSetAlgorithmCppCommand(vtkDataSetAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkProbeFilterCppCommand(vtkProbeFilter *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkProbeFilterCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkProbeFilterCppCommand(static_cast<vtkProbeFilter *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkProbeFilter_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkProbeFilter"),vtkProbeFilterNewCommand,vtkProbeFilterCommand);
  return 0;
}

int VTKTCL_EXPORT vtkProbeFilterCppCommand(vtkProbeFilter *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkProbeFilter",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkDataSetAlgorithmCppCommand(static_cast<vtkDataSetAlgorithm *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkDataSetAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkProbeFilter  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProbeFilter");
    return TCL_OK;
    }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkProbeFilter  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProbeFilter");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkProbeFilter  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProbeFilter");
    return TCL_OK;
    }
    }
  if ((!strcmp("SetSourceData",argv[1]))&&(argc == 3))
    {
    vtkDataObject  *temp0;
    error = 0;

    temp0 = (vtkDataObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataObject"),interp,error));
    if (!error)
    {
    op->SetSourceData(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetSource",argv[1]))&&(argc == 2))
    {
    vtkDataObject  *temp20;
    temp20 = (op)->GetSource();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDataObject");
    return TCL_OK;
    }
  if ((!strcmp("SetSourceConnection",argv[1]))&&(argc == 3))
    {
    vtkAlgorithmOutput  *temp0;
    error = 0;

    temp0 = (vtkAlgorithmOutput *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAlgorithmOutput"),interp,error));
    if (!error)
    {
    op->SetSourceConnection(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetSpatialMatch",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->SetSpatialMatch(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetSpatialMatch",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetSpatialMatch();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SpatialMatchOn",argv[1]))&&(argc == 2))
    {
    op->SpatialMatchOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("SpatialMatchOff",argv[1]))&&(argc == 2))
    {
    op->SpatialMatchOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("GetValidPoints",argv[1]))&&(argc == 2))
    {
    vtkIdTypeArray  *temp20;
    temp20 = (op)->GetValidPoints();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkIdTypeArray");
    return TCL_OK;
    }
  if ((!strcmp("SetValidPointMaskArrayName",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    op->SetValidPointMaskArrayName(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetValidPointMaskArrayName",argv[1]))&&(argc == 2))
    {
    char    *temp20;
    temp20 = (op)->GetValidPointMaskArrayName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("SetPassCellArrays",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->SetPassCellArrays(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("PassCellArraysOn",argv[1]))&&(argc == 2))
    {
    op->PassCellArraysOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("PassCellArraysOff",argv[1]))&&(argc == 2))
    {
    op->PassCellArraysOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("GetPassCellArrays",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetPassCellArrays();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetPassPointArrays",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->SetPassPointArrays(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("PassPointArraysOn",argv[1]))&&(argc == 2))
    {
    op->PassPointArraysOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("PassPointArraysOff",argv[1]))&&(argc == 2))
    {
    op->PassPointArraysOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("GetPassPointArrays",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetPassPointArrays();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetPassFieldArrays",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->SetPassFieldArrays(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("PassFieldArraysOn",argv[1]))&&(argc == 2))
    {
    op->PassFieldArraysOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("PassFieldArraysOff",argv[1]))&&(argc == 2))
    {
    op->PassFieldArraysOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("GetPassFieldArrays",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetPassFieldArrays();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetTolerance",argv[1]))&&(argc == 3))
    {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
    {
    op->SetTolerance(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetTolerance",argv[1]))&&(argc == 2))
    {
    double   temp20;
    temp20 = (op)->GetTolerance();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetComputeTolerance",argv[1]))&&(argc == 3))
    {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
    {
    op->SetComputeTolerance(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("ComputeToleranceOn",argv[1]))&&(argc == 2))
    {
    op->ComputeToleranceOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("ComputeToleranceOff",argv[1]))&&(argc == 2))
    {
    op->ComputeToleranceOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("GetComputeTolerance",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->GetComputeTolerance();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkProbeFilterCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkDataSetAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkProbeFilter:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetSourceData\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSource\n",NULL);
    Tcl_AppendResult(interp,"  SetSourceConnection\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetSpatialMatch\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSpatialMatch\n",NULL);
    Tcl_AppendResult(interp,"  SpatialMatchOn\n",NULL);
    Tcl_AppendResult(interp,"  SpatialMatchOff\n",NULL);
    Tcl_AppendResult(interp,"  GetValidPoints\n",NULL);
    Tcl_AppendResult(interp,"  SetValidPointMaskArrayName\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetValidPointMaskArrayName\n",NULL);
    Tcl_AppendResult(interp,"  SetPassCellArrays\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  PassCellArraysOn\n",NULL);
    Tcl_AppendResult(interp,"  PassCellArraysOff\n",NULL);
    Tcl_AppendResult(interp,"  GetPassCellArrays\n",NULL);
    Tcl_AppendResult(interp,"  SetPassPointArrays\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  PassPointArraysOn\n",NULL);
    Tcl_AppendResult(interp,"  PassPointArraysOff\n",NULL);
    Tcl_AppendResult(interp,"  GetPassPointArrays\n",NULL);
    Tcl_AppendResult(interp,"  SetPassFieldArrays\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  PassFieldArraysOn\n",NULL);
    Tcl_AppendResult(interp,"  PassFieldArraysOff\n",NULL);
    Tcl_AppendResult(interp,"  GetPassFieldArrays\n",NULL);
    Tcl_AppendResult(interp,"  SetTolerance\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTolerance\n",NULL);
    Tcl_AppendResult(interp,"  SetComputeTolerance\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  ComputeToleranceOn\n",NULL);
    Tcl_AppendResult(interp,"  ComputeToleranceOff\n",NULL);
    Tcl_AppendResult(interp,"  GetComputeTolerance\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkDataSetAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetSourceData" );
    Tcl_DStringAppendElement ( &dString, "GetSource" );
    Tcl_DStringAppendElement ( &dString, "SetSourceConnection" );
    Tcl_DStringAppendElement ( &dString, "SetSpatialMatch" );
    Tcl_DStringAppendElement ( &dString, "GetSpatialMatch" );
    Tcl_DStringAppendElement ( &dString, "SpatialMatchOn" );
    Tcl_DStringAppendElement ( &dString, "SpatialMatchOff" );
    Tcl_DStringAppendElement ( &dString, "GetValidPoints" );
    Tcl_DStringAppendElement ( &dString, "SetValidPointMaskArrayName" );
    Tcl_DStringAppendElement ( &dString, "GetValidPointMaskArrayName" );
    Tcl_DStringAppendElement ( &dString, "SetPassCellArrays" );
    Tcl_DStringAppendElement ( &dString, "PassCellArraysOn" );
    Tcl_DStringAppendElement ( &dString, "PassCellArraysOff" );
    Tcl_DStringAppendElement ( &dString, "GetPassCellArrays" );
    Tcl_DStringAppendElement ( &dString, "SetPassPointArrays" );
    Tcl_DStringAppendElement ( &dString, "PassPointArraysOn" );
    Tcl_DStringAppendElement ( &dString, "PassPointArraysOff" );
    Tcl_DStringAppendElement ( &dString, "GetPassPointArrays" );
    Tcl_DStringAppendElement ( &dString, "SetPassFieldArrays" );
    Tcl_DStringAppendElement ( &dString, "PassFieldArraysOn" );
    Tcl_DStringAppendElement ( &dString, "PassFieldArraysOff" );
    Tcl_DStringAppendElement ( &dString, "GetPassFieldArrays" );
    Tcl_DStringAppendElement ( &dString, "SetTolerance" );
    Tcl_DStringAppendElement ( &dString, "GetTolerance" );
    Tcl_DStringAppendElement ( &dString, "SetComputeTolerance" );
    Tcl_DStringAppendElement ( &dString, "ComputeToleranceOn" );
    Tcl_DStringAppendElement ( &dString, "ComputeToleranceOff" );
    Tcl_DStringAppendElement ( &dString, "GetComputeTolerance" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkDataSetAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkProbeFilter *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetSourceData */
    if ( strcmp ( argv[2], "SetSourceData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSourceData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSourceData */
    Tcl_DStringAppendElement ( &dString, " Specify the data set that will be probed at the input points.\n The Input gives the geometry (the points and cells) for the output,\n while the Source is probed (interpolated) to generate the scalars,\n vectors, etc. for the output points based on the point locations.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSourceData(vtkDataObject *source);" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for SetSourceData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetSource */
    if ( strcmp ( argv[2], "GetSource" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSource" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSource */
    Tcl_DStringAppendElement ( &dString, " Specify the data set that will be probed at the input points.\n The Input gives the geometry (the points and cells) for the output,\n while the Source is probed (interpolated) to generate the scalars,\n vectors, etc. for the output points based on the point locations.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDataObject *GetSource();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for GetSource */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetSourceConnection */
    if ( strcmp ( argv[2], "SetSourceConnection" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSourceConnection" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAlgorithmOutput" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSourceConnection */
    Tcl_DStringAppendElement ( &dString, " Specify the data set that will be probed at the input points.\n The Input gives the geometry (the points and cells) for the output,\n while the Source is probed (interpolated) to generate the scalars,\n vectors, etc. for the output points based on the point locations.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSourceConnection(vtkAlgorithmOutput *algOutput);" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for SetSourceConnection */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetSpatialMatch */
    if ( strcmp ( argv[2], "SetSpatialMatch" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSpatialMatch" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSpatialMatch */
    Tcl_DStringAppendElement ( &dString, " This flag is used only when a piece is requested to update.  By default\n the flag is off.  Because no spatial correspondence between input pieces\n and source pieces is known, all of the source has to be requested no\n matter what piece of the output is requested.  When there is a spatial\n correspondence, the user/application can set this flag.  This hint allows\n the breakup of the probe operation to be much more efficient.  When piece\n m of n is requested for update by ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSpatialMatch(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for SetSpatialMatch */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetSpatialMatch */
    if ( strcmp ( argv[2], "GetSpatialMatch" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSpatialMatch" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSpatialMatch */
    Tcl_DStringAppendElement ( &dString, " This flag is used only when a piece is requested to update.  By default\n the flag is off.  Because no spatial correspondence between input pieces\n and source pieces is known, all of the source has to be requested no\n matter what piece of the output is requested.  When there is a spatial\n correspondence, the user/application can set this flag.  This hint allows\n the breakup of the probe operation to be much more efficient.  When piece\n m of n is requested for update by ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "int GetSpatialMatch();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for GetSpatialMatch */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SpatialMatchOn */
    if ( strcmp ( argv[2], "SpatialMatchOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SpatialMatchOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SpatialMatchOn */
    Tcl_DStringAppendElement ( &dString, " This flag is used only when a piece is requested to update.  By default\n the flag is off.  Because no spatial correspondence between input pieces\n and source pieces is known, all of the source has to be requested no\n matter what piece of the output is requested.  When there is a spatial\n correspondence, the user/application can set this flag.  This hint allows\n the breakup of the probe operation to be much more efficient.  When piece\n m of n is requested for update by ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SpatialMatchOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for SpatialMatchOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SpatialMatchOff */
    if ( strcmp ( argv[2], "SpatialMatchOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SpatialMatchOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SpatialMatchOff */
    Tcl_DStringAppendElement ( &dString, " This flag is used only when a piece is requested to update.  By default\n the flag is off.  Because no spatial correspondence between input pieces\n and source pieces is known, all of the source has to be requested no\n matter what piece of the output is requested.  When there is a spatial\n correspondence, the user/application can set this flag.  This hint allows\n the breakup of the probe operation to be much more efficient.  When piece\n m of n is requested for update by ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SpatialMatchOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for SpatialMatchOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetValidPoints */
    if ( strcmp ( argv[2], "GetValidPoints" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetValidPoints" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetValidPoints */
    Tcl_DStringAppendElement ( &dString, " Get the list of point ids in the output that contain attribute data\n interpolated from the source.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdTypeArray *GetValidPoints();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for GetValidPoints */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetValidPointMaskArrayName */
    if ( strcmp ( argv[2], "SetValidPointMaskArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetValidPointMaskArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetValidPointMaskArrayName */
    Tcl_DStringAppendElement ( &dString, " Returns the name of the char array added to the output with values 1 for\n valid points and 0 for invalid points.\n Set to \"vtkValidPointMask\" by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetValidPointMaskArrayName(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for SetValidPointMaskArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetValidPointMaskArrayName */
    if ( strcmp ( argv[2], "GetValidPointMaskArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetValidPointMaskArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetValidPointMaskArrayName */
    Tcl_DStringAppendElement ( &dString, " Returns the name of the char array added to the output with values 1 for\n valid points and 0 for invalid points.\n Set to \"vtkValidPointMask\" by default.\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetValidPointMaskArrayName();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for GetValidPointMaskArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetPassCellArrays */
    if ( strcmp ( argv[2], "SetPassCellArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPassCellArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPassCellArrays */
    Tcl_DStringAppendElement ( &dString, " Shallow copy the input cell data arrays to the output.\n Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPassCellArrays(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for SetPassCellArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: PassCellArraysOn */
    if ( strcmp ( argv[2], "PassCellArraysOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PassCellArraysOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PassCellArraysOn */
    Tcl_DStringAppendElement ( &dString, " Shallow copy the input cell data arrays to the output.\n Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void PassCellArraysOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for PassCellArraysOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: PassCellArraysOff */
    if ( strcmp ( argv[2], "PassCellArraysOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PassCellArraysOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PassCellArraysOff */
    Tcl_DStringAppendElement ( &dString, " Shallow copy the input cell data arrays to the output.\n Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void PassCellArraysOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for PassCellArraysOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetPassCellArrays */
    if ( strcmp ( argv[2], "GetPassCellArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPassCellArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPassCellArrays */
    Tcl_DStringAppendElement ( &dString, " Shallow copy the input cell data arrays to the output.\n Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetPassCellArrays();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for GetPassCellArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetPassPointArrays */
    if ( strcmp ( argv[2], "SetPassPointArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPassPointArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPassPointArrays */
    Tcl_DStringAppendElement ( &dString, " Shallow copy the input point data arrays to the output\n Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPassPointArrays(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for SetPassPointArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: PassPointArraysOn */
    if ( strcmp ( argv[2], "PassPointArraysOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PassPointArraysOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PassPointArraysOn */
    Tcl_DStringAppendElement ( &dString, " Shallow copy the input point data arrays to the output\n Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void PassPointArraysOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for PassPointArraysOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: PassPointArraysOff */
    if ( strcmp ( argv[2], "PassPointArraysOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PassPointArraysOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PassPointArraysOff */
    Tcl_DStringAppendElement ( &dString, " Shallow copy the input point data arrays to the output\n Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void PassPointArraysOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for PassPointArraysOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetPassPointArrays */
    if ( strcmp ( argv[2], "GetPassPointArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPassPointArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPassPointArrays */
    Tcl_DStringAppendElement ( &dString, " Shallow copy the input point data arrays to the output\n Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetPassPointArrays();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for GetPassPointArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetPassFieldArrays */
    if ( strcmp ( argv[2], "SetPassFieldArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPassFieldArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPassFieldArrays */
    Tcl_DStringAppendElement ( &dString, " Set whether to pass the field-data arrays from the Input i.e. the input\n providing the geometry to the output. On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPassFieldArrays(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for SetPassFieldArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: PassFieldArraysOn */
    if ( strcmp ( argv[2], "PassFieldArraysOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PassFieldArraysOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PassFieldArraysOn */
    Tcl_DStringAppendElement ( &dString, " Set whether to pass the field-data arrays from the Input i.e. the input\n providing the geometry to the output. On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void PassFieldArraysOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for PassFieldArraysOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: PassFieldArraysOff */
    if ( strcmp ( argv[2], "PassFieldArraysOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PassFieldArraysOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PassFieldArraysOff */
    Tcl_DStringAppendElement ( &dString, " Set whether to pass the field-data arrays from the Input i.e. the input\n providing the geometry to the output. On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void PassFieldArraysOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for PassFieldArraysOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetPassFieldArrays */
    if ( strcmp ( argv[2], "GetPassFieldArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPassFieldArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPassFieldArrays */
    Tcl_DStringAppendElement ( &dString, " Set whether to pass the field-data arrays from the Input i.e. the input\n providing the geometry to the output. On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetPassFieldArrays();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for GetPassFieldArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetTolerance */
    if ( strcmp ( argv[2], "SetTolerance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTolerance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTolerance */
    Tcl_DStringAppendElement ( &dString, " Set the tolerance used to compute whether a point in the\n source is in a cell of the input.  This value is only used\n if ComputeTolerance is off.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTolerance(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for SetTolerance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetTolerance */
    if ( strcmp ( argv[2], "GetTolerance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTolerance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTolerance */
    Tcl_DStringAppendElement ( &dString, " Set the tolerance used to compute whether a point in the\n source is in a cell of the input.  This value is only used\n if ComputeTolerance is off.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetTolerance();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for GetTolerance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetComputeTolerance */
    if ( strcmp ( argv[2], "SetComputeTolerance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetComputeTolerance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetComputeTolerance */
    Tcl_DStringAppendElement ( &dString, " Set whether to use the Tolerance field or precompute the tolerance.\n When on, the tolerance will be computed and the field\n value is ignored. Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetComputeTolerance(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for SetComputeTolerance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: ComputeToleranceOn */
    if ( strcmp ( argv[2], "ComputeToleranceOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ComputeToleranceOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ComputeToleranceOn */
    Tcl_DStringAppendElement ( &dString, " Set whether to use the Tolerance field or precompute the tolerance.\n When on, the tolerance will be computed and the field\n value is ignored. Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void ComputeToleranceOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for ComputeToleranceOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: ComputeToleranceOff */
    if ( strcmp ( argv[2], "ComputeToleranceOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ComputeToleranceOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ComputeToleranceOff */
    Tcl_DStringAppendElement ( &dString, " Set whether to use the Tolerance field or precompute the tolerance.\n When on, the tolerance will be computed and the field\n value is ignored. Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void ComputeToleranceOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for ComputeToleranceOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetComputeTolerance */
    if ( strcmp ( argv[2], "GetComputeTolerance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetComputeTolerance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetComputeTolerance */
    Tcl_DStringAppendElement ( &dString, " Set whether to use the Tolerance field or precompute the tolerance.\n When on, the tolerance will be computed and the field\n value is ignored. Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetComputeTolerance();" );
    Tcl_DStringAppendElement ( &dString, "vtkProbeFilter" );
    /* Closing for GetComputeTolerance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkDataSetAlgorithmCppCommand(static_cast<vtkDataSetAlgorithm *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
