// java wrapper for vtkContourTriangulator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkContourTriangulator.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPolyDataAlgorithm_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkContourTriangulator_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkContourTriangulator",dType)) { return me; }
  if ((res= vtkPolyDataAlgorithm_Typecast(me,dType)) != NULL) { return res; }
  return NULL;
}


extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkContourTriangulator_GetClassName_10(JNIEnv *env, jobject obj)
{
  vtkContourTriangulator *op;
  const char    *temp20;

  op = (vtkContourTriangulator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetClassName();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkContourTriangulator_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkContourTriangulator *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkContourTriangulator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkContourTriangulator_GetTriangulationError_12(JNIEnv *env, jobject obj)
{
  vtkContourTriangulator *op;
  int      temp20;

  op = (vtkContourTriangulator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetTriangulationError();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkContourTriangulator_SetTriangulationErrorDisplay_13(JNIEnv *env, jobject obj,jint id0)
{
  vtkContourTriangulator *op;
  int      temp0;
  temp0 = id0;

  op = (vtkContourTriangulator *)vtkJavaGetPointerFromObject(env,obj);
  op->SetTriangulationErrorDisplay(temp0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkContourTriangulator_TriangulationErrorDisplayOn_14(JNIEnv *env, jobject obj)
{
  vtkContourTriangulator *op;

  op = (vtkContourTriangulator *)vtkJavaGetPointerFromObject(env,obj);
  op->TriangulationErrorDisplayOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkContourTriangulator_TriangulationErrorDisplayOff_15(JNIEnv *env, jobject obj)
{
  vtkContourTriangulator *op;

  op = (vtkContourTriangulator *)vtkJavaGetPointerFromObject(env,obj);
  op->TriangulationErrorDisplayOff();
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkContourTriangulator_GetTriangulationErrorDisplay_16(JNIEnv *env, jobject obj)
{
  vtkContourTriangulator *op;
  int      temp20;

  op = (vtkContourTriangulator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetTriangulationErrorDisplay();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkContourTriangulator_TriangulatePolygon_17(JNIEnv *env, jobject obj,jobject id0,jobject id1,jobject id2)
{
  vtkContourTriangulator *op;
  vtkIdList  *temp0;
  vtkPoints  *temp1;
  vtkCellArray  *temp2;
  int      temp20;
  temp0 = (vtkIdList *)(vtkJavaGetPointerFromObject(env,id0));
  temp1 = (vtkPoints *)(vtkJavaGetPointerFromObject(env,id1));
  temp2 = (vtkCellArray *)(vtkJavaGetPointerFromObject(env,id2));

  op = (vtkContourTriangulator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->TriangulatePolygon(temp0,temp1,temp2);
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkContourTriangulator_TriangulateContours_18(JNIEnv *env, jobject obj,jobject id0,jint id1,jint id2,jobject id3,jdoubleArray id4)
{
  vtkContourTriangulator *op;
  vtkPolyData  *temp0;
  vtkIdType   temp1;
  vtkIdType   temp2;
  vtkCellArray  *temp3;
  double temp4[3];
  void *tempArray4;
  int      temp20;
  temp0 = (vtkPolyData *)(vtkJavaGetPointerFromObject(env,id0));
  temp1 = id1;
  temp2 = id2;
  temp3 = (vtkCellArray *)(vtkJavaGetPointerFromObject(env,id3));
  tempArray4 = (void *)(env->GetDoubleArrayElements(id4,NULL));
  temp4[0] = ((jdouble *)tempArray4)[0];
  temp4[1] = ((jdouble *)tempArray4)[1];
  temp4[2] = ((jdouble *)tempArray4)[2];

  op = (vtkContourTriangulator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->TriangulateContours(temp0,temp1,temp2,temp3,temp4);
  ((jdouble *)tempArray4)[0] = temp4[0];
  ((jdouble *)tempArray4)[1] = temp4[1];
  ((jdouble *)tempArray4)[2] = temp4[2];
  env->ReleaseDoubleArrayElements(id4,(jdouble *)tempArray4,0);
  return temp20;
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkContourTriangulator_VTKInit(JNIEnv *, jobject)
{
  vtkContourTriangulator *aNewOne = vtkContourTriangulator::New();
  return (jlong)(size_t)(void*)aNewOne;
}
