// tcl wrapper for vtkPUnstructuredGridGhostCellsGenerator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPUnstructuredGridGhostCellsGenerator.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkPUnstructuredGridGhostCellsGeneratorNewCommand()
{
  vtkPUnstructuredGridGhostCellsGenerator *temp = vtkPUnstructuredGridGhostCellsGenerator::New();
  return static_cast<ClientData>(temp);
}

int vtkUnstructuredGridAlgorithmCppCommand(vtkUnstructuredGridAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkPUnstructuredGridGhostCellsGeneratorCppCommand(vtkPUnstructuredGridGhostCellsGenerator *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkPUnstructuredGridGhostCellsGeneratorCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkPUnstructuredGridGhostCellsGeneratorCppCommand(static_cast<vtkPUnstructuredGridGhostCellsGenerator *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkPUnstructuredGridGhostCellsGenerator_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkPUnstructuredGridGhostCellsGenerator"),vtkPUnstructuredGridGhostCellsGeneratorNewCommand,vtkPUnstructuredGridGhostCellsGeneratorCommand);
  return 0;
}

int VTKTCL_EXPORT vtkPUnstructuredGridGhostCellsGeneratorCppCommand(vtkPUnstructuredGridGhostCellsGenerator *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkPUnstructuredGridGhostCellsGenerator",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkUnstructuredGridAlgorithmCppCommand(static_cast<vtkUnstructuredGridAlgorithm *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkUnstructuredGridAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkPUnstructuredGridGhostCellsGenerator  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPUnstructuredGridGhostCellsGenerator");
    return TCL_OK;
    }
  if ((!strcmp("SetController",argv[1]))&&(argc == 3))
    {
    vtkMultiProcessController  *temp0;
    error = 0;

    temp0 = (vtkMultiProcessController *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkMultiProcessController"),interp,error));
    if (!error)
    {
    op->SetController(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetController",argv[1]))&&(argc == 2))
    {
    vtkMultiProcessController  *temp20;
    temp20 = (op)->GetController();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMultiProcessController");
    return TCL_OK;
    }
  if ((!strcmp("SetUseGlobalPointIds",argv[1]))&&(argc == 3))
    {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
    {
    op->SetUseGlobalPointIds(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetUseGlobalPointIds",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->GetUseGlobalPointIds();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("UseGlobalPointIdsOn",argv[1]))&&(argc == 2))
    {
    op->UseGlobalPointIdsOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("UseGlobalPointIdsOff",argv[1]))&&(argc == 2))
    {
    op->UseGlobalPointIdsOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("SetGlobalPointIdsArrayName",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    op->SetGlobalPointIdsArrayName(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetGlobalPointIdsArrayName",argv[1]))&&(argc == 2))
    {
    char    *temp20;
    temp20 = (op)->GetGlobalPointIdsArrayName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkPUnstructuredGridGhostCellsGeneratorCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkUnstructuredGridAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkPUnstructuredGridGhostCellsGenerator:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  SetController\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetController\n",NULL);
    Tcl_AppendResult(interp,"  SetUseGlobalPointIds\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetUseGlobalPointIds\n",NULL);
    Tcl_AppendResult(interp,"  UseGlobalPointIdsOn\n",NULL);
    Tcl_AppendResult(interp,"  UseGlobalPointIdsOff\n",NULL);
    Tcl_AppendResult(interp,"  SetGlobalPointIdsArrayName\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetGlobalPointIdsArrayName\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkUnstructuredGridAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "SetController" );
    Tcl_DStringAppendElement ( &dString, "GetController" );
    Tcl_DStringAppendElement ( &dString, "SetUseGlobalPointIds" );
    Tcl_DStringAppendElement ( &dString, "GetUseGlobalPointIds" );
    Tcl_DStringAppendElement ( &dString, "UseGlobalPointIdsOn" );
    Tcl_DStringAppendElement ( &dString, "UseGlobalPointIdsOff" );
    Tcl_DStringAppendElement ( &dString, "SetGlobalPointIdsArrayName" );
    Tcl_DStringAppendElement ( &dString, "GetGlobalPointIdsArrayName" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkUnstructuredGridAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkPUnstructuredGridGhostCellsGenerator *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkPUnstructuredGridGhostCellsGenerator" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetController */
    if ( strcmp ( argv[2], "SetController" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetController" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkMultiProcessController" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetController */
    Tcl_DStringAppendElement ( &dString, " Set/Get the MPI multi process controller object.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetController(vtkMultiProcessController *c);" );
    Tcl_DStringAppendElement ( &dString, "vtkPUnstructuredGridGhostCellsGenerator" );
    /* Closing for SetController */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetController */
    if ( strcmp ( argv[2], "GetController" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetController" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetController */
    Tcl_DStringAppendElement ( &dString, " Set/Get the MPI multi process controller object.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkMultiProcessController *GetController();" );
    Tcl_DStringAppendElement ( &dString, "vtkPUnstructuredGridGhostCellsGenerator" );
    /* Closing for GetController */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetUseGlobalPointIds */
    if ( strcmp ( argv[2], "SetUseGlobalPointIds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetUseGlobalPointIds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetUseGlobalPointIds */
    Tcl_DStringAppendElement ( &dString, " Specify if the filter must take benefit of global point ids if they exist.\n If false, point coordinates are used. Default is TRUE.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetUseGlobalPointIds(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPUnstructuredGridGhostCellsGenerator" );
    /* Closing for SetUseGlobalPointIds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetUseGlobalPointIds */
    if ( strcmp ( argv[2], "GetUseGlobalPointIds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetUseGlobalPointIds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetUseGlobalPointIds */
    Tcl_DStringAppendElement ( &dString, " Specify if the filter must take benefit of global point ids if they exist.\n If false, point coordinates are used. Default is TRUE.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetUseGlobalPointIds();" );
    Tcl_DStringAppendElement ( &dString, "vtkPUnstructuredGridGhostCellsGenerator" );
    /* Closing for GetUseGlobalPointIds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: UseGlobalPointIdsOn */
    if ( strcmp ( argv[2], "UseGlobalPointIdsOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UseGlobalPointIdsOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UseGlobalPointIdsOn */
    Tcl_DStringAppendElement ( &dString, " Specify if the filter must take benefit of global point ids if they exist.\n If false, point coordinates are used. Default is TRUE.\n" );
    Tcl_DStringAppendElement ( &dString, "void UseGlobalPointIdsOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPUnstructuredGridGhostCellsGenerator" );
    /* Closing for UseGlobalPointIdsOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: UseGlobalPointIdsOff */
    if ( strcmp ( argv[2], "UseGlobalPointIdsOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UseGlobalPointIdsOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UseGlobalPointIdsOff */
    Tcl_DStringAppendElement ( &dString, " Specify if the filter must take benefit of global point ids if they exist.\n If false, point coordinates are used. Default is TRUE.\n" );
    Tcl_DStringAppendElement ( &dString, "void UseGlobalPointIdsOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPUnstructuredGridGhostCellsGenerator" );
    /* Closing for UseGlobalPointIdsOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetGlobalPointIdsArrayName */
    if ( strcmp ( argv[2], "SetGlobalPointIdsArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetGlobalPointIdsArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetGlobalPointIdsArrayName */
    Tcl_DStringAppendElement ( &dString, " Specify the name of the global point ids data array if the GlobalIds\n attribute array is not set. Default is \"GlobalNodeIds\".\n" );
    Tcl_DStringAppendElement ( &dString, "void SetGlobalPointIdsArrayName(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkPUnstructuredGridGhostCellsGenerator" );
    /* Closing for SetGlobalPointIdsArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetGlobalPointIdsArrayName */
    if ( strcmp ( argv[2], "GetGlobalPointIdsArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetGlobalPointIdsArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetGlobalPointIdsArrayName */
    Tcl_DStringAppendElement ( &dString, " Specify the name of the global point ids data array if the GlobalIds\n attribute array is not set. Default is \"GlobalNodeIds\".\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetGlobalPointIdsArrayName();" );
    Tcl_DStringAppendElement ( &dString, "vtkPUnstructuredGridGhostCellsGenerator" );
    /* Closing for GetGlobalPointIdsArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkUnstructuredGridAlgorithmCppCommand(static_cast<vtkUnstructuredGridAlgorithm *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
