// tcl wrapper for vtkStructuredImplicitConnectivity object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkStructuredImplicitConnectivity.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkStructuredImplicitConnectivityNewCommand()
{
  vtkStructuredImplicitConnectivity *temp = vtkStructuredImplicitConnectivity::New();
  return static_cast<ClientData>(temp);
}

int vtkObjectCppCommand(vtkObject *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkStructuredImplicitConnectivityCppCommand(vtkStructuredImplicitConnectivity *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkStructuredImplicitConnectivityCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkStructuredImplicitConnectivityCppCommand(static_cast<vtkStructuredImplicitConnectivity *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkStructuredImplicitConnectivity_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkStructuredImplicitConnectivity"),vtkStructuredImplicitConnectivityNewCommand,vtkStructuredImplicitConnectivityCommand);
  return 0;
}

int VTKTCL_EXPORT vtkStructuredImplicitConnectivityCppCommand(vtkStructuredImplicitConnectivity *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkStructuredImplicitConnectivity",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkObject"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkStructuredImplicitConnectivity  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkStructuredImplicitConnectivity");
    return TCL_OK;
    }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkStructuredImplicitConnectivity  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkStructuredImplicitConnectivity");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkStructuredImplicitConnectivity  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkStructuredImplicitConnectivity");
    return TCL_OK;
    }
    }
  if ((!strcmp("SetWholeExtent",argv[1]))&&(argc == 8))
    {
    int    temp0[6];
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0[0] = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp0[1] = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp0[2] = tempi;
    if (Tcl_GetInt(interp,argv[5],&tempi) != TCL_OK) error = 1;
    temp0[3] = tempi;
    if (Tcl_GetInt(interp,argv[6],&tempi) != TCL_OK) error = 1;
    temp0[4] = tempi;
    if (Tcl_GetInt(interp,argv[7],&tempi) != TCL_OK) error = 1;
    temp0[5] = tempi;
    if (!error)
    {
    op->SetWholeExtent(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("EstablishConnectivity",argv[1]))&&(argc == 2))
    {
    op->EstablishConnectivity();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("HasImplicitConnectivity",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->HasImplicitConnectivity();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("ExchangeData",argv[1]))&&(argc == 2))
    {
    op->ExchangeData();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("GetOutputStructuredGrid",argv[1]))&&(argc == 4))
    {
    int      temp0;
    vtkStructuredGrid  *temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = (vtkStructuredGrid *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkStructuredGrid"),interp,error));
    if (!error)
    {
    op->GetOutputStructuredGrid(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetOutputImageData",argv[1]))&&(argc == 4))
    {
    int      temp0;
    vtkImageData  *temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = (vtkImageData *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkImageData"),interp,error));
    if (!error)
    {
    op->GetOutputImageData(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetOutputRectilinearGrid",argv[1]))&&(argc == 4))
    {
    int      temp0;
    vtkRectilinearGrid  *temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = (vtkRectilinearGrid *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkRectilinearGrid"),interp,error));
    if (!error)
    {
    op->GetOutputRectilinearGrid(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkStructuredImplicitConnectivityCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkStructuredImplicitConnectivity:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetWholeExtent\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  EstablishConnectivity\n",NULL);
    Tcl_AppendResult(interp,"  HasImplicitConnectivity\n",NULL);
    Tcl_AppendResult(interp,"  ExchangeData\n",NULL);
    Tcl_AppendResult(interp,"  GetOutputStructuredGrid\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetOutputImageData\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetOutputRectilinearGrid\t with 2 args\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetWholeExtent" );
    Tcl_DStringAppendElement ( &dString, "EstablishConnectivity" );
    Tcl_DStringAppendElement ( &dString, "HasImplicitConnectivity" );
    Tcl_DStringAppendElement ( &dString, "ExchangeData" );
    Tcl_DStringAppendElement ( &dString, "GetOutputStructuredGrid" );
    Tcl_DStringAppendElement ( &dString, "GetOutputImageData" );
    Tcl_DStringAppendElement ( &dString, "GetOutputRectilinearGrid" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkObjectCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkStructuredImplicitConnectivity *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetWholeExtent */
    if ( strcmp ( argv[2], "SetWholeExtent" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetWholeExtent" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetWholeExtent */
    Tcl_DStringAppendElement ( &dString, " \\brief Sets the whole extent for the distributed structured domain.\n \\param wholeExt the extent of the entire domain (in).\n \\note All ranks must call this method with the same whole extent.\n \\post this->DomainInfo != NULL\n" );
    Tcl_DStringAppendElement ( &dString, "void SetWholeExtent(int wholeExt\\[6\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity" );
    /* Closing for SetWholeExtent */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: EstablishConnectivity */
    if ( strcmp ( argv[2], "EstablishConnectivity" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "EstablishConnectivity" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for EstablishConnectivity */
    Tcl_DStringAppendElement ( &dString, " \\brief Finds implicit connectivity for a distributed structured dataset.\n \\note This is a collective operation, all ranks must call this method.\n \\pre this->Controller != NULL\n \\pre this->DomainInfo != NULL\n" );
    Tcl_DStringAppendElement ( &dString, "void EstablishConnectivity();" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity" );
    /* Closing for EstablishConnectivity */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: HasImplicitConnectivity */
    if ( strcmp ( argv[2], "HasImplicitConnectivity" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HasImplicitConnectivity" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HasImplicitConnectivity */
    Tcl_DStringAppendElement ( &dString, " \\brief Checks if there is implicit connectivity.\n \\return status true if implicit connectivity in one or more dimensions.\n" );
    Tcl_DStringAppendElement ( &dString, "bool HasImplicitConnectivity();" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity" );
    /* Closing for HasImplicitConnectivity */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: ExchangeData */
    if ( strcmp ( argv[2], "ExchangeData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ExchangeData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ExchangeData */
    Tcl_DStringAppendElement ( &dString, " \\brief Exchanges one layer (row or column) of data between neighboring\n grids to fix the implicit connectivity.\n \\note This is a collective operation, all ranks must call this method.\n \\pre this->Controller != NULL\n \\pre this->DomainInfo != NULL\n" );
    Tcl_DStringAppendElement ( &dString, "void ExchangeData();" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity" );
    /* Closing for ExchangeData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetOutputStructuredGrid */
    if ( strcmp ( argv[2], "GetOutputStructuredGrid" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOutputStructuredGrid" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredGrid" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOutputStructuredGrid */
    Tcl_DStringAppendElement ( &dString, " \\brief Gets the output structured grid instance on this process.\n \\param gridID the ID of the grid\n \\param grid pointer to data-structure where to store the output.\n" );
    Tcl_DStringAppendElement ( &dString, "void GetOutputStructuredGrid(const int gridID, vtkStructuredGrid *grid);" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity" );
    /* Closing for GetOutputStructuredGrid */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetOutputImageData */
    if ( strcmp ( argv[2], "GetOutputImageData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOutputImageData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "vtkImageData" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOutputImageData */
    Tcl_DStringAppendElement ( &dString, " \\brief Gets the output uniform grid instance on this process.\n \\param gridID the ID of the grid.\n \\param grid pointer to data-structure where to store the output.\n" );
    Tcl_DStringAppendElement ( &dString, "void GetOutputImageData(const int gridID, vtkImageData *grid);" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity" );
    /* Closing for GetOutputImageData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetOutputRectilinearGrid */
    if ( strcmp ( argv[2], "GetOutputRectilinearGrid" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOutputRectilinearGrid" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "vtkRectilinearGrid" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOutputRectilinearGrid */
    Tcl_DStringAppendElement ( &dString, " \\brief Gets the output rectilinear grid instance on this process.\n \\param gridID the ID of the grid.\n \\param grid pointer to data-structure where to store the output.\n" );
    Tcl_DStringAppendElement ( &dString, "void GetOutputRectilinearGrid(const int gridID, vtkRectilinearGrid *grid);" );
    Tcl_DStringAppendElement ( &dString, "vtkStructuredImplicitConnectivity" );
    /* Closing for GetOutputRectilinearGrid */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
