// tcl wrapper for vtkSMPContourGrid object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkSMPContourGrid.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkSMPContourGridNewCommand()
{
  vtkSMPContourGrid *temp = vtkSMPContourGrid::New();
  return static_cast<ClientData>(temp);
}

int vtkContourGridCppCommand(vtkContourGrid *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkSMPContourGridCppCommand(vtkSMPContourGrid *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkSMPContourGridCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkSMPContourGridCppCommand(static_cast<vtkSMPContourGrid *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkSMPContourGrid_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkSMPContourGrid"),vtkSMPContourGridNewCommand,vtkSMPContourGridCommand);
  return 0;
}

int VTKTCL_EXPORT vtkSMPContourGridCppCommand(vtkSMPContourGrid *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkSMPContourGrid",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkContourGridCppCommand(static_cast<vtkContourGrid *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkContourGrid"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkSMPContourGrid  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkSMPContourGrid");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkSMPContourGrid  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkSMPContourGrid");
    return TCL_OK;
    }
    }
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkSMPContourGrid  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkSMPContourGrid");
    return TCL_OK;
    }
  if ((!strcmp("SetMergePieces",argv[1]))&&(argc == 3))
    {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
    {
    op->SetMergePieces(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetMergePieces",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->GetMergePieces();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("MergePiecesOn",argv[1]))&&(argc == 2))
    {
    op->MergePiecesOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("MergePiecesOff",argv[1]))&&(argc == 2))
    {
    op->MergePiecesOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkSMPContourGridCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkContourGridCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkSMPContourGrid:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  SetMergePieces\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetMergePieces\n",NULL);
    Tcl_AppendResult(interp,"  MergePiecesOn\n",NULL);
    Tcl_AppendResult(interp,"  MergePiecesOff\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkContourGridCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "SetMergePieces" );
    Tcl_DStringAppendElement ( &dString, "GetMergePieces" );
    Tcl_DStringAppendElement ( &dString, "MergePiecesOn" );
    Tcl_DStringAppendElement ( &dString, "MergePiecesOff" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkContourGridCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkSMPContourGrid" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkSMPContourGrid" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkSMPContourGrid *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkSMPContourGrid" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkSMPContourGrid *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkSMPContourGrid" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Constructor.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkSMPContourGrid *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkSMPContourGrid" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetMergePieces */
    if ( strcmp ( argv[2], "SetMergePieces" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMergePieces" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMergePieces */
    Tcl_DStringAppendElement ( &dString, " If MergePieces is true (default), this filter will merge all\n pieces generated by processing the input with multiple threads.\n The output will be a vtkPolyData. Note that this has a slight overhead\n which becomes more significant as the number of threads used grows.\n If MergePieces is false, this filter will generate a vtkMultiBlock\n of vtkPolyData where the number of pieces will be equal to the number\n of threads used.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetMergePieces(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkSMPContourGrid" );
    /* Closing for SetMergePieces */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetMergePieces */
    if ( strcmp ( argv[2], "GetMergePieces" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMergePieces" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMergePieces */
    Tcl_DStringAppendElement ( &dString, " If MergePieces is true (default), this filter will merge all\n pieces generated by processing the input with multiple threads.\n The output will be a vtkPolyData. Note that this has a slight overhead\n which becomes more significant as the number of threads used grows.\n If MergePieces is false, this filter will generate a vtkMultiBlock\n of vtkPolyData where the number of pieces will be equal to the number\n of threads used.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetMergePieces();" );
    Tcl_DStringAppendElement ( &dString, "vtkSMPContourGrid" );
    /* Closing for GetMergePieces */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: MergePiecesOn */
    if ( strcmp ( argv[2], "MergePiecesOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "MergePiecesOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for MergePiecesOn */
    Tcl_DStringAppendElement ( &dString, " If MergePieces is true (default), this filter will merge all\n pieces generated by processing the input with multiple threads.\n The output will be a vtkPolyData. Note that this has a slight overhead\n which becomes more significant as the number of threads used grows.\n If MergePieces is false, this filter will generate a vtkMultiBlock\n of vtkPolyData where the number of pieces will be equal to the number\n of threads used.\n" );
    Tcl_DStringAppendElement ( &dString, "void MergePiecesOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkSMPContourGrid" );
    /* Closing for MergePiecesOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: MergePiecesOff */
    if ( strcmp ( argv[2], "MergePiecesOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "MergePiecesOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for MergePiecesOff */
    Tcl_DStringAppendElement ( &dString, " If MergePieces is true (default), this filter will merge all\n pieces generated by processing the input with multiple threads.\n The output will be a vtkPolyData. Note that this has a slight overhead\n which becomes more significant as the number of threads used grows.\n If MergePieces is false, this filter will generate a vtkMultiBlock\n of vtkPolyData where the number of pieces will be equal to the number\n of threads used.\n" );
    Tcl_DStringAppendElement ( &dString, "void MergePiecesOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkSMPContourGrid" );
    /* Closing for MergePiecesOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkContourGridCppCommand(static_cast<vtkContourGrid *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
