// tcl wrapper for vtkHyperTreeGridSource object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkHyperTreeGridSource.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkHyperTreeGridSourceNewCommand()
{
  vtkHyperTreeGridSource *temp = vtkHyperTreeGridSource::New();
  return static_cast<ClientData>(temp);
}

int vtkHyperTreeGridAlgorithmCppCommand(vtkHyperTreeGridAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkHyperTreeGridSourceCppCommand(vtkHyperTreeGridSource *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkHyperTreeGridSourceCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkHyperTreeGridSourceCppCommand(static_cast<vtkHyperTreeGridSource *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkHyperTreeGridSource_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkHyperTreeGridSource"),vtkHyperTreeGridSourceNewCommand,vtkHyperTreeGridSourceCommand);
  return 0;
}

int VTKTCL_EXPORT vtkHyperTreeGridSourceCppCommand(vtkHyperTreeGridSource *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkHyperTreeGridSource",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkHyperTreeGridAlgorithmCppCommand(static_cast<vtkHyperTreeGridAlgorithm *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkHyperTreeGridAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkHyperTreeGridSource  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkHyperTreeGridSource");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkHyperTreeGridSource  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkHyperTreeGridSource");
    return TCL_OK;
    }
    }
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkHyperTreeGridSource  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkHyperTreeGridSource");
    return TCL_OK;
    }
  if ((!strcmp("GetMaximumLevel",argv[1]))&&(argc == 2))
    {
    unsigned int      temp20;
    temp20 = (op)->GetMaximumLevel();
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetMaximumLevel",argv[1]))&&(argc == 3))
    {
    unsigned int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    op->SetMaximumLevel(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetOrigin",argv[1]))&&(argc == 5))
    {
    double   temp0;
    double   temp1;
    double   temp2;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
    {
    op->SetOrigin(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetOrigin",argv[1]))&&(argc == 5))
    {
    double temp0[3];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
    {
    op->SetOrigin(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetOrigin",argv[1]))&&(argc == 2))
    {
    double  *temp20;
    temp20 = (op)->GetOrigin();
    if(temp20)
      {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
      }
    else
      {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
      }
    return TCL_OK;
    }
  if ((!strcmp("SetGridScale",argv[1]))&&(argc == 5))
    {
    double   temp0;
    double   temp1;
    double   temp2;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
    {
    op->SetGridScale(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetGridScale",argv[1]))&&(argc == 5))
    {
    double temp0[3];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
    {
    op->SetGridScale(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetGridScale",argv[1]))&&(argc == 2))
    {
    double  *temp20;
    temp20 = (op)->GetGridScale();
    if(temp20)
      {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
      }
    else
      {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
      }
    return TCL_OK;
    }
  if ((!strcmp("SetGridSize",argv[1]))&&(argc == 5))
    {
    unsigned int      temp0;
    unsigned int      temp1;
    unsigned int      temp2;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = static_cast<unsigned int>(tempi);
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    op->SetGridSize(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetGridSize",argv[1]))&&(argc == 2))
    {
    unsigned int     *temp20;
    temp20 = (op)->GetGridSize();
    if(temp20)
      {
      char tempResult[1024];
      *tempResult = '\0';
      sprintf(tempResult,"%u %u %u ",temp20[0],temp20[1],temp20[2]);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
      }
    else
      {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
      }
    return TCL_OK;
    }
  if ((!strcmp("SetTransposedRootIndexing",argv[1]))&&(argc == 3))
    {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
    {
    op->SetTransposedRootIndexing(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetTransposedRootIndexing",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->GetTransposedRootIndexing();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetIndexingModeToKJI",argv[1]))&&(argc == 2))
    {
    op->SetIndexingModeToKJI();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("SetIndexingModeToIJK",argv[1]))&&(argc == 2))
    {
    op->SetIndexingModeToIJK();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("SetBranchFactor",argv[1]))&&(argc == 3))
    {
    unsigned int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    op->SetBranchFactor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetBranchFactorMinValue",argv[1]))&&(argc == 2))
    {
    unsigned int      temp20;
    temp20 = (op)->GetBranchFactorMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetBranchFactorMaxValue",argv[1]))&&(argc == 2))
    {
    unsigned int      temp20;
    temp20 = (op)->GetBranchFactorMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetBranchFactor",argv[1]))&&(argc == 2))
    {
    unsigned int      temp20;
    temp20 = (op)->GetBranchFactor();
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetDimension",argv[1]))&&(argc == 3))
    {
    unsigned int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    op->SetDimension(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetDimensionMinValue",argv[1]))&&(argc == 2))
    {
    unsigned int      temp20;
    temp20 = (op)->GetDimensionMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetDimensionMaxValue",argv[1]))&&(argc == 2))
    {
    unsigned int      temp20;
    temp20 = (op)->GetDimensionMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetDimension",argv[1]))&&(argc == 2))
    {
    unsigned int      temp20;
    temp20 = (op)->GetDimension();
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetUseDescriptor",argv[1]))&&(argc == 3))
    {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
    {
    op->SetUseDescriptor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetUseDescriptor",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->GetUseDescriptor();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("UseDescriptorOn",argv[1]))&&(argc == 2))
    {
    op->UseDescriptorOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("UseDescriptorOff",argv[1]))&&(argc == 2))
    {
    op->UseDescriptorOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("SetUseMaterialMask",argv[1]))&&(argc == 3))
    {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
    {
    op->SetUseMaterialMask(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetUseMaterialMask",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->GetUseMaterialMask();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("UseMaterialMaskOn",argv[1]))&&(argc == 2))
    {
    op->UseMaterialMaskOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("UseMaterialMaskOff",argv[1]))&&(argc == 2))
    {
    op->UseMaterialMaskOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("SetDescriptor",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    op->SetDescriptor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetDescriptor",argv[1]))&&(argc == 2))
    {
    char    *temp20;
    temp20 = (op)->GetDescriptor();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("SetMaterialMask",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    op->SetMaterialMask(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetMaterialMask",argv[1]))&&(argc == 2))
    {
    char    *temp20;
    temp20 = (op)->GetMaterialMask();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("SetDescriptorBits",argv[1]))&&(argc == 3))
    {
    vtkBitArray  *temp0;
    error = 0;

    temp0 = (vtkBitArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkBitArray"),interp,error));
    if (!error)
    {
    op->SetDescriptorBits(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetDescriptorBits",argv[1]))&&(argc == 2))
    {
    vtkBitArray  *temp20;
    temp20 = (op)->GetDescriptorBits();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkBitArray");
    return TCL_OK;
    }
  if ((!strcmp("SetLevelZeroMaterialIndex",argv[1]))&&(argc == 3))
    {
    vtkIdTypeArray  *temp0;
    error = 0;

    temp0 = (vtkIdTypeArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkIdTypeArray"),interp,error));
    if (!error)
    {
    op->SetLevelZeroMaterialIndex(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetMaterialMaskBits",argv[1]))&&(argc == 3))
    {
    vtkBitArray  *temp0;
    error = 0;

    temp0 = (vtkBitArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkBitArray"),interp,error));
    if (!error)
    {
    op->SetMaterialMaskBits(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetMaterialMaskBits",argv[1]))&&(argc == 2))
    {
    vtkBitArray  *temp20;
    temp20 = (op)->GetMaterialMaskBits();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkBitArray");
    return TCL_OK;
    }
  if ((!strcmp("SetQuadric",argv[1]))&&(argc == 3))
    {
    vtkQuadric  *temp0;
    error = 0;

    temp0 = (vtkQuadric *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkQuadric"),interp,error));
    if (!error)
    {
    op->SetQuadric(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetQuadric",argv[1]))&&(argc == 2))
    {
    vtkQuadric  *temp20;
    temp20 = (op)->GetQuadric();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkQuadric");
    return TCL_OK;
    }
  if ((!strcmp("SetQuadricCoefficients",argv[1]))&&(argc == 12))
    {
    double temp0[10];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp0[3] = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp0[4] = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp0[5] = tempd;
    if (Tcl_GetDouble(interp,argv[8],&tempd) != TCL_OK) error = 1;
    temp0[6] = tempd;
    if (Tcl_GetDouble(interp,argv[9],&tempd) != TCL_OK) error = 1;
    temp0[7] = tempd;
    if (Tcl_GetDouble(interp,argv[10],&tempd) != TCL_OK) error = 1;
    temp0[8] = tempd;
    if (Tcl_GetDouble(interp,argv[11],&tempd) != TCL_OK) error = 1;
    temp0[9] = tempd;
    if (!error)
    {
    op->SetQuadricCoefficients(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetQuadricCoefficients",argv[1]))&&(argc == 12))
    {
    double temp0[10];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp0[3] = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp0[4] = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp0[5] = tempd;
    if (Tcl_GetDouble(interp,argv[8],&tempd) != TCL_OK) error = 1;
    temp0[6] = tempd;
    if (Tcl_GetDouble(interp,argv[9],&tempd) != TCL_OK) error = 1;
    temp0[7] = tempd;
    if (Tcl_GetDouble(interp,argv[10],&tempd) != TCL_OK) error = 1;
    temp0[8] = tempd;
    if (Tcl_GetDouble(interp,argv[11],&tempd) != TCL_OK) error = 1;
    temp0[9] = tempd;
    if (!error)
    {
    op->GetQuadricCoefficients(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetMTime",argv[1]))&&(argc == 2))
    {
    unsigned long     temp20;
    temp20 = (op)->GetMTime();
    char tempResult[1024];
    sprintf(tempResult,"%lu",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkHyperTreeGridSourceCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkHyperTreeGridAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkHyperTreeGridSource:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetMaximumLevel\n",NULL);
    Tcl_AppendResult(interp,"  SetMaximumLevel\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetOrigin\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetOrigin\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetOrigin\n",NULL);
    Tcl_AppendResult(interp,"  SetGridScale\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetGridScale\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetGridScale\n",NULL);
    Tcl_AppendResult(interp,"  SetGridSize\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetGridSize\n",NULL);
    Tcl_AppendResult(interp,"  SetTransposedRootIndexing\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTransposedRootIndexing\n",NULL);
    Tcl_AppendResult(interp,"  SetIndexingModeToKJI\n",NULL);
    Tcl_AppendResult(interp,"  SetIndexingModeToIJK\n",NULL);
    Tcl_AppendResult(interp,"  SetBranchFactor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetBranchFactorMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetBranchFactorMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetBranchFactor\n",NULL);
    Tcl_AppendResult(interp,"  SetDimension\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDimensionMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetDimensionMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetDimension\n",NULL);
    Tcl_AppendResult(interp,"  SetUseDescriptor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetUseDescriptor\n",NULL);
    Tcl_AppendResult(interp,"  UseDescriptorOn\n",NULL);
    Tcl_AppendResult(interp,"  UseDescriptorOff\n",NULL);
    Tcl_AppendResult(interp,"  SetUseMaterialMask\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetUseMaterialMask\n",NULL);
    Tcl_AppendResult(interp,"  UseMaterialMaskOn\n",NULL);
    Tcl_AppendResult(interp,"  UseMaterialMaskOff\n",NULL);
    Tcl_AppendResult(interp,"  SetDescriptor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDescriptor\n",NULL);
    Tcl_AppendResult(interp,"  SetMaterialMask\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetMaterialMask\n",NULL);
    Tcl_AppendResult(interp,"  SetDescriptorBits\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDescriptorBits\n",NULL);
    Tcl_AppendResult(interp,"  SetLevelZeroMaterialIndex\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetMaterialMaskBits\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetMaterialMaskBits\n",NULL);
    Tcl_AppendResult(interp,"  SetQuadric\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetQuadric\n",NULL);
    Tcl_AppendResult(interp,"  SetQuadricCoefficients\t with 10 args\n",NULL);
    Tcl_AppendResult(interp,"  GetQuadricCoefficients\t with 10 args\n",NULL);
    Tcl_AppendResult(interp,"  GetMTime\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkHyperTreeGridAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetMaximumLevel" );
    Tcl_DStringAppendElement ( &dString, "SetMaximumLevel" );
    Tcl_DStringAppendElement ( &dString, "SetOrigin" );
    Tcl_DStringAppendElement ( &dString, "SetOrigin" );
    Tcl_DStringAppendElement ( &dString, "GetOrigin" );
    Tcl_DStringAppendElement ( &dString, "SetGridScale" );
    Tcl_DStringAppendElement ( &dString, "SetGridScale" );
    Tcl_DStringAppendElement ( &dString, "GetGridScale" );
    Tcl_DStringAppendElement ( &dString, "SetGridSize" );
    Tcl_DStringAppendElement ( &dString, "GetGridSize" );
    Tcl_DStringAppendElement ( &dString, "SetTransposedRootIndexing" );
    Tcl_DStringAppendElement ( &dString, "GetTransposedRootIndexing" );
    Tcl_DStringAppendElement ( &dString, "SetIndexingModeToKJI" );
    Tcl_DStringAppendElement ( &dString, "SetIndexingModeToIJK" );
    Tcl_DStringAppendElement ( &dString, "SetBranchFactor" );
    Tcl_DStringAppendElement ( &dString, "GetBranchFactorMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetBranchFactorMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetBranchFactor" );
    Tcl_DStringAppendElement ( &dString, "SetDimension" );
    Tcl_DStringAppendElement ( &dString, "GetDimensionMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetDimensionMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetDimension" );
    Tcl_DStringAppendElement ( &dString, "SetUseDescriptor" );
    Tcl_DStringAppendElement ( &dString, "GetUseDescriptor" );
    Tcl_DStringAppendElement ( &dString, "UseDescriptorOn" );
    Tcl_DStringAppendElement ( &dString, "UseDescriptorOff" );
    Tcl_DStringAppendElement ( &dString, "SetUseMaterialMask" );
    Tcl_DStringAppendElement ( &dString, "GetUseMaterialMask" );
    Tcl_DStringAppendElement ( &dString, "UseMaterialMaskOn" );
    Tcl_DStringAppendElement ( &dString, "UseMaterialMaskOff" );
    Tcl_DStringAppendElement ( &dString, "SetDescriptor" );
    Tcl_DStringAppendElement ( &dString, "GetDescriptor" );
    Tcl_DStringAppendElement ( &dString, "SetMaterialMask" );
    Tcl_DStringAppendElement ( &dString, "GetMaterialMask" );
    Tcl_DStringAppendElement ( &dString, "SetDescriptorBits" );
    Tcl_DStringAppendElement ( &dString, "GetDescriptorBits" );
    Tcl_DStringAppendElement ( &dString, "SetLevelZeroMaterialIndex" );
    Tcl_DStringAppendElement ( &dString, "SetMaterialMaskBits" );
    Tcl_DStringAppendElement ( &dString, "GetMaterialMaskBits" );
    Tcl_DStringAppendElement ( &dString, "SetQuadric" );
    Tcl_DStringAppendElement ( &dString, "GetQuadric" );
    Tcl_DStringAppendElement ( &dString, "SetQuadricCoefficients" );
    Tcl_DStringAppendElement ( &dString, "GetQuadricCoefficients" );
    Tcl_DStringAppendElement ( &dString, "GetMTime" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkHyperTreeGridAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkHyperTreeGridSource *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetMaximumLevel */
    if ( strcmp ( argv[2], "GetMaximumLevel" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMaximumLevel" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMaximumLevel */
    Tcl_DStringAppendElement ( &dString, " Return the maximum number of levels of the hypertree.\n \\post positive_result: result>=1\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetMaximumLevel();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetMaximumLevel */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetMaximumLevel */
    if ( strcmp ( argv[2], "SetMaximumLevel" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMaximumLevel" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMaximumLevel */
    Tcl_DStringAppendElement ( &dString, " Set the maximum number of levels of the hypertree.\n \\pre positive_levels: levels>=1\n \\post is_set: this->GetLevels()==levels\n" );
    Tcl_DStringAppendElement ( &dString, "void SetMaximumLevel(unsigned int levels);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetMaximumLevel */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetOrigin */
    if ( strcmp ( argv[2], "SetOrigin" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOrigin" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOrigin */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetOrigin(double, double, double);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetOrigin */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetOrigin */
    if ( strcmp ( argv[2], "SetOrigin" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOrigin" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOrigin */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetOrigin(double a\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetOrigin */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetOrigin */
    if ( strcmp ( argv[2], "GetOrigin" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOrigin" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOrigin */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "double *GetOrigin();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetOrigin */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetGridScale */
    if ( strcmp ( argv[2], "SetGridScale" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetGridScale" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetGridScale */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetGridScale(double, double, double);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetGridScale */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetGridScale */
    if ( strcmp ( argv[2], "SetGridScale" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetGridScale" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetGridScale */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetGridScale(double a\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetGridScale */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetGridScale */
    if ( strcmp ( argv[2], "GetGridScale" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetGridScale" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetGridScale */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "double *GetGridScale();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetGridScale */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetGridSize */
    if ( strcmp ( argv[2], "SetGridSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetGridSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetGridSize */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetGridSize(unsigned int, unsigned int, unsigned int);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetGridSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetGridSize */
    if ( strcmp ( argv[2], "GetGridSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetGridSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetGridSize */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "unsigned int *GetGridSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetGridSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetTransposedRootIndexing */
    if ( strcmp ( argv[2], "SetTransposedRootIndexing" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTransposedRootIndexing" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTransposedRootIndexing */
    Tcl_DStringAppendElement ( &dString, " Specify whether indexing mode of grid root cells must be transposed to\n x-axis first, z-axis last, instead of the default z-axis first, k-axis last\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTransposedRootIndexing(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetTransposedRootIndexing */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetTransposedRootIndexing */
    if ( strcmp ( argv[2], "GetTransposedRootIndexing" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTransposedRootIndexing" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTransposedRootIndexing */
    Tcl_DStringAppendElement ( &dString, " Specify whether indexing mode of grid root cells must be transposed to\n x-axis first, z-axis last, instead of the default z-axis first, k-axis last\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetTransposedRootIndexing();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetTransposedRootIndexing */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetIndexingModeToKJI */
    if ( strcmp ( argv[2], "SetIndexingModeToKJI" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetIndexingModeToKJI" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetIndexingModeToKJI */
    Tcl_DStringAppendElement ( &dString, " Specify whether indexing mode of grid root cells must be transposed to\n x-axis first, z-axis last, instead of the default z-axis first, k-axis last\n" );
    Tcl_DStringAppendElement ( &dString, "void SetIndexingModeToKJI();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetIndexingModeToKJI */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetIndexingModeToIJK */
    if ( strcmp ( argv[2], "SetIndexingModeToIJK" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetIndexingModeToIJK" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetIndexingModeToIJK */
    Tcl_DStringAppendElement ( &dString, " Specify whether indexing mode of grid root cells must be transposed to\n x-axis first, z-axis last, instead of the default z-axis first, k-axis last\n" );
    Tcl_DStringAppendElement ( &dString, "void SetIndexingModeToIJK();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetIndexingModeToIJK */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetBranchFactor */
    if ( strcmp ( argv[2], "SetBranchFactor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetBranchFactor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetBranchFactor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the subdivision factor in the grid refinement scheme\n" );
    Tcl_DStringAppendElement ( &dString, "void SetBranchFactor(unsigned int);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetBranchFactor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetBranchFactorMinValue */
    if ( strcmp ( argv[2], "GetBranchFactorMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetBranchFactorMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetBranchFactorMinValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the subdivision factor in the grid refinement scheme\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetBranchFactorMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetBranchFactorMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetBranchFactorMaxValue */
    if ( strcmp ( argv[2], "GetBranchFactorMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetBranchFactorMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetBranchFactorMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the subdivision factor in the grid refinement scheme\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetBranchFactorMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetBranchFactorMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetBranchFactor */
    if ( strcmp ( argv[2], "GetBranchFactor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetBranchFactor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetBranchFactor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the subdivision factor in the grid refinement scheme\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetBranchFactor();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetBranchFactor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetDimension */
    if ( strcmp ( argv[2], "SetDimension" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDimension" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDimension */
    Tcl_DStringAppendElement ( &dString, " Set/Get the dimensionality of the grid\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDimension(unsigned int);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetDimension */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetDimensionMinValue */
    if ( strcmp ( argv[2], "GetDimensionMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDimensionMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDimensionMinValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the dimensionality of the grid\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetDimensionMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetDimensionMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetDimensionMaxValue */
    if ( strcmp ( argv[2], "GetDimensionMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDimensionMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDimensionMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the dimensionality of the grid\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetDimensionMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetDimensionMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetDimension */
    if ( strcmp ( argv[2], "GetDimension" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDimension" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDimension */
    Tcl_DStringAppendElement ( &dString, " Set/Get the dimensionality of the grid\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetDimension();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetDimension */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetUseDescriptor */
    if ( strcmp ( argv[2], "SetUseDescriptor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetUseDescriptor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetUseDescriptor */
    Tcl_DStringAppendElement ( &dString, " Set/get whether the descriptor string should be used.\n NB: Otherwise a quadric definition is expected.\n Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "void SetUseDescriptor(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetUseDescriptor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetUseDescriptor */
    if ( strcmp ( argv[2], "GetUseDescriptor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetUseDescriptor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetUseDescriptor */
    Tcl_DStringAppendElement ( &dString, " Set/get whether the descriptor string should be used.\n NB: Otherwise a quadric definition is expected.\n Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetUseDescriptor();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetUseDescriptor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: UseDescriptorOn */
    if ( strcmp ( argv[2], "UseDescriptorOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UseDescriptorOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UseDescriptorOn */
    Tcl_DStringAppendElement ( &dString, " Set/get whether the descriptor string should be used.\n NB: Otherwise a quadric definition is expected.\n Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "void UseDescriptorOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for UseDescriptorOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: UseDescriptorOff */
    if ( strcmp ( argv[2], "UseDescriptorOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UseDescriptorOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UseDescriptorOff */
    Tcl_DStringAppendElement ( &dString, " Set/get whether the descriptor string should be used.\n NB: Otherwise a quadric definition is expected.\n Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "void UseDescriptorOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for UseDescriptorOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetUseMaterialMask */
    if ( strcmp ( argv[2], "SetUseMaterialMask" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetUseMaterialMask" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetUseMaterialMask */
    Tcl_DStringAppendElement ( &dString, " Set/get whether the material mask should be used.\n NB: This is only used when UseDescriptor is ON\n Default: false\n" );
    Tcl_DStringAppendElement ( &dString, "void SetUseMaterialMask(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetUseMaterialMask */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetUseMaterialMask */
    if ( strcmp ( argv[2], "GetUseMaterialMask" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetUseMaterialMask" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetUseMaterialMask */
    Tcl_DStringAppendElement ( &dString, " Set/get whether the material mask should be used.\n NB: This is only used when UseDescriptor is ON\n Default: false\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetUseMaterialMask();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetUseMaterialMask */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: UseMaterialMaskOn */
    if ( strcmp ( argv[2], "UseMaterialMaskOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UseMaterialMaskOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UseMaterialMaskOn */
    Tcl_DStringAppendElement ( &dString, " Set/get whether the material mask should be used.\n NB: This is only used when UseDescriptor is ON\n Default: false\n" );
    Tcl_DStringAppendElement ( &dString, "void UseMaterialMaskOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for UseMaterialMaskOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: UseMaterialMaskOff */
    if ( strcmp ( argv[2], "UseMaterialMaskOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UseMaterialMaskOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UseMaterialMaskOff */
    Tcl_DStringAppendElement ( &dString, " Set/get whether the material mask should be used.\n NB: This is only used when UseDescriptor is ON\n Default: false\n" );
    Tcl_DStringAppendElement ( &dString, "void UseMaterialMaskOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for UseMaterialMaskOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetDescriptor */
    if ( strcmp ( argv[2], "SetDescriptor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDescriptor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDescriptor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the string used to describe the grid\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDescriptor(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetDescriptor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetDescriptor */
    if ( strcmp ( argv[2], "GetDescriptor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDescriptor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDescriptor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the string used to describe the grid\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetDescriptor();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetDescriptor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetMaterialMask */
    if ( strcmp ( argv[2], "SetMaterialMask" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMaterialMask" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMaterialMask */
    Tcl_DStringAppendElement ( &dString, " Set/Get the string used to as a material mask\n" );
    Tcl_DStringAppendElement ( &dString, "void SetMaterialMask(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetMaterialMask */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetMaterialMask */
    if ( strcmp ( argv[2], "GetMaterialMask" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMaterialMask" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMaterialMask */
    Tcl_DStringAppendElement ( &dString, " Set/Get the string used to as a material mask\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetMaterialMask();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetMaterialMask */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetDescriptorBits */
    if ( strcmp ( argv[2], "SetDescriptorBits" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDescriptorBits" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkBitArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDescriptorBits */
    Tcl_DStringAppendElement ( &dString, " Set/Get the bitarray used to describe the grid\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetDescriptorBits(vtkBitArray *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetDescriptorBits */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetDescriptorBits */
    if ( strcmp ( argv[2], "GetDescriptorBits" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDescriptorBits" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDescriptorBits */
    Tcl_DStringAppendElement ( &dString, " Set/Get the bitarray used to describe the grid\n" );
    Tcl_DStringAppendElement ( &dString, "vtkBitArray *GetDescriptorBits();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetDescriptorBits */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetLevelZeroMaterialIndex */
    if ( strcmp ( argv[2], "SetLevelZeroMaterialIndex" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLevelZeroMaterialIndex" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkIdTypeArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLevelZeroMaterialIndex */
    Tcl_DStringAppendElement ( &dString, " Set the index array used to as a material mask\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetLevelZeroMaterialIndex(vtkIdTypeArray *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetLevelZeroMaterialIndex */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetMaterialMaskBits */
    if ( strcmp ( argv[2], "SetMaterialMaskBits" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMaterialMaskBits" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkBitArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMaterialMaskBits */
    Tcl_DStringAppendElement ( &dString, " Set/Get the bitarray used as a material mask\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetMaterialMaskBits(vtkBitArray *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetMaterialMaskBits */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetMaterialMaskBits */
    if ( strcmp ( argv[2], "GetMaterialMaskBits" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMaterialMaskBits" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMaterialMaskBits */
    Tcl_DStringAppendElement ( &dString, " Set/Get the bitarray used as a material mask\n" );
    Tcl_DStringAppendElement ( &dString, "vtkBitArray *GetMaterialMaskBits();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetMaterialMaskBits */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetQuadric */
    if ( strcmp ( argv[2], "SetQuadric" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetQuadric" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkQuadric" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetQuadric */
    Tcl_DStringAppendElement ( &dString, " Set/Get the quadric function\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetQuadric(vtkQuadric *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetQuadric */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetQuadric */
    if ( strcmp ( argv[2], "GetQuadric" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetQuadric" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetQuadric */
    Tcl_DStringAppendElement ( &dString, " Set/Get the quadric function\n" );
    Tcl_DStringAppendElement ( &dString, "vtkQuadric *GetQuadric();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetQuadric */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetQuadricCoefficients */
    if ( strcmp ( argv[2], "SetQuadricCoefficients" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetQuadricCoefficients" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetQuadricCoefficients */
    Tcl_DStringAppendElement ( &dString, " Helpers to set/get the 10 coefficients of the quadric function\n" );
    Tcl_DStringAppendElement ( &dString, "void SetQuadricCoefficients(double\\[10\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for SetQuadricCoefficients */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetQuadricCoefficients */
    if ( strcmp ( argv[2], "GetQuadricCoefficients" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetQuadricCoefficients" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetQuadricCoefficients */
    Tcl_DStringAppendElement ( &dString, " Helpers to set/get the 10 coefficients of the quadric function\n" );
    Tcl_DStringAppendElement ( &dString, "void GetQuadricCoefficients(double\\[10\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetQuadricCoefficients */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetMTime */
    if ( strcmp ( argv[2], "GetMTime" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMTime" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMTime */
    Tcl_DStringAppendElement ( &dString, " Override GetMTime because we delegate to a vtkQuadric\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned long GetMTime();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGridSource" );
    /* Closing for GetMTime */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkHyperTreeGridAlgorithmCppCommand(static_cast<vtkHyperTreeGridAlgorithm *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
