// tcl wrapper for vtkRInterface object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkRInterface.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkRInterfaceNewCommand()
{
  vtkRInterface *temp = vtkRInterface::New();
  return static_cast<ClientData>(temp);
}

int vtkObjectCppCommand(vtkObject *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkRInterfaceCppCommand(vtkRInterface *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkRInterfaceCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkRInterfaceCppCommand(static_cast<vtkRInterface *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkRInterface_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkRInterface"),vtkRInterfaceNewCommand,vtkRInterfaceCommand);
  return 0;
}

int VTKTCL_EXPORT vtkRInterfaceCppCommand(vtkRInterface *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkRInterface",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkObject"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkRInterface  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRInterface");
    return TCL_OK;
    }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkRInterface  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRInterface");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkRInterface  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRInterface");
    return TCL_OK;
    }
    }
  if ((!strcmp("EvalRcommand",argv[1]))&&(argc == 4))
    {
    char    *temp0;
    int      temp1;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (!error)
    {
    temp20 = (op)->EvalRcommand(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("EvalRscript",argv[1]))&&(argc == 4))
    {
    char    *temp0;
    bool   temp1;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi ? true : false;
    if (!error)
    {
    temp20 = (op)->EvalRscript(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("OutputBuffer",argv[1]))&&(argc == 4))
    {
    char    *temp0;
    int      temp1;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (!error)
    {
    temp20 = (op)->OutputBuffer(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("AssignVTKDataArrayToRVariable",argv[1]))&&(argc == 4))
    {
    vtkDataArray  *temp0;
    char    *temp1;
    error = 0;

    temp0 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataArray"),interp,error));
    temp1 = argv[3];
    if (!error)
    {
    op->AssignVTKDataArrayToRVariable(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("AssignVTKArrayToRVariable",argv[1]))&&(argc == 4))
    {
    vtkArray  *temp0;
    char    *temp1;
    error = 0;

    temp0 = (vtkArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkArray"),interp,error));
    temp1 = argv[3];
    if (!error)
    {
    op->AssignVTKArrayToRVariable(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("AssignVTKTreeToRVariable",argv[1]))&&(argc == 4))
    {
    vtkTree  *temp0;
    char    *temp1;
    error = 0;

    temp0 = (vtkTree *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTree"),interp,error));
    temp1 = argv[3];
    if (!error)
    {
    op->AssignVTKTreeToRVariable(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("AssignRVariableToVTKTree",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    vtkTree  *temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->AssignRVariableToVTKTree(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTree");
    return TCL_OK;
    }
    }
  if ((!strcmp("AssignRVariableToVTKDataArray",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    vtkDataArray  *temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->AssignRVariableToVTKDataArray(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDataArray");
    return TCL_OK;
    }
    }
  if ((!strcmp("AssignRVariableToVTKArray",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    vtkArray  *temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->AssignRVariableToVTKArray(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkArray");
    return TCL_OK;
    }
    }
  if ((!strcmp("AssignRVariableToVTKTable",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    vtkTable  *temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->AssignRVariableToVTKTable(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTable");
    return TCL_OK;
    }
    }
  if ((!strcmp("AssignVTKTableToRVariable",argv[1]))&&(argc == 4))
    {
    vtkTable  *temp0;
    char    *temp1;
    error = 0;

    temp0 = (vtkTable *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTable"),interp,error));
    temp1 = argv[3];
    if (!error)
    {
    op->AssignVTKTableToRVariable(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkRInterfaceCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkRInterface:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  EvalRcommand\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  EvalRscript\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  OutputBuffer\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  AssignVTKDataArrayToRVariable\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  AssignVTKArrayToRVariable\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  AssignVTKTreeToRVariable\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  AssignRVariableToVTKTree\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  AssignRVariableToVTKDataArray\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  AssignRVariableToVTKArray\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  AssignRVariableToVTKTable\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  AssignVTKTableToRVariable\t with 2 args\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "EvalRcommand" );
    Tcl_DStringAppendElement ( &dString, "EvalRscript" );
    Tcl_DStringAppendElement ( &dString, "OutputBuffer" );
    Tcl_DStringAppendElement ( &dString, "AssignVTKDataArrayToRVariable" );
    Tcl_DStringAppendElement ( &dString, "AssignVTKArrayToRVariable" );
    Tcl_DStringAppendElement ( &dString, "AssignVTKTreeToRVariable" );
    Tcl_DStringAppendElement ( &dString, "AssignRVariableToVTKTree" );
    Tcl_DStringAppendElement ( &dString, "AssignRVariableToVTKDataArray" );
    Tcl_DStringAppendElement ( &dString, "AssignRVariableToVTKArray" );
    Tcl_DStringAppendElement ( &dString, "AssignRVariableToVTKTable" );
    Tcl_DStringAppendElement ( &dString, "AssignVTKTableToRVariable" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkObjectCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkRInterface *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: EvalRcommand */
    if ( strcmp ( argv[2], "EvalRcommand" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "EvalRcommand" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for EvalRcommand */
    Tcl_DStringAppendElement ( &dString, " Evaluate an R command on the embedded R interpreter that takes one integer argument.\n" );
    Tcl_DStringAppendElement ( &dString, "int EvalRcommand(const char *commandName, int param);" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for EvalRcommand */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: EvalRscript */
    if ( strcmp ( argv[2], "EvalRscript" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "EvalRscript" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for EvalRscript */
    Tcl_DStringAppendElement ( &dString, " Evaluate an R script given in string on the embedded R interpreter.  Set showRoutput\n to turn on and off output from R.\n" );
    Tcl_DStringAppendElement ( &dString, "int EvalRscript(const char *string, bool showRoutput=true);" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for EvalRscript */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: OutputBuffer */
    if ( strcmp ( argv[2], "OutputBuffer" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "OutputBuffer" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for OutputBuffer */
    Tcl_DStringAppendElement ( &dString, " Provide a character buffer in p of length n.  All output from the R interpreter instance\n will be written to p by default.\n" );
    Tcl_DStringAppendElement ( &dString, "int OutputBuffer(char *p, int n);" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for OutputBuffer */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: AssignVTKDataArrayToRVariable */
    if ( strcmp ( argv[2], "AssignVTKDataArrayToRVariable" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AssignVTKDataArrayToRVariable" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AssignVTKDataArrayToRVariable */
    Tcl_DStringAppendElement ( &dString, " Copies vtkDataArray da into the R interpreter instance as a variable named RVariableName.\n If RVariableName already exists, it will be overwritten.\n" );
    Tcl_DStringAppendElement ( &dString, "void AssignVTKDataArrayToRVariable(vtkDataArray *da, const char *RVariableName);" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for AssignVTKDataArrayToRVariable */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: AssignVTKArrayToRVariable */
    if ( strcmp ( argv[2], "AssignVTKArrayToRVariable" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AssignVTKArrayToRVariable" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkArray" );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AssignVTKArrayToRVariable */
    Tcl_DStringAppendElement ( &dString, " Copies vtkArray da into the R interpreter instance as a variable named RVariableName.\n If RVariableName already exists, it will be overwritten.\n" );
    Tcl_DStringAppendElement ( &dString, "void AssignVTKArrayToRVariable(vtkArray *da, const char *RVariableName);" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for AssignVTKArrayToRVariable */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: AssignVTKTreeToRVariable */
    if ( strcmp ( argv[2], "AssignVTKTreeToRVariable" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AssignVTKTreeToRVariable" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTree" );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AssignVTKTreeToRVariable */
    Tcl_DStringAppendElement ( &dString, " Copies vtkTree tr into the R interpreter instance as a variable named RVariableName.\n If RVariableName already exists, it will be overwritten.\n" );
    Tcl_DStringAppendElement ( &dString, "void AssignVTKTreeToRVariable(vtkTree *tr, const char *RVariableName);" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for AssignVTKTreeToRVariable */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: AssignRVariableToVTKTree */
    if ( strcmp ( argv[2], "AssignRVariableToVTKTree" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AssignRVariableToVTKTree" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AssignRVariableToVTKTree */
    Tcl_DStringAppendElement ( &dString, " Copies the R variable RVariableName to the returned vtkDataArray.  If the operation fails,\n the method will return NULL.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkTree *AssignRVariableToVTKTree(const char *RVariableName);" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for AssignRVariableToVTKTree */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: AssignRVariableToVTKDataArray */
    if ( strcmp ( argv[2], "AssignRVariableToVTKDataArray" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AssignRVariableToVTKDataArray" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AssignRVariableToVTKDataArray */
    Tcl_DStringAppendElement ( &dString, " Copies the R variable RVariableName to the returned vtkDataArray.  If the operation fails,\n the method will return NULL.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray *AssignRVariableToVTKDataArray(const char *RVariableName);" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for AssignRVariableToVTKDataArray */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: AssignRVariableToVTKArray */
    if ( strcmp ( argv[2], "AssignRVariableToVTKArray" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AssignRVariableToVTKArray" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AssignRVariableToVTKArray */
    Tcl_DStringAppendElement ( &dString, " Copies the R variable RVariableName to the returned vtkArray.  If the operation fails,\n the method will return NULL.  The returned vtkArray is currently always a vtkDenseArray\n of type double.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkArray *AssignRVariableToVTKArray(const char *RVariableName);" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for AssignRVariableToVTKArray */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: AssignRVariableToVTKTable */
    if ( strcmp ( argv[2], "AssignRVariableToVTKTable" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AssignRVariableToVTKTable" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AssignRVariableToVTKTable */
    Tcl_DStringAppendElement ( &dString, " Copies the R matrix or R list in RVariableName to the returned vtkTable.  If the operation fails,\n the method will return NULL.  If RVariableName is an R list, each list entry must be a vector of\n the same length.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkTable *AssignRVariableToVTKTable(const char *RVariableName);" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for AssignRVariableToVTKTable */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: AssignVTKTableToRVariable */
    if ( strcmp ( argv[2], "AssignVTKTableToRVariable" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AssignVTKTableToRVariable" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTable" );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AssignVTKTableToRVariable */
    Tcl_DStringAppendElement ( &dString, " Copies the vtkTable given in table to an R list structure name RVariableName.  The R list\n will be length of the number of columns in table.  Each member of the list will contain a\n column of table.\n" );
    Tcl_DStringAppendElement ( &dString, "void AssignVTKTableToRVariable(vtkTable *table, const char *RVariableName);" );
    Tcl_DStringAppendElement ( &dString, "vtkRInterface" );
    /* Closing for AssignVTKTableToRVariable */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
