// tcl wrapper for vtkAMRDataSetCache object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkAMRDataSetCache.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkAMRDataSetCacheNewCommand()
{
  vtkAMRDataSetCache *temp = vtkAMRDataSetCache::New();
  return static_cast<ClientData>(temp);
}

int vtkObjectCppCommand(vtkObject *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkAMRDataSetCacheCppCommand(vtkAMRDataSetCache *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkAMRDataSetCacheCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkAMRDataSetCacheCppCommand(static_cast<vtkAMRDataSetCache *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkAMRDataSetCache_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkAMRDataSetCache"),vtkAMRDataSetCacheNewCommand,vtkAMRDataSetCacheCommand);
  return 0;
}

int VTKTCL_EXPORT vtkAMRDataSetCacheCppCommand(vtkAMRDataSetCache *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkAMRDataSetCache",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkObject"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkAMRDataSetCache  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAMRDataSetCache");
    return TCL_OK;
    }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkAMRDataSetCache  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAMRDataSetCache");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkAMRDataSetCache  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAMRDataSetCache");
    return TCL_OK;
    }
    }
  if ((!strcmp("InsertAMRBlock",argv[1]))&&(argc == 4))
    {
    int      temp0;
    vtkUniformGrid  *temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = (vtkUniformGrid *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkUniformGrid"),interp,error));
    if (!error)
    {
    op->InsertAMRBlock(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("InsertAMRBlockPointData",argv[1]))&&(argc == 4))
    {
    int      temp0;
    vtkDataArray  *temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkDataArray"),interp,error));
    if (!error)
    {
    op->InsertAMRBlockPointData(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("InsertAMRBlockCellData",argv[1]))&&(argc == 4))
    {
    int      temp0;
    vtkDataArray  *temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkDataArray"),interp,error));
    if (!error)
    {
    op->InsertAMRBlockCellData(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetAMRBlockCellData",argv[1]))&&(argc == 4))
    {
    int      temp0;
    char    *temp1;
    vtkDataArray  *temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = argv[3];
    if (!error)
    {
    temp20 = (op)->GetAMRBlockCellData(temp0,temp1);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDataArray");
    return TCL_OK;
    }
    }
  if ((!strcmp("GetAMRBlockPointData",argv[1]))&&(argc == 4))
    {
    int      temp0;
    char    *temp1;
    vtkDataArray  *temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = argv[3];
    if (!error)
    {
    temp20 = (op)->GetAMRBlockPointData(temp0,temp1);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDataArray");
    return TCL_OK;
    }
    }
  if ((!strcmp("GetAMRBlock",argv[1]))&&(argc == 3))
    {
    int      temp0;
    vtkUniformGrid  *temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    temp20 = (op)->GetAMRBlock(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkUniformGrid");
    return TCL_OK;
    }
    }
  if ((!strcmp("HasAMRBlockCellData",argv[1]))&&(argc == 4))
    {
    int      temp0;
    char    *temp1;
    bool   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = argv[3];
    if (!error)
    {
    temp20 = (op)->HasAMRBlockCellData(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("HasAMRBlockPointData",argv[1]))&&(argc == 4))
    {
    int      temp0;
    char    *temp1;
    bool   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = argv[3];
    if (!error)
    {
    temp20 = (op)->HasAMRBlockPointData(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("HasAMRBlock",argv[1]))&&(argc == 3))
    {
    int      temp0;
    bool   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    temp20 = (op)->HasAMRBlock(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkAMRDataSetCacheCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkAMRDataSetCache:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  InsertAMRBlock\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  InsertAMRBlockPointData\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  InsertAMRBlockCellData\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetAMRBlockCellData\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetAMRBlockPointData\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetAMRBlock\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  HasAMRBlockCellData\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  HasAMRBlockPointData\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  HasAMRBlock\t with 1 arg\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "InsertAMRBlock" );
    Tcl_DStringAppendElement ( &dString, "InsertAMRBlockPointData" );
    Tcl_DStringAppendElement ( &dString, "InsertAMRBlockCellData" );
    Tcl_DStringAppendElement ( &dString, "GetAMRBlockCellData" );
    Tcl_DStringAppendElement ( &dString, "GetAMRBlockPointData" );
    Tcl_DStringAppendElement ( &dString, "GetAMRBlock" );
    Tcl_DStringAppendElement ( &dString, "HasAMRBlockCellData" );
    Tcl_DStringAppendElement ( &dString, "HasAMRBlockPointData" );
    Tcl_DStringAppendElement ( &dString, "HasAMRBlock" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkObjectCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkAMRDataSetCache *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: InsertAMRBlock */
    if ( strcmp ( argv[2], "InsertAMRBlock" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "InsertAMRBlock" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "vtkUniformGrid" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for InsertAMRBlock */
    Tcl_DStringAppendElement ( &dString, " Inserts an AMR block to the cache\n" );
    Tcl_DStringAppendElement ( &dString, "void InsertAMRBlock(int compositeIdx, vtkUniformGrid *amrGrid);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for InsertAMRBlock */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: InsertAMRBlockPointData */
    if ( strcmp ( argv[2], "InsertAMRBlockPointData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "InsertAMRBlockPointData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for InsertAMRBlockPointData */
    Tcl_DStringAppendElement ( &dString, " Inserts a point data array to an already cached block\n NOTE: this->HasAMRBlock( compositeIdx ) == true\n" );
    Tcl_DStringAppendElement ( &dString, "void InsertAMRBlockPointData(int compositeIdx, vtkDataArray *dataArray);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for InsertAMRBlockPointData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: InsertAMRBlockCellData */
    if ( strcmp ( argv[2], "InsertAMRBlockCellData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "InsertAMRBlockCellData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for InsertAMRBlockCellData */
    Tcl_DStringAppendElement ( &dString, " Inserts a cell data array to an already cached block\n NOTE: this->HasAMRBlock( compositeIdx ) == true\n" );
    Tcl_DStringAppendElement ( &dString, "void InsertAMRBlockCellData(int compositeIdx, vtkDataArray *dataArray);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for InsertAMRBlockCellData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetAMRBlockCellData */
    if ( strcmp ( argv[2], "GetAMRBlockCellData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAMRBlockCellData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAMRBlockCellData */
    Tcl_DStringAppendElement ( &dString, " Given the name of the cell array and AMR block composite index, this\n method returns a pointer to the cell data array.\n NOTE: Null is returned if the cell array and/or block is not cached.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray *GetAMRBlockCellData(int compositeIdx, const char *dataName);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for GetAMRBlockCellData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetAMRBlockPointData */
    if ( strcmp ( argv[2], "GetAMRBlockPointData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAMRBlockPointData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAMRBlockPointData */
    Tcl_DStringAppendElement ( &dString, " Given the name of the point array and AMR block composite index, this\n method returns a pointer to the point data array.\n NOTE: Null is returend if the point array and /or block is not cached.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray *GetAMRBlockPointData(int compositeIdx, const char *dataName);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for GetAMRBlockPointData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetAMRBlock */
    if ( strcmp ( argv[2], "GetAMRBlock" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAMRBlock" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAMRBlock */
    Tcl_DStringAppendElement ( &dString, " Given the composite index, this method returns the AMR block.\n NOTE: Null is returned if the AMR block does not exist in the cache.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkUniformGrid *GetAMRBlock(int compositeIdx);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for GetAMRBlock */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: HasAMRBlockCellData */
    if ( strcmp ( argv[2], "HasAMRBlockCellData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HasAMRBlockCellData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HasAMRBlockCellData */
    Tcl_DStringAppendElement ( &dString, " Checks if the cell data array, associated with the provided name, has\n been cached for the AMR block with the given composite index.\n" );
    Tcl_DStringAppendElement ( &dString, "bool HasAMRBlockCellData(int compositeIdx, const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for HasAMRBlockCellData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: HasAMRBlockPointData */
    if ( strcmp ( argv[2], "HasAMRBlockPointData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HasAMRBlockPointData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HasAMRBlockPointData */
    Tcl_DStringAppendElement ( &dString, " Checks if the point data array, associated with the provided name, has\n been cached for the AMR block with the given composite index.\n" );
    Tcl_DStringAppendElement ( &dString, "bool HasAMRBlockPointData(int compositeIdx, const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for HasAMRBlockPointData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: HasAMRBlock */
    if ( strcmp ( argv[2], "HasAMRBlock" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HasAMRBlock" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HasAMRBlock */
    Tcl_DStringAppendElement ( &dString, " Checks if the AMR block associated with the given composite is cached.\n" );
    Tcl_DStringAppendElement ( &dString, "bool HasAMRBlock(const int compositeIdx);" );
    Tcl_DStringAppendElement ( &dString, "vtkAMRDataSetCache" );
    /* Closing for HasAMRBlock */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
