#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkAbstractParticleWriter_TclCreate(Tcl_Interp *interp);
int vtkArrayReader_TclCreate(Tcl_Interp *interp);
int vtkArrayWriter_TclCreate(Tcl_Interp *interp);
int vtkASCIITextCodec_TclCreate(Tcl_Interp *interp);
int vtkBase64InputStream_TclCreate(Tcl_Interp *interp);
int vtkBase64OutputStream_TclCreate(Tcl_Interp *interp);
int vtkBase64Utilities_TclCreate(Tcl_Interp *interp);
int vtkDataCompressor_TclCreate(Tcl_Interp *interp);
int vtkDelimitedTextWriter_TclCreate(Tcl_Interp *interp);
int vtkGlobFileNames_TclCreate(Tcl_Interp *interp);
int vtkInputStream_TclCreate(Tcl_Interp *interp);
int vtkJavaScriptDataWriter_TclCreate(Tcl_Interp *interp);
int vtkOutputStream_TclCreate(Tcl_Interp *interp);
int vtkSortFileNames_TclCreate(Tcl_Interp *interp);
int vtkTextCodec_TclCreate(Tcl_Interp *interp);
int vtkTextCodecFactory_TclCreate(Tcl_Interp *interp);
int vtkUTF16TextCodec_TclCreate(Tcl_Interp *interp);
int vtkUTF8TextCodec_TclCreate(Tcl_Interp *interp);
int vtkAbstractPolyDataReader_TclCreate(Tcl_Interp *interp);
int vtkWriter_TclCreate(Tcl_Interp *interp);
int vtkZLibDataCompressor_TclCreate(Tcl_Interp *interp);
int vtkArrayDataReader_TclCreate(Tcl_Interp *interp);
int vtkArrayDataWriter_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkiocoretcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkiocoretcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkiocoretcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkiocoretcl_Init(interp);
}


int VTK_EXPORT Vtkiocoretcl_Init(Tcl_Interp *interp)
{

  vtkAbstractParticleWriter_TclCreate(interp);
  vtkArrayReader_TclCreate(interp);
  vtkArrayWriter_TclCreate(interp);
  vtkASCIITextCodec_TclCreate(interp);
  vtkBase64InputStream_TclCreate(interp);
  vtkBase64OutputStream_TclCreate(interp);
  vtkBase64Utilities_TclCreate(interp);
  vtkDataCompressor_TclCreate(interp);
  vtkDelimitedTextWriter_TclCreate(interp);
  vtkGlobFileNames_TclCreate(interp);
  vtkInputStream_TclCreate(interp);
  vtkJavaScriptDataWriter_TclCreate(interp);
  vtkOutputStream_TclCreate(interp);
  vtkSortFileNames_TclCreate(interp);
  vtkTextCodec_TclCreate(interp);
  vtkTextCodecFactory_TclCreate(interp);
  vtkUTF16TextCodec_TclCreate(interp);
  vtkUTF8TextCodec_TclCreate(interp);
  vtkAbstractPolyDataReader_TclCreate(interp);
  vtkWriter_TclCreate(interp);
  vtkZLibDataCompressor_TclCreate(interp);
  vtkArrayDataReader_TclCreate(interp);
  vtkArrayDataWriter_TclCreate(interp);
  char pkgName[]="vtkIOCoreTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
