#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkEnSight6BinaryReader_TclCreate(Tcl_Interp *interp);
int vtkEnSight6Reader_TclCreate(Tcl_Interp *interp);
int vtkEnSightGoldBinaryReader_TclCreate(Tcl_Interp *interp);
int vtkEnSightGoldReader_TclCreate(Tcl_Interp *interp);
int vtkEnSightMasterServerReader_TclCreate(Tcl_Interp *interp);
int vtkEnSightReader_TclCreate(Tcl_Interp *interp);
int vtkGenericEnSightReader_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkioensighttcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkioensighttcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkioensighttcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkioensighttcl_Init(interp);
}


int VTK_EXPORT Vtkioensighttcl_Init(Tcl_Interp *interp)
{

  vtkEnSight6BinaryReader_TclCreate(interp);
  vtkEnSight6Reader_TclCreate(interp);
  vtkEnSightGoldBinaryReader_TclCreate(interp);
  vtkEnSightGoldReader_TclCreate(interp);
  vtkEnSightMasterServerReader_TclCreate(interp);
  vtkEnSightReader_TclCreate(interp);
  vtkGenericEnSightReader_TclCreate(interp);
  char pkgName[]="vtkIOEnSightTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
