// tcl wrapper for vtkNIFTIImageWriter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkNIFTIImageWriter.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkNIFTIImageWriterNewCommand()
{
  vtkNIFTIImageWriter *temp = vtkNIFTIImageWriter::New();
  return static_cast<ClientData>(temp);
}

int vtkImageWriterCppCommand(vtkImageWriter *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkNIFTIImageWriterCppCommand(vtkNIFTIImageWriter *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkNIFTIImageWriterCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkNIFTIImageWriterCppCommand(static_cast<vtkNIFTIImageWriter *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkNIFTIImageWriter_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkNIFTIImageWriter"),vtkNIFTIImageWriterNewCommand,vtkNIFTIImageWriterCommand);
  return 0;
}

int VTKTCL_EXPORT vtkNIFTIImageWriterCppCommand(vtkNIFTIImageWriter *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkNIFTIImageWriter",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkImageWriterCppCommand(static_cast<vtkImageWriter *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkImageWriter"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkNIFTIImageWriter  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkNIFTIImageWriter");
    return TCL_OK;
    }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkNIFTIImageWriter  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkNIFTIImageWriter");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkNIFTIImageWriter  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkNIFTIImageWriter");
    return TCL_OK;
    }
    }
  if ((!strcmp("SetNIFTIVersion",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->SetNIFTIVersion(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetNIFTIVersion",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetNIFTIVersion();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetDescription",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    op->SetDescription(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetDescription",argv[1]))&&(argc == 2))
    {
    char    *temp20;
    temp20 = (op)->GetDescription();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("GetTimeDimension",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetTimeDimension();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetTimeDimension",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->SetTimeDimension(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetTimeSpacing",argv[1]))&&(argc == 2))
    {
    double   temp20;
    temp20 = (op)->GetTimeSpacing();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetTimeSpacing",argv[1]))&&(argc == 3))
    {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
    {
    op->SetTimeSpacing(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetRescaleSlope",argv[1]))&&(argc == 3))
    {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
    {
    op->SetRescaleSlope(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetRescaleSlope",argv[1]))&&(argc == 2))
    {
    double   temp20;
    temp20 = (op)->GetRescaleSlope();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetRescaleIntercept",argv[1]))&&(argc == 3))
    {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
    {
    op->SetRescaleIntercept(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetRescaleIntercept",argv[1]))&&(argc == 2))
    {
    double   temp20;
    temp20 = (op)->GetRescaleIntercept();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetPlanarRGB",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->GetPlanarRGB();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetPlanarRGB",argv[1]))&&(argc == 3))
    {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
    {
    op->SetPlanarRGB(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("PlanarRGBOn",argv[1]))&&(argc == 2))
    {
    op->PlanarRGBOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("PlanarRGBOff",argv[1]))&&(argc == 2))
    {
    op->PlanarRGBOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("SetQFac",argv[1]))&&(argc == 3))
    {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
    {
    op->SetQFac(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetQFac",argv[1]))&&(argc == 2))
    {
    double   temp20;
    temp20 = (op)->GetQFac();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetQFormMatrix",argv[1]))&&(argc == 3))
    {
    vtkMatrix4x4  *temp0;
    error = 0;

    temp0 = (vtkMatrix4x4 *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkMatrix4x4"),interp,error));
    if (!error)
    {
    op->SetQFormMatrix(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetQFormMatrix",argv[1]))&&(argc == 2))
    {
    vtkMatrix4x4  *temp20;
    temp20 = (op)->GetQFormMatrix();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMatrix4x4");
    return TCL_OK;
    }
  if ((!strcmp("SetSFormMatrix",argv[1]))&&(argc == 3))
    {
    vtkMatrix4x4  *temp0;
    error = 0;

    temp0 = (vtkMatrix4x4 *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkMatrix4x4"),interp,error));
    if (!error)
    {
    op->SetSFormMatrix(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetSFormMatrix",argv[1]))&&(argc == 2))
    {
    vtkMatrix4x4  *temp20;
    temp20 = (op)->GetSFormMatrix();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMatrix4x4");
    return TCL_OK;
    }
  if ((!strcmp("SetNIFTIHeader",argv[1]))&&(argc == 3))
    {
    vtkNIFTIImageHeader  *temp0;
    error = 0;

    temp0 = (vtkNIFTIImageHeader *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkNIFTIImageHeader"),interp,error));
    if (!error)
    {
    op->SetNIFTIHeader(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetNIFTIHeader",argv[1]))&&(argc == 2))
    {
    vtkNIFTIImageHeader  *temp20;
    temp20 = (op)->GetNIFTIHeader();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkNIFTIImageHeader");
    return TCL_OK;
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkNIFTIImageWriterCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkImageWriterCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkNIFTIImageWriter:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetNIFTIVersion\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNIFTIVersion\n",NULL);
    Tcl_AppendResult(interp,"  SetDescription\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDescription\n",NULL);
    Tcl_AppendResult(interp,"  GetTimeDimension\n",NULL);
    Tcl_AppendResult(interp,"  SetTimeDimension\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTimeSpacing\n",NULL);
    Tcl_AppendResult(interp,"  SetTimeSpacing\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetRescaleSlope\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRescaleSlope\n",NULL);
    Tcl_AppendResult(interp,"  SetRescaleIntercept\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRescaleIntercept\n",NULL);
    Tcl_AppendResult(interp,"  GetPlanarRGB\n",NULL);
    Tcl_AppendResult(interp,"  SetPlanarRGB\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  PlanarRGBOn\n",NULL);
    Tcl_AppendResult(interp,"  PlanarRGBOff\n",NULL);
    Tcl_AppendResult(interp,"  SetQFac\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetQFac\n",NULL);
    Tcl_AppendResult(interp,"  SetQFormMatrix\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetQFormMatrix\n",NULL);
    Tcl_AppendResult(interp,"  SetSFormMatrix\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSFormMatrix\n",NULL);
    Tcl_AppendResult(interp,"  SetNIFTIHeader\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNIFTIHeader\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkImageWriterCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetNIFTIVersion" );
    Tcl_DStringAppendElement ( &dString, "GetNIFTIVersion" );
    Tcl_DStringAppendElement ( &dString, "SetDescription" );
    Tcl_DStringAppendElement ( &dString, "GetDescription" );
    Tcl_DStringAppendElement ( &dString, "GetTimeDimension" );
    Tcl_DStringAppendElement ( &dString, "SetTimeDimension" );
    Tcl_DStringAppendElement ( &dString, "GetTimeSpacing" );
    Tcl_DStringAppendElement ( &dString, "SetTimeSpacing" );
    Tcl_DStringAppendElement ( &dString, "SetRescaleSlope" );
    Tcl_DStringAppendElement ( &dString, "GetRescaleSlope" );
    Tcl_DStringAppendElement ( &dString, "SetRescaleIntercept" );
    Tcl_DStringAppendElement ( &dString, "GetRescaleIntercept" );
    Tcl_DStringAppendElement ( &dString, "GetPlanarRGB" );
    Tcl_DStringAppendElement ( &dString, "SetPlanarRGB" );
    Tcl_DStringAppendElement ( &dString, "PlanarRGBOn" );
    Tcl_DStringAppendElement ( &dString, "PlanarRGBOff" );
    Tcl_DStringAppendElement ( &dString, "SetQFac" );
    Tcl_DStringAppendElement ( &dString, "GetQFac" );
    Tcl_DStringAppendElement ( &dString, "SetQFormMatrix" );
    Tcl_DStringAppendElement ( &dString, "GetQFormMatrix" );
    Tcl_DStringAppendElement ( &dString, "SetSFormMatrix" );
    Tcl_DStringAppendElement ( &dString, "GetSFormMatrix" );
    Tcl_DStringAppendElement ( &dString, "SetNIFTIHeader" );
    Tcl_DStringAppendElement ( &dString, "GetNIFTIHeader" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkImageWriterCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Static method for construction.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkNIFTIImageWriter *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, " Static method for construction.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, " Static method for construction.\n" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, " Static method for construction.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, " Static method for construction.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetNIFTIVersion */
    if ( strcmp ( argv[2], "SetNIFTIVersion" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNIFTIVersion" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNIFTIVersion */
    Tcl_DStringAppendElement ( &dString, " Set the version number for the NIfTI file format to use.\n This can be 1, 2, or 0 (the default).  If set to zero, then it\n will save as NIfTI version 1 unless SetNIFTIHeader() provided\n header information from a NIfTI version 2 file.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNIFTIVersion(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for SetNIFTIVersion */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetNIFTIVersion */
    if ( strcmp ( argv[2], "GetNIFTIVersion" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNIFTIVersion" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNIFTIVersion */
    Tcl_DStringAppendElement ( &dString, " Set the version number for the NIfTI file format to use.\n This can be 1, 2, or 0 (the default).  If set to zero, then it\n will save as NIfTI version 1 unless SetNIFTIHeader() provided\n header information from a NIfTI version 2 file.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNIFTIVersion();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for GetNIFTIVersion */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetDescription */
    if ( strcmp ( argv[2], "SetDescription" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDescription" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDescription */
    Tcl_DStringAppendElement ( &dString, " Set a short description (max 80 chars) of how the file was produced.\n The default description is \"VTKX.Y\" where X.Y is the VTK version.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDescription(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for SetDescription */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetDescription */
    if ( strcmp ( argv[2], "GetDescription" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDescription" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDescription */
    Tcl_DStringAppendElement ( &dString, " Set a short description (max 80 chars) of how the file was produced.\n The default description is \"VTKX.Y\" where X.Y is the VTK version.\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetDescription();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for GetDescription */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetTimeDimension */
    if ( strcmp ( argv[2], "GetTimeDimension" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTimeDimension" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTimeDimension */
    Tcl_DStringAppendElement ( &dString, " Set the time dimension to use in the NIFTI file (or zero if none).\n The number of components of the input data must be divisible by the time\n dimension if the time dimension is not set to zero.  The vector dimension\n will be set to the number of components divided by the time dimension.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetTimeDimension();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for GetTimeDimension */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetTimeDimension */
    if ( strcmp ( argv[2], "SetTimeDimension" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTimeDimension" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTimeDimension */
    Tcl_DStringAppendElement ( &dString, " Set the time dimension to use in the NIFTI file (or zero if none).\n The number of components of the input data must be divisible by the time\n dimension if the time dimension is not set to zero.  The vector dimension\n will be set to the number of components divided by the time dimension.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTimeDimension(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for SetTimeDimension */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetTimeSpacing */
    if ( strcmp ( argv[2], "GetTimeSpacing" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTimeSpacing" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTimeSpacing */
    Tcl_DStringAppendElement ( &dString, " Set the time dimension to use in the NIFTI file (or zero if none).\n The number of components of the input data must be divisible by the time\n dimension if the time dimension is not set to zero.  The vector dimension\n will be set to the number of components divided by the time dimension.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetTimeSpacing();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for GetTimeSpacing */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetTimeSpacing */
    if ( strcmp ( argv[2], "SetTimeSpacing" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTimeSpacing" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTimeSpacing */
    Tcl_DStringAppendElement ( &dString, " Set the time dimension to use in the NIFTI file (or zero if none).\n The number of components of the input data must be divisible by the time\n dimension if the time dimension is not set to zero.  The vector dimension\n will be set to the number of components divided by the time dimension.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTimeSpacing(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for SetTimeSpacing */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetRescaleSlope */
    if ( strcmp ( argv[2], "SetRescaleSlope" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRescaleSlope" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRescaleSlope */
    Tcl_DStringAppendElement ( &dString, " Set the slope and intercept for calibrating the scalar values.\n Other programs that read the NIFTI file can use the equation\n v = u*RescaleSlope + RescaleIntercept to rescale the data to\n real values.  If both the slope and the intercept are zero,\n then the SclSlope and SclIntercept in the header info provided\n via SetNIFTIHeader() are used instead.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRescaleSlope(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for SetRescaleSlope */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetRescaleSlope */
    if ( strcmp ( argv[2], "GetRescaleSlope" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRescaleSlope" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRescaleSlope */
    Tcl_DStringAppendElement ( &dString, " Set the slope and intercept for calibrating the scalar values.\n Other programs that read the NIFTI file can use the equation\n v = u*RescaleSlope + RescaleIntercept to rescale the data to\n real values.  If both the slope and the intercept are zero,\n then the SclSlope and SclIntercept in the header info provided\n via SetNIFTIHeader() are used instead.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRescaleSlope();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for GetRescaleSlope */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetRescaleIntercept */
    if ( strcmp ( argv[2], "SetRescaleIntercept" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRescaleIntercept" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRescaleIntercept */
    Tcl_DStringAppendElement ( &dString, " Set the slope and intercept for calibrating the scalar values.\n Other programs that read the NIFTI file can use the equation\n v = u*RescaleSlope + RescaleIntercept to rescale the data to\n real values.  If both the slope and the intercept are zero,\n then the SclSlope and SclIntercept in the header info provided\n via SetNIFTIHeader() are used instead.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRescaleIntercept(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for SetRescaleIntercept */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetRescaleIntercept */
    if ( strcmp ( argv[2], "GetRescaleIntercept" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRescaleIntercept" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRescaleIntercept */
    Tcl_DStringAppendElement ( &dString, " Set the slope and intercept for calibrating the scalar values.\n Other programs that read the NIFTI file can use the equation\n v = u*RescaleSlope + RescaleIntercept to rescale the data to\n real values.  If both the slope and the intercept are zero,\n then the SclSlope and SclIntercept in the header info provided\n via SetNIFTIHeader() are used instead.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRescaleIntercept();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for GetRescaleIntercept */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetPlanarRGB */
    if ( strcmp ( argv[2], "GetPlanarRGB" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPlanarRGB" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPlanarRGB */
    Tcl_DStringAppendElement ( &dString, " Write planar RGB (separate R, G, and B planes), rather than packed RGB.\n Use this option with extreme caution: the NIFTI standard requires RGB\n pixels to be packed.  The Analyze format, however, was used to store\n both planar RGB and packed RGB depending on the software, without any\n indication in the header about which convention was being used.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetPlanarRGB();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for GetPlanarRGB */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetPlanarRGB */
    if ( strcmp ( argv[2], "SetPlanarRGB" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPlanarRGB" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPlanarRGB */
    Tcl_DStringAppendElement ( &dString, " Write planar RGB (separate R, G, and B planes), rather than packed RGB.\n Use this option with extreme caution: the NIFTI standard requires RGB\n pixels to be packed.  The Analyze format, however, was used to store\n both planar RGB and packed RGB depending on the software, without any\n indication in the header about which convention was being used.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPlanarRGB(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for SetPlanarRGB */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: PlanarRGBOn */
    if ( strcmp ( argv[2], "PlanarRGBOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PlanarRGBOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PlanarRGBOn */
    Tcl_DStringAppendElement ( &dString, " Write planar RGB (separate R, G, and B planes), rather than packed RGB.\n Use this option with extreme caution: the NIFTI standard requires RGB\n pixels to be packed.  The Analyze format, however, was used to store\n both planar RGB and packed RGB depending on the software, without any\n indication in the header about which convention was being used.\n" );
    Tcl_DStringAppendElement ( &dString, "void PlanarRGBOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for PlanarRGBOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: PlanarRGBOff */
    if ( strcmp ( argv[2], "PlanarRGBOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PlanarRGBOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PlanarRGBOff */
    Tcl_DStringAppendElement ( &dString, " Write planar RGB (separate R, G, and B planes), rather than packed RGB.\n Use this option with extreme caution: the NIFTI standard requires RGB\n pixels to be packed.  The Analyze format, however, was used to store\n both planar RGB and packed RGB depending on the software, without any\n indication in the header about which convention was being used.\n" );
    Tcl_DStringAppendElement ( &dString, "void PlanarRGBOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for PlanarRGBOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetQFac */
    if ( strcmp ( argv[2], "SetQFac" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetQFac" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetQFac */
    Tcl_DStringAppendElement ( &dString, " The QFac sets the ordering of the slices in the NIFTI file.\n If QFac is -1, then the slice ordering in the file will be reversed\n as compared to VTK. Use with caution.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetQFac(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for SetQFac */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetQFac */
    if ( strcmp ( argv[2], "GetQFac" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetQFac" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetQFac */
    Tcl_DStringAppendElement ( &dString, " The QFac sets the ordering of the slices in the NIFTI file.\n If QFac is -1, then the slice ordering in the file will be reversed\n as compared to VTK. Use with caution.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetQFac();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for GetQFac */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetQFormMatrix */
    if ( strcmp ( argv[2], "SetQFormMatrix" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetQFormMatrix" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkMatrix4x4" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetQFormMatrix */
    Tcl_DStringAppendElement ( &dString, " Set the \"qform\" orientation and offset for the image data.\n The 3x3 portion of the matrix must be orthonormal and have a\n positive determinant, it will be used to compute the quaternion.\n The last column of the matrix will be used for the offset.\n In the NIFTI header, the qform_code will be set to 1.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetQFormMatrix(vtkMatrix4x4 *);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for SetQFormMatrix */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetQFormMatrix */
    if ( strcmp ( argv[2], "GetQFormMatrix" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetQFormMatrix" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetQFormMatrix */
    Tcl_DStringAppendElement ( &dString, " Set the \"qform\" orientation and offset for the image data.\n The 3x3 portion of the matrix must be orthonormal and have a\n positive determinant, it will be used to compute the quaternion.\n The last column of the matrix will be used for the offset.\n In the NIFTI header, the qform_code will be set to 1.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkMatrix4x4 *GetQFormMatrix();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for GetQFormMatrix */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetSFormMatrix */
    if ( strcmp ( argv[2], "SetSFormMatrix" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSFormMatrix" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkMatrix4x4" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSFormMatrix */
    Tcl_DStringAppendElement ( &dString, " Set a matrix for the \"sform\" transformation stored in the file.\n Unlike the qform matrix, the sform matrix can contain scaling\n information.  Before being stored in the NIFTI header, the\n first three columns of the matrix will be multipled by the voxel\n spacing. In the NIFTI header, the sform_code will be set to 2.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSFormMatrix(vtkMatrix4x4 *);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for SetSFormMatrix */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetSFormMatrix */
    if ( strcmp ( argv[2], "GetSFormMatrix" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSFormMatrix" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSFormMatrix */
    Tcl_DStringAppendElement ( &dString, " Set a matrix for the \"sform\" transformation stored in the file.\n Unlike the qform matrix, the sform matrix can contain scaling\n information.  Before being stored in the NIFTI header, the\n first three columns of the matrix will be multipled by the voxel\n spacing. In the NIFTI header, the sform_code will be set to 2.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkMatrix4x4 *GetSFormMatrix();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for GetSFormMatrix */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetNIFTIHeader */
    if ( strcmp ( argv[2], "SetNIFTIHeader" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNIFTIHeader" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageHeader" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNIFTIHeader */
    Tcl_DStringAppendElement ( &dString, " Set the NIFTI header information to use when writing the file.\n The data dimensions and pixdim from the supplied header will be\n ignored.  Likewise, the QForm and SForm information in the supplied\n header will be ignored if you have called SetQFormMatrix() or\n SetSFormMatrix() to provide the orientation information for the file.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNIFTIHeader(vtkNIFTIImageHeader *hdr);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for SetNIFTIHeader */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetNIFTIHeader */
    if ( strcmp ( argv[2], "GetNIFTIHeader" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNIFTIHeader" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNIFTIHeader */
    Tcl_DStringAppendElement ( &dString, " Set the NIFTI header information to use when writing the file.\n The data dimensions and pixdim from the supplied header will be\n ignored.  Likewise, the QForm and SForm information in the supplied\n header will be ignored if you have called SetQFormMatrix() or\n SetSFormMatrix() to provide the orientation information for the file.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageHeader *GetNIFTIHeader();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageWriter" );
    /* Closing for GetNIFTIHeader */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkImageWriterCppCommand(static_cast<vtkImageWriter *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
