#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkDatabaseToTableReader_TclCreate(Tcl_Interp *interp);
int vtkRowQuery_TclCreate(Tcl_Interp *interp);
int vtkRowQueryToTable_TclCreate(Tcl_Interp *interp);
int vtkSQLDatabase_TclCreate(Tcl_Interp *interp);
int vtkSQLDatabaseSchema_TclCreate(Tcl_Interp *interp);
int vtkSQLDatabaseTableSource_TclCreate(Tcl_Interp *interp);
int vtkSQLQuery_TclCreate(Tcl_Interp *interp);
int vtkTableToDatabaseWriter_TclCreate(Tcl_Interp *interp);
int vtkSQLiteDatabase_TclCreate(Tcl_Interp *interp);
int vtkSQLiteQuery_TclCreate(Tcl_Interp *interp);
int vtkSQLiteToTableReader_TclCreate(Tcl_Interp *interp);
int vtkTableToSQLiteWriter_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkiosqltcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkiosqltcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkiosqltcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkiosqltcl_Init(interp);
}


int VTK_EXPORT Vtkiosqltcl_Init(Tcl_Interp *interp)
{

  vtkDatabaseToTableReader_TclCreate(interp);
  vtkRowQuery_TclCreate(interp);
  vtkRowQueryToTable_TclCreate(interp);
  vtkSQLDatabase_TclCreate(interp);
  vtkSQLDatabaseSchema_TclCreate(interp);
  vtkSQLDatabaseTableSource_TclCreate(interp);
  vtkSQLQuery_TclCreate(interp);
  vtkTableToDatabaseWriter_TclCreate(interp);
  vtkSQLiteDatabase_TclCreate(interp);
  vtkSQLiteQuery_TclCreate(interp);
  vtkSQLiteToTableReader_TclCreate(interp);
  vtkTableToSQLiteWriter_TclCreate(interp);
  char pkgName[]="vtkIOSQLTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
