// java wrapper for vtkCheckerboardSplatter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkCheckerboardSplatter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkImageAlgorithm_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkCheckerboardSplatter_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkCheckerboardSplatter",dType)) { return me; }
  if ((res= vtkImageAlgorithm_Typecast(me,dType)) != NULL) { return res; }
  return NULL;
}


extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkCheckerboardSplatter_GetClassName_10(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  const char    *temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetClassName();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkCheckerboardSplatter *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetSampleDimensions_12(JNIEnv *env, jobject obj,jint id0,jint id1,jint id2)
{
  vtkCheckerboardSplatter *op;
  int      temp0;
  int      temp1;
  int      temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetSampleDimensions(temp0,temp1,temp2);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetSampleDimensions_13(JNIEnv *env, jobject obj,jintArray id0)
{
  vtkCheckerboardSplatter *op;
  int    temp0[3];
  void *tempArray0;
  tempArray0 = (void *)(env->GetIntArrayElements(id0,NULL));
  temp0[0] = ((jint *)tempArray0)[0];
  temp0[1] = ((jint *)tempArray0)[1];
  temp0[2] = ((jint *)tempArray0)[2];

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetSampleDimensions(temp0);
  ((jint *)tempArray0)[0] = temp0[0];
  ((jint *)tempArray0)[1] = temp0[1];
  ((jint *)tempArray0)[2] = temp0[2];
  env->ReleaseIntArrayElements(id0,(jint *)tempArray0,0);
}

extern "C" JNIEXPORT jarray  JNICALL Java_vtk_vtkCheckerboardSplatter_GetSampleDimensions_14(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int     *temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetSampleDimensions();
    return vtkJavaMakeJArrayOfIntFromInt(env,temp20,3);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetModelBounds_15(JNIEnv *env, jobject obj,jdouble id0,jdouble id1,jdouble id2,jdouble id3,jdouble id4,jdouble id5)
{
  vtkCheckerboardSplatter *op;
  double   temp0;
  double   temp1;
  double   temp2;
  double   temp3;
  double   temp4;
  double   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetModelBounds(temp0,temp1,temp2,temp3,temp4,temp5);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetModelBounds_16(JNIEnv *env, jobject obj,jdoubleArray id0)
{
  vtkCheckerboardSplatter *op;
  double temp0[6];
  void *tempArray0;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,NULL));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];
  temp0[3] = ((jdouble *)tempArray0)[3];
  temp0[4] = ((jdouble *)tempArray0)[4];
  temp0[5] = ((jdouble *)tempArray0)[5];

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetModelBounds(temp0);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  ((jdouble *)tempArray0)[3] = temp0[3];
  ((jdouble *)tempArray0)[4] = temp0[4];
  ((jdouble *)tempArray0)[5] = temp0[5];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
}

extern "C" JNIEXPORT jarray  JNICALL Java_vtk_vtkCheckerboardSplatter_GetModelBounds_17(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  double  *temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetModelBounds();
    return vtkJavaMakeJArrayOfDoubleFromDouble(env,temp20,6);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetFootprint_18(JNIEnv *env, jobject obj,jint id0)
{
  vtkCheckerboardSplatter *op;
  int      temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetFootprint(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetFootprintMinValue_19(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFootprintMinValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetFootprintMaxValue_110(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFootprintMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetFootprint_111(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFootprint();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetRadius_112(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkCheckerboardSplatter *op;
  double   temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetRadius(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCheckerboardSplatter_GetRadiusMinValue_113(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  double   temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetRadiusMinValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCheckerboardSplatter_GetRadiusMaxValue_114(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  double   temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetRadiusMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCheckerboardSplatter_GetRadius_115(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  double   temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetRadius();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetScaleFactor_116(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkCheckerboardSplatter *op;
  double   temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetScaleFactor(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCheckerboardSplatter_GetScaleFactorMinValue_117(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  double   temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetScaleFactorMinValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCheckerboardSplatter_GetScaleFactorMaxValue_118(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  double   temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetScaleFactorMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCheckerboardSplatter_GetScaleFactor_119(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  double   temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetScaleFactor();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetExponentFactor_120(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkCheckerboardSplatter *op;
  double   temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetExponentFactor(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCheckerboardSplatter_GetExponentFactor_121(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  double   temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetExponentFactor();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetScalarWarping_122(JNIEnv *env, jobject obj,jint id0)
{
  vtkCheckerboardSplatter *op;
  int      temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetScalarWarping(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetScalarWarping_123(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetScalarWarping();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_ScalarWarpingOn_124(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->ScalarWarpingOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_ScalarWarpingOff_125(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->ScalarWarpingOff();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetNormalWarping_126(JNIEnv *env, jobject obj,jint id0)
{
  vtkCheckerboardSplatter *op;
  int      temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetNormalWarping(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetNormalWarping_127(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNormalWarping();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_NormalWarpingOn_128(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->NormalWarpingOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_NormalWarpingOff_129(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->NormalWarpingOff();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetEccentricity_130(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkCheckerboardSplatter *op;
  double   temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetEccentricity(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCheckerboardSplatter_GetEccentricityMinValue_131(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  double   temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetEccentricityMinValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCheckerboardSplatter_GetEccentricityMaxValue_132(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  double   temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetEccentricityMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCheckerboardSplatter_GetEccentricity_133(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  double   temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetEccentricity();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetAccumulationMode_134(JNIEnv *env, jobject obj,jint id0)
{
  vtkCheckerboardSplatter *op;
  int      temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetAccumulationMode(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetAccumulationModeMinValue_135(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetAccumulationModeMinValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetAccumulationModeMaxValue_136(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetAccumulationModeMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetAccumulationMode_137(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetAccumulationMode();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetAccumulationModeToMin_138(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetAccumulationModeToMin();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetAccumulationModeToMax_139(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetAccumulationModeToMax();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetAccumulationModeToSum_140(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetAccumulationModeToSum();
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkCheckerboardSplatter_GetAccumulationModeAsString_141(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  const char    *temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetAccumulationModeAsString();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetOutputScalarType_142(JNIEnv *env, jobject obj,jint id0)
{
  vtkCheckerboardSplatter *op;
  int      temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetOutputScalarType(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetOutputScalarType_143(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetOutputScalarType();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetOutputScalarTypeToDouble_144(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetOutputScalarTypeToDouble();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetOutputScalarTypeToFloat_145(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetOutputScalarTypeToFloat();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetCapping_146(JNIEnv *env, jobject obj,jint id0)
{
  vtkCheckerboardSplatter *op;
  int      temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetCapping(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetCapping_147(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetCapping();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_CappingOn_148(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->CappingOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_CappingOff_149(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->CappingOff();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetCapValue_150(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkCheckerboardSplatter *op;
  double   temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetCapValue(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCheckerboardSplatter_GetCapValue_151(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  double   temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetCapValue();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetNullValue_152(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkCheckerboardSplatter *op;
  double   temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetNullValue(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCheckerboardSplatter_GetNullValue_153(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  double   temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNullValue();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetMaximumDimension_154(JNIEnv *env, jobject obj,jint id0)
{
  vtkCheckerboardSplatter *op;
  int      temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetMaximumDimension(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetMaximumDimensionMinValue_155(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetMaximumDimensionMinValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetMaximumDimensionMaxValue_156(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetMaximumDimensionMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetMaximumDimension_157(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetMaximumDimension();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_SetParallelSplatCrossover_158(JNIEnv *env, jobject obj,jint id0)
{
  vtkCheckerboardSplatter *op;
  int      temp0;
  temp0 = id0;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->SetParallelSplatCrossover(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetParallelSplatCrossoverMinValue_159(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetParallelSplatCrossoverMinValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetParallelSplatCrossoverMaxValue_160(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetParallelSplatCrossoverMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCheckerboardSplatter_GetParallelSplatCrossover_161(JNIEnv *env, jobject obj)
{
  vtkCheckerboardSplatter *op;
  int      temp20;

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetParallelSplatCrossover();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCheckerboardSplatter_ComputeModelBounds_162(JNIEnv *env, jobject obj,jobject id0,jobject id1,jobject id2)
{
  vtkCheckerboardSplatter *op;
  vtkDataSet  *temp0;
  vtkImageData  *temp1;
  vtkInformation  *temp2;
  temp0 = (vtkDataSet *)(vtkJavaGetPointerFromObject(env,id0));
  temp1 = (vtkImageData *)(vtkJavaGetPointerFromObject(env,id1));
  temp2 = (vtkInformation *)(vtkJavaGetPointerFromObject(env,id2));

  op = (vtkCheckerboardSplatter *)vtkJavaGetPointerFromObject(env,obj);
  op->ComputeModelBounds(temp0,temp1,temp2);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkCheckerboardSplatter_VTKInit(JNIEnv *, jobject)
{
  vtkCheckerboardSplatter *aNewOne = vtkCheckerboardSplatter::New();
  return (jlong)(size_t)(void*)aNewOne;
}
