#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkBooleanTexture_TclCreate(Tcl_Interp *interp);
int vtkShepardMethod_TclCreate(Tcl_Interp *interp);
int vtkVoxelModeller_TclCreate(Tcl_Interp *interp);
int vtkSurfaceReconstructionFilter_TclCreate(Tcl_Interp *interp);
int vtkFastSplatter_TclCreate(Tcl_Interp *interp);
int vtkGaussianSplatter_TclCreate(Tcl_Interp *interp);
int vtkCheckerboardSplatter_TclCreate(Tcl_Interp *interp);
int vtkSampleFunction_TclCreate(Tcl_Interp *interp);
int vtkPointLoad_TclCreate(Tcl_Interp *interp);
int vtkImageCursor3D_TclCreate(Tcl_Interp *interp);
int vtkImageRectilinearWipe_TclCreate(Tcl_Interp *interp);
int vtkTriangularTexture_TclCreate(Tcl_Interp *interp);
int vtkSliceCubes_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkimaginghybridtcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkimaginghybridtcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkimaginghybridtcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkimaginghybridtcl_Init(interp);
}


int VTK_EXPORT Vtkimaginghybridtcl_Init(Tcl_Interp *interp)
{

  vtkBooleanTexture_TclCreate(interp);
  vtkShepardMethod_TclCreate(interp);
  vtkVoxelModeller_TclCreate(interp);
  vtkSurfaceReconstructionFilter_TclCreate(interp);
  vtkFastSplatter_TclCreate(interp);
  vtkGaussianSplatter_TclCreate(interp);
  vtkCheckerboardSplatter_TclCreate(interp);
  vtkSampleFunction_TclCreate(interp);
  vtkPointLoad_TclCreate(interp);
  vtkImageCursor3D_TclCreate(interp);
  vtkImageRectilinearWipe_TclCreate(interp);
  vtkTriangularTexture_TclCreate(interp);
  vtkSliceCubes_TclCreate(interp);
  char pkgName[]="vtkImagingHybridTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
