#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkImageConnector_TclCreate(Tcl_Interp *interp);
int vtkImageContinuousDilate3D_TclCreate(Tcl_Interp *interp);
int vtkImageContinuousErode3D_TclCreate(Tcl_Interp *interp);
int vtkImageDilateErode3D_TclCreate(Tcl_Interp *interp);
int vtkImageIslandRemoval2D_TclCreate(Tcl_Interp *interp);
int vtkImageNonMaximumSuppression_TclCreate(Tcl_Interp *interp);
int vtkImageOpenClose3D_TclCreate(Tcl_Interp *interp);
int vtkImageSeedConnectivity_TclCreate(Tcl_Interp *interp);
int vtkImageSkeleton2D_TclCreate(Tcl_Interp *interp);
int vtkImageThresholdConnectivity_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkimagingmorphologicaltcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkimagingmorphologicaltcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkimagingmorphologicaltcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkimagingmorphologicaltcl_Init(interp);
}


int VTK_EXPORT Vtkimagingmorphologicaltcl_Init(Tcl_Interp *interp)
{

  vtkImageConnector_TclCreate(interp);
  vtkImageContinuousDilate3D_TclCreate(interp);
  vtkImageContinuousErode3D_TclCreate(interp);
  vtkImageDilateErode3D_TclCreate(interp);
  vtkImageIslandRemoval2D_TclCreate(interp);
  vtkImageNonMaximumSuppression_TclCreate(interp);
  vtkImageOpenClose3D_TclCreate(interp);
  vtkImageSeedConnectivity_TclCreate(interp);
  vtkImageSkeleton2D_TclCreate(interp);
  vtkImageThresholdConnectivity_TclCreate(interp);
  char pkgName[]="vtkImagingMorphologicalTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
