// java wrapper for vtkMPICommunicator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkMPICommunicator.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkCommunicator_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkMPICommunicator_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkMPICommunicator",dType)) { return me; }
  if ((res= vtkCommunicator_Typecast(me,dType)) != NULL) { return res; }
  return NULL;
}


extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkMPICommunicator_GetClassName_10(JNIEnv *env, jobject obj)
{
  vtkMPICommunicator *op;
  const char    *temp20;

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetClassName();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMPICommunicator_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkMPICommunicator *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMPICommunicator_GetWorldCommunicator_12(JNIEnv *env, jobject obj)
{
  vtkMPICommunicator *op;
  vtkMPICommunicator  *temp20;

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetWorldCommunicator();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMPICommunicator_Initialize_13(JNIEnv *env, jobject obj,jobject id0)
{
  vtkMPICommunicator *op;
  vtkProcessGroup  *temp0;
  int      temp20;
  temp0 = (vtkProcessGroup *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->Initialize(temp0);
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMPICommunicator_SplitInitialize_14(JNIEnv *env, jobject obj,jobject id0,jint id1,jint id2)
{
  vtkMPICommunicator *op;
  vtkCommunicator  *temp0;
  int      temp1;
  int      temp2;
  int      temp20;
  temp0 = (vtkCommunicator *)(vtkJavaGetPointerFromObject(env,id0));
  temp1 = id1;
  temp2 = id2;

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->SplitInitialize(temp0,temp1,temp2);
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMPICommunicator_Barrier_15(JNIEnv *env, jobject obj)
{
  vtkMPICommunicator *op;

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  op->Barrier();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMPICommunicator_Free_16(JNIEnv *env, jobject obj,jstring id0)
{
  vtkMPICommunicator *op;
  char    *temp0;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  op->Free(temp0);
  delete[] temp0;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMPICommunicator_SetUseSsend_17(JNIEnv *env, jobject obj,jint id0)
{
  vtkMPICommunicator *op;
  int      temp0;
  temp0 = id0;

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  op->SetUseSsend(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMPICommunicator_GetUseSsendMinValue_18(JNIEnv *env, jobject obj)
{
  vtkMPICommunicator *op;
  int      temp20;

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetUseSsendMinValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMPICommunicator_GetUseSsendMaxValue_19(JNIEnv *env, jobject obj)
{
  vtkMPICommunicator *op;
  int      temp20;

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetUseSsendMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMPICommunicator_GetUseSsend_110(JNIEnv *env, jobject obj)
{
  vtkMPICommunicator *op;
  int      temp20;

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetUseSsend();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMPICommunicator_UseSsendOn_111(JNIEnv *env, jobject obj)
{
  vtkMPICommunicator *op;

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  op->UseSsendOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMPICommunicator_UseSsendOff_112(JNIEnv *env, jobject obj)
{
  vtkMPICommunicator *op;

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  op->UseSsendOff();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMPICommunicator_CopyFrom_113(JNIEnv *env, jobject obj,jobject id0)
{
  vtkMPICommunicator *op;
  vtkMPICommunicator  *temp0;
  temp0 = (vtkMPICommunicator *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkMPICommunicator *)vtkJavaGetPointerFromObject(env,obj);
  op->CopyFrom(temp0);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkMPICommunicator_VTKInit(JNIEnv *, jobject)
{
  vtkMPICommunicator *aNewOne = vtkMPICommunicator::New();
  return (jlong)(size_t)(void*)aNewOne;
}
