// tcl wrapper for vtkMPICommunicator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkMPICommunicator.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkMPICommunicatorNewCommand()
{
  vtkMPICommunicator *temp = vtkMPICommunicator::New();
  return static_cast<ClientData>(temp);
}

int vtkCommunicatorCppCommand(vtkCommunicator *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkMPICommunicatorCppCommand(vtkMPICommunicator *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkMPICommunicatorCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkMPICommunicatorCppCommand(static_cast<vtkMPICommunicator *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkMPICommunicator_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkMPICommunicator"),vtkMPICommunicatorNewCommand,vtkMPICommunicatorCommand);
  return 0;
}

int VTKTCL_EXPORT vtkMPICommunicatorCppCommand(vtkMPICommunicator *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkMPICommunicator",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkCommunicatorCppCommand(static_cast<vtkCommunicator *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkCommunicator"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkMPICommunicator  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMPICommunicator");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkMPICommunicator  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMPICommunicator");
    return TCL_OK;
    }
    }
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkMPICommunicator  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMPICommunicator");
    return TCL_OK;
    }
  if ((!strcmp("GetWorldCommunicator",argv[1]))&&(argc == 2))
    {
    vtkMPICommunicator  *temp20;
    temp20 = (op)->GetWorldCommunicator();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMPICommunicator");
    return TCL_OK;
    }
  if ((!strcmp("Initialize",argv[1]))&&(argc == 3))
    {
    vtkProcessGroup  *temp0;
    int      temp20;
    error = 0;

    temp0 = (vtkProcessGroup *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkProcessGroup"),interp,error));
    if (!error)
    {
    temp20 = (op)->Initialize(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("SplitInitialize",argv[1]))&&(argc == 5))
    {
    vtkCommunicator  *temp0;
    int      temp1;
    int      temp2;
    int      temp20;
    error = 0;

    temp0 = (vtkCommunicator *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkCommunicator"),interp,error));
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = tempi;
    if (!error)
    {
    temp20 = (op)->SplitInitialize(temp0,temp1,temp2);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("Barrier",argv[1]))&&(argc == 2))
    {
    op->Barrier();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("Free",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    op->Free(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetUseSsend",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->SetUseSsend(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetUseSsendMinValue",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetUseSsendMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetUseSsendMaxValue",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetUseSsendMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetUseSsend",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetUseSsend();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("UseSsendOn",argv[1]))&&(argc == 2))
    {
    op->UseSsendOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("UseSsendOff",argv[1]))&&(argc == 2))
    {
    op->UseSsendOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("CopyFrom",argv[1]))&&(argc == 3))
    {
    vtkMPICommunicator  *temp0;
    error = 0;

    temp0 = (vtkMPICommunicator *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkMPICommunicator"),interp,error));
    if (!error)
    {
    op->CopyFrom(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkMPICommunicatorCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkCommunicatorCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkMPICommunicator:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetWorldCommunicator\n",NULL);
    Tcl_AppendResult(interp,"  Initialize\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SplitInitialize\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  Barrier\n",NULL);
    Tcl_AppendResult(interp,"  Free\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetUseSsend\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetUseSsendMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetUseSsendMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetUseSsend\n",NULL);
    Tcl_AppendResult(interp,"  UseSsendOn\n",NULL);
    Tcl_AppendResult(interp,"  UseSsendOff\n",NULL);
    Tcl_AppendResult(interp,"  CopyFrom\t with 1 arg\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkCommunicatorCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetWorldCommunicator" );
    Tcl_DStringAppendElement ( &dString, "Initialize" );
    Tcl_DStringAppendElement ( &dString, "SplitInitialize" );
    Tcl_DStringAppendElement ( &dString, "Barrier" );
    Tcl_DStringAppendElement ( &dString, "Free" );
    Tcl_DStringAppendElement ( &dString, "SetUseSsend" );
    Tcl_DStringAppendElement ( &dString, "GetUseSsendMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetUseSsendMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetUseSsend" );
    Tcl_DStringAppendElement ( &dString, "UseSsendOn" );
    Tcl_DStringAppendElement ( &dString, "UseSsendOff" );
    Tcl_DStringAppendElement ( &dString, "CopyFrom" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkCommunicatorCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Creates an empty communicator.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkMPICommunicator *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetWorldCommunicator */
    if ( strcmp ( argv[2], "GetWorldCommunicator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetWorldCommunicator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetWorldCommunicator */
    Tcl_DStringAppendElement ( &dString, " Returns the singleton which behaves as the global\n communicator (MPI_COMM_WORLD)\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkMPICommunicator *GetWorldCommunicator();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for GetWorldCommunicator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: Initialize */
    if ( strcmp ( argv[2], "Initialize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Initialize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkProcessGroup" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Initialize */
    Tcl_DStringAppendElement ( &dString, " Used to initialize the communicator (i.e. create the underlying MPI_Comm).\n The group must be associated with a valid vtkMPICommunicator.\n" );
    Tcl_DStringAppendElement ( &dString, "int Initialize(vtkProcessGroup *group);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for Initialize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SplitInitialize */
    if ( strcmp ( argv[2], "SplitInitialize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SplitInitialize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkCommunicator" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SplitInitialize */
    Tcl_DStringAppendElement ( &dString, " Used to initialize the communicator (i.e. create the underlying MPI_Comm)\n using MPI_Comm_split on the given communicator. Return values are 1 for success\n and 0 otherwise.\n" );
    Tcl_DStringAppendElement ( &dString, "int SplitInitialize(vtkCommunicator *oldcomm, int color, int key);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for SplitInitialize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: Barrier */
    if ( strcmp ( argv[2], "Barrier" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Barrier" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Barrier */
    Tcl_DStringAppendElement ( &dString, " More efficient implementations of collective operations that use\n the equivalent MPI commands. Return values are 1 for success\n and 0 otherwise.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void Barrier();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for Barrier */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: Free */
    if ( strcmp ( argv[2], "Free" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Free" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Free */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static void Free(char *ptr);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for Free */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetUseSsend */
    if ( strcmp ( argv[2], "SetUseSsend" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetUseSsend" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetUseSsend */
    Tcl_DStringAppendElement ( &dString, " When set to 1, all MPI_Send calls are replaced by MPI_Ssend calls.\n Default is 0.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetUseSsend(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for SetUseSsend */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetUseSsendMinValue */
    if ( strcmp ( argv[2], "GetUseSsendMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetUseSsendMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetUseSsendMinValue */
    Tcl_DStringAppendElement ( &dString, " When set to 1, all MPI_Send calls are replaced by MPI_Ssend calls.\n Default is 0.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetUseSsendMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for GetUseSsendMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetUseSsendMaxValue */
    if ( strcmp ( argv[2], "GetUseSsendMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetUseSsendMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetUseSsendMaxValue */
    Tcl_DStringAppendElement ( &dString, " When set to 1, all MPI_Send calls are replaced by MPI_Ssend calls.\n Default is 0.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetUseSsendMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for GetUseSsendMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetUseSsend */
    if ( strcmp ( argv[2], "GetUseSsend" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetUseSsend" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetUseSsend */
    Tcl_DStringAppendElement ( &dString, " When set to 1, all MPI_Send calls are replaced by MPI_Ssend calls.\n Default is 0.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetUseSsend();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for GetUseSsend */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: UseSsendOn */
    if ( strcmp ( argv[2], "UseSsendOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UseSsendOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UseSsendOn */
    Tcl_DStringAppendElement ( &dString, " When set to 1, all MPI_Send calls are replaced by MPI_Ssend calls.\n Default is 0.\n" );
    Tcl_DStringAppendElement ( &dString, "void UseSsendOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for UseSsendOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: UseSsendOff */
    if ( strcmp ( argv[2], "UseSsendOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UseSsendOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UseSsendOff */
    Tcl_DStringAppendElement ( &dString, " When set to 1, all MPI_Send calls are replaced by MPI_Ssend calls.\n Default is 0.\n" );
    Tcl_DStringAppendElement ( &dString, "void UseSsendOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for UseSsendOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: CopyFrom */
    if ( strcmp ( argv[2], "CopyFrom" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "CopyFrom" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for CopyFrom */
    Tcl_DStringAppendElement ( &dString, " Copies all the attributes of source, deleting previously\n stored data. The MPI communicator handle is also copied.\n Normally, this should not be needed. It is used during\n the construction of a new communicator for copying the\n world communicator, keeping the same context.\n" );
    Tcl_DStringAppendElement ( &dString, "void CopyFrom(vtkMPICommunicator *source);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    /* Closing for CopyFrom */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkCommunicatorCppCommand(static_cast<vtkCommunicator *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
