// tcl wrapper for vtkMPIController object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkMPIController.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkMPIControllerNewCommand()
{
  vtkMPIController *temp = vtkMPIController::New();
  return static_cast<ClientData>(temp);
}

int vtkMultiProcessControllerCppCommand(vtkMultiProcessController *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkMPIControllerCppCommand(vtkMPIController *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkMPIControllerCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkMPIControllerCppCommand(static_cast<vtkMPIController *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkMPIController_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkMPIController"),vtkMPIControllerNewCommand,vtkMPIControllerCommand);
  return 0;
}

int VTKTCL_EXPORT vtkMPIControllerCppCommand(vtkMPIController *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkMPIController",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkMultiProcessControllerCppCommand(static_cast<vtkMultiProcessController *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkMultiProcessController"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkMPIController  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMPIController");
    return TCL_OK;
    }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkMPIController  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMPIController");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkMPIController  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMPIController");
    return TCL_OK;
    }
    }
  if ((!strcmp("Initialize",argv[1]))&&(argc == 2))
    {
    op->Initialize();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("Finalize",argv[1]))&&(argc == 2))
    {
    op->Finalize();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("Finalize",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->Finalize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("SingleMethodExecute",argv[1]))&&(argc == 2))
    {
    op->SingleMethodExecute();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("MultipleMethodExecute",argv[1]))&&(argc == 2))
    {
    op->MultipleMethodExecute();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("CreateOutputWindow",argv[1]))&&(argc == 2))
    {
    op->CreateOutputWindow();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("ErrorString",argv[1]))&&(argc == 3))
    {
    int      temp0;
    char    *temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    temp20 = (op)->ErrorString(temp0);
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
    }
  if ((!strcmp("SetCommunicator",argv[1]))&&(argc == 3))
    {
    vtkMPICommunicator  *temp0;
    error = 0;

    temp0 = (vtkMPICommunicator *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkMPICommunicator"),interp,error));
    if (!error)
    {
    op->SetCommunicator(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("CreateSubController",argv[1]))&&(argc == 3))
    {
    vtkProcessGroup  *temp0;
    vtkMPIController  *temp20;
    error = 0;

    temp0 = (vtkProcessGroup *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkProcessGroup"),interp,error));
    if (!error)
    {
    temp20 = (op)->CreateSubController(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMPIController");
    return TCL_OK;
    }
    }
  if ((!strcmp("PartitionController",argv[1]))&&(argc == 4))
    {
    int      temp0;
    int      temp1;
    vtkMPIController  *temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (!error)
    {
    temp20 = (op)->PartitionController(temp0,temp1);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMPIController");
    return TCL_OK;
    }
    }
  if ((!strcmp("GetProcessorName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetProcessorName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("SetUseSsendForRMI",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->SetUseSsendForRMI(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetUseSsendForRMI",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetUseSsendForRMI();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkMPIControllerCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkMultiProcessControllerCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkMPIController:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  Initialize\n",NULL);
    Tcl_AppendResult(interp,"  Finalize\n",NULL);
    Tcl_AppendResult(interp,"  Finalize\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SingleMethodExecute\n",NULL);
    Tcl_AppendResult(interp,"  MultipleMethodExecute\n",NULL);
    Tcl_AppendResult(interp,"  CreateOutputWindow\n",NULL);
    Tcl_AppendResult(interp,"  ErrorString\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetCommunicator\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  CreateSubController\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  PartitionController\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetProcessorName\n",NULL);
    Tcl_AppendResult(interp,"  SetUseSsendForRMI\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetUseSsendForRMI\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkMultiProcessControllerCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "Initialize" );
    Tcl_DStringAppendElement ( &dString, "Finalize" );
    Tcl_DStringAppendElement ( &dString, "Finalize" );
    Tcl_DStringAppendElement ( &dString, "SingleMethodExecute" );
    Tcl_DStringAppendElement ( &dString, "MultipleMethodExecute" );
    Tcl_DStringAppendElement ( &dString, "CreateOutputWindow" );
    Tcl_DStringAppendElement ( &dString, "ErrorString" );
    Tcl_DStringAppendElement ( &dString, "SetCommunicator" );
    Tcl_DStringAppendElement ( &dString, "CreateSubController" );
    Tcl_DStringAppendElement ( &dString, "PartitionController" );
    Tcl_DStringAppendElement ( &dString, "GetProcessorName" );
    Tcl_DStringAppendElement ( &dString, "SetUseSsendForRMI" );
    Tcl_DStringAppendElement ( &dString, "GetUseSsendForRMI" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkMultiProcessControllerCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkMPIController *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: Initialize */
    if ( strcmp ( argv[2], "Initialize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Initialize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Initialize */
    Tcl_DStringAppendElement ( &dString, " Same as Initialize(0, 0, 1). Mainly for calling from wrapped languages.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void Initialize();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for Initialize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: Finalize */
    if ( strcmp ( argv[2], "Finalize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Finalize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Finalize */
    Tcl_DStringAppendElement ( &dString, " This method is for cleaning up and has to be called before\n the end of the program if MPI was initialized with\nInitialize()\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void Finalize();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for Finalize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: Finalize */
    if ( strcmp ( argv[2], "Finalize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Finalize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Finalize */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "virtual void Finalize(int finalizedExternally);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for Finalize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SingleMethodExecute */
    if ( strcmp ( argv[2], "SingleMethodExecute" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SingleMethodExecute" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SingleMethodExecute */
    Tcl_DStringAppendElement ( &dString, " Execute the SingleMethod (as define by SetSingleMethod) using\n this->NumberOfProcesses processes.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SingleMethodExecute();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for SingleMethodExecute */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: MultipleMethodExecute */
    if ( strcmp ( argv[2], "MultipleMethodExecute" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "MultipleMethodExecute" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for MultipleMethodExecute */
    Tcl_DStringAppendElement ( &dString, " Execute the MultipleMethods (as define by calling SetMultipleMethod\n for each of the required this->NumberOfProcesses methods) using\n this->NumberOfProcesses processes.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void MultipleMethodExecute();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for MultipleMethodExecute */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: CreateOutputWindow */
    if ( strcmp ( argv[2], "CreateOutputWindow" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "CreateOutputWindow" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for CreateOutputWindow */
    Tcl_DStringAppendElement ( &dString, " This method can be used to tell the controller to create\n a special output window in which all messages are preceded\n by the process id.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void CreateOutputWindow();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for CreateOutputWindow */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: ErrorString */
    if ( strcmp ( argv[2], "ErrorString" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ErrorString" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ErrorString */
    Tcl_DStringAppendElement ( &dString, " Given an MPI error code, return a string which contains\n an error message. This string has to be freed by the user.\n" );
    Tcl_DStringAppendElement ( &dString, "static char *ErrorString(int err);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for ErrorString */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetCommunicator */
    if ( strcmp ( argv[2], "SetCommunicator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetCommunicator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkMPICommunicator" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetCommunicator */
    Tcl_DStringAppendElement ( &dString, " MPIController uses this communicator in all sends and\n receives. By default, MPI_COMM_WORLD is used.\n THIS SHOULD ONLY BE CALLED ON THE PROCESSES INCLUDED\n IN THE COMMUNICATOR. FOR EXAMPLE, IF THE COMMUNICATOR\n CONTAINS PROCESSES 0 AND 1, INVOKING THIS METHOD ON\n ANY OTHER PROCESS WILL CAUSE AN MPI ERROR AND POSSIBLY\n LEAD TO A CRASH.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetCommunicator(vtkMPICommunicator *comm);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for SetCommunicator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: CreateSubController */
    if ( strcmp ( argv[2], "CreateSubController" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "CreateSubController" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkProcessGroup" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for CreateSubController */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkMPIController *CreateSubController(vtkProcessGroup *group);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for CreateSubController */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: PartitionController */
    if ( strcmp ( argv[2], "PartitionController" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PartitionController" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PartitionController */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkMPIController *PartitionController(int localColor, int localKey);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for PartitionController */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetProcessorName */
    if ( strcmp ( argv[2], "GetProcessorName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetProcessorName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetProcessorName */
    Tcl_DStringAppendElement ( &dString, " Return true iff *one or more* of the communicator request objects is\n complete. The indices of the completed requests, w.r.t. the requests array,\n are given in the completed user-supplied vtkIntArray.\n" );
    Tcl_DStringAppendElement ( &dString, "static const char *GetProcessorName();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for GetProcessorName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetUseSsendForRMI */
    if ( strcmp ( argv[2], "SetUseSsendForRMI" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetUseSsendForRMI" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetUseSsendForRMI */
    Tcl_DStringAppendElement ( &dString, " When set to 1, TriggerRMI uses Ssend() instead of Send() calls.\n Off (0) by default.\n" );
    Tcl_DStringAppendElement ( &dString, "static void SetUseSsendForRMI(int use_send);" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for SetUseSsendForRMI */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetUseSsendForRMI */
    if ( strcmp ( argv[2], "GetUseSsendForRMI" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetUseSsendForRMI" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetUseSsendForRMI */
    Tcl_DStringAppendElement ( &dString, " When set to 1, TriggerRMI uses Ssend() instead of Send() calls.\n Off (0) by default.\n" );
    Tcl_DStringAppendElement ( &dString, "static int GetUseSsendForRMI();" );
    Tcl_DStringAppendElement ( &dString, "vtkMPIController" );
    /* Closing for GetUseSsendForRMI */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkMultiProcessControllerCppCommand(static_cast<vtkMultiProcessController *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
