// tcl wrapper for vtkPickingManager object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPickingManager.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkPickingManagerNewCommand()
{
  vtkPickingManager *temp = vtkPickingManager::New();
  return static_cast<ClientData>(temp);
}

int vtkObjectCppCommand(vtkObject *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkPickingManagerCppCommand(vtkPickingManager *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkPickingManagerCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkPickingManagerCppCommand(static_cast<vtkPickingManager *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkPickingManager_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkPickingManager"),vtkPickingManagerNewCommand,vtkPickingManagerCommand);
  return 0;
}

int VTKTCL_EXPORT vtkPickingManagerCppCommand(vtkPickingManager *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkPickingManager",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkObject"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkPickingManager  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPickingManager");
    return TCL_OK;
    }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkPickingManager  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPickingManager");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkPickingManager  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPickingManager");
    return TCL_OK;
    }
    }
  if ((!strcmp("EnabledOn",argv[1]))&&(argc == 2))
    {
    op->EnabledOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("EnabledOff",argv[1]))&&(argc == 2))
    {
    op->EnabledOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("SetEnabled",argv[1]))&&(argc == 3))
    {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
    {
    op->SetEnabled(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetEnabled",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->GetEnabled();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetOptimizeOnInteractorEvents",argv[1]))&&(argc == 3))
    {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
    {
    op->SetOptimizeOnInteractorEvents(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetOptimizeOnInteractorEvents",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->GetOptimizeOnInteractorEvents();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetInteractor",argv[1]))&&(argc == 3))
    {
    vtkRenderWindowInteractor  *temp0;
    error = 0;

    temp0 = (vtkRenderWindowInteractor *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkRenderWindowInteractor"),interp,error));
    if (!error)
    {
    op->SetInteractor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetInteractor",argv[1]))&&(argc == 2))
    {
    vtkRenderWindowInteractor  *temp20;
    temp20 = (op)->GetInteractor();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRenderWindowInteractor");
    return TCL_OK;
    }
  if ((!strcmp("AddPicker",argv[1]))&&(argc == 4))
    {
    vtkAbstractPicker  *temp0;
    vtkObject  *temp1;
    error = 0;

    temp0 = (vtkAbstractPicker *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractPicker"),interp,error));
    temp1 = (vtkObject *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    op->AddPicker(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("RemovePicker",argv[1]))&&(argc == 4))
    {
    vtkAbstractPicker  *temp0;
    vtkObject  *temp1;
    error = 0;

    temp0 = (vtkAbstractPicker *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractPicker"),interp,error));
    temp1 = (vtkObject *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    op->RemovePicker(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("RemoveObject",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    op->RemoveObject(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("Pick",argv[1]))&&(argc == 4))
    {
    vtkAbstractPicker  *temp0;
    vtkObject  *temp1;
    bool   temp20;
    error = 0;

    temp0 = (vtkAbstractPicker *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractPicker"),interp,error));
    temp1 = (vtkObject *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->Pick(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("Pick",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    bool   temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->Pick(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("Pick",argv[1]))&&(argc == 3))
    {
    vtkAbstractPicker  *temp0;
    bool   temp20;
    error = 0;

    temp0 = (vtkAbstractPicker *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractPicker"),interp,error));
    if (!error)
    {
    temp20 = (op)->Pick(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetAssemblyPath",argv[1]))&&(argc == 8))
    {
    double   temp0;
    double   temp1;
    double   temp2;
    vtkAbstractPropPicker  *temp3;
    vtkRenderer  *temp4;
    vtkObject  *temp5;
    vtkAssemblyPath  *temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    temp3 = (vtkAbstractPropPicker *)(vtkTclGetPointerFromObject(argv[5],const_cast<char *>("vtkAbstractPropPicker"),interp,error));
    temp4 = (vtkRenderer *)(vtkTclGetPointerFromObject(argv[6],const_cast<char *>("vtkRenderer"),interp,error));
    temp5 = (vtkObject *)(vtkTclGetPointerFromObject(argv[7],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->GetAssemblyPath(temp0,temp1,temp2,temp3,temp4,temp5);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAssemblyPath");
    return TCL_OK;
    }
    }
  if ((!strcmp("GetNumberOfPickers",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetNumberOfPickers();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetNumberOfObjectsLinked",argv[1]))&&(argc == 3))
    {
    vtkAbstractPicker  *temp0;
    int      temp20;
    error = 0;

    temp0 = (vtkAbstractPicker *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractPicker"),interp,error));
    if (!error)
    {
    temp20 = (op)->GetNumberOfObjectsLinked(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkPickingManagerCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkPickingManager:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  EnabledOn\n",NULL);
    Tcl_AppendResult(interp,"  EnabledOff\n",NULL);
    Tcl_AppendResult(interp,"  SetEnabled\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetEnabled\n",NULL);
    Tcl_AppendResult(interp,"  SetOptimizeOnInteractorEvents\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetOptimizeOnInteractorEvents\n",NULL);
    Tcl_AppendResult(interp,"  SetInteractor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetInteractor\n",NULL);
    Tcl_AppendResult(interp,"  AddPicker\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  RemovePicker\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  RemoveObject\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  Pick\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  Pick\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  Pick\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAssemblyPath\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfPickers\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfObjectsLinked\t with 1 arg\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "EnabledOn" );
    Tcl_DStringAppendElement ( &dString, "EnabledOff" );
    Tcl_DStringAppendElement ( &dString, "SetEnabled" );
    Tcl_DStringAppendElement ( &dString, "GetEnabled" );
    Tcl_DStringAppendElement ( &dString, "SetOptimizeOnInteractorEvents" );
    Tcl_DStringAppendElement ( &dString, "GetOptimizeOnInteractorEvents" );
    Tcl_DStringAppendElement ( &dString, "SetInteractor" );
    Tcl_DStringAppendElement ( &dString, "GetInteractor" );
    Tcl_DStringAppendElement ( &dString, "AddPicker" );
    Tcl_DStringAppendElement ( &dString, "RemovePicker" );
    Tcl_DStringAppendElement ( &dString, "RemoveObject" );
    Tcl_DStringAppendElement ( &dString, "Pick" );
    Tcl_DStringAppendElement ( &dString, "Pick" );
    Tcl_DStringAppendElement ( &dString, "Pick" );
    Tcl_DStringAppendElement ( &dString, "GetAssemblyPath" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPickers" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfObjectsLinked" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkObjectCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkPickingManager *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: EnabledOn */
    if ( strcmp ( argv[2], "EnabledOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "EnabledOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for EnabledOn */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable management.\n When disabled, it redirects every pick on the picker.\n By default the picking manager is disabled when initialized.\n" );
    Tcl_DStringAppendElement ( &dString, "void EnabledOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for EnabledOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: EnabledOff */
    if ( strcmp ( argv[2], "EnabledOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "EnabledOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for EnabledOff */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable management.\n When disabled, it redirects every pick on the picker.\n By default the picking manager is disabled when initialized.\n" );
    Tcl_DStringAppendElement ( &dString, "void EnabledOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for EnabledOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetEnabled */
    if ( strcmp ( argv[2], "SetEnabled" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetEnabled" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetEnabled */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable management.\n When disabled, it redirects every pick on the picker.\n By default the picking manager is disabled when initialized.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetEnabled(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for SetEnabled */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetEnabled */
    if ( strcmp ( argv[2], "GetEnabled" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetEnabled" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetEnabled */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable management.\n When disabled, it redirects every pick on the picker.\n By default the picking manager is disabled when initialized.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetEnabled();" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for GetEnabled */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetOptimizeOnInteractorEvents */
    if ( strcmp ( argv[2], "SetOptimizeOnInteractorEvents" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOptimizeOnInteractorEvents" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOptimizeOnInteractorEvents */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable optimization depending on the renderWindowInteractor events.\n The mechanism keeps in cache the last selected picker as well as the last\n render time to recompute the selection only if a new render event\n occurred after the last selection; otherwise, it simply returns the last\n picker selected.\n By default pickingManagers does use the optimization.\n Warning: Turning off the caching significantly decreases performance.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetOptimizeOnInteractorEvents(bool optimize);" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for SetOptimizeOnInteractorEvents */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetOptimizeOnInteractorEvents */
    if ( strcmp ( argv[2], "GetOptimizeOnInteractorEvents" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOptimizeOnInteractorEvents" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOptimizeOnInteractorEvents */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable optimization depending on the renderWindowInteractor events.\n The mechanism keeps in cache the last selected picker as well as the last\n render time to recompute the selection only if a new render event\n occurred after the last selection; otherwise, it simply returns the last\n picker selected.\n By default pickingManagers does use the optimization.\n Warning: Turning off the caching significantly decreases performance.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetOptimizeOnInteractorEvents();" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for GetOptimizeOnInteractorEvents */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetInteractor */
    if ( strcmp ( argv[2], "SetInteractor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetInteractor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkRenderWindowInteractor" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetInteractor */
    Tcl_DStringAppendElement ( &dString, " Set the window interactor associated with the manager.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetInteractor(vtkRenderWindowInteractor *iren);" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for SetInteractor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetInteractor */
    if ( strcmp ( argv[2], "GetInteractor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetInteractor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetInteractor */
    Tcl_DStringAppendElement ( &dString, " Set the window interactor associated with the manager.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderWindowInteractor *GetInteractor();" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for GetInteractor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: AddPicker */
    if ( strcmp ( argv[2], "AddPicker" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AddPicker" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPicker" );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AddPicker */
    Tcl_DStringAppendElement ( &dString, " Register a picker into the picking manager.\n It can be internally associated (optional) with an \\a object.\n This allows the removal of all the pickers of the given object.\n Note that a picker can be registered multiple times with different objects.\n \\sa RemovePicker(), RemoveObject().\n" );
    Tcl_DStringAppendElement ( &dString, "void AddPicker(vtkAbstractPicker *picker, vtkObject *object=0);" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for AddPicker */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: RemovePicker */
    if ( strcmp ( argv[2], "RemovePicker" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemovePicker" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPicker" );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemovePicker */
    Tcl_DStringAppendElement ( &dString, " Unregister the \\a picker from the picking manager.\n If \\a object is non null, only the pair (\\a picker, \\a object) is removed.\n" );
    Tcl_DStringAppendElement ( &dString, "void RemovePicker(vtkAbstractPicker *picker, vtkObject *object=0);" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for RemovePicker */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: RemoveObject */
    if ( strcmp ( argv[2], "RemoveObject" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemoveObject" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemoveObject */
    Tcl_DStringAppendElement ( &dString, " Remove all occurences of the \\a object from the registered list.\n If a picker associated with the \\a object is not also associated with\n any other object, it is removed from the list as well.\n" );
    Tcl_DStringAppendElement ( &dString, "void RemoveObject(vtkObject *object);" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for RemoveObject */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: Pick */
    if ( strcmp ( argv[2], "Pick" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Pick" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPicker" );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Pick */
    Tcl_DStringAppendElement ( &dString, " Run the picking selection process and return true if the \\a object\n is associated with the given picker if it is the best one, false otherwise.\n If OptimizeOnInteractorEvents is true, the pick can reuse cached\n information.\n" );
    Tcl_DStringAppendElement ( &dString, "bool Pick(vtkAbstractPicker *picker, vtkObject *object);" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for Pick */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: Pick */
    if ( strcmp ( argv[2], "Pick" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Pick" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Pick */
    Tcl_DStringAppendElement ( &dString, " Run the picking selection process and return true if the \\a object\n is associated with the best picker.\n This is an overloaded function.\n" );
    Tcl_DStringAppendElement ( &dString, "bool Pick(vtkObject *object);" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for Pick */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: Pick */
    if ( strcmp ( argv[2], "Pick" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Pick" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPicker" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Pick */
    Tcl_DStringAppendElement ( &dString, " Run the picking selection process and return if \\a picker is the one\n selected.\n This is an overloaded function.\n" );
    Tcl_DStringAppendElement ( &dString, "bool Pick(vtkAbstractPicker *picker);" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for Pick */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetAssemblyPath */
    if ( strcmp ( argv[2], "GetAssemblyPath" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAssemblyPath" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPropPicker" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderer" );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAssemblyPath */
    Tcl_DStringAppendElement ( &dString, " If the picking manager is enabled, it runs the picking selection process\n and return the assembly path associated to the picker passed as\n argument if it is the one mediated.\n Otherwise it simply proceeds to a pick using the given renderer and\n returns the corresponding assembly path.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkAssemblyPath *GetAssemblyPath(double X, double Y, double Z, vtkAbstractPropPicker *picker, vtkRenderer *renderer, vtkObject *obj);" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for GetAssemblyPath */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetNumberOfPickers */
    if ( strcmp ( argv[2], "GetNumberOfPickers" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPickers" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfPickers */
    Tcl_DStringAppendElement ( &dString, " Return the number of pickers registered.\n If the same picker is added multiple times with different objects, it is\n counted once.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfPickers();" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for GetNumberOfPickers */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetNumberOfObjectsLinked */
    if ( strcmp ( argv[2], "GetNumberOfObjectsLinked" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfObjectsLinked" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPicker" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfObjectsLinked */
    Tcl_DStringAppendElement ( &dString, " Return the number of objects linked with a given \\a picker.\n Note: a null object is counted as an associated object.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfObjectsLinked(vtkAbstractPicker *picker);" );
    Tcl_DStringAppendElement ( &dString, "vtkPickingManager" );
    /* Closing for GetNumberOfObjectsLinked */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
