// java wrapper for vtkTextProperty object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTextProperty.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkTextProperty_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkTextProperty",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != NULL) { return res; }
  return NULL;
}


extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkTextProperty_GetClassName_10(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  const char    *temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetClassName();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkTextProperty *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetColor_12(JNIEnv *env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  vtkTextProperty *op;
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetColor(temp0,temp1,temp2);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetColor_13(JNIEnv *env, jobject obj,jdoubleArray id0)
{
  vtkTextProperty *op;
  double temp0[3];
  void *tempArray0;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,NULL));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetColor(temp0);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
}

extern "C" JNIEXPORT jarray  JNICALL Java_vtk_vtkTextProperty_GetColor_14(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  double  *temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetColor();
    return vtkJavaMakeJArrayOfDoubleFromDouble(env,temp20,3);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetOpacity_15(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkTextProperty *op;
  double   temp0;
  temp0 = id0;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetOpacity(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTextProperty_GetOpacityMinValue_16(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  double   temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetOpacityMinValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTextProperty_GetOpacityMaxValue_17(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  double   temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetOpacityMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTextProperty_GetOpacity_18(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  double   temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetOpacity();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetBackgroundColor_19(JNIEnv *env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  vtkTextProperty *op;
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetBackgroundColor(temp0,temp1,temp2);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetBackgroundColor_110(JNIEnv *env, jobject obj,jdoubleArray id0)
{
  vtkTextProperty *op;
  double temp0[3];
  void *tempArray0;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,NULL));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetBackgroundColor(temp0);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
}

extern "C" JNIEXPORT jarray  JNICALL Java_vtk_vtkTextProperty_GetBackgroundColor_111(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  double  *temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetBackgroundColor();
    return vtkJavaMakeJArrayOfDoubleFromDouble(env,temp20,3);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetBackgroundOpacity_112(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkTextProperty *op;
  double   temp0;
  temp0 = id0;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetBackgroundOpacity(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTextProperty_GetBackgroundOpacityMinValue_113(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  double   temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetBackgroundOpacityMinValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTextProperty_GetBackgroundOpacityMaxValue_114(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  double   temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetBackgroundOpacityMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTextProperty_GetBackgroundOpacity_115(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  double   temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetBackgroundOpacity();
  return temp20;
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkTextProperty_GetFontFamilyAsString_116(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  char    *temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFontFamilyAsString();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetFontFamilyAsString_117(JNIEnv *env, jobject obj,jstring id0)
{
  vtkTextProperty *op;
  char    *temp0;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetFontFamilyAsString(temp0);
  delete[] temp0;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetFontFamily_118(JNIEnv *env, jobject obj,jint id0)
{
  vtkTextProperty *op;
  int      temp0;
  temp0 = id0;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetFontFamily(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetFontFamily_119(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFontFamily();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetFontFamilyMinValue_120(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFontFamilyMinValue();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetFontFamilyToArial_121(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetFontFamilyToArial();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetFontFamilyToCourier_122(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetFontFamilyToCourier();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetFontFamilyToTimes_123(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetFontFamilyToTimes();
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetFontFamilyFromString_124(JNIEnv *env, jobject obj,jstring id0)
{
  vtkTextProperty *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFontFamilyFromString(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkTextProperty_GetFontFamilyAsString_125(JNIEnv *env, jobject obj,jint id0)
{
  vtkTextProperty *op;
  int      temp0;
  const char    *temp20;
  temp0 = id0;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFontFamilyAsString(temp0);
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkTextProperty_GetFontFile_126(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  char    *temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFontFile();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetFontFile_127(JNIEnv *env, jobject obj,jstring id0)
{
  vtkTextProperty *op;
  char    *temp0;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetFontFile(temp0);
  delete[] temp0;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetFontSize_128(JNIEnv *env, jobject obj,jint id0)
{
  vtkTextProperty *op;
  int      temp0;
  temp0 = id0;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetFontSize(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetFontSizeMinValue_129(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFontSizeMinValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetFontSizeMaxValue_130(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFontSizeMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetFontSize_131(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFontSize();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetBold_132(JNIEnv *env, jobject obj,jint id0)
{
  vtkTextProperty *op;
  int      temp0;
  temp0 = id0;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetBold(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetBold_133(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetBold();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_BoldOn_134(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->BoldOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_BoldOff_135(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->BoldOff();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetItalic_136(JNIEnv *env, jobject obj,jint id0)
{
  vtkTextProperty *op;
  int      temp0;
  temp0 = id0;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetItalic(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetItalic_137(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetItalic();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_ItalicOn_138(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->ItalicOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_ItalicOff_139(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->ItalicOff();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetShadow_140(JNIEnv *env, jobject obj,jint id0)
{
  vtkTextProperty *op;
  int      temp0;
  temp0 = id0;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetShadow(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetShadow_141(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetShadow();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_ShadowOn_142(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->ShadowOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_ShadowOff_143(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->ShadowOff();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetShadowOffset_144(JNIEnv *env, jobject obj,jint id0,jint id1)
{
  vtkTextProperty *op;
  int      temp0;
  int      temp1;
  temp0 = id0;
  temp1 = id1;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetShadowOffset(temp0,temp1);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetShadowOffset_145(JNIEnv *env, jobject obj,jintArray id0)
{
  vtkTextProperty *op;
  int    temp0[2];
  void *tempArray0;
  tempArray0 = (void *)(env->GetIntArrayElements(id0,NULL));
  temp0[0] = ((jint *)tempArray0)[0];
  temp0[1] = ((jint *)tempArray0)[1];

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetShadowOffset(temp0);
  ((jint *)tempArray0)[0] = temp0[0];
  ((jint *)tempArray0)[1] = temp0[1];
  env->ReleaseIntArrayElements(id0,(jint *)tempArray0,0);
}

extern "C" JNIEXPORT jarray  JNICALL Java_vtk_vtkTextProperty_GetShadowOffset_146(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int     *temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetShadowOffset();
    return vtkJavaMakeJArrayOfIntFromInt(env,temp20,2);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_GetShadowColor_147(JNIEnv *env, jobject obj,jdoubleArray id0)
{
  vtkTextProperty *op;
  double temp0[3];
  void *tempArray0;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,NULL));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->GetShadowColor(temp0);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetJustification_148(JNIEnv *env, jobject obj,jint id0)
{
  vtkTextProperty *op;
  int      temp0;
  temp0 = id0;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetJustification(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetJustificationMinValue_149(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetJustificationMinValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetJustificationMaxValue_150(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetJustificationMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetJustification_151(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetJustification();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetJustificationToLeft_152(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetJustificationToLeft();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetJustificationToCentered_153(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetJustificationToCentered();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetJustificationToRight_154(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetJustificationToRight();
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkTextProperty_GetJustificationAsString_155(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  const char    *temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetJustificationAsString();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetVerticalJustification_156(JNIEnv *env, jobject obj,jint id0)
{
  vtkTextProperty *op;
  int      temp0;
  temp0 = id0;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetVerticalJustification(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetVerticalJustificationMinValue_157(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetVerticalJustificationMinValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetVerticalJustificationMaxValue_158(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetVerticalJustificationMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextProperty_GetVerticalJustification_159(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  int      temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetVerticalJustification();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetVerticalJustificationToBottom_160(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetVerticalJustificationToBottom();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetVerticalJustificationToCentered_161(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetVerticalJustificationToCentered();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetVerticalJustificationToTop_162(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetVerticalJustificationToTop();
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkTextProperty_GetVerticalJustificationAsString_163(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  const char    *temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetVerticalJustificationAsString();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetOrientation_164(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkTextProperty *op;
  double   temp0;
  temp0 = id0;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetOrientation(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTextProperty_GetOrientation_165(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  double   temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetOrientation();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetLineSpacing_166(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkTextProperty *op;
  double   temp0;
  temp0 = id0;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetLineSpacing(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTextProperty_GetLineSpacing_167(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  double   temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetLineSpacing();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_SetLineOffset_168(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkTextProperty *op;
  double   temp0;
  temp0 = id0;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->SetLineOffset(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTextProperty_GetLineOffset_169(JNIEnv *env, jobject obj)
{
  vtkTextProperty *op;
  double   temp20;

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetLineOffset();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextProperty_ShallowCopy_170(JNIEnv *env, jobject obj,jobject id0)
{
  vtkTextProperty *op;
  vtkTextProperty  *temp0;
  temp0 = (vtkTextProperty *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkTextProperty *)vtkJavaGetPointerFromObject(env,obj);
  op->ShallowCopy(temp0);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTextProperty_VTKInit(JNIEnv *, jobject)
{
  vtkTextProperty *aNewOne = vtkTextProperty::New();
  return (jlong)(size_t)(void*)aNewOne;
}
