#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkFreeTypeStringToImage_TclCreate(Tcl_Interp *interp);
int vtkMathTextFreeTypeTextRenderer_TclCreate(Tcl_Interp *interp);
int vtkMathTextUtilities_TclCreate(Tcl_Interp *interp);
int vtkTextRendererStringToImage_TclCreate(Tcl_Interp *interp);
int vtkScaledTextActor_TclCreate(Tcl_Interp *interp);
int vtkVectorText_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkrenderingfreetypetcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkrenderingfreetypetcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkrenderingfreetypetcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkrenderingfreetypetcl_Init(interp);
}


int VTK_EXPORT Vtkrenderingfreetypetcl_Init(Tcl_Interp *interp)
{

  vtkFreeTypeStringToImage_TclCreate(interp);
  vtkMathTextFreeTypeTextRenderer_TclCreate(interp);
  vtkMathTextUtilities_TclCreate(interp);
  vtkTextRendererStringToImage_TclCreate(interp);
  vtkScaledTextActor_TclCreate(interp);
  vtkVectorText_TclCreate(interp);
  char pkgName[]="vtkRenderingFreeTypeTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
