// tcl wrapper for vtkGenericCompositePolyDataMapper2 object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkGenericCompositePolyDataMapper2.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkGenericCompositePolyDataMapper2NewCommand()
{
  vtkGenericCompositePolyDataMapper2 *temp = vtkGenericCompositePolyDataMapper2::New();
  return static_cast<ClientData>(temp);
}

int vtkOpenGLPolyDataMapperCppCommand(vtkOpenGLPolyDataMapper *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkGenericCompositePolyDataMapper2CppCommand(vtkGenericCompositePolyDataMapper2 *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkGenericCompositePolyDataMapper2Command(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkGenericCompositePolyDataMapper2CppCommand(static_cast<vtkGenericCompositePolyDataMapper2 *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkGenericCompositePolyDataMapper2_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkGenericCompositePolyDataMapper2"),vtkGenericCompositePolyDataMapper2NewCommand,vtkGenericCompositePolyDataMapper2Command);
  return 0;
}

int VTKTCL_EXPORT vtkGenericCompositePolyDataMapper2CppCommand(vtkGenericCompositePolyDataMapper2 *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkGenericCompositePolyDataMapper2",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkOpenGLPolyDataMapperCppCommand(static_cast<vtkOpenGLPolyDataMapper *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkOpenGLPolyDataMapper"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkGenericCompositePolyDataMapper2  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkGenericCompositePolyDataMapper2");
    return TCL_OK;
    }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkGenericCompositePolyDataMapper2  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkGenericCompositePolyDataMapper2");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkGenericCompositePolyDataMapper2  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkGenericCompositePolyDataMapper2");
    return TCL_OK;
    }
    }
  if ((!strcmp("GetIsOpaque",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->GetIsOpaque();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetCompositeDataDisplayAttributes",argv[1]))&&(argc == 3))
    {
    vtkCompositeDataDisplayAttributes  *temp0;
    error = 0;

    temp0 = (vtkCompositeDataDisplayAttributes *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkCompositeDataDisplayAttributes"),interp,error));
    if (!error)
    {
    op->SetCompositeDataDisplayAttributes(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetCompositeDataDisplayAttributes",argv[1]))&&(argc == 2))
    {
    vtkCompositeDataDisplayAttributes  *temp20;
    temp20 = (op)->GetCompositeDataDisplayAttributes();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkCompositeDataDisplayAttributes");
    return TCL_OK;
    }
  if ((!strcmp("SetBlockVisibility",argv[1]))&&(argc == 4))
    {
    unsigned int      temp0;
    bool   temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi ? true : false;
    if (!error)
    {
    op->SetBlockVisibility(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetBlockVisibility",argv[1]))&&(argc == 3))
    {
    unsigned int      temp0;
    bool   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    temp20 = (op)->GetBlockVisibility(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("RemoveBlockVisibility",argv[1]))&&(argc == 3))
    {
    unsigned int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    op->RemoveBlockVisibility(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("RemoveBlockVisibilites",argv[1]))&&(argc == 2))
    {
    op->RemoveBlockVisibilites();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("SetBlockColor",argv[1]))&&(argc == 6))
    {
    unsigned int      temp0;
    double   temp1;
    double   temp2;
    double   temp3;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp3 = tempd;
    if (!error)
    {
    op->SetBlockColor(temp0,temp1,temp2,temp3);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("RemoveBlockColor",argv[1]))&&(argc == 3))
    {
    unsigned int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    op->RemoveBlockColor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("RemoveBlockColors",argv[1]))&&(argc == 2))
    {
    op->RemoveBlockColors();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("SetBlockOpacity",argv[1]))&&(argc == 4))
    {
    unsigned int      temp0;
    double   temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (!error)
    {
    op->SetBlockOpacity(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetBlockOpacity",argv[1]))&&(argc == 3))
    {
    unsigned int      temp0;
    double   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    temp20 = (op)->GetBlockOpacity(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("RemoveBlockOpacity",argv[1]))&&(argc == 3))
    {
    unsigned int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    op->RemoveBlockOpacity(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("RemoveBlockOpacities",argv[1]))&&(argc == 2))
    {
    op->RemoveBlockOpacities();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("ReleaseGraphicsResources",argv[1]))&&(argc == 3))
    {
    vtkWindow  *temp0;
    error = 0;

    temp0 = (vtkWindow *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkWindow"),interp,error));
    if (!error)
    {
    op->ReleaseGraphicsResources(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkGenericCompositePolyDataMapper2Command));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkOpenGLPolyDataMapperCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkGenericCompositePolyDataMapper2:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetIsOpaque\n",NULL);
    Tcl_AppendResult(interp,"  SetCompositeDataDisplayAttributes\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetCompositeDataDisplayAttributes\n",NULL);
    Tcl_AppendResult(interp,"  SetBlockVisibility\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetBlockVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RemoveBlockVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RemoveBlockVisibilites\n",NULL);
    Tcl_AppendResult(interp,"  SetBlockColor\t with 4 args\n",NULL);
    Tcl_AppendResult(interp,"  RemoveBlockColor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RemoveBlockColors\n",NULL);
    Tcl_AppendResult(interp,"  SetBlockOpacity\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetBlockOpacity\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RemoveBlockOpacity\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RemoveBlockOpacities\n",NULL);
    Tcl_AppendResult(interp,"  ReleaseGraphicsResources\t with 1 arg\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkOpenGLPolyDataMapperCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "GetIsOpaque" );
    Tcl_DStringAppendElement ( &dString, "SetCompositeDataDisplayAttributes" );
    Tcl_DStringAppendElement ( &dString, "GetCompositeDataDisplayAttributes" );
    Tcl_DStringAppendElement ( &dString, "SetBlockVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetBlockVisibility" );
    Tcl_DStringAppendElement ( &dString, "RemoveBlockVisibility" );
    Tcl_DStringAppendElement ( &dString, "RemoveBlockVisibilites" );
    Tcl_DStringAppendElement ( &dString, "SetBlockColor" );
    Tcl_DStringAppendElement ( &dString, "RemoveBlockColor" );
    Tcl_DStringAppendElement ( &dString, "RemoveBlockColors" );
    Tcl_DStringAppendElement ( &dString, "SetBlockOpacity" );
    Tcl_DStringAppendElement ( &dString, "GetBlockOpacity" );
    Tcl_DStringAppendElement ( &dString, "RemoveBlockOpacity" );
    Tcl_DStringAppendElement ( &dString, "RemoveBlockOpacities" );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkOpenGLPolyDataMapperCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkGenericCompositePolyDataMapper2 *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2 *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2 *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetIsOpaque */
    if ( strcmp ( argv[2], "GetIsOpaque" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetIsOpaque" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetIsOpaque */
    Tcl_DStringAppendElement ( &dString, " Returns if the mapper does not expect to have translucent geometry. This\n may happen when using ScalarMode is set to not map scalars i.e. render the\n scalar array directly as colors and the scalar array has opacity i.e. alpha\n component. Note that even if this method returns true, an actor may treat\n the geometry as translucent since a constant translucency is set on the\n property, for example.\n Overridden to use the actual data and ScalarMode to determine if we have\n ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "virtual bool GetIsOpaque();" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for GetIsOpaque */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetCompositeDataDisplayAttributes */
    if ( strcmp ( argv[2], "SetCompositeDataDisplayAttributes" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetCompositeDataDisplayAttributes" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkCompositeDataDisplayAttributes" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetCompositeDataDisplayAttributes */
    Tcl_DStringAppendElement ( &dString, " Set/get the composite data set attributes.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetCompositeDataDisplayAttributes(vtkCompositeDataDisplayAttributes *attributes);" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for SetCompositeDataDisplayAttributes */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetCompositeDataDisplayAttributes */
    if ( strcmp ( argv[2], "GetCompositeDataDisplayAttributes" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCompositeDataDisplayAttributes" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCompositeDataDisplayAttributes */
    Tcl_DStringAppendElement ( &dString, " Set/get the composite data set attributes.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkCompositeDataDisplayAttributes *GetCompositeDataDisplayAttributes();" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for GetCompositeDataDisplayAttributes */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetBlockVisibility */
    if ( strcmp ( argv[2], "SetBlockVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetBlockVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetBlockVisibility */
    Tcl_DStringAppendElement ( &dString, " Set/get the visibility for a block given its flat index.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetBlockVisibility(unsigned int index, bool visible);" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for SetBlockVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetBlockVisibility */
    if ( strcmp ( argv[2], "GetBlockVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetBlockVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetBlockVisibility */
    Tcl_DStringAppendElement ( &dString, " Set/get the visibility for a block given its flat index.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetBlockVisibility(unsigned int index) const;" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for GetBlockVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: RemoveBlockVisibility */
    if ( strcmp ( argv[2], "RemoveBlockVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemoveBlockVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemoveBlockVisibility */
    Tcl_DStringAppendElement ( &dString, " Set/get the visibility for a block given its flat index.\n" );
    Tcl_DStringAppendElement ( &dString, "void RemoveBlockVisibility(unsigned int index);" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for RemoveBlockVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: RemoveBlockVisibilites */
    if ( strcmp ( argv[2], "RemoveBlockVisibilites" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemoveBlockVisibilites" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemoveBlockVisibilites */
    Tcl_DStringAppendElement ( &dString, " Set/get the visibility for a block given its flat index.\n" );
    Tcl_DStringAppendElement ( &dString, "void RemoveBlockVisibilites();" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for RemoveBlockVisibilites */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetBlockColor */
    if ( strcmp ( argv[2], "SetBlockColor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetBlockColor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetBlockColor */
    Tcl_DStringAppendElement ( &dString, " Set/get the color for a block given its flat index.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetBlockColor(unsigned int index, double r, double g, double b);" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for SetBlockColor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: RemoveBlockColor */
    if ( strcmp ( argv[2], "RemoveBlockColor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemoveBlockColor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemoveBlockColor */
    Tcl_DStringAppendElement ( &dString, " Set/get the color for a block given its flat index.\n" );
    Tcl_DStringAppendElement ( &dString, "void RemoveBlockColor(unsigned int index);" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for RemoveBlockColor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: RemoveBlockColors */
    if ( strcmp ( argv[2], "RemoveBlockColors" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemoveBlockColors" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemoveBlockColors */
    Tcl_DStringAppendElement ( &dString, " Set/get the color for a block given its flat index.\n" );
    Tcl_DStringAppendElement ( &dString, "void RemoveBlockColors();" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for RemoveBlockColors */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetBlockOpacity */
    if ( strcmp ( argv[2], "SetBlockOpacity" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetBlockOpacity" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetBlockOpacity */
    Tcl_DStringAppendElement ( &dString, " Set/get the opacity for a block given its flat index.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetBlockOpacity(unsigned int index, double opacity);" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for SetBlockOpacity */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetBlockOpacity */
    if ( strcmp ( argv[2], "GetBlockOpacity" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetBlockOpacity" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetBlockOpacity */
    Tcl_DStringAppendElement ( &dString, " Set/get the opacity for a block given its flat index.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetBlockOpacity(unsigned int index);" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for GetBlockOpacity */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: RemoveBlockOpacity */
    if ( strcmp ( argv[2], "RemoveBlockOpacity" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemoveBlockOpacity" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemoveBlockOpacity */
    Tcl_DStringAppendElement ( &dString, " Set/get the opacity for a block given its flat index.\n" );
    Tcl_DStringAppendElement ( &dString, "void RemoveBlockOpacity(unsigned int index);" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for RemoveBlockOpacity */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: RemoveBlockOpacities */
    if ( strcmp ( argv[2], "RemoveBlockOpacities" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemoveBlockOpacities" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemoveBlockOpacities */
    Tcl_DStringAppendElement ( &dString, " Set/get the opacity for a block given its flat index.\n" );
    Tcl_DStringAppendElement ( &dString, "void RemoveBlockOpacities();" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for RemoveBlockOpacities */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: ReleaseGraphicsResources */
    if ( strcmp ( argv[2], "ReleaseGraphicsResources" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkWindow" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ReleaseGraphicsResources */
    Tcl_DStringAppendElement ( &dString, " Release any graphics resources that are being consumed by this mapper.\n The parameter window could be used to determine which graphic\n resources to release.\n" );
    Tcl_DStringAppendElement ( &dString, "void ReleaseGraphicsResources(vtkWindow *);" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCompositePolyDataMapper2" );
    /* Closing for ReleaseGraphicsResources */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkOpenGLPolyDataMapperCppCommand(static_cast<vtkOpenGLPolyDataMapper *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
