// java wrapper for vtkOpenGLRenderer object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkOpenGLRenderer.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkRenderer_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkOpenGLRenderer_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkOpenGLRenderer",dType)) { return me; }
  if ((res= vtkRenderer_Typecast(me,dType)) != NULL) { return res; }
  return NULL;
}


extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkOpenGLRenderer_GetClassName_10(JNIEnv *env, jobject obj)
{
  vtkOpenGLRenderer *op;
  const char    *temp20;

  op = (vtkOpenGLRenderer *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetClassName();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkOpenGLRenderer_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkOpenGLRenderer *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkOpenGLRenderer *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLRenderer_DeviceRender_12(JNIEnv *env, jobject obj)
{
  vtkOpenGLRenderer *op;

  op = (vtkOpenGLRenderer *)vtkJavaGetPointerFromObject(env,obj);
  op->DeviceRender();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLRenderer_DeviceRenderTranslucentPolygonalGeometry_13(JNIEnv *env, jobject obj)
{
  vtkOpenGLRenderer *op;

  op = (vtkOpenGLRenderer *)vtkJavaGetPointerFromObject(env,obj);
  op->DeviceRenderTranslucentPolygonalGeometry();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLRenderer_Clear_14(JNIEnv *env, jobject obj)
{
  vtkOpenGLRenderer *op;

  op = (vtkOpenGLRenderer *)vtkJavaGetPointerFromObject(env,obj);
  op->Clear();
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkOpenGLRenderer_UpdateLights_15(JNIEnv *env, jobject obj)
{
  vtkOpenGLRenderer *op;
  int      temp20;

  op = (vtkOpenGLRenderer *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->UpdateLights();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkOpenGLRenderer_GetDepthPeelingHigherLayer_16(JNIEnv *env, jobject obj)
{
  vtkOpenGLRenderer *op;
  int      temp20;

  op = (vtkOpenGLRenderer *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetDepthPeelingHigherLayer();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLRenderer_SetPass_17(JNIEnv *env, jobject obj,jobject id0)
{
  vtkOpenGLRenderer *op;
  vtkRenderPass  *temp0;
  temp0 = (vtkRenderPass *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkOpenGLRenderer *)vtkJavaGetPointerFromObject(env,obj);
  op->SetPass(temp0);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkOpenGLRenderer_GetPass_18(JNIEnv *env, jobject obj)
{
  vtkOpenGLRenderer *op;
  vtkRenderPass  *temp20;

  op = (vtkOpenGLRenderer *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetPass();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkOpenGLRenderer_VTKInit(JNIEnv *, jobject)
{
  vtkOpenGLRenderer *aNewOne = vtkOpenGLRenderer::New();
  return (jlong)(size_t)(void*)aNewOne;
}
