// tcl wrapper for vtkRenderStepsPass object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkRenderStepsPass.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkRenderStepsPassNewCommand()
{
  vtkRenderStepsPass *temp = vtkRenderStepsPass::New();
  return static_cast<ClientData>(temp);
}

int vtkRenderPassCppCommand(vtkRenderPass *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkRenderStepsPassCppCommand(vtkRenderStepsPass *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkRenderStepsPassCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkRenderStepsPassCppCommand(static_cast<vtkRenderStepsPass *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkRenderStepsPass_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkRenderStepsPass"),vtkRenderStepsPassNewCommand,vtkRenderStepsPassCommand);
  return 0;
}

int VTKTCL_EXPORT vtkRenderStepsPassCppCommand(vtkRenderStepsPass *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkRenderStepsPass",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkRenderPassCppCommand(static_cast<vtkRenderPass *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkRenderPass"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkRenderStepsPass  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRenderStepsPass");
    return TCL_OK;
    }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkRenderStepsPass  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRenderStepsPass");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkRenderStepsPass  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRenderStepsPass");
    return TCL_OK;
    }
    }
  if ((!strcmp("ReleaseGraphicsResources",argv[1]))&&(argc == 3))
    {
    vtkWindow  *temp0;
    error = 0;

    temp0 = (vtkWindow *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkWindow"),interp,error));
    if (!error)
    {
    op->ReleaseGraphicsResources(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetCameraPass",argv[1]))&&(argc == 2))
    {
    vtkCameraPass  *temp20;
    temp20 = (op)->GetCameraPass();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkCameraPass");
    return TCL_OK;
    }
  if ((!strcmp("SetCameraPass",argv[1]))&&(argc == 3))
    {
    vtkCameraPass  *temp0;
    error = 0;

    temp0 = (vtkCameraPass *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkCameraPass"),interp,error));
    if (!error)
    {
    op->SetCameraPass(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetLightsPass",argv[1]))&&(argc == 2))
    {
    vtkRenderPass  *temp20;
    temp20 = (op)->GetLightsPass();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRenderPass");
    return TCL_OK;
    }
  if ((!strcmp("SetLightsPass",argv[1]))&&(argc == 3))
    {
    vtkRenderPass  *temp0;
    error = 0;

    temp0 = (vtkRenderPass *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkRenderPass"),interp,error));
    if (!error)
    {
    op->SetLightsPass(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetOpaquePass",argv[1]))&&(argc == 2))
    {
    vtkRenderPass  *temp20;
    temp20 = (op)->GetOpaquePass();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRenderPass");
    return TCL_OK;
    }
  if ((!strcmp("SetOpaquePass",argv[1]))&&(argc == 3))
    {
    vtkRenderPass  *temp0;
    error = 0;

    temp0 = (vtkRenderPass *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkRenderPass"),interp,error));
    if (!error)
    {
    op->SetOpaquePass(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetTranslucentPass",argv[1]))&&(argc == 2))
    {
    vtkRenderPass  *temp20;
    temp20 = (op)->GetTranslucentPass();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRenderPass");
    return TCL_OK;
    }
  if ((!strcmp("SetTranslucentPass",argv[1]))&&(argc == 3))
    {
    vtkRenderPass  *temp0;
    error = 0;

    temp0 = (vtkRenderPass *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkRenderPass"),interp,error));
    if (!error)
    {
    op->SetTranslucentPass(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetVolumetricPass",argv[1]))&&(argc == 2))
    {
    vtkRenderPass  *temp20;
    temp20 = (op)->GetVolumetricPass();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRenderPass");
    return TCL_OK;
    }
  if ((!strcmp("SetVolumetricPass",argv[1]))&&(argc == 3))
    {
    vtkRenderPass  *temp0;
    error = 0;

    temp0 = (vtkRenderPass *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkRenderPass"),interp,error));
    if (!error)
    {
    op->SetVolumetricPass(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetOverlayPass",argv[1]))&&(argc == 2))
    {
    vtkRenderPass  *temp20;
    temp20 = (op)->GetOverlayPass();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRenderPass");
    return TCL_OK;
    }
  if ((!strcmp("SetOverlayPass",argv[1]))&&(argc == 3))
    {
    vtkRenderPass  *temp0;
    error = 0;

    temp0 = (vtkRenderPass *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkRenderPass"),interp,error));
    if (!error)
    {
    op->SetOverlayPass(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetPostProcessPass",argv[1]))&&(argc == 2))
    {
    vtkRenderPass  *temp20;
    temp20 = (op)->GetPostProcessPass();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRenderPass");
    return TCL_OK;
    }
  if ((!strcmp("SetPostProcessPass",argv[1]))&&(argc == 3))
    {
    vtkRenderPass  *temp0;
    error = 0;

    temp0 = (vtkRenderPass *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkRenderPass"),interp,error));
    if (!error)
    {
    op->SetPostProcessPass(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkRenderStepsPassCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkRenderPassCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkRenderStepsPass:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  ReleaseGraphicsResources\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetCameraPass\n",NULL);
    Tcl_AppendResult(interp,"  SetCameraPass\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLightsPass\n",NULL);
    Tcl_AppendResult(interp,"  SetLightsPass\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetOpaquePass\n",NULL);
    Tcl_AppendResult(interp,"  SetOpaquePass\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTranslucentPass\n",NULL);
    Tcl_AppendResult(interp,"  SetTranslucentPass\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetVolumetricPass\n",NULL);
    Tcl_AppendResult(interp,"  SetVolumetricPass\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetOverlayPass\n",NULL);
    Tcl_AppendResult(interp,"  SetOverlayPass\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPostProcessPass\n",NULL);
    Tcl_AppendResult(interp,"  SetPostProcessPass\t with 1 arg\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkRenderPassCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    Tcl_DStringAppendElement ( &dString, "GetCameraPass" );
    Tcl_DStringAppendElement ( &dString, "SetCameraPass" );
    Tcl_DStringAppendElement ( &dString, "GetLightsPass" );
    Tcl_DStringAppendElement ( &dString, "SetLightsPass" );
    Tcl_DStringAppendElement ( &dString, "GetOpaquePass" );
    Tcl_DStringAppendElement ( &dString, "SetOpaquePass" );
    Tcl_DStringAppendElement ( &dString, "GetTranslucentPass" );
    Tcl_DStringAppendElement ( &dString, "SetTranslucentPass" );
    Tcl_DStringAppendElement ( &dString, "GetVolumetricPass" );
    Tcl_DStringAppendElement ( &dString, "SetVolumetricPass" );
    Tcl_DStringAppendElement ( &dString, "GetOverlayPass" );
    Tcl_DStringAppendElement ( &dString, "SetOverlayPass" );
    Tcl_DStringAppendElement ( &dString, "GetPostProcessPass" );
    Tcl_DStringAppendElement ( &dString, "SetPostProcessPass" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkRenderPassCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkRenderStepsPass *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: ReleaseGraphicsResources */
    if ( strcmp ( argv[2], "ReleaseGraphicsResources" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkWindow" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ReleaseGraphicsResources */
    Tcl_DStringAppendElement ( &dString, " Release graphics resources and ask components to release their own\n resources.\n \\pre w_exists: w!=0\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void ReleaseGraphicsResources(vtkWindow *w);" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for ReleaseGraphicsResources */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetCameraPass */
    if ( strcmp ( argv[2], "GetCameraPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCameraPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCameraPass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the Camera Step\n" );
    Tcl_DStringAppendElement ( &dString, "vtkCameraPass *GetCameraPass();" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for GetCameraPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetCameraPass */
    if ( strcmp ( argv[2], "SetCameraPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetCameraPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkCameraPass" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetCameraPass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the Camera Step\n" );
    Tcl_DStringAppendElement ( &dString, "void SetCameraPass(vtkCameraPass *);" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for SetCameraPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetLightsPass */
    if ( strcmp ( argv[2], "GetLightsPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLightsPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLightsPass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the Lights Step\n" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass *GetLightsPass();" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for GetLightsPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetLightsPass */
    if ( strcmp ( argv[2], "SetLightsPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLightsPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLightsPass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the Lights Step\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLightsPass(vtkRenderPass *);" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for SetLightsPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetOpaquePass */
    if ( strcmp ( argv[2], "GetOpaquePass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOpaquePass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOpaquePass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the Opaque Step\n" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass *GetOpaquePass();" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for GetOpaquePass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetOpaquePass */
    if ( strcmp ( argv[2], "SetOpaquePass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOpaquePass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOpaquePass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the Opaque Step\n" );
    Tcl_DStringAppendElement ( &dString, "void SetOpaquePass(vtkRenderPass *);" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for SetOpaquePass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetTranslucentPass */
    if ( strcmp ( argv[2], "GetTranslucentPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTranslucentPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTranslucentPass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the translucent Step\n" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass *GetTranslucentPass();" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for GetTranslucentPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetTranslucentPass */
    if ( strcmp ( argv[2], "SetTranslucentPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTranslucentPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTranslucentPass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the translucent Step\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTranslucentPass(vtkRenderPass *);" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for SetTranslucentPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetVolumetricPass */
    if ( strcmp ( argv[2], "GetVolumetricPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetVolumetricPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetVolumetricPass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the Volume Step\n" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass *GetVolumetricPass();" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for GetVolumetricPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetVolumetricPass */
    if ( strcmp ( argv[2], "SetVolumetricPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetVolumetricPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetVolumetricPass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the Volume Step\n" );
    Tcl_DStringAppendElement ( &dString, "void SetVolumetricPass(vtkRenderPass *);" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for SetVolumetricPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetOverlayPass */
    if ( strcmp ( argv[2], "GetOverlayPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOverlayPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOverlayPass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the Overlay Step\n" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass *GetOverlayPass();" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for GetOverlayPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetOverlayPass */
    if ( strcmp ( argv[2], "SetOverlayPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOverlayPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOverlayPass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the Overlay Step\n" );
    Tcl_DStringAppendElement ( &dString, "void SetOverlayPass(vtkRenderPass *);" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for SetOverlayPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetPostProcessPass */
    if ( strcmp ( argv[2], "GetPostProcessPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPostProcessPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPostProcessPass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the PostProcess Step\n" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass *GetPostProcessPass();" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for GetPostProcessPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetPostProcessPass */
    if ( strcmp ( argv[2], "SetPostProcessPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPostProcessPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPostProcessPass */
    Tcl_DStringAppendElement ( &dString, " Get the RenderPass used for the PostProcess Step\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPostProcessPass(vtkRenderPass *);" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderStepsPass" );
    /* Closing for SetPostProcessPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkRenderPassCppCommand(static_cast<vtkRenderPass *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
