// java wrapper for vtkShader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkShader.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkShader_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkShader",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != NULL) { return res; }
  return NULL;
}


extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkShader_GetClassName_10(JNIEnv *env, jobject obj)
{
  vtkShader *op;
  const char    *temp20;

  op = (vtkShader *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetClassName();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkShader_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkShader *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkShader *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkShader_SetType_12(JNIEnv *env, jobject obj,jint id0)
{
  vtkShader *op;
  vtkShader::Type   temp0;
  temp0 = static_cast<vtkShader::Type>(id0);

  op = (vtkShader *)vtkJavaGetPointerFromObject(env,obj);
  op->SetType(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkShader_GetType_13(JNIEnv *env, jobject obj)
{
  vtkShader *op;
  vtkShader::Type   temp20;

  op = (vtkShader *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetType();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkShader_SetSource_14(JNIEnv *env, jobject obj,jstring id0)
{
  vtkShader *op;
  std::string temp0;
  vtkJavaUTFToString(env,id0,temp0);

  op = (vtkShader *)vtkJavaGetPointerFromObject(env,obj);
  op->SetSource(temp0);
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkShader_GetSource_15(JNIEnv *env, jobject obj)
{
  vtkShader *op;
  std::string   temp20;

  op = (vtkShader *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetSource();
  return vtkJavaMakeJavaString(env,temp20.c_str());
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkShader_GetError_16(JNIEnv *env, jobject obj)
{
  vtkShader *op;
  std::string   temp20;

  op = (vtkShader *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetError();
  return vtkJavaMakeJavaString(env,temp20.c_str());
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkShader_GetHandle_17(JNIEnv *env, jobject obj)
{
  vtkShader *op;
  int      temp20;

  op = (vtkShader *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetHandle();
  return temp20;
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkShader_Compile_18(JNIEnv *env, jobject obj)
{
  vtkShader *op;
  bool   temp20;

  op = (vtkShader *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->Compile();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkShader_Cleanup_19(JNIEnv *env, jobject obj)
{
  vtkShader *op;

  op = (vtkShader *)vtkJavaGetPointerFromObject(env,obj);
  op->Cleanup();
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkShader_VTKInit(JNIEnv *, jobject)
{
  vtkShader *aNewOne = vtkShader::New();
  return (jlong)(size_t)(void*)aNewOne;
}
