// tcl wrapper for vtkShaderProgram object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkShaderProgram.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkShaderProgramNewCommand()
{
  vtkShaderProgram *temp = vtkShaderProgram::New();
  return static_cast<ClientData>(temp);
}

int vtkObjectCppCommand(vtkObject *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkShaderProgramCppCommand(vtkShaderProgram *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkShaderProgramCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkShaderProgramCppCommand(static_cast<vtkShaderProgram *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkShaderProgram_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkShaderProgram"),vtkShaderProgramNewCommand,vtkShaderProgramCommand);
  return 0;
}

int VTKTCL_EXPORT vtkShaderProgramCppCommand(vtkShaderProgram *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkShaderProgram",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkObject"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkShaderProgram  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkShaderProgram");
    return TCL_OK;
    }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkShaderProgram  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkShaderProgram");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkShaderProgram  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkShaderProgram");
    return TCL_OK;
    }
    }
  if ((!strcmp("GetVertexShader",argv[1]))&&(argc == 2))
    {
    vtkShader  *temp20;
    temp20 = (op)->GetVertexShader();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkShader");
    return TCL_OK;
    }
  if ((!strcmp("SetVertexShader",argv[1]))&&(argc == 3))
    {
    vtkShader  *temp0;
    error = 0;

    temp0 = (vtkShader *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkShader"),interp,error));
    if (!error)
    {
    op->SetVertexShader(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetFragmentShader",argv[1]))&&(argc == 2))
    {
    vtkShader  *temp20;
    temp20 = (op)->GetFragmentShader();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkShader");
    return TCL_OK;
    }
  if ((!strcmp("SetFragmentShader",argv[1]))&&(argc == 3))
    {
    vtkShader  *temp0;
    error = 0;

    temp0 = (vtkShader *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkShader"),interp,error));
    if (!error)
    {
    op->SetFragmentShader(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetGeometryShader",argv[1]))&&(argc == 2))
    {
    vtkShader  *temp20;
    temp20 = (op)->GetGeometryShader();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkShader");
    return TCL_OK;
    }
  if ((!strcmp("SetGeometryShader",argv[1]))&&(argc == 3))
    {
    vtkShader  *temp0;
    error = 0;

    temp0 = (vtkShader *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkShader"),interp,error));
    if (!error)
    {
    op->SetGeometryShader(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetCompiled",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->GetCompiled();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetCompiled",argv[1]))&&(argc == 3))
    {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
    {
    op->SetCompiled(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("CompiledOn",argv[1]))&&(argc == 2))
    {
    op->CompiledOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("CompiledOff",argv[1]))&&(argc == 2))
    {
    op->CompiledOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
  if ((!strcmp("GetMD5Hash",argv[1]))&&(argc == 2))
    {
    std::string   temp20;
    temp20 = (op)->GetMD5Hash();
    Tcl_SetResult(interp, const_cast<char *>(temp20.c_str()), TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("isBound",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->isBound();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("ReleaseGraphicsResources",argv[1]))&&(argc == 3))
    {
    vtkWindow  *temp0;
    error = 0;

    temp0 = (vtkWindow *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkWindow"),interp,error));
    if (!error)
    {
    op->ReleaseGraphicsResources(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetHandle",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetHandle();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetError",argv[1]))&&(argc == 2))
    {
    std::string   temp20;
    temp20 = (op)->GetError();
    Tcl_SetResult(interp, const_cast<char *>(temp20.c_str()), TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("EnableAttributeArray",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    bool   temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->EnableAttributeArray(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("DisableAttributeArray",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    bool   temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->DisableAttributeArray(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetUniformi",argv[1]))&&(argc == 4))
    {
    char    *temp0;
    int      temp1;
    bool   temp20;
    error = 0;

    temp0 = argv[2];
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (!error)
    {
    temp20 = (op)->SetUniformi(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetUniformf",argv[1]))&&(argc == 4))
    {
    char    *temp0;
    float    temp1;
    bool   temp20;
    error = 0;

    temp0 = argv[2];
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (!error)
    {
    temp20 = (op)->SetUniformf(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetUniformMatrix",argv[1]))&&(argc == 4))
    {
    char    *temp0;
    vtkMatrix3x3  *temp1;
    bool   temp20;
    error = 0;

    temp0 = argv[2];
    temp1 = (vtkMatrix3x3 *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkMatrix3x3"),interp,error));
    if (!error)
    {
    temp20 = (op)->SetUniformMatrix(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetUniformMatrix",argv[1]))&&(argc == 4))
    {
    char    *temp0;
    vtkMatrix4x4  *temp1;
    bool   temp20;
    error = 0;

    temp0 = argv[2];
    temp1 = (vtkMatrix4x4 *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkMatrix4x4"),interp,error));
    if (!error)
    {
    temp20 = (op)->SetUniformMatrix(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetNumberOfOutputs",argv[1]))&&(argc == 3))
    {
    unsigned int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    op->SetNumberOfOutputs(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("IsUniformUsed",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    bool   temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsUniformUsed(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkShaderProgramCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkShaderProgram:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetVertexShader\n",NULL);
    Tcl_AppendResult(interp,"  SetVertexShader\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetFragmentShader\n",NULL);
    Tcl_AppendResult(interp,"  SetFragmentShader\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetGeometryShader\n",NULL);
    Tcl_AppendResult(interp,"  SetGeometryShader\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetCompiled\n",NULL);
    Tcl_AppendResult(interp,"  SetCompiled\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  CompiledOn\n",NULL);
    Tcl_AppendResult(interp,"  CompiledOff\n",NULL);
    Tcl_AppendResult(interp,"  GetMD5Hash\n",NULL);
    Tcl_AppendResult(interp,"  isBound\n",NULL);
    Tcl_AppendResult(interp,"  ReleaseGraphicsResources\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetHandle\n",NULL);
    Tcl_AppendResult(interp,"  GetError\n",NULL);
    Tcl_AppendResult(interp,"  EnableAttributeArray\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  DisableAttributeArray\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetUniformi\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  SetUniformf\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  SetUniformMatrix\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  SetUniformMatrix\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  SetNumberOfOutputs\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  IsUniformUsed\t with 1 arg\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "GetVertexShader" );
    Tcl_DStringAppendElement ( &dString, "SetVertexShader" );
    Tcl_DStringAppendElement ( &dString, "GetFragmentShader" );
    Tcl_DStringAppendElement ( &dString, "SetFragmentShader" );
    Tcl_DStringAppendElement ( &dString, "GetGeometryShader" );
    Tcl_DStringAppendElement ( &dString, "SetGeometryShader" );
    Tcl_DStringAppendElement ( &dString, "GetCompiled" );
    Tcl_DStringAppendElement ( &dString, "SetCompiled" );
    Tcl_DStringAppendElement ( &dString, "CompiledOn" );
    Tcl_DStringAppendElement ( &dString, "CompiledOff" );
    Tcl_DStringAppendElement ( &dString, "GetMD5Hash" );
    Tcl_DStringAppendElement ( &dString, "isBound" );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    Tcl_DStringAppendElement ( &dString, "GetHandle" );
    Tcl_DStringAppendElement ( &dString, "GetError" );
    Tcl_DStringAppendElement ( &dString, "EnableAttributeArray" );
    Tcl_DStringAppendElement ( &dString, "DisableAttributeArray" );
    Tcl_DStringAppendElement ( &dString, "SetUniformi" );
    Tcl_DStringAppendElement ( &dString, "SetUniformf" );
    Tcl_DStringAppendElement ( &dString, "SetUniformMatrix" );
    Tcl_DStringAppendElement ( &dString, "SetUniformMatrix" );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfOutputs" );
    Tcl_DStringAppendElement ( &dString, "IsUniformUsed" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkObjectCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkShaderProgram *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetVertexShader */
    if ( strcmp ( argv[2], "GetVertexShader" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetVertexShader" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetVertexShader */
    Tcl_DStringAppendElement ( &dString, " Get the vertex shader for this program\n" );
    Tcl_DStringAppendElement ( &dString, "vtkShader *GetVertexShader();" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for GetVertexShader */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetVertexShader */
    if ( strcmp ( argv[2], "SetVertexShader" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetVertexShader" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkShader" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetVertexShader */
    Tcl_DStringAppendElement ( &dString, " Get the vertex shader for this program\n" );
    Tcl_DStringAppendElement ( &dString, "void SetVertexShader(vtkShader *);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for SetVertexShader */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetFragmentShader */
    if ( strcmp ( argv[2], "GetFragmentShader" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetFragmentShader" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetFragmentShader */
    Tcl_DStringAppendElement ( &dString, " Get the fragment shader for this program\n" );
    Tcl_DStringAppendElement ( &dString, "vtkShader *GetFragmentShader();" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for GetFragmentShader */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetFragmentShader */
    if ( strcmp ( argv[2], "SetFragmentShader" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetFragmentShader" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkShader" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetFragmentShader */
    Tcl_DStringAppendElement ( &dString, " Get the fragment shader for this program\n" );
    Tcl_DStringAppendElement ( &dString, "void SetFragmentShader(vtkShader *);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for SetFragmentShader */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetGeometryShader */
    if ( strcmp ( argv[2], "GetGeometryShader" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetGeometryShader" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetGeometryShader */
    Tcl_DStringAppendElement ( &dString, " Get the geometry shader for this program\n" );
    Tcl_DStringAppendElement ( &dString, "vtkShader *GetGeometryShader();" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for GetGeometryShader */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetGeometryShader */
    if ( strcmp ( argv[2], "SetGeometryShader" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetGeometryShader" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkShader" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetGeometryShader */
    Tcl_DStringAppendElement ( &dString, " Get the geometry shader for this program\n" );
    Tcl_DStringAppendElement ( &dString, "void SetGeometryShader(vtkShader *);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for SetGeometryShader */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetCompiled */
    if ( strcmp ( argv[2], "GetCompiled" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCompiled" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCompiled */
    Tcl_DStringAppendElement ( &dString, " Set/Get flag for if this program is compiled\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetCompiled();" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for GetCompiled */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetCompiled */
    if ( strcmp ( argv[2], "SetCompiled" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetCompiled" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetCompiled */
    Tcl_DStringAppendElement ( &dString, " Set/Get flag for if this program is compiled\n" );
    Tcl_DStringAppendElement ( &dString, "void SetCompiled(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for SetCompiled */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: CompiledOn */
    if ( strcmp ( argv[2], "CompiledOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "CompiledOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for CompiledOn */
    Tcl_DStringAppendElement ( &dString, " Set/Get flag for if this program is compiled\n" );
    Tcl_DStringAppendElement ( &dString, "void CompiledOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for CompiledOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: CompiledOff */
    if ( strcmp ( argv[2], "CompiledOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "CompiledOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for CompiledOff */
    Tcl_DStringAppendElement ( &dString, " Set/Get flag for if this program is compiled\n" );
    Tcl_DStringAppendElement ( &dString, "void CompiledOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for CompiledOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetMD5Hash */
    if ( strcmp ( argv[2], "GetMD5Hash" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMD5Hash" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMD5Hash */
    Tcl_DStringAppendElement ( &dString, " Set/Get the md5 hash of this program\n" );
    Tcl_DStringAppendElement ( &dString, "std::string GetMD5Hash() const;" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for GetMD5Hash */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: isBound */
    if ( strcmp ( argv[2], "isBound" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "isBound" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for isBound */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "bool isBound() const;" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for isBound */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: ReleaseGraphicsResources */
    if ( strcmp ( argv[2], "ReleaseGraphicsResources" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkWindow" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ReleaseGraphicsResources */
    Tcl_DStringAppendElement ( &dString, " release any graphics resources this class is using.\n" );
    Tcl_DStringAppendElement ( &dString, "void ReleaseGraphicsResources(vtkWindow *win);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for ReleaseGraphicsResources */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetHandle */
    if ( strcmp ( argv[2], "GetHandle" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetHandle" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetHandle */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int GetHandle() const;" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for GetHandle */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetError */
    if ( strcmp ( argv[2], "GetError" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetError" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetError */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "std::string GetError() const;" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for GetError */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: EnableAttributeArray */
    if ( strcmp ( argv[2], "EnableAttributeArray" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "EnableAttributeArray" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for EnableAttributeArray */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "bool EnableAttributeArray(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for EnableAttributeArray */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: DisableAttributeArray */
    if ( strcmp ( argv[2], "DisableAttributeArray" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DisableAttributeArray" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DisableAttributeArray */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "bool DisableAttributeArray(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for DisableAttributeArray */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetUniformi */
    if ( strcmp ( argv[2], "SetUniformi" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetUniformi" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetUniformi */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "bool SetUniformi(const char *name, int v);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for SetUniformi */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetUniformf */
    if ( strcmp ( argv[2], "SetUniformf" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetUniformf" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetUniformf */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "bool SetUniformf(const char *name, float v);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for SetUniformf */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetUniformMatrix */
    if ( strcmp ( argv[2], "SetUniformMatrix" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetUniformMatrix" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringAppendElement ( &dString, "vtkMatrix3x3" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetUniformMatrix */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "bool SetUniformMatrix(const char *name, vtkMatrix3x3 *v);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for SetUniformMatrix */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetUniformMatrix */
    if ( strcmp ( argv[2], "SetUniformMatrix" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetUniformMatrix" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringAppendElement ( &dString, "vtkMatrix4x4" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetUniformMatrix */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "bool SetUniformMatrix(const char *name, vtkMatrix4x4 *v);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for SetUniformMatrix */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetNumberOfOutputs */
    if ( strcmp ( argv[2], "SetNumberOfOutputs" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfOutputs" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNumberOfOutputs */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetNumberOfOutputs(unsigned int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for SetNumberOfOutputs */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsUniformUsed */
    if ( strcmp ( argv[2], "IsUniformUsed" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsUniformUsed" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsUniformUsed */
    Tcl_DStringAppendElement ( &dString, " methods to inquire as to what uniforms/attributes are used by\n this shader.  This can save some compute time if the uniforms\n or attributes are expensive to compute\n" );
    Tcl_DStringAppendElement ( &dString, "bool IsUniformUsed(const char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    /* Closing for IsUniformUsed */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
