// tcl wrapper for vtkShadowMapBakerPass object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkShadowMapBakerPass.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkShadowMapBakerPassNewCommand()
{
  vtkShadowMapBakerPass *temp = vtkShadowMapBakerPass::New();
  return static_cast<ClientData>(temp);
}

int vtkRenderPassCppCommand(vtkRenderPass *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkShadowMapBakerPassCppCommand(vtkShadowMapBakerPass *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkShadowMapBakerPassCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkShadowMapBakerPassCppCommand(static_cast<vtkShadowMapBakerPass *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkShadowMapBakerPass_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkShadowMapBakerPass"),vtkShadowMapBakerPassNewCommand,vtkShadowMapBakerPassCommand);
  return 0;
}

int VTKTCL_EXPORT vtkShadowMapBakerPassCppCommand(vtkShadowMapBakerPass *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkShadowMapBakerPass",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkRenderPassCppCommand(static_cast<vtkRenderPass *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkRenderPass"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkShadowMapBakerPass  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkShadowMapBakerPass");
    return TCL_OK;
    }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkShadowMapBakerPass  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkShadowMapBakerPass");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkShadowMapBakerPass  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkShadowMapBakerPass");
    return TCL_OK;
    }
    }
  if ((!strcmp("ReleaseGraphicsResources",argv[1]))&&(argc == 3))
    {
    vtkWindow  *temp0;
    error = 0;

    temp0 = (vtkWindow *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkWindow"),interp,error));
    if (!error)
    {
    op->ReleaseGraphicsResources(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetOpaqueSequence",argv[1]))&&(argc == 2))
    {
    vtkRenderPass  *temp20;
    temp20 = (op)->GetOpaqueSequence();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRenderPass");
    return TCL_OK;
    }
  if ((!strcmp("SetOpaqueSequence",argv[1]))&&(argc == 3))
    {
    vtkRenderPass  *temp0;
    error = 0;

    temp0 = (vtkRenderPass *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkRenderPass"),interp,error));
    if (!error)
    {
    op->SetOpaqueSequence(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetCompositeZPass",argv[1]))&&(argc == 2))
    {
    vtkRenderPass  *temp20;
    temp20 = (op)->GetCompositeZPass();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkRenderPass");
    return TCL_OK;
    }
  if ((!strcmp("SetCompositeZPass",argv[1]))&&(argc == 3))
    {
    vtkRenderPass  *temp0;
    error = 0;

    temp0 = (vtkRenderPass *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkRenderPass"),interp,error));
    if (!error)
    {
    op->SetCompositeZPass(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetResolution",argv[1]))&&(argc == 3))
    {
    unsigned int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
    {
    op->SetResolution(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetResolution",argv[1]))&&(argc == 2))
    {
    unsigned int      temp20;
    temp20 = (op)->GetResolution();
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetHasShadows",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->GetHasShadows();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("LightCreatesShadow",argv[1]))&&(argc == 3))
    {
    vtkLight  *temp0;
    bool   temp20;
    error = 0;

    temp0 = (vtkLight *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkLight"),interp,error));
    if (!error)
    {
    temp20 = (op)->LightCreatesShadow(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetNeedUpdate",argv[1]))&&(argc == 2))
    {
    bool   temp20;
    temp20 = (op)->GetNeedUpdate();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetUpToDate",argv[1]))&&(argc == 2))
    {
    op->SetUpToDate();
    Tcl_ResetResult(interp);
    return TCL_OK;
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkShadowMapBakerPassCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkRenderPassCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkShadowMapBakerPass:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  ReleaseGraphicsResources\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetOpaqueSequence\n",NULL);
    Tcl_AppendResult(interp,"  SetOpaqueSequence\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetCompositeZPass\n",NULL);
    Tcl_AppendResult(interp,"  SetCompositeZPass\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetResolution\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetResolution\n",NULL);
    Tcl_AppendResult(interp,"  GetHasShadows\n",NULL);
    Tcl_AppendResult(interp,"  LightCreatesShadow\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNeedUpdate\n",NULL);
    Tcl_AppendResult(interp,"  SetUpToDate\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkRenderPassCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    Tcl_DStringAppendElement ( &dString, "GetOpaqueSequence" );
    Tcl_DStringAppendElement ( &dString, "SetOpaqueSequence" );
    Tcl_DStringAppendElement ( &dString, "GetCompositeZPass" );
    Tcl_DStringAppendElement ( &dString, "SetCompositeZPass" );
    Tcl_DStringAppendElement ( &dString, "SetResolution" );
    Tcl_DStringAppendElement ( &dString, "GetResolution" );
    Tcl_DStringAppendElement ( &dString, "GetHasShadows" );
    Tcl_DStringAppendElement ( &dString, "LightCreatesShadow" );
    Tcl_DStringAppendElement ( &dString, "GetNeedUpdate" );
    Tcl_DStringAppendElement ( &dString, "SetUpToDate" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkRenderPassCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkShadowMapBakerPass *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: ReleaseGraphicsResources */
    if ( strcmp ( argv[2], "ReleaseGraphicsResources" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkWindow" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ReleaseGraphicsResources */
    Tcl_DStringAppendElement ( &dString, " Release graphics resources and ask components to release their own\n resources.\n \\pre w_exists: w!=0\n" );
    Tcl_DStringAppendElement ( &dString, "void ReleaseGraphicsResources(vtkWindow *w);" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for ReleaseGraphicsResources */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetOpaqueSequence */
    if ( strcmp ( argv[2], "GetOpaqueSequence" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOpaqueSequence" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOpaqueSequence */
    Tcl_DStringAppendElement ( &dString, " Delegate for rendering the camera, lights, and opaque geometry.\n If it is NULL, nothing will be rendered and a warning will be emitted.\n It defaults to a vtkCameraPass with a sequence of\n vtkLightPass/vtkOpaquePass.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass *GetOpaqueSequence();" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for GetOpaqueSequence */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetOpaqueSequence */
    if ( strcmp ( argv[2], "SetOpaqueSequence" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOpaqueSequence" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOpaqueSequence */
    Tcl_DStringAppendElement ( &dString, " Delegate for rendering the camera, lights, and opaque geometry.\n If it is NULL, nothing will be rendered and a warning will be emitted.\n It defaults to a vtkCameraPass with a sequence of\n vtkLightPass/vtkOpaquePass.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetOpaqueSequence(vtkRenderPass *opaqueSequence);" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for SetOpaqueSequence */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetCompositeZPass */
    if ( strcmp ( argv[2], "GetCompositeZPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCompositeZPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCompositeZPass */
    Tcl_DStringAppendElement ( &dString, " Delegate for compositing of the shadow maps across processors.\n If it is NULL, there is no z compositing.\n It is usually set to a vtkCompositeZPass (Parallel package).\n Initial value is a NULL pointer.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass *GetCompositeZPass();" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for GetCompositeZPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetCompositeZPass */
    if ( strcmp ( argv[2], "SetCompositeZPass" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetCompositeZPass" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkRenderPass" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetCompositeZPass */
    Tcl_DStringAppendElement ( &dString, " Delegate for compositing of the shadow maps across processors.\n If it is NULL, there is no z compositing.\n It is usually set to a vtkCompositeZPass (Parallel package).\n Initial value is a NULL pointer.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetCompositeZPass(vtkRenderPass *compositeZPass);" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for SetCompositeZPass */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetResolution */
    if ( strcmp ( argv[2], "SetResolution" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetResolution" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetResolution */
    Tcl_DStringAppendElement ( &dString, " Set/Get the number of pixels in each dimension of the shadow maps\n (shadow maps are square). Initial value is 256. The greater the better.\n Resolution does not have to be a power-of-two value.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetResolution(unsigned int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for SetResolution */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetResolution */
    if ( strcmp ( argv[2], "GetResolution" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetResolution" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetResolution */
    Tcl_DStringAppendElement ( &dString, " Set/Get the number of pixels in each dimension of the shadow maps\n (shadow maps are square). Initial value is 256. The greater the better.\n Resolution does not have to be a power-of-two value.\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetResolution();" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for GetResolution */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetHasShadows */
    if ( strcmp ( argv[2], "GetHasShadows" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetHasShadows" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetHasShadows */
    Tcl_DStringAppendElement ( &dString, " INTERNAL USE ONLY.\n Internally used by vtkShadowMapBakerPass and vtkShadowMapPass.\n\n Tell if there is at least one shadow.\n Initial value is false.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetHasShadows();" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for GetHasShadows */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: LightCreatesShadow */
    if ( strcmp ( argv[2], "LightCreatesShadow" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "LightCreatesShadow" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkLight" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for LightCreatesShadow */
    Tcl_DStringAppendElement ( &dString, " INTERNAL USE ONLY.\n Internally used by vtkShadowMapBakerPass and vtkShadowMapPass.\n\n Tell if the light `l' can create shadows.\n The light has to not be a head light and to be directional or\n positional with an angle less than 180 degrees.\n \\pre l_exists: l!=0\n" );
    Tcl_DStringAppendElement ( &dString, "bool LightCreatesShadow(vtkLight *l);" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for LightCreatesShadow */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetNeedUpdate */
    if ( strcmp ( argv[2], "GetNeedUpdate" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNeedUpdate" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNeedUpdate */
    Tcl_DStringAppendElement ( &dString, " INTERNAL USE ONLY.\n Internally used by vtkShadowMapBakerPass and vtkShadowMapPass.\n\n Do the shadows need to be updated?\n Value changed by vtkShadowMapBakerPass and used by vtkShadowMapPass.\n Initial value is true.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetNeedUpdate();" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for GetNeedUpdate */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetUpToDate */
    if ( strcmp ( argv[2], "SetUpToDate" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetUpToDate" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetUpToDate */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetUpToDate();" );
    Tcl_DStringAppendElement ( &dString, "vtkShadowMapBakerPass" );
    /* Closing for SetUpToDate */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkRenderPassCppCommand(static_cast<vtkRenderPass *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
