#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkDirectionEncoder_TclCreate(Tcl_Interp *interp);
int vtkEncodedGradientEstimator_TclCreate(Tcl_Interp *interp);
int vtkEncodedGradientShader_TclCreate(Tcl_Interp *interp);
int vtkFiniteDifferenceGradientEstimator_TclCreate(Tcl_Interp *interp);
int vtkFixedPointRayCastImage_TclCreate(Tcl_Interp *interp);
int vtkFixedPointVolumeRayCastCompositeGOHelper_TclCreate(Tcl_Interp *interp);
int vtkFixedPointVolumeRayCastCompositeGOShadeHelper_TclCreate(Tcl_Interp *interp);
int vtkFixedPointVolumeRayCastCompositeHelper_TclCreate(Tcl_Interp *interp);
int vtkFixedPointVolumeRayCastCompositeShadeHelper_TclCreate(Tcl_Interp *interp);
int vtkFixedPointVolumeRayCastHelper_TclCreate(Tcl_Interp *interp);
int vtkFixedPointVolumeRayCastMIPHelper_TclCreate(Tcl_Interp *interp);
int vtkFixedPointVolumeRayCastMapper_TclCreate(Tcl_Interp *interp);
int vtkGPUVolumeRayCastMapper_TclCreate(Tcl_Interp *interp);
int vtkProjectedTetrahedraMapper_TclCreate(Tcl_Interp *interp);
int vtkRayCastImageDisplayHelper_TclCreate(Tcl_Interp *interp);
int vtkRecursiveSphereDirectionEncoder_TclCreate(Tcl_Interp *interp);
int vtkSphericalDirectionEncoder_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridBunykRayCastFunction_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridHomogeneousRayIntegrator_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridLinearRayIntegrator_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridPartialPreIntegration_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridPreIntegration_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridVolumeMapper_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridVolumeRayCastFunction_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridVolumeRayCastIterator_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridVolumeRayCastMapper_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridVolumeRayIntegrator_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridVolumeZSweepMapper_TclCreate(Tcl_Interp *interp);
int vtkVolumeMapper_TclCreate(Tcl_Interp *interp);
int vtkVolumeOutlineSource_TclCreate(Tcl_Interp *interp);
int vtkVolumePicker_TclCreate(Tcl_Interp *interp);
int vtkVolumeRayCastCompositeFunction_TclCreate(Tcl_Interp *interp);
int vtkVolumeRayCastFunction_TclCreate(Tcl_Interp *interp);
int vtkVolumeRayCastIsosurfaceFunction_TclCreate(Tcl_Interp *interp);
int vtkVolumeRayCastMIPFunction_TclCreate(Tcl_Interp *interp);
int vtkVolumeRayCastMapper_TclCreate(Tcl_Interp *interp);
int vtkVolumeRayCastSpaceLeapingImageFilter_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkrenderingvolumetcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkrenderingvolumetcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkrenderingvolumetcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkrenderingvolumetcl_Init(interp);
}


int VTK_EXPORT Vtkrenderingvolumetcl_Init(Tcl_Interp *interp)
{

  vtkDirectionEncoder_TclCreate(interp);
  vtkEncodedGradientEstimator_TclCreate(interp);
  vtkEncodedGradientShader_TclCreate(interp);
  vtkFiniteDifferenceGradientEstimator_TclCreate(interp);
  vtkFixedPointRayCastImage_TclCreate(interp);
  vtkFixedPointVolumeRayCastCompositeGOHelper_TclCreate(interp);
  vtkFixedPointVolumeRayCastCompositeGOShadeHelper_TclCreate(interp);
  vtkFixedPointVolumeRayCastCompositeHelper_TclCreate(interp);
  vtkFixedPointVolumeRayCastCompositeShadeHelper_TclCreate(interp);
  vtkFixedPointVolumeRayCastHelper_TclCreate(interp);
  vtkFixedPointVolumeRayCastMIPHelper_TclCreate(interp);
  vtkFixedPointVolumeRayCastMapper_TclCreate(interp);
  vtkGPUVolumeRayCastMapper_TclCreate(interp);
  vtkProjectedTetrahedraMapper_TclCreate(interp);
  vtkRayCastImageDisplayHelper_TclCreate(interp);
  vtkRecursiveSphereDirectionEncoder_TclCreate(interp);
  vtkSphericalDirectionEncoder_TclCreate(interp);
  vtkUnstructuredGridBunykRayCastFunction_TclCreate(interp);
  vtkUnstructuredGridHomogeneousRayIntegrator_TclCreate(interp);
  vtkUnstructuredGridLinearRayIntegrator_TclCreate(interp);
  vtkUnstructuredGridPartialPreIntegration_TclCreate(interp);
  vtkUnstructuredGridPreIntegration_TclCreate(interp);
  vtkUnstructuredGridVolumeMapper_TclCreate(interp);
  vtkUnstructuredGridVolumeRayCastFunction_TclCreate(interp);
  vtkUnstructuredGridVolumeRayCastIterator_TclCreate(interp);
  vtkUnstructuredGridVolumeRayCastMapper_TclCreate(interp);
  vtkUnstructuredGridVolumeRayIntegrator_TclCreate(interp);
  vtkUnstructuredGridVolumeZSweepMapper_TclCreate(interp);
  vtkVolumeMapper_TclCreate(interp);
  vtkVolumeOutlineSource_TclCreate(interp);
  vtkVolumePicker_TclCreate(interp);
  vtkVolumeRayCastCompositeFunction_TclCreate(interp);
  vtkVolumeRayCastFunction_TclCreate(interp);
  vtkVolumeRayCastIsosurfaceFunction_TclCreate(interp);
  vtkVolumeRayCastMIPFunction_TclCreate(interp);
  vtkVolumeRayCastMapper_TclCreate(interp);
  vtkVolumeRayCastSpaceLeapingImageFilter_TclCreate(interp);
  char pkgName[]="vtkRenderingVolumeTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
