// tcl wrapper for vtkTanglegramItem object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTanglegramItem.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkTanglegramItemNewCommand()
{
  vtkTanglegramItem *temp = vtkTanglegramItem::New();
  return static_cast<ClientData>(temp);
}

int vtkContextItemCppCommand(vtkContextItem *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkTanglegramItemCppCommand(vtkTanglegramItem *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkTanglegramItemCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
    {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
    }
   return vtkTanglegramItemCppCommand(static_cast<vtkTanglegramItem *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkTanglegramItem_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkTanglegramItem"),vtkTanglegramItemNewCommand,vtkTanglegramItemCommand);
  return 0;
}

int VTKTCL_EXPORT vtkTanglegramItemCppCommand(vtkTanglegramItem *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
    {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
    }
  if (!interp)
    {
    if (!strcmp("DoTypecasting",argv[0]))
      {
      if (!strcmp("vtkTanglegramItem",argv[1]))
        {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
        }
      if (vtkContextItemCppCommand(static_cast<vtkContextItem *>(op),interp,argc,argv) == TCL_OK)
        {
        return TCL_OK;
        }
      }
    return TCL_ERROR;
    }

  if (!strcmp("GetSuperClassName",argv[1]))
    {
    Tcl_SetResult(interp,const_cast<char *>("vtkContextItem"), TCL_VOLATILE);
    return TCL_OK;
    }

  try
    {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
    {
    vtkTanglegramItem  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTanglegramItem");
    return TCL_OK;
    }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
    {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
    }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
    {
    vtkTanglegramItem  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTanglegramItem");
    return TCL_OK;
    }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
    {
    vtkObject  *temp0;
    vtkTanglegramItem  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
    {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTanglegramItem");
    return TCL_OK;
    }
    }
  if ((!strcmp("SetTree1",argv[1]))&&(argc == 3))
    {
    vtkTree  *temp0;
    error = 0;

    temp0 = (vtkTree *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTree"),interp,error));
    if (!error)
    {
    op->SetTree1(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetTree2",argv[1]))&&(argc == 3))
    {
    vtkTree  *temp0;
    error = 0;

    temp0 = (vtkTree *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTree"),interp,error));
    if (!error)
    {
    op->SetTree2(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetTable",argv[1]))&&(argc == 2))
    {
    vtkTable  *temp20;
    temp20 = (op)->GetTable();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTable");
    return TCL_OK;
    }
  if ((!strcmp("SetTable",argv[1]))&&(argc == 3))
    {
    vtkTable  *temp0;
    error = 0;

    temp0 = (vtkTable *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTable"),interp,error));
    if (!error)
    {
    op->SetTable(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetTree1Label",argv[1]))&&(argc == 2))
    {
    char    *temp20;
    temp20 = (op)->GetTree1Label();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("SetTree1Label",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    op->SetTree1Label(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetTree2Label",argv[1]))&&(argc == 2))
    {
    char    *temp20;
    temp20 = (op)->GetTree2Label();
    if (temp20)
      {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
      }
    else
      {
      Tcl_ResetResult(interp);
      }
    return TCL_OK;
    }
  if ((!strcmp("SetTree2Label",argv[1]))&&(argc == 3))
    {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
    {
    op->SetTree2Label(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("SetOrientation",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->SetOrientation(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetOrientation",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetOrientation();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("GetMinimumVisibleFontSize",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetMinimumVisibleFontSize();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetMinimumVisibleFontSize",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->SetMinimumVisibleFontSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetLabelSizeDifference",argv[1]))&&(argc == 2))
    {
    int      temp20;
    temp20 = (op)->GetLabelSizeDifference();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetLabelSizeDifference",argv[1]))&&(argc == 3))
    {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
    {
    op->SetLabelSizeDifference(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetCorrespondenceLineWidth",argv[1]))&&(argc == 2))
    {
    float    temp20;
    temp20 = (op)->GetCorrespondenceLineWidth();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetCorrespondenceLineWidth",argv[1]))&&(argc == 3))
    {
    float    temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
    {
    op->SetCorrespondenceLineWidth(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }
  if ((!strcmp("GetTreeLineWidth",argv[1]))&&(argc == 2))
    {
    float    temp20;
    temp20 = (op)->GetTreeLineWidth();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
    }
  if ((!strcmp("SetTreeLineWidth",argv[1]))&&(argc == 3))
    {
    float    temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
    {
    op->SetTreeLineWidth(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
    }
    }

  if (!strcmp("ListInstances",argv[1]))
    {
    vtkTclListInstances(interp,(ClientData)(vtkTanglegramItemCommand));
    return TCL_OK;
    }

  if (!strcmp("ListMethods",argv[1]))
    {
    vtkContextItemCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkTanglegramItem:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetTree1\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetTree2\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTable\n",NULL);
    Tcl_AppendResult(interp,"  SetTable\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTree1Label\n",NULL);
    Tcl_AppendResult(interp,"  SetTree1Label\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTree2Label\n",NULL);
    Tcl_AppendResult(interp,"  SetTree2Label\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetOrientation\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetOrientation\n",NULL);
    Tcl_AppendResult(interp,"  GetMinimumVisibleFontSize\n",NULL);
    Tcl_AppendResult(interp,"  SetMinimumVisibleFontSize\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLabelSizeDifference\n",NULL);
    Tcl_AppendResult(interp,"  SetLabelSizeDifference\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetCorrespondenceLineWidth\n",NULL);
    Tcl_AppendResult(interp,"  SetCorrespondenceLineWidth\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTreeLineWidth\n",NULL);
    Tcl_AppendResult(interp,"  SetTreeLineWidth\t with 1 arg\n",NULL);
    return TCL_OK;
    }

  if (!strcmp("DescribeMethods",argv[1]))
    {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkContextItemCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetTree1" );
    Tcl_DStringAppendElement ( &dString, "SetTree2" );
    Tcl_DStringAppendElement ( &dString, "GetTable" );
    Tcl_DStringAppendElement ( &dString, "SetTable" );
    Tcl_DStringAppendElement ( &dString, "GetTree1Label" );
    Tcl_DStringAppendElement ( &dString, "SetTree1Label" );
    Tcl_DStringAppendElement ( &dString, "GetTree2Label" );
    Tcl_DStringAppendElement ( &dString, "SetTree2Label" );
    Tcl_DStringAppendElement ( &dString, "SetOrientation" );
    Tcl_DStringAppendElement ( &dString, "GetOrientation" );
    Tcl_DStringAppendElement ( &dString, "GetMinimumVisibleFontSize" );
    Tcl_DStringAppendElement ( &dString, "SetMinimumVisibleFontSize" );
    Tcl_DStringAppendElement ( &dString, "GetLabelSizeDifference" );
    Tcl_DStringAppendElement ( &dString, "SetLabelSizeDifference" );
    Tcl_DStringAppendElement ( &dString, "GetCorrespondenceLineWidth" );
    Tcl_DStringAppendElement ( &dString, "SetCorrespondenceLineWidth" );
    Tcl_DStringAppendElement ( &dString, "GetTreeLineWidth" );
    Tcl_DStringAppendElement ( &dString, "SetTreeLineWidth" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
    }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkContextItemCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkTanglegramItem *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetTree1 */
    if ( strcmp ( argv[2], "SetTree1" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTree1" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTree" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTree1 */
    Tcl_DStringAppendElement ( &dString, " Set the first tree\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetTree1(vtkTree *tree);" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for SetTree1 */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetTree2 */
    if ( strcmp ( argv[2], "SetTree2" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTree2" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTree" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTree2 */
    Tcl_DStringAppendElement ( &dString, " Set the second tree\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetTree2(vtkTree *tree);" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for SetTree2 */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetTable */
    if ( strcmp ( argv[2], "GetTable" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTable" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTable */
    Tcl_DStringAppendElement ( &dString, " Get/Set the table that describes the correspondences between the\n two trees.  The first column should contain the names of the leaf\n nodes from tree #1.  The columns of this table should be named\n after the leaf nodes of tree #2.  A non-zero cell should be used\n to create a connection between the two trees.  Different numbers\n in the table will result in connections being drawn in different\n colors.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkTable *GetTable();" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for GetTable */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetTable */
    if ( strcmp ( argv[2], "SetTable" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTable" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTable" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTable */
    Tcl_DStringAppendElement ( &dString, " Get/Set the table that describes the correspondences between the\n two trees.  The first column should contain the names of the leaf\n nodes from tree #1.  The columns of this table should be named\n after the leaf nodes of tree #2.  A non-zero cell should be used\n to create a connection between the two trees.  Different numbers\n in the table will result in connections being drawn in different\n colors.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTable(vtkTable *table);" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for SetTable */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetTree1Label */
    if ( strcmp ( argv[2], "GetTree1Label" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTree1Label" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTree1Label */
    Tcl_DStringAppendElement ( &dString, " Get/Set the label for tree #1.\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetTree1Label();" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for GetTree1Label */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetTree1Label */
    if ( strcmp ( argv[2], "SetTree1Label" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTree1Label" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTree1Label */
    Tcl_DStringAppendElement ( &dString, " Get/Set the label for tree #1.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTree1Label(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for SetTree1Label */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetTree2Label */
    if ( strcmp ( argv[2], "GetTree2Label" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTree2Label" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTree2Label */
    Tcl_DStringAppendElement ( &dString, " Get/Set the label for tree #2.\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetTree2Label();" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for GetTree2Label */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetTree2Label */
    if ( strcmp ( argv[2], "SetTree2Label" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTree2Label" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTree2Label */
    Tcl_DStringAppendElement ( &dString, " Get/Set the label for tree #2.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTree2Label(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for SetTree2Label */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetOrientation */
    if ( strcmp ( argv[2], "SetOrientation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOrientation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOrientation */
    Tcl_DStringAppendElement ( &dString, " Set which way the tanglegram should face within the visualization.\n The default is for tree #1 to be drawn left to right.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetOrientation(int orientation);" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for SetOrientation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetOrientation */
    if ( strcmp ( argv[2], "GetOrientation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOrientation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOrientation */
    Tcl_DStringAppendElement ( &dString, " Get the current orientation.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetOrientation();" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for GetOrientation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetMinimumVisibleFontSize */
    if ( strcmp ( argv[2], "GetMinimumVisibleFontSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMinimumVisibleFontSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMinimumVisibleFontSize */
    Tcl_DStringAppendElement ( &dString, " Get/Set the smallest font size that is still considered legible.\n If the current zoom level requires our vertex labels to be smaller\n than this size the labels will not be drawn at all.  Default value\n is 8 pt.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetMinimumVisibleFontSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for GetMinimumVisibleFontSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetMinimumVisibleFontSize */
    if ( strcmp ( argv[2], "SetMinimumVisibleFontSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMinimumVisibleFontSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMinimumVisibleFontSize */
    Tcl_DStringAppendElement ( &dString, " Get/Set the smallest font size that is still considered legible.\n If the current zoom level requires our vertex labels to be smaller\n than this size the labels will not be drawn at all.  Default value\n is 8 pt.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetMinimumVisibleFontSize(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for SetMinimumVisibleFontSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetLabelSizeDifference */
    if ( strcmp ( argv[2], "GetLabelSizeDifference" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLabelSizeDifference" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLabelSizeDifference */
    Tcl_DStringAppendElement ( &dString, " Get/Set how much larger the dendrogram labels should be compared to the\n vertex labels.  Because the vertex labels automatically resize based\n on zoom levels, this is a relative (not absolute) size.  Default value\n is 4 pts larger than the vertex labels.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetLabelSizeDifference();" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for GetLabelSizeDifference */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetLabelSizeDifference */
    if ( strcmp ( argv[2], "SetLabelSizeDifference" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLabelSizeDifference" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLabelSizeDifference */
    Tcl_DStringAppendElement ( &dString, " Get/Set how much larger the dendrogram labels should be compared to the\n vertex labels.  Because the vertex labels automatically resize based\n on zoom levels, this is a relative (not absolute) size.  Default value\n is 4 pts larger than the vertex labels.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLabelSizeDifference(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for SetLabelSizeDifference */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetCorrespondenceLineWidth */
    if ( strcmp ( argv[2], "GetCorrespondenceLineWidth" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCorrespondenceLineWidth" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCorrespondenceLineWidth */
    Tcl_DStringAppendElement ( &dString, " Get/Set how wide the correspondence lines should be.  Default is two pixels.\n" );
    Tcl_DStringAppendElement ( &dString, "float GetCorrespondenceLineWidth();" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for GetCorrespondenceLineWidth */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetCorrespondenceLineWidth */
    if ( strcmp ( argv[2], "SetCorrespondenceLineWidth" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetCorrespondenceLineWidth" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetCorrespondenceLineWidth */
    Tcl_DStringAppendElement ( &dString, " Get/Set how wide the correspondence lines should be.  Default is two pixels.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetCorrespondenceLineWidth(float a);" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for SetCorrespondenceLineWidth */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: GetTreeLineWidth */
    if ( strcmp ( argv[2], "GetTreeLineWidth" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTreeLineWidth" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTreeLineWidth */
    Tcl_DStringAppendElement ( &dString, " Get/Set how wide the edges of the trees should be.  Default is one pixel.\n" );
    Tcl_DStringAppendElement ( &dString, "float GetTreeLineWidth();" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for GetTreeLineWidth */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
    /* Starting function: SetTreeLineWidth */
    if ( strcmp ( argv[2], "SetTreeLineWidth" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTreeLineWidth" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTreeLineWidth */
    Tcl_DStringAppendElement ( &dString, " Get/Set how wide the edges of the trees should be.  Default is one pixel.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTreeLineWidth(float width);" );
    Tcl_DStringAppendElement ( &dString, "vtkTanglegramItem" );
    /* Closing for SetTreeLineWidth */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
    }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
   }
 }

  if (vtkContextItemCppCommand(static_cast<vtkContextItem *>(op),interp,argc,argv) == TCL_OK)
    {
    return TCL_OK;
    }
    }
  catch (std::exception &e)
    {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
    }
  return TCL_ERROR;
}
