// python wrapper for vtkAMRDataInternals
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkAMRDataInternals.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkAMRDataInternals(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkAMRDataInternals_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkAMRDataInternals_Doc();


static PyObject *
PyvtkAMRDataInternals_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataInternals *op = static_cast<vtkAMRDataInternals *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkAMRDataInternals::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAMRDataInternals_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataInternals *op = static_cast<vtkAMRDataInternals *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkAMRDataInternals::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAMRDataInternals_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataInternals *op = static_cast<vtkAMRDataInternals *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkAMRDataInternals *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkAMRDataInternals::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkAMRDataInternals_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkAMRDataInternals *tempr = vtkAMRDataInternals::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAMRDataInternals_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataInternals *op = static_cast<vtkAMRDataInternals *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->Initialize();
      }
    else
      {
      op->vtkAMRDataInternals::Initialize();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkAMRDataInternals_Insert(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Insert");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataInternals *op = static_cast<vtkAMRDataInternals *>(vp);

  unsigned int temp0;
  vtkUniformGrid *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkUniformGrid"))
    {
    if (ap.IsBound())
      {
      op->Insert(temp0, temp1);
      }
    else
      {
      op->vtkAMRDataInternals::Insert(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkAMRDataInternals_GetDataSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDataSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataInternals *op = static_cast<vtkAMRDataInternals *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    vtkUniformGrid *tempr = (ap.IsBound() ?
      op->GetDataSet(temp0) :
      op->vtkAMRDataInternals::GetDataSet(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAMRDataInternals_ShallowCopy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ShallowCopy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataInternals *op = static_cast<vtkAMRDataInternals *>(vp);

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    if (ap.IsBound())
      {
      op->ShallowCopy(temp0);
      }
    else
      {
      op->vtkAMRDataInternals::ShallowCopy(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkAMRDataInternals_Empty(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Empty");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataInternals *op = static_cast<vtkAMRDataInternals *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->Empty() :
      op->vtkAMRDataInternals::Empty());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAMRDataInternals_GetNumberOfBlocks(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfBlocks");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataInternals *op = static_cast<vtkAMRDataInternals *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    unsigned int tempr = (ap.IsBound() ?
      op->GetNumberOfBlocks() :
      op->vtkAMRDataInternals::GetNumberOfBlocks());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkAMRDataInternals_Methods[] = {
  {"GetClassName", PyvtkAMRDataInternals_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkAMRDataInternals_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkAMRDataInternals_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkAMRDataInternals\nC++: vtkAMRDataInternals *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkAMRDataInternals_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkAMRDataInternals\nC++: vtkAMRDataInternals *SafeDownCast(vtkObject* o)\n\n"},
  {"Initialize", PyvtkAMRDataInternals_Initialize, METH_VARARGS,
   "V.Initialize()\nC++: void Initialize()\n\n"},
  {"Insert", PyvtkAMRDataInternals_Insert, METH_VARARGS,
   "V.Insert(int, vtkUniformGrid)\nC++: void Insert(unsigned int index, vtkUniformGrid *grid)\n\n"},
  {"GetDataSet", PyvtkAMRDataInternals_GetDataSet, METH_VARARGS,
   "V.GetDataSet(int) -> vtkUniformGrid\nC++: vtkUniformGrid *GetDataSet(unsigned int compositeIndex)\n\n"},
  {"ShallowCopy", PyvtkAMRDataInternals_ShallowCopy, METH_VARARGS,
   "V.ShallowCopy(vtkObject)\nC++: virtual void ShallowCopy(vtkObject *src)\n\n"},
  {"Empty", PyvtkAMRDataInternals_Empty, METH_VARARGS,
   "V.Empty() -> bool\nC++: bool Empty()\n\n"},
  {"GetNumberOfBlocks", PyvtkAMRDataInternals_GetNumberOfBlocks, METH_VARARGS,
   "V.GetNumberOfBlocks() -> int\nC++: unsigned int GetNumberOfBlocks()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkAMRDataInternals_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonDataModelPython.vtkAMRDataInternals", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkAMRDataInternals_StaticNew()
{
  return vtkAMRDataInternals::New();
}

PyObject *PyvtkAMRDataInternals_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkAMRDataInternals_Type, PyvtkAMRDataInternals_Methods,
    "vtkAMRDataInternals",
    PyvtkAMRDataInternals_Doc(), &PyvtkAMRDataInternals_StaticNew);

  PyTypeObject *pytype = &PyvtkAMRDataInternals_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkAMRDataInternals_Doc()
{
  static const char *docstring[] = {
    "vtkAMRDataInternals - container of vtkUniformGrid for an AMR data set\n\n",
    "Superclass: vtkObject\n\n",
    "vtkAMRDataInternals stores a list of non-empty blocks of an AMR data\nset\n\nSee Also:\n\nvtkOverlappingAMR, vtkAMRBox\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkAMRDataInternals(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkAMRDataInternals_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkAMRDataInternals", o) != 0)
    {
    Py_DECREF(o);
    }

}

