// python wrapper for vtkAMREnzoParticlesReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkAMREnzoParticlesReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkAMREnzoParticlesReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkAMREnzoParticlesReader_ClassNew(); }

#ifndef DECLARED_PyvtkAMRBaseParticlesReader_ClassNew
extern "C" { PyObject *PyvtkAMRBaseParticlesReader_ClassNew(); }
#define DECLARED_PyvtkAMRBaseParticlesReader_ClassNew
#endif

static const char **PyvtkAMREnzoParticlesReader_Doc();


static PyObject *
PyvtkAMREnzoParticlesReader_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMREnzoParticlesReader *op = static_cast<vtkAMREnzoParticlesReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkAMREnzoParticlesReader::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAMREnzoParticlesReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMREnzoParticlesReader *op = static_cast<vtkAMREnzoParticlesReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkAMREnzoParticlesReader::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAMREnzoParticlesReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMREnzoParticlesReader *op = static_cast<vtkAMREnzoParticlesReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkAMREnzoParticlesReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkAMREnzoParticlesReader::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkAMREnzoParticlesReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkAMREnzoParticlesReader *tempr = vtkAMREnzoParticlesReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAMREnzoParticlesReader_SetParticleType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParticleType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMREnzoParticlesReader *op = static_cast<vtkAMREnzoParticlesReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetParticleType(temp0);
      }
    else
      {
      op->vtkAMREnzoParticlesReader::SetParticleType(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkAMREnzoParticlesReader_GetParticleType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParticleType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMREnzoParticlesReader *op = static_cast<vtkAMREnzoParticlesReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetParticleType() :
      op->vtkAMREnzoParticlesReader::GetParticleType());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAMREnzoParticlesReader_GetTotalNumberOfParticles(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTotalNumberOfParticles");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMREnzoParticlesReader *op = static_cast<vtkAMREnzoParticlesReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetTotalNumberOfParticles() :
      op->vtkAMREnzoParticlesReader::GetTotalNumberOfParticles());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkAMREnzoParticlesReader_Methods[] = {
  {"GetClassName", PyvtkAMREnzoParticlesReader_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkAMREnzoParticlesReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkAMREnzoParticlesReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkAMREnzoParticlesReader\nC++: vtkAMREnzoParticlesReader *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkAMREnzoParticlesReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkAMREnzoParticlesReader\nC++: vtkAMREnzoParticlesReader *SafeDownCast(vtkObject* o)\n\n"},
  {"SetParticleType", PyvtkAMREnzoParticlesReader_SetParticleType, METH_VARARGS,
   "V.SetParticleType(int)\nC++: void SetParticleType(int a)\n\nReturns the requested particle type.\n"},
  {"GetParticleType", PyvtkAMREnzoParticlesReader_GetParticleType, METH_VARARGS,
   "V.GetParticleType() -> int\nC++: int GetParticleType()\n\nReturns the requested particle type.\n"},
  {"GetTotalNumberOfParticles", PyvtkAMREnzoParticlesReader_GetTotalNumberOfParticles, METH_VARARGS,
   "V.GetTotalNumberOfParticles() -> int\nC++: int GetTotalNumberOfParticles()\n\nSee vtkAMRBaseParticlesReader::GetTotalNumberOfParticles.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkAMREnzoParticlesReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOAMRPython.vtkAMREnzoParticlesReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkAMREnzoParticlesReader_StaticNew()
{
  return vtkAMREnzoParticlesReader::New();
}

PyObject *PyvtkAMREnzoParticlesReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkAMREnzoParticlesReader_Type, PyvtkAMREnzoParticlesReader_Methods,
    "vtkAMREnzoParticlesReader",
    PyvtkAMREnzoParticlesReader_Doc(), &PyvtkAMREnzoParticlesReader_StaticNew);

  PyTypeObject *pytype = &PyvtkAMREnzoParticlesReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAMRBaseParticlesReader_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkAMREnzoParticlesReader_Doc()
{
  static const char *docstring[] = {
    "vtkAMREnzoParticlesReader.h -- Reads AMR Enzo Particle datasets\n\n",
    "Superclass: vtkAMRBaseParticlesReader\n\n",
    "A concrete instance of the vtkAMRBaseParticlesReader which provides\n functionality for loading ENZO AMR particle datasets from ENZO.\n\nSee Also:\n\n\n vtkAMRBaseParticlesReader\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkAMREnzoParticlesReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkAMREnzoParticlesReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkAMREnzoParticlesReader", o) != 0)
    {
    Py_DECREF(o);
    }

}

