// python wrapper for vtkAbstractCellLinks
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkAbstractCellLinks.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkAbstractCellLinks(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkAbstractCellLinks_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkAbstractCellLinks_Doc();


static PyObject *
PyvtkAbstractCellLinks_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAbstractCellLinks *op = static_cast<vtkAbstractCellLinks *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkAbstractCellLinks::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAbstractCellLinks_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAbstractCellLinks *op = static_cast<vtkAbstractCellLinks *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkAbstractCellLinks::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAbstractCellLinks_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAbstractCellLinks *op = static_cast<vtkAbstractCellLinks *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkAbstractCellLinks *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkAbstractCellLinks::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkAbstractCellLinks_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkAbstractCellLinks *tempr = vtkAbstractCellLinks::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAbstractCellLinks_BuildLinks(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "BuildLinks");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAbstractCellLinks *op = static_cast<vtkAbstractCellLinks *>(vp);

  vtkDataSet *temp0 = NULL;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataSet"))
    {
    op->BuildLinks(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkAbstractCellLinks_GetIdType(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GetIdType");

  vtkIdType temp0;
  vtkIdType temp1;
  vtkCellArray *temp2 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetVTKObject(temp2, "vtkCellArray"))
    {
    int tempr = vtkAbstractCellLinks::GetIdType(temp0, temp1, temp2);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkAbstractCellLinks_Methods[] = {
  {"GetClassName", PyvtkAbstractCellLinks_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\nStandard type and print methods.\n"},
  {"IsA", PyvtkAbstractCellLinks_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\nStandard type and print methods.\n"},
  {"NewInstance", PyvtkAbstractCellLinks_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkAbstractCellLinks\nC++: vtkAbstractCellLinks *NewInstance()\n\nStandard type and print methods.\n"},
  {"SafeDownCast", PyvtkAbstractCellLinks_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkAbstractCellLinks\nC++: vtkAbstractCellLinks *SafeDownCast(vtkObject* o)\n\nStandard type and print methods.\n"},
  {"BuildLinks", PyvtkAbstractCellLinks_BuildLinks, METH_VARARGS,
   "V.BuildLinks(vtkDataSet)\nC++: virtual void BuildLinks(vtkDataSet *data)\n\nBuild the link list array. All subclasses must implement this\nmethod.\n"},
  {"GetIdType", PyvtkAbstractCellLinks_GetIdType, METH_VARARGS,
   "V.GetIdType(int, int, vtkCellArray) -> int\nC++: static int GetIdType(vtkIdType maxPtId, vtkIdType maxCellId,\n    vtkCellArray *ca)\n\nBased on the input (i.e., number of points, number of cells, and\nlength of connectivity array) this helper method returns the\nintegral type to use when instantiating cell link-related classes\nin order to properly represent the data.  The return value is one\nof the types (VTK_ID_TYPE,VTK_INT,VTK_SHORT) defined in the file\nvtkType.h. Subclasses may choose to instantiate themselves with\ndifferent integral types for performance and/or memory reasons.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkAbstractCellLinks_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonDataModelPython.vtkAbstractCellLinks", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkAbstractCellLinks_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkAbstractCellLinks_Type, PyvtkAbstractCellLinks_Methods,
    "vtkAbstractCellLinks",
    PyvtkAbstractCellLinks_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkAbstractCellLinks_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkAbstractCellLinks_Doc()
{
  static const char *docstring[] = {
    "vtkAbstractCellLinks - an abstract base class for classes that build\n\n",
    "Superclass: vtkObject\n\n",
    "vtkAbstractCellLinks is a family of supplemental objects to\nvtkCellArray and vtkCellTypes, enabling fast access from points to\nthe cells using the points. vtkAbstractCellLinks is an array of\nlinks, each link representing a list of cell ids using a particular\npoint. The information provided by this object can be used to\ndetermine neighbors and construct other local topological\ninformation.\n\nSee Als",
    "o:\n\nvtkCellLinks vtkStaticCellLinks vtkStaticCellLinksTemplate\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkAbstractCellLinks(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkAbstractCellLinks_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkAbstractCellLinks", o) != 0)
    {
    Py_DECREF(o);
    }

}

