// python wrapper for vtkAbstractRenderDevice
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkRect.h"
#include "vtkStdString.h"
#include "vtkAbstractRenderDevice.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkAbstractRenderDevice(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkAbstractRenderDevice_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkAbstractRenderDevice_Doc();


static PyObject *
PyvtkAbstractRenderDevice_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAbstractRenderDevice *op = static_cast<vtkAbstractRenderDevice *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkAbstractRenderDevice::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAbstractRenderDevice_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAbstractRenderDevice *op = static_cast<vtkAbstractRenderDevice *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkAbstractRenderDevice::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAbstractRenderDevice_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAbstractRenderDevice *op = static_cast<vtkAbstractRenderDevice *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkAbstractRenderDevice *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkAbstractRenderDevice::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkAbstractRenderDevice_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkAbstractRenderDevice *tempr = vtkAbstractRenderDevice::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAbstractRenderDevice_SetRequestedGLVersion(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRequestedGLVersion");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAbstractRenderDevice *op = static_cast<vtkAbstractRenderDevice *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    if (ap.IsBound())
      {
      op->SetRequestedGLVersion(temp0, temp1);
      }
    else
      {
      op->vtkAbstractRenderDevice::SetRequestedGLVersion(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkAbstractRenderDevice_CreateNewWindow(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateNewWindow");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAbstractRenderDevice *op = static_cast<vtkAbstractRenderDevice *>(vp);

  vtkRecti *temp0 = NULL;
  PyObject *pobj0 = NULL;
  std::string temp1;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkRecti") &&
      ap.GetValue(temp1))
    {
    bool tempr = op->CreateNewWindow(*temp0, temp1);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkAbstractRenderDevice_MakeCurrent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MakeCurrent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAbstractRenderDevice *op = static_cast<vtkAbstractRenderDevice *>(vp);

  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(0))
    {
    op->MakeCurrent();

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkAbstractRenderDevice_Methods[] = {
  {"GetClassName", PyvtkAbstractRenderDevice_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkAbstractRenderDevice_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkAbstractRenderDevice_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkAbstractRenderDevice\nC++: vtkAbstractRenderDevice *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkAbstractRenderDevice_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkAbstractRenderDevice\nC++: vtkAbstractRenderDevice *SafeDownCast(vtkObject* o)\n\n"},
  {"SetRequestedGLVersion", PyvtkAbstractRenderDevice_SetRequestedGLVersion, METH_VARARGS,
   "V.SetRequestedGLVersion(int, int)\nC++: void SetRequestedGLVersion(int major, int minor)\n\n"},
  {"CreateNewWindow", PyvtkAbstractRenderDevice_CreateNewWindow, METH_VARARGS,
   "V.CreateNewWindow(vtkRecti, string) -> bool\nC++: virtual bool CreateNewWindow(const vtkRecti &geometry,\n    const std::string &name)\n\n"},
  {"MakeCurrent", PyvtkAbstractRenderDevice_MakeCurrent, METH_VARARGS,
   "V.MakeCurrent()\nC++: virtual void MakeCurrent()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkAbstractRenderDevice_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingCorePython.vtkAbstractRenderDevice", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkAbstractRenderDevice_StaticNew()
{
  return vtkAbstractRenderDevice::New();
}

PyObject *PyvtkAbstractRenderDevice_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkAbstractRenderDevice_Type, PyvtkAbstractRenderDevice_Methods,
    "vtkAbstractRenderDevice",
    PyvtkAbstractRenderDevice_Doc(), &PyvtkAbstractRenderDevice_StaticNew);

  PyTypeObject *pytype = &PyvtkAbstractRenderDevice_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkAbstractRenderDevice_Doc()
{
  static const char *docstring[] = {
    "vtkAbstractRenderDevice - no description provided.\n\n",
    "Superclass: vtkObject\n\n",
    "\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkAbstractRenderDevice(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkAbstractRenderDevice_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkAbstractRenderDevice", o) != 0)
    {
    Py_DECREF(o);
    }

}

