// python wrapper for vtkAppendPoints
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkAppendPoints.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkAppendPoints(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkAppendPoints_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkAppendPoints_Doc();


static PyObject *
PyvtkAppendPoints_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAppendPoints *op = static_cast<vtkAppendPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkAppendPoints::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAppendPoints_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAppendPoints *op = static_cast<vtkAppendPoints *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkAppendPoints::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAppendPoints_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAppendPoints *op = static_cast<vtkAppendPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkAppendPoints *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkAppendPoints::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkAppendPoints_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkAppendPoints *tempr = vtkAppendPoints::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAppendPoints_SetInputIdArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputIdArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAppendPoints *op = static_cast<vtkAppendPoints *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetInputIdArrayName(temp0);
      }
    else
      {
      op->vtkAppendPoints::SetInputIdArrayName(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkAppendPoints_GetInputIdArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInputIdArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAppendPoints *op = static_cast<vtkAppendPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    char *tempr = (ap.IsBound() ?
      op->GetInputIdArrayName() :
      op->vtkAppendPoints::GetInputIdArrayName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAppendPoints_SetOutputPointsPrecision(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutputPointsPrecision");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAppendPoints *op = static_cast<vtkAppendPoints *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetOutputPointsPrecision(temp0);
      }
    else
      {
      op->vtkAppendPoints::SetOutputPointsPrecision(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkAppendPoints_GetOutputPointsPrecision(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputPointsPrecision");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAppendPoints *op = static_cast<vtkAppendPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetOutputPointsPrecision() :
      op->vtkAppendPoints::GetOutputPointsPrecision());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkAppendPoints_Methods[] = {
  {"GetClassName", PyvtkAppendPoints_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkAppendPoints_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkAppendPoints_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkAppendPoints\nC++: vtkAppendPoints *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkAppendPoints_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkAppendPoints\nC++: vtkAppendPoints *SafeDownCast(vtkObject* o)\n\n"},
  {"SetInputIdArrayName", PyvtkAppendPoints_SetInputIdArrayName, METH_VARARGS,
   "V.SetInputIdArrayName(string)\nC++: void SetInputIdArrayName(char *)\n\nSets the output array name to fill with the input connection\nindex for each point. This provides a way to trace a point back\nto a particular input. If this is NULL (the default), the array\nis not generated.\n"},
  {"GetInputIdArrayName", PyvtkAppendPoints_GetInputIdArrayName, METH_VARARGS,
   "V.GetInputIdArrayName() -> string\nC++: char *GetInputIdArrayName()\n\nSets the output array name to fill with the input connection\nindex for each point. This provides a way to trace a point back\nto a particular input. If this is NULL (the default), the array\nis not generated.\n"},
  {"SetOutputPointsPrecision", PyvtkAppendPoints_SetOutputPointsPrecision, METH_VARARGS,
   "V.SetOutputPointsPrecision(int)\nC++: void SetOutputPointsPrecision(int a)\n\nSet/get the desired precision for the output type. See the\ndocumentation for the vtkAlgorithm::DesiredOutputPrecision enum\nfor an explanation of the available precision settings. If the\ndesired precision is DEFAULT_PRECISION and any of the inputs are\ndouble precision, then the output precision will be double\nprecision. Otherwise, if the desired precision is\nDEFAULT_PRECISION and all the inputs are single precision, then\nthe output will be single precision.\n"},
  {"GetOutputPointsPrecision", PyvtkAppendPoints_GetOutputPointsPrecision, METH_VARARGS,
   "V.GetOutputPointsPrecision() -> int\nC++: int GetOutputPointsPrecision()\n\nSet/get the desired precision for the output type. See the\ndocumentation for the vtkAlgorithm::DesiredOutputPrecision enum\nfor an explanation of the available precision settings. If the\ndesired precision is DEFAULT_PRECISION and any of the inputs are\ndouble precision, then the output precision will be double\nprecision. Otherwise, if the desired precision is\nDEFAULT_PRECISION and all the inputs are single precision, then\nthe output will be single precision.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkAppendPoints_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersGeneralPython.vtkAppendPoints", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkAppendPoints_StaticNew()
{
  return vtkAppendPoints::New();
}

PyObject *PyvtkAppendPoints_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkAppendPoints_Type, PyvtkAppendPoints_Methods,
    "vtkAppendPoints",
    PyvtkAppendPoints_Doc(), &PyvtkAppendPoints_StaticNew);

  PyTypeObject *pytype = &PyvtkAppendPoints_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkAppendPoints_Doc()
{
  static const char *docstring[] = {
    "vtkAppendPoints - appends points of one or more vtkPolyData data sets\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "vtkAppendPoints is a filter that appends the points and associated\ndata of one or more polygonal (vtkPolyData) datasets. This filter can\noptionally add a new array marking the input index that the point\ncame from.\n\nSee Also:\n\nvtkAppendFilter vtkAppendPolyData\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkAppendPoints(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkAppendPoints_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkAppendPoints", o) != 0)
    {
    Py_DECREF(o);
    }

}

