// python wrapper for vtkAreaPicker
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkAreaPicker.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkAreaPicker(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkAreaPicker_ClassNew(); }

#ifndef DECLARED_PyvtkAbstractPropPicker_ClassNew
extern "C" { PyObject *PyvtkAbstractPropPicker_ClassNew(); }
#define DECLARED_PyvtkAbstractPropPicker_ClassNew
#endif

static const char **PyvtkAreaPicker_Doc();


static PyObject *
PyvtkAreaPicker_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAreaPicker *op = static_cast<vtkAreaPicker *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkAreaPicker::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAreaPicker_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAreaPicker *op = static_cast<vtkAreaPicker *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkAreaPicker::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAreaPicker_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAreaPicker *op = static_cast<vtkAreaPicker *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkAreaPicker *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkAreaPicker::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkAreaPicker_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkAreaPicker *tempr = vtkAreaPicker::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAreaPicker_SetPickCoords(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPickCoords");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAreaPicker *op = static_cast<vtkAreaPicker *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
    {
    if (ap.IsBound())
      {
      op->SetPickCoords(temp0, temp1, temp2, temp3);
      }
    else
      {
      op->vtkAreaPicker::SetPickCoords(temp0, temp1, temp2, temp3);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkAreaPicker_SetRenderer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRenderer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAreaPicker *op = static_cast<vtkAreaPicker *>(vp);

  vtkRenderer *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderer"))
    {
    if (ap.IsBound())
      {
      op->SetRenderer(temp0);
      }
    else
      {
      op->vtkAreaPicker::SetRenderer(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkAreaPicker_Pick_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Pick");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAreaPicker *op = static_cast<vtkAreaPicker *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->Pick() :
      op->vtkAreaPicker::Pick());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyObject *
PyvtkAreaPicker_Pick_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Pick");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAreaPicker *op = static_cast<vtkAreaPicker *>(vp);

  double temp0;
  double temp1;
  double temp2;
  vtkRenderer *temp3 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3, 4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp3, "vtkRenderer")))
    {
    int tempr = (ap.IsBound() ?
      op->Pick(temp0, temp1, temp2, temp3) :
      op->vtkAreaPicker::Pick(temp0, temp1, temp2, temp3));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyObject *
PyvtkAreaPicker_Pick(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 0:
      return PyvtkAreaPicker_Pick_s1(self, args);
    case 3:
    case 4:
      return PyvtkAreaPicker_Pick_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "Pick");
  return NULL;
}



static PyObject *
PyvtkAreaPicker_AreaPick(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AreaPick");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAreaPicker *op = static_cast<vtkAreaPicker *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  vtkRenderer *temp4 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4, 5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp4, "vtkRenderer")))
    {
    int tempr = (ap.IsBound() ?
      op->AreaPick(temp0, temp1, temp2, temp3, temp4) :
      op->vtkAreaPicker::AreaPick(temp0, temp1, temp2, temp3, temp4));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAreaPicker_GetMapper(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMapper");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAreaPicker *op = static_cast<vtkAreaPicker *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkAbstractMapper3D *tempr = (ap.IsBound() ?
      op->GetMapper() :
      op->vtkAreaPicker::GetMapper());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAreaPicker_GetDataSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDataSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAreaPicker *op = static_cast<vtkAreaPicker *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkDataSet *tempr = (ap.IsBound() ?
      op->GetDataSet() :
      op->vtkAreaPicker::GetDataSet());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAreaPicker_GetProp3Ds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProp3Ds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAreaPicker *op = static_cast<vtkAreaPicker *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkProp3DCollection *tempr = (ap.IsBound() ?
      op->GetProp3Ds() :
      op->vtkAreaPicker::GetProp3Ds());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAreaPicker_GetFrustum(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFrustum");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAreaPicker *op = static_cast<vtkAreaPicker *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkPlanes *tempr = (ap.IsBound() ?
      op->GetFrustum() :
      op->vtkAreaPicker::GetFrustum());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkAreaPicker_GetClipPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClipPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAreaPicker *op = static_cast<vtkAreaPicker *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkPoints *tempr = (ap.IsBound() ?
      op->GetClipPoints() :
      op->vtkAreaPicker::GetClipPoints());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkAreaPicker_Methods[] = {
  {"GetClassName", PyvtkAreaPicker_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkAreaPicker_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkAreaPicker_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkAreaPicker\nC++: vtkAreaPicker *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkAreaPicker_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkAreaPicker\nC++: vtkAreaPicker *SafeDownCast(vtkObject* o)\n\n"},
  {"SetPickCoords", PyvtkAreaPicker_SetPickCoords, METH_VARARGS,
   "V.SetPickCoords(float, float, float, float)\nC++: void SetPickCoords(double x0, double y0, double x1,\n    double y1)\n\nSet the default screen rectangle to pick in.\n"},
  {"SetRenderer", PyvtkAreaPicker_SetRenderer, METH_VARARGS,
   "V.SetRenderer(vtkRenderer)\nC++: void SetRenderer(vtkRenderer *)\n\nSet the default renderer to pick on.\n"},
  {"Pick", PyvtkAreaPicker_Pick, METH_VARARGS,
   "V.Pick() -> int\nC++: virtual int Pick()\nV.Pick(float, float, float, vtkRenderer) -> int\nC++: virtual int Pick(double x0, double y0, double z0,\n    vtkRenderer *renderer=NULL)\n\nPerform an AreaPick within the default screen rectangle and\nrenderer.\n"},
  {"AreaPick", PyvtkAreaPicker_AreaPick, METH_VARARGS,
   "V.AreaPick(float, float, float, float, vtkRenderer) -> int\nC++: virtual int AreaPick(double x0, double y0, double x1,\n    double y1, vtkRenderer *renderer=NULL)\n\nPerform pick operation in volume behind the given screen\ncoordinates. Props intersecting the selection frustum will be\naccessible via GetProp3D. GetPlanes returns a vtkImplicitFunciton\nsuitable for vtkExtractGeometry.\n"},
  {"GetMapper", PyvtkAreaPicker_GetMapper, METH_VARARGS,
   "V.GetMapper() -> vtkAbstractMapper3D\nC++: vtkAbstractMapper3D *GetMapper()\n\nReturn mapper that was picked (if any).\n"},
  {"GetDataSet", PyvtkAreaPicker_GetDataSet, METH_VARARGS,
   "V.GetDataSet() -> vtkDataSet\nC++: vtkDataSet *GetDataSet()\n\nGet a pointer to the dataset that was picked (if any). If nothing\nwas picked then NULL is returned.\n"},
  {"GetProp3Ds", PyvtkAreaPicker_GetProp3Ds, METH_VARARGS,
   "V.GetProp3Ds() -> vtkProp3DCollection\nC++: vtkProp3DCollection *GetProp3Ds()\n\nReturn a collection of all the prop 3D's that were intersected by\nthe pick ray. This collection is not sorted.\n"},
  {"GetFrustum", PyvtkAreaPicker_GetFrustum, METH_VARARGS,
   "V.GetFrustum() -> vtkPlanes\nC++: vtkPlanes *GetFrustum()\n\nReturn the six planes that define the selection frustum. The\nimplicit function defined by the planes evaluates to negative\ninside and positive outside.\n"},
  {"GetClipPoints", PyvtkAreaPicker_GetClipPoints, METH_VARARGS,
   "V.GetClipPoints() -> vtkPoints\nC++: vtkPoints *GetClipPoints()\n\nReturn eight points that define the selection frustum.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkAreaPicker_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingCorePython.vtkAreaPicker", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkAreaPicker_StaticNew()
{
  return vtkAreaPicker::New();
}

PyObject *PyvtkAreaPicker_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkAreaPicker_Type, PyvtkAreaPicker_Methods,
    "vtkAreaPicker",
    PyvtkAreaPicker_Doc(), &PyvtkAreaPicker_StaticNew);

  PyTypeObject *pytype = &PyvtkAreaPicker_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAbstractPropPicker_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkAreaPicker_Doc()
{
  static const char *docstring[] = {
    "vtkAreaPicker - Picks props behind a selection rectangle on a\nviewport.\n\n",
    "Superclass: vtkAbstractPropPicker\n\n",
    "The vtkAreaPicker picks all vtkProp3Ds that lie behind the screen\nspace rectangle from x0,y0 and x1,y1. The selection is based upon the\nbounding box of the prop and is thus not exact.\n\nLike vtkPicker, a pick results in a list of Prop3Ds because many\nprops may lie within the pick frustum. You can also get an\nAssemblyPath, which in this case is defined to be the path to the one\nparticular prop in th",
    "e Prop3D list that lies nearest to the near\nplane.\n\nThis picker also returns the selection frustum, defined as either a\nvtkPlanes, or a set of eight corner vertices in world space. The\nvtkPlanes version is an ImplicitFunction, which is suitable for use\nwith the vtkExtractGeometry. The six frustum planes are in order:\nleft, right, bottom, top, near, far\n\nBecause this picker picks everything within ",
    "a volume, the world pick\npoint result is ill-defined. Therefore if you ask this class for the\nworld pick position, you will get the centroid of the pick frustum.\nThis may be outside of all props in the prop list.\n\nSee Also:\n\nvtkInteractorStyleRubberBandPick, vtkExtractSelectedFrustum.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkAreaPicker(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkAreaPicker_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkAreaPicker", o) != 0)
    {
    Py_DECREF(o);
    }

}

