// python wrapper for vtkBreakPoint
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkBreakPoint.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkBreakPoint(PyObject *); }

static const char **PyvtkBreakPoint_Doc();


static PyObject *
PyvtkBreakPoint_Break(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "Break");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
    {
    vtkBreakPoint::Break();

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkBreakPoint_Methods[] = {
  {"Break", PyvtkBreakPoint_Break, METH_VARARGS,
   "V.Break()\nC++: static void Break()\n\nProcess fall asleep until local variable `i' is set to a value\ndifferent from 0 inside a debugger.\n"},
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkBreakPoint_vtkBreakPoint_s1(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkBreakPoint");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
    {
    vtkBreakPoint *op = new vtkBreakPoint();

    result = PyVTKSpecialObject_New("vtkBreakPoint", op);
    }

  return result;
}

static PyObject *
PyvtkBreakPoint_vtkBreakPoint_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkBreakPoint");

  vtkBreakPoint *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkBreakPoint"))
    {
    vtkBreakPoint *op = new vtkBreakPoint(*temp0);

    result = PyVTKSpecialObject_New("vtkBreakPoint", op);
    }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkBreakPoint_vtkBreakPoint_Methods[] = {
  {NULL, PyvtkBreakPoint_vtkBreakPoint_s2, METH_VARARGS,
   "@W vtkBreakPoint"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkBreakPoint_vtkBreakPoint(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
    {
    case 0:
      return PyvtkBreakPoint_vtkBreakPoint_s1(self, args);
    case 1:
      return PyvtkBreakPoint_vtkBreakPoint_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "vtkBreakPoint");
  return NULL;
}


static PyObject *
PyvtkBreakPoint_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
    {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
    }

  return PyvtkBreakPoint_vtkBreakPoint(NULL, args);
}

static void PyvtkBreakPoint_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkBreakPoint *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkBreakPoint_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkBreakPoint_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkBreakPoint", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkBreakPoint_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkBreakPoint_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkBreakPoint_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkBreakPoint_CCopy(const void *obj)
{
  if (obj)
    {
    return new vtkBreakPoint(*static_cast<const vtkBreakPoint*>(obj));
    }
  return 0;
}

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkBreakPoint_TypeNew(); }

PyObject *PyvtkBreakPoint_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkBreakPoint_Type,
    PyvtkBreakPoint_Methods,
    PyvtkBreakPoint_vtkBreakPoint_Methods,
    PyvtkBreakPoint_Doc(), &PyvtkBreakPoint_CCopy);

  PyTypeObject *pytype = &PyvtkBreakPoint_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkBreakPoint_Doc()
{
  static const char *docstring[] = {
    "vtkBreakPoint - Utility function to debug with gdb and MPI.\n\n",
    "Wherever you need to set a break point inside a piece of code run by\nMPI,\n\nStep 1: call vtkBreakPoint::Break() in the code. Step 2: start MPI,\neach process will display its PID and sleep. Step 3: start gdb with\nthe PID: gdb --pid=\n\nStep 4: set a breakpoint at the line of interest: (gdb) b  Step 5: go\nout of the sleep: (gdb) set var i=1 Original instructions at the\nOpenMPI FAQ:\nhttp://www.open-mpi.",
    "de/faq/?category=debugging#serial-debuggers\n- 6 Can I use serial debuggers (such as gdb) to debug MPI\n  applications?\n- 6.1. Attach to individual MPI processes after they are running.\n\nImplementation:\n\nThis function is in Common, not in Parallel because it does not\ndepend on MPI and you may want to call vtkBreakPoint::Break() in any\nclass of VTK.\n\n",
    "V.vtkBreakPoint()\nC++: vtkBreakPoint()\nV.vtkBreakPoint(vtkBreakPoint)\nC++: vtkBreakPoint(const &vtkBreakPoint)\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkBreakPoint(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkBreakPoint_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkBreakPoint", o) != 0)
    {
    Py_DECREF(o);
    }

}

