// python wrapper for vtkCellDistanceSelector
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkCellDistanceSelector.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkCellDistanceSelector(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkCellDistanceSelector_ClassNew(); }

#ifndef DECLARED_PyvtkSelectionAlgorithm_ClassNew
extern "C" { PyObject *PyvtkSelectionAlgorithm_ClassNew(); }
#define DECLARED_PyvtkSelectionAlgorithm_ClassNew
#endif

static const char **PyvtkCellDistanceSelector_Doc();

static PyTypeObject PyvtkCellDistanceSelector_InputPorts_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersSelectionPython.vtkCellDistanceSelector.InputPorts", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkCellDistanceSelector_InputPorts_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkCellDistanceSelector_InputPorts_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkCellDistanceSelector_InputPorts_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}


static PyObject *
PyvtkCellDistanceSelector_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkCellDistanceSelector::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkCellDistanceSelector::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkCellDistanceSelector *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkCellDistanceSelector::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkCellDistanceSelector *tempr = vtkCellDistanceSelector::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_SetInputMeshConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputMeshConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  vtkAlgorithmOutput *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAlgorithmOutput"))
    {
    if (ap.IsBound())
      {
      op->SetInputMeshConnection(temp0);
      }
    else
      {
      op->vtkCellDistanceSelector::SetInputMeshConnection(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_SetInputMesh(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputMesh");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  vtkDataObject *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataObject"))
    {
    if (ap.IsBound())
      {
      op->SetInputMesh(temp0);
      }
    else
      {
      op->vtkCellDistanceSelector::SetInputMesh(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_SetInputSelectionConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputSelectionConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  vtkAlgorithmOutput *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAlgorithmOutput"))
    {
    if (ap.IsBound())
      {
      op->SetInputSelectionConnection(temp0);
      }
    else
      {
      op->vtkCellDistanceSelector::SetInputSelectionConnection(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_SetInputSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  vtkSelection *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSelection"))
    {
    if (ap.IsBound())
      {
      op->SetInputSelection(temp0);
      }
    else
      {
      op->vtkCellDistanceSelector::SetInputSelection(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_SetDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetDistance(temp0);
      }
    else
      {
      op->vtkCellDistanceSelector::SetDistance(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_GetDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetDistance() :
      op->vtkCellDistanceSelector::GetDistance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_SetIncludeSeed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIncludeSeed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetIncludeSeed(temp0);
      }
    else
      {
      op->vtkCellDistanceSelector::SetIncludeSeed(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_GetIncludeSeed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIncludeSeed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetIncludeSeed() :
      op->vtkCellDistanceSelector::GetIncludeSeed());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_IncludeSeedOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IncludeSeedOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->IncludeSeedOn();
      }
    else
      {
      op->vtkCellDistanceSelector::IncludeSeedOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_IncludeSeedOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IncludeSeedOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->IncludeSeedOff();
      }
    else
      {
      op->vtkCellDistanceSelector::IncludeSeedOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_SetAddIntermediate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAddIntermediate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetAddIntermediate(temp0);
      }
    else
      {
      op->vtkCellDistanceSelector::SetAddIntermediate(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_GetAddIntermediate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAddIntermediate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetAddIntermediate() :
      op->vtkCellDistanceSelector::GetAddIntermediate());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_AddIntermediateOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddIntermediateOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->AddIntermediateOn();
      }
    else
      {
      op->vtkCellDistanceSelector::AddIntermediateOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkCellDistanceSelector_AddIntermediateOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddIntermediateOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellDistanceSelector *op = static_cast<vtkCellDistanceSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->AddIntermediateOff();
      }
    else
      {
      op->vtkCellDistanceSelector::AddIntermediateOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkCellDistanceSelector_Methods[] = {
  {"GetClassName", PyvtkCellDistanceSelector_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkCellDistanceSelector_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkCellDistanceSelector_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkCellDistanceSelector\nC++: vtkCellDistanceSelector *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkCellDistanceSelector_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkCellDistanceSelector\nC++: vtkCellDistanceSelector *SafeDownCast(vtkObject* o)\n\n"},
  {"SetInputMeshConnection", PyvtkCellDistanceSelector_SetInputMeshConnection, METH_VARARGS,
   "V.SetInputMeshConnection(vtkAlgorithmOutput)\nC++: void SetInputMeshConnection(vtkAlgorithmOutput *in)\n\nA convenience method to set the data object input connection to\nthe producer output\n"},
  {"SetInputMesh", PyvtkCellDistanceSelector_SetInputMesh, METH_VARARGS,
   "V.SetInputMesh(vtkDataObject)\nC++: void SetInputMesh(vtkDataObject *obj)\n\nA convenience method to set the input data object\n"},
  {"SetInputSelectionConnection", PyvtkCellDistanceSelector_SetInputSelectionConnection, METH_VARARGS,
   "V.SetInputSelectionConnection(vtkAlgorithmOutput)\nC++: void SetInputSelectionConnection(vtkAlgorithmOutput *in)\n\nA convenience method to set the selection input connection to the\nproducer output\n"},
  {"SetInputSelection", PyvtkCellDistanceSelector_SetInputSelection, METH_VARARGS,
   "V.SetInputSelection(vtkSelection)\nC++: void SetInputSelection(vtkSelection *obj)\n\nA convenience method to set the input selection\n"},
  {"SetDistance", PyvtkCellDistanceSelector_SetDistance, METH_VARARGS,
   "V.SetDistance(int)\nC++: void SetDistance(int a)\n\nTells how far (in term of topological distance) away from seed\ncells to expand the selection\n"},
  {"GetDistance", PyvtkCellDistanceSelector_GetDistance, METH_VARARGS,
   "V.GetDistance() -> int\nC++: int GetDistance()\n\nTells how far (in term of topological distance) away from seed\ncells to expand the selection\n"},
  {"SetIncludeSeed", PyvtkCellDistanceSelector_SetIncludeSeed, METH_VARARGS,
   "V.SetIncludeSeed(int)\nC++: void SetIncludeSeed(int a)\n\nIf set, seed cells passed with SetSeedCells will be included in\nthe final selection\n"},
  {"GetIncludeSeed", PyvtkCellDistanceSelector_GetIncludeSeed, METH_VARARGS,
   "V.GetIncludeSeed() -> int\nC++: int GetIncludeSeed()\n\nIf set, seed cells passed with SetSeedCells will be included in\nthe final selection\n"},
  {"IncludeSeedOn", PyvtkCellDistanceSelector_IncludeSeedOn, METH_VARARGS,
   "V.IncludeSeedOn()\nC++: void IncludeSeedOn()\n\nIf set, seed cells passed with SetSeedCells will be included in\nthe final selection\n"},
  {"IncludeSeedOff", PyvtkCellDistanceSelector_IncludeSeedOff, METH_VARARGS,
   "V.IncludeSeedOff()\nC++: void IncludeSeedOff()\n\nIf set, seed cells passed with SetSeedCells will be included in\nthe final selection\n"},
  {"SetAddIntermediate", PyvtkCellDistanceSelector_SetAddIntermediate, METH_VARARGS,
   "V.SetAddIntermediate(int)\nC++: void SetAddIntermediate(int a)\n\nIf set, intermediate cells (between seed cells and the selection\nboundary) will be included in the final selection\n"},
  {"GetAddIntermediate", PyvtkCellDistanceSelector_GetAddIntermediate, METH_VARARGS,
   "V.GetAddIntermediate() -> int\nC++: int GetAddIntermediate()\n\nIf set, intermediate cells (between seed cells and the selection\nboundary) will be included in the final selection\n"},
  {"AddIntermediateOn", PyvtkCellDistanceSelector_AddIntermediateOn, METH_VARARGS,
   "V.AddIntermediateOn()\nC++: void AddIntermediateOn()\n\nIf set, intermediate cells (between seed cells and the selection\nboundary) will be included in the final selection\n"},
  {"AddIntermediateOff", PyvtkCellDistanceSelector_AddIntermediateOff, METH_VARARGS,
   "V.AddIntermediateOff()\nC++: void AddIntermediateOff()\n\nIf set, intermediate cells (between seed cells and the selection\nboundary) will be included in the final selection\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkCellDistanceSelector_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersSelectionPython.vtkCellDistanceSelector", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkCellDistanceSelector_StaticNew()
{
  return vtkCellDistanceSelector::New();
}

PyObject *PyvtkCellDistanceSelector_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkCellDistanceSelector_Type, PyvtkCellDistanceSelector_Methods,
    "vtkCellDistanceSelector",
    PyvtkCellDistanceSelector_Doc(), &PyvtkCellDistanceSelector_StaticNew);

  PyTypeObject *pytype = &PyvtkCellDistanceSelector_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSelectionAlgorithm_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkCellDistanceSelector_InputPorts_Type);
  PyvtkCellDistanceSelector_InputPorts_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkCellDistanceSelector_InputPorts_Type);

  o = (PyObject *)&PyvtkCellDistanceSelector_InputPorts_Type;
  if (PyDict_SetItemString(d, "InputPorts", o) != 0)
    {
    Py_DECREF(o);
    }

  for (int c = 0; c < 2; c++)
    {
    typedef vtkCellDistanceSelector::InputPorts cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[2] = {
        { "INPUT_MESH", vtkCellDistanceSelector::INPUT_MESH },
        { "INPUT_SELECTION", vtkCellDistanceSelector::INPUT_SELECTION },
      };

    o = PyvtkCellDistanceSelector_InputPorts_FromEnum(constants[c].value);
    if (o)
      {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
      }
    }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkCellDistanceSelector_Doc()
{
  static const char *docstring[] = {
    "vtkCellDistanceSelector - select neighbor cells up to a distance\n\n",
    "Superclass: vtkSelectionAlgorithm\n\n",
    "This filter grows an input selection by iteratively selecting\nneighbor cells (a neighbor cell is a cell that shares a\nvertex/edge/face), up to a given topological distance to the selected\nneighborhood (number of times we add neighbor cells). This filter\ntakes a vtkSelection and a vtkCompositeDataSet as inputs. It outputs\na vtkSelection identifying all the selected cells.\n\nThanks:\n\nThis file has be",
    "en initially developed in the frame of CEA's Love\nvisualization software development\n\nCEA/DIF - Commissariat a l'Energie Atomique, Centre DAM Ile-De-France\n\nBP12, F-91297 Arpajon, France.\n\nModified and integrated into VTK, Kitware SAS 2012 Implementation by\nThierry Carrard and Philippe Pebay\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkCellDistanceSelector(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkCellDistanceSelector_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkCellDistanceSelector", o) != 0)
    {
    Py_DECREF(o);
    }

}

