// python wrapper for vtkCenteredSliderWidget
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkCenteredSliderWidget.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkCenteredSliderWidget(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkCenteredSliderWidget_ClassNew(); }

#ifndef DECLARED_PyvtkAbstractWidget_ClassNew
extern "C" { PyObject *PyvtkAbstractWidget_ClassNew(); }
#define DECLARED_PyvtkAbstractWidget_ClassNew
#endif

static const char **PyvtkCenteredSliderWidget_Doc();


static PyObject *
PyvtkCenteredSliderWidget_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCenteredSliderWidget *op = static_cast<vtkCenteredSliderWidget *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkCenteredSliderWidget::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkCenteredSliderWidget_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCenteredSliderWidget *op = static_cast<vtkCenteredSliderWidget *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkCenteredSliderWidget::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkCenteredSliderWidget_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCenteredSliderWidget *op = static_cast<vtkCenteredSliderWidget *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkCenteredSliderWidget *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkCenteredSliderWidget::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkCenteredSliderWidget_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkCenteredSliderWidget *tempr = vtkCenteredSliderWidget::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkCenteredSliderWidget_SetRepresentation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCenteredSliderWidget *op = static_cast<vtkCenteredSliderWidget *>(vp);

  vtkSliderRepresentation *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSliderRepresentation"))
    {
    if (ap.IsBound())
      {
      op->SetRepresentation(temp0);
      }
    else
      {
      op->vtkCenteredSliderWidget::SetRepresentation(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkCenteredSliderWidget_GetSliderRepresentation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliderRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCenteredSliderWidget *op = static_cast<vtkCenteredSliderWidget *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkSliderRepresentation *tempr = (ap.IsBound() ?
      op->GetSliderRepresentation() :
      op->vtkCenteredSliderWidget::GetSliderRepresentation());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkCenteredSliderWidget_CreateDefaultRepresentation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateDefaultRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCenteredSliderWidget *op = static_cast<vtkCenteredSliderWidget *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->CreateDefaultRepresentation();
      }
    else
      {
      op->vtkCenteredSliderWidget::CreateDefaultRepresentation();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkCenteredSliderWidget_GetValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCenteredSliderWidget *op = static_cast<vtkCenteredSliderWidget *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetValue() :
      op->vtkCenteredSliderWidget::GetValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkCenteredSliderWidget_Methods[] = {
  {"GetClassName", PyvtkCenteredSliderWidget_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\nStandard macros.\n"},
  {"IsA", PyvtkCenteredSliderWidget_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\nStandard macros.\n"},
  {"NewInstance", PyvtkCenteredSliderWidget_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkCenteredSliderWidget\nC++: vtkCenteredSliderWidget *NewInstance()\n\nStandard macros.\n"},
  {"SafeDownCast", PyvtkCenteredSliderWidget_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkCenteredSliderWidget\nC++: vtkCenteredSliderWidget *SafeDownCast(vtkObject* o)\n\nStandard macros.\n"},
  {"SetRepresentation", PyvtkCenteredSliderWidget_SetRepresentation, METH_VARARGS,
   "V.SetRepresentation(vtkSliderRepresentation)\nC++: void SetRepresentation(vtkSliderRepresentation *r)\n\nSpecify an instance of vtkWidgetRepresentation used to represent\nthis widget in the scene. Note that the representation is a\nsubclass of vtkProp so it can be added to the renderer\nindependent of the widget.\n"},
  {"GetSliderRepresentation", PyvtkCenteredSliderWidget_GetSliderRepresentation, METH_VARARGS,
   "V.GetSliderRepresentation() -> vtkSliderRepresentation\nC++: vtkSliderRepresentation *GetSliderRepresentation()\n\nReturn the representation as a vtkSliderRepresentation.\n"},
  {"CreateDefaultRepresentation", PyvtkCenteredSliderWidget_CreateDefaultRepresentation, METH_VARARGS,
   "V.CreateDefaultRepresentation()\nC++: void CreateDefaultRepresentation()\n\nCreate the default widget representation if one is not set.\n"},
  {"GetValue", PyvtkCenteredSliderWidget_GetValue, METH_VARARGS,
   "V.GetValue() -> float\nC++: double GetValue()\n\nGet the value fo this widget.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkCenteredSliderWidget_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInteractionWidgetsPython.vtkCenteredSliderWidget", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkCenteredSliderWidget_StaticNew()
{
  return vtkCenteredSliderWidget::New();
}

PyObject *PyvtkCenteredSliderWidget_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkCenteredSliderWidget_Type, PyvtkCenteredSliderWidget_Methods,
    "vtkCenteredSliderWidget",
    PyvtkCenteredSliderWidget_Doc(), &PyvtkCenteredSliderWidget_StaticNew);

  PyTypeObject *pytype = &PyvtkCenteredSliderWidget_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAbstractWidget_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkCenteredSliderWidget_Doc()
{
  static const char *docstring[] = {
    "vtkCenteredSliderWidget - set a value by manipulating a slider\n\n",
    "Superclass: vtkAbstractWidget\n\n",
    "The vtkCenteredSliderWidget is used to adjust a scalar value in an\napplication. This class measures deviations form the center point on\nthe slider. Moving the slider modifies the value of the widget, which\ncan be used to set parameters on other objects. Note that the actual\nappearance of the widget depends on the specific representation for\nthe widget.\n\nTo use this widget, set the widget represent",
    "ation. The representation\nis assumed to consist of a tube, two end caps, and a slider (the\ndetails may vary depending on the particulars of the representation).\nThen in the representation you will typically set minimum and maximum\nvalue, as well as the current value. The position of the slider must\nalso be set, as well as various properties.\n\nNote that the value should be obtain from the widget, n",
    "ot from the\nrepresentation. Also note that Minimum and Maximum values are in\nterms of value per second. The value you get from this widget's\nGetValue method is multiplied by time.\n\nEvent Bindings:\n\nBy default, the widget responds to the following VTK events (i.e., it\nwatches the vtkRenderWindowInteractor for these events):\n\nIf the slider bead is selected:\n  LeftButtonPressEvent - select slider (if",
    " on slider)\n  LeftButtonReleaseEvent - release slider (if selected)\n  MouseMoveEvent - move slider If the end caps or slider tube are\nselected:\n  LeftButtonPressEvent - move (or animate) to cap or point on tube; \n\nNote that the event bindings described above can be changed using\nthis class's vtkWidgetEventTranslator. This class translates VTK\nevents into the vtkCenteredSliderWidget's widget events",
    ":\n\n\n  vtkWidgetEvent::Select -- some part of the widget has been selected\n  vtkWidgetEvent::EndSelect -- the selection process has completed\n  vtkWidgetEvent::Move -- a request for slider motion has been\ninvoked \n\nIn turn, when these widget events are processed, the\nvtkCenteredSliderWidget invokes the following VTK events on itself\n(which observers can listen for):\n\n\n  vtkCommand::StartInteraction",
    "Event (on vtkWidgetEvent::Select)\n  vtkCommand::EndInteractionEvent (on vtkWidgetEvent::EndSelect)\n  vtkCommand::InteractionEvent (on vtkWidgetEvent::Move) \n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkCenteredSliderWidget(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkCenteredSliderWidget_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkCenteredSliderWidget", o) != 0)
    {
    Py_DECREF(o);
    }

}

