// python wrapper for vtkContextKeyEvent
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkVector.h"
#include "vtkContextKeyEvent.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkContextKeyEvent(PyObject *); }

static const char **PyvtkContextKeyEvent_Doc();


static PyObject *
PyvtkContextKeyEvent_SetInteractor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInteractor");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkContextKeyEvent *op = static_cast<vtkContextKeyEvent *>(vp);

  vtkRenderWindowInteractor *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderWindowInteractor"))
    {
    op->SetInteractor(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkContextKeyEvent_GetInteractor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInteractor");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkContextKeyEvent *op = static_cast<vtkContextKeyEvent *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkRenderWindowInteractor *tempr = op->GetInteractor();

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkContextKeyEvent_SetPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPosition");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkContextKeyEvent *op = static_cast<vtkContextKeyEvent *>(vp);

  vtkVector2i *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkVector2i"))
    {
    op->SetPosition(*temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkContextKeyEvent_GetPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPosition");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkContextKeyEvent *op = static_cast<vtkContextKeyEvent *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkVector2i tempr = op->GetPosition();

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildSpecialObject(&tempr, "vtkVector2i");
      }
    }

  return result;
}


static PyObject *
PyvtkContextKeyEvent_GetKeyCode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetKeyCode");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkContextKeyEvent *op = static_cast<vtkContextKeyEvent *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    char tempr = op->GetKeyCode();

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkContextKeyEvent_Methods[] = {
  {"SetInteractor", PyvtkContextKeyEvent_SetInteractor, METH_VARARGS,
   "V.SetInteractor(vtkRenderWindowInteractor)\nC++: void SetInteractor(vtkRenderWindowInteractor *interactor)\n\nSet the interactor for the key event.\n"},
  {"GetInteractor", PyvtkContextKeyEvent_GetInteractor, METH_VARARGS,
   "V.GetInteractor() -> vtkRenderWindowInteractor\nC++: vtkRenderWindowInteractor *GetInteractor()\n\nGet the interactor for the key event. This can be null, and is\nprovided only for convenience.\n"},
  {"SetPosition", PyvtkContextKeyEvent_SetPosition, METH_VARARGS,
   "V.SetPosition(vtkVector2i)\nC++: void SetPosition(const vtkVector2i &position)\n\nSet the position of the mouse when the key was pressed.\n"},
  {"GetPosition", PyvtkContextKeyEvent_GetPosition, METH_VARARGS,
   "V.GetPosition() -> vtkVector2i\nC++: vtkVector2i GetPosition()\n\nGet the position of the mouse when the key was pressed.\n"},
  {"GetKeyCode", PyvtkContextKeyEvent_GetKeyCode, METH_VARARGS,
   "V.GetKeyCode() -> char\nC++: char GetKeyCode()\n\n"},
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkContextKeyEvent_vtkContextKeyEvent_s1(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkContextKeyEvent");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
    {
    vtkContextKeyEvent *op = new vtkContextKeyEvent();

    result = PyVTKSpecialObject_New("vtkContextKeyEvent", op);
    }

  return result;
}

static PyObject *
PyvtkContextKeyEvent_vtkContextKeyEvent_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkContextKeyEvent");

  vtkContextKeyEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextKeyEvent"))
    {
    vtkContextKeyEvent *op = new vtkContextKeyEvent(*temp0);

    result = PyVTKSpecialObject_New("vtkContextKeyEvent", op);
    }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkContextKeyEvent_vtkContextKeyEvent_Methods[] = {
  {NULL, PyvtkContextKeyEvent_vtkContextKeyEvent_s2, METH_VARARGS,
   "@W vtkContextKeyEvent"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkContextKeyEvent_vtkContextKeyEvent(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
    {
    case 0:
      return PyvtkContextKeyEvent_vtkContextKeyEvent_s1(self, args);
    case 1:
      return PyvtkContextKeyEvent_vtkContextKeyEvent_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "vtkContextKeyEvent");
  return NULL;
}


static PyObject *
PyvtkContextKeyEvent_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
    {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
    }

  return PyvtkContextKeyEvent_vtkContextKeyEvent(NULL, args);
}

static void PyvtkContextKeyEvent_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkContextKeyEvent *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkContextKeyEvent_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkContextKeyEvent_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingContext2DPython.vtkContextKeyEvent", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkContextKeyEvent_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkContextKeyEvent_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkContextKeyEvent_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkContextKeyEvent_CCopy(const void *obj)
{
  if (obj)
    {
    return new vtkContextKeyEvent(*static_cast<const vtkContextKeyEvent*>(obj));
    }
  return 0;
}

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkContextKeyEvent_TypeNew(); }

PyObject *PyvtkContextKeyEvent_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkContextKeyEvent_Type,
    PyvtkContextKeyEvent_Methods,
    PyvtkContextKeyEvent_vtkContextKeyEvent_Methods,
    PyvtkContextKeyEvent_Doc(), &PyvtkContextKeyEvent_CCopy);

  PyTypeObject *pytype = &PyvtkContextKeyEvent_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkContextKeyEvent_Doc()
{
  static const char *docstring[] = {
    "vtkContextKeyEvent - data structure to represent key events.\n\n",
    "Provides a convenient data structure to represent key events in the\nvtkContextScene. Passed to vtkAbstractContextItem objects.\n\n",
    "V.vtkContextKeyEvent()\nC++: vtkContextKeyEvent()\nV.vtkContextKeyEvent(vtkContextKeyEvent)\nC++: vtkContextKeyEvent(const &vtkContextKeyEvent)\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkContextKeyEvent(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkContextKeyEvent_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkContextKeyEvent", o) != 0)
    {
    Py_DECREF(o);
    }

}

