// python wrapper for vtkEventForwarderCommand
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkEventForwarderCommand.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkEventForwarderCommand(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkEventForwarderCommand_ClassNew(); }

#ifndef DECLARED_PyvtkCommand_ClassNew
extern "C" { PyObject *PyvtkCommand_ClassNew(); }
#define DECLARED_PyvtkCommand_ClassNew
#endif

static const char **PyvtkEventForwarderCommand_Doc();


static PyObject *
PyvtkEventForwarderCommand_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEventForwarderCommand *op = static_cast<vtkEventForwarderCommand *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkEventForwarderCommand::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkEventForwarderCommand_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEventForwarderCommand *op = static_cast<vtkEventForwarderCommand *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkEventForwarderCommand::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkEventForwarderCommand_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEventForwarderCommand *op = static_cast<vtkEventForwarderCommand *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkEventForwarderCommand *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkEventForwarderCommand::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkEventForwarderCommand_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkEventForwarderCommand *tempr = vtkEventForwarderCommand::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkEventForwarderCommand_Execute(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Execute");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEventForwarderCommand *op = static_cast<vtkEventForwarderCommand *>(vp);

  vtkObject *temp0 = NULL;
  unsigned long temp1;
  void  *temp2 = NULL;
  Py_buffer pbuf2 = VTK_PYBUFFER_INITIALIZER;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkObject") &&
      ap.GetValue(temp1) &&
      ap.GetBuffer(temp2, &pbuf2))
    {
    if (ap.IsBound())
      {
      op->Execute(temp0, temp1, temp2);
      }
    else
      {
      op->vtkEventForwarderCommand::Execute(temp0, temp1, temp2);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf2.obj != 0)
    {
    PyBuffer_Release(&pbuf2);
    }
#endif
  return result;
}


static PyObject *
PyvtkEventForwarderCommand_SetTarget(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTarget");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEventForwarderCommand *op = static_cast<vtkEventForwarderCommand *>(vp);

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    if (ap.IsBound())
      {
      op->SetTarget(temp0);
      }
    else
      {
      op->vtkEventForwarderCommand::SetTarget(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkEventForwarderCommand_GetTarget(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTarget");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEventForwarderCommand *op = static_cast<vtkEventForwarderCommand *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    void  *tempr = (ap.IsBound() ?
      op->GetTarget() :
      op->vtkEventForwarderCommand::GetTarget());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkEventForwarderCommand_Methods[] = {
  {"GetClassName", PyvtkEventForwarderCommand_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkEventForwarderCommand_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkEventForwarderCommand_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkEventForwarderCommand\nC++: vtkEventForwarderCommand *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkEventForwarderCommand_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkEventForwarderCommand\nC++: vtkEventForwarderCommand *SafeDownCast(vtkObject* o)\n\n"},
  {"Execute", PyvtkEventForwarderCommand_Execute, METH_VARARGS,
   "V.Execute(vtkObject, int, void)\nC++: void Execute(vtkObject *caller, unsigned long eid,\n    void *callData)\n\nSatisfy the superclass API for callbacks. Recall that the caller\nis the instance invoking the event; eid is the event id (see\nvtkCommand.h); and calldata is information sent when the callback\nwas invoked (e.g., progress value in the\nvtkCommand::ProgressEvent).\n"},
  {"SetTarget", PyvtkEventForwarderCommand_SetTarget, METH_VARARGS,
   "V.SetTarget(vtkObject)\nC++: virtual void SetTarget(vtkObject *obj)\n\nMethods to set and get client and callback information, and the\ncallback function.\n"},
  {"GetTarget", PyvtkEventForwarderCommand_GetTarget, METH_VARARGS,
   "V.GetTarget() -> void\nC++: virtual void *GetTarget()\n\nMethods to set and get client and callback information, and the\ncallback function.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkEventForwarderCommand_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkEventForwarderCommand", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkEventForwarderCommand_StaticNew()
{
  return vtkEventForwarderCommand::New();
}

PyObject *PyvtkEventForwarderCommand_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkEventForwarderCommand_Type, PyvtkEventForwarderCommand_Methods,
    "vtkEventForwarderCommand",
    PyvtkEventForwarderCommand_Doc(), &PyvtkEventForwarderCommand_StaticNew);

  PyTypeObject *pytype = &PyvtkEventForwarderCommand_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkCommand_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkEventForwarderCommand_Doc()
{
  static const char *docstring[] = {
    "vtkEventForwarderCommand - a simple event forwarder command\n\n",
    "Superclass: vtkCommand\n\n",
    "Use vtkEventForwarderCommand to forward an event to a new object.\nThis command will intercept the event, and use InvokeEvent on a\n'target' as if that object was the one that invoked the event instead\nof the object this commmand was attached to using AddObserver.\n\nSee Also:\n\nvtkCommand\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkEventForwarderCommand(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkEventForwarderCommand_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkEventForwarderCommand", o) != 0)
    {
    Py_DECREF(o);
    }

}

