// python wrapper for vtkFixedWidthTextReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkFixedWidthTextReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkFixedWidthTextReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkFixedWidthTextReader_ClassNew(); }

#ifndef DECLARED_PyvtkTableAlgorithm_ClassNew
extern "C" { PyObject *PyvtkTableAlgorithm_ClassNew(); }
#define DECLARED_PyvtkTableAlgorithm_ClassNew
#endif

static const char **PyvtkFixedWidthTextReader_Doc();


static PyObject *
PyvtkFixedWidthTextReader_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkFixedWidthTextReader::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkFixedWidthTextReader::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkFixedWidthTextReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkFixedWidthTextReader::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkFixedWidthTextReader *tempr = vtkFixedWidthTextReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkFixedWidthTextReader::GetFileName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetFileName(temp0);
      }
    else
      {
      op->vtkFixedWidthTextReader::SetFileName(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_SetFieldWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFieldWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetFieldWidth(temp0);
      }
    else
      {
      op->vtkFixedWidthTextReader::SetFieldWidth(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_GetFieldWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFieldWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetFieldWidth() :
      op->vtkFixedWidthTextReader::GetFieldWidth());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_SetStripWhiteSpace(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStripWhiteSpace");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetStripWhiteSpace(temp0);
      }
    else
      {
      op->vtkFixedWidthTextReader::SetStripWhiteSpace(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_GetStripWhiteSpace(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStripWhiteSpace");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->GetStripWhiteSpace() :
      op->vtkFixedWidthTextReader::GetStripWhiteSpace());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_StripWhiteSpaceOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StripWhiteSpaceOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->StripWhiteSpaceOn();
      }
    else
      {
      op->vtkFixedWidthTextReader::StripWhiteSpaceOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_StripWhiteSpaceOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StripWhiteSpaceOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->StripWhiteSpaceOff();
      }
    else
      {
      op->vtkFixedWidthTextReader::StripWhiteSpaceOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_GetHaveHeaders(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHaveHeaders");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->GetHaveHeaders() :
      op->vtkFixedWidthTextReader::GetHaveHeaders());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_SetHaveHeaders(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetHaveHeaders");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetHaveHeaders(temp0);
      }
    else
      {
      op->vtkFixedWidthTextReader::SetHaveHeaders(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_HaveHeadersOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HaveHeadersOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->HaveHeadersOn();
      }
    else
      {
      op->vtkFixedWidthTextReader::HaveHeadersOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_HaveHeadersOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HaveHeadersOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->HaveHeadersOff();
      }
    else
      {
      op->vtkFixedWidthTextReader::HaveHeadersOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_SetTableErrorObserver(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTableErrorObserver");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  vtkCommand *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCommand"))
    {
    if (ap.IsBound())
      {
      op->SetTableErrorObserver(temp0);
      }
    else
      {
      op->vtkFixedWidthTextReader::SetTableErrorObserver(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkFixedWidthTextReader_GetTableErrorObserver(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTableErrorObserver");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedWidthTextReader *op = static_cast<vtkFixedWidthTextReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkCommand *tempr = (ap.IsBound() ?
      op->GetTableErrorObserver() :
      op->vtkFixedWidthTextReader::GetTableErrorObserver());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkFixedWidthTextReader_Methods[] = {
  {"GetClassName", PyvtkFixedWidthTextReader_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkFixedWidthTextReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkFixedWidthTextReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkFixedWidthTextReader\nC++: vtkFixedWidthTextReader *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkFixedWidthTextReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkFixedWidthTextReader\nC++: vtkFixedWidthTextReader *SafeDownCast(vtkObject* o)\n\n"},
  {"GetFileName", PyvtkFixedWidthTextReader_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: char *GetFileName()\n\n"},
  {"SetFileName", PyvtkFixedWidthTextReader_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: void SetFileName(char *)\n\n"},
  {"SetFieldWidth", PyvtkFixedWidthTextReader_SetFieldWidth, METH_VARARGS,
   "V.SetFieldWidth(int)\nC++: void SetFieldWidth(int a)\n\nSet/get the field width\n"},
  {"GetFieldWidth", PyvtkFixedWidthTextReader_GetFieldWidth, METH_VARARGS,
   "V.GetFieldWidth() -> int\nC++: int GetFieldWidth()\n\nSet/get the field width\n"},
  {"SetStripWhiteSpace", PyvtkFixedWidthTextReader_SetStripWhiteSpace, METH_VARARGS,
   "V.SetStripWhiteSpace(bool)\nC++: void SetStripWhiteSpace(bool a)\n\nIf set, this flag will cause the reader to strip whitespace from\nthe beginning and ending of each field.  Defaults to off.\n"},
  {"GetStripWhiteSpace", PyvtkFixedWidthTextReader_GetStripWhiteSpace, METH_VARARGS,
   "V.GetStripWhiteSpace() -> bool\nC++: bool GetStripWhiteSpace()\n\nIf set, this flag will cause the reader to strip whitespace from\nthe beginning and ending of each field.  Defaults to off.\n"},
  {"StripWhiteSpaceOn", PyvtkFixedWidthTextReader_StripWhiteSpaceOn, METH_VARARGS,
   "V.StripWhiteSpaceOn()\nC++: void StripWhiteSpaceOn()\n\nIf set, this flag will cause the reader to strip whitespace from\nthe beginning and ending of each field.  Defaults to off.\n"},
  {"StripWhiteSpaceOff", PyvtkFixedWidthTextReader_StripWhiteSpaceOff, METH_VARARGS,
   "V.StripWhiteSpaceOff()\nC++: void StripWhiteSpaceOff()\n\nIf set, this flag will cause the reader to strip whitespace from\nthe beginning and ending of each field.  Defaults to off.\n"},
  {"GetHaveHeaders", PyvtkFixedWidthTextReader_GetHaveHeaders, METH_VARARGS,
   "V.GetHaveHeaders() -> bool\nC++: bool GetHaveHeaders()\n\nSet/get whether to treat the first line of the file as headers.\n"},
  {"SetHaveHeaders", PyvtkFixedWidthTextReader_SetHaveHeaders, METH_VARARGS,
   "V.SetHaveHeaders(bool)\nC++: void SetHaveHeaders(bool a)\n\nSet/get whether to treat the first line of the file as headers.\n"},
  {"HaveHeadersOn", PyvtkFixedWidthTextReader_HaveHeadersOn, METH_VARARGS,
   "V.HaveHeadersOn()\nC++: void HaveHeadersOn()\n\nSet/get whether to treat the first line of the file as headers.\n"},
  {"HaveHeadersOff", PyvtkFixedWidthTextReader_HaveHeadersOff, METH_VARARGS,
   "V.HaveHeadersOff()\nC++: void HaveHeadersOff()\n\nSet/get whether to treat the first line of the file as headers.\n"},
  {"SetTableErrorObserver", PyvtkFixedWidthTextReader_SetTableErrorObserver, METH_VARARGS,
   "V.SetTableErrorObserver(vtkCommand)\nC++: void SetTableErrorObserver(vtkCommand *)\n\nSet/get the ErrorObserver for the internal vtkTable This is\nuseful for applications that want to catch error messages.\n"},
  {"GetTableErrorObserver", PyvtkFixedWidthTextReader_GetTableErrorObserver, METH_VARARGS,
   "V.GetTableErrorObserver() -> vtkCommand\nC++: vtkCommand *GetTableErrorObserver()\n\nSet/get the ErrorObserver for the internal vtkTable This is\nuseful for applications that want to catch error messages.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkFixedWidthTextReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOInfovisPython.vtkFixedWidthTextReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkFixedWidthTextReader_StaticNew()
{
  return vtkFixedWidthTextReader::New();
}

PyObject *PyvtkFixedWidthTextReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkFixedWidthTextReader_Type, PyvtkFixedWidthTextReader_Methods,
    "vtkFixedWidthTextReader",
    PyvtkFixedWidthTextReader_Doc(), &PyvtkFixedWidthTextReader_StaticNew);

  PyTypeObject *pytype = &PyvtkFixedWidthTextReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTableAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkFixedWidthTextReader_Doc()
{
  static const char *docstring[] = {
    "vtkFixedWidthTextReader - reader for pulling in text files with\nfixed-width fields\n\n",
    "Superclass: vtkTableAlgorithm\n\n",
    "vtkFixedWidthTextReader reads in a table from a text file where each\ncolumn occupies a certain number of characters.\n\nThis class emits ProgressEvent for every 100 lines it reads.\n\nCaveats:\n\nThis first version of the reader will assume that all fields have the\nsame width.  It also assumes that the first line in the file has at\nleast as many fields (i.e. at least as many characters) as any other\nlin",
    "e in the file.\n\nThanks:\n\nThanks to Andy Wilson from Sandia National Laboratories for\nimplementing this class.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkFixedWidthTextReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkFixedWidthTextReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkFixedWidthTextReader", o) != 0)
    {
    Py_DECREF(o);
    }

}

