// python wrapper for vtkGeoAlignedImageRepresentation
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkGeoAlignedImageRepresentation.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoAlignedImageRepresentation(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoAlignedImageRepresentation_ClassNew(); }

#ifndef DECLARED_PyvtkDataRepresentation_ClassNew
extern "C" { PyObject *PyvtkDataRepresentation_ClassNew(); }
#define DECLARED_PyvtkDataRepresentation_ClassNew
#endif

static const char **PyvtkGeoAlignedImageRepresentation_Doc();


static PyObject *
PyvtkGeoAlignedImageRepresentation_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageRepresentation *op = static_cast<vtkGeoAlignedImageRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGeoAlignedImageRepresentation::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageRepresentation *op = static_cast<vtkGeoAlignedImageRepresentation *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoAlignedImageRepresentation::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageRepresentation *op = static_cast<vtkGeoAlignedImageRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkGeoAlignedImageRepresentation *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoAlignedImageRepresentation::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkGeoAlignedImageRepresentation *tempr = vtkGeoAlignedImageRepresentation::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_GetBestImageForBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBestImageForBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageRepresentation *op = static_cast<vtkGeoAlignedImageRepresentation *>(vp);

  double temp0[4];
  double save0[4];
  const int size0 = 4;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    ap.SaveArray(temp0, save0, size0);

    vtkGeoImageNode *tempr = (ap.IsBound() ?
      op->GetBestImageForBounds(temp0) :
      op->vtkGeoAlignedImageRepresentation::GetBestImageForBounds(temp0));

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(0, temp0, size0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_GetSource(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSource");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageRepresentation *op = static_cast<vtkGeoAlignedImageRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkGeoSource *tempr = (ap.IsBound() ?
      op->GetSource() :
      op->vtkGeoAlignedImageRepresentation::GetSource());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_SetSource(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSource");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageRepresentation *op = static_cast<vtkGeoAlignedImageRepresentation *>(vp);

  vtkGeoSource *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoSource"))
    {
    if (ap.IsBound())
      {
      op->SetSource(temp0);
      }
    else
      {
      op->vtkGeoAlignedImageRepresentation::SetSource(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_SaveDatabase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SaveDatabase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageRepresentation *op = static_cast<vtkGeoAlignedImageRepresentation *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SaveDatabase(temp0);
      }
    else
      {
      op->vtkGeoAlignedImageRepresentation::SaveDatabase(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkGeoAlignedImageRepresentation_Methods[] = {
  {"GetClassName", PyvtkGeoAlignedImageRepresentation_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGeoAlignedImageRepresentation_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGeoAlignedImageRepresentation_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoAlignedImageRepresentation\nC++: vtkGeoAlignedImageRepresentation *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGeoAlignedImageRepresentation_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGeoAlignedImageRepresentation\nC++: vtkGeoAlignedImageRepresentation *SafeDownCast(vtkObject* o)\n\n"},
  {"GetBestImageForBounds", PyvtkGeoAlignedImageRepresentation_GetBestImageForBounds, METH_VARARGS,
   "V.GetBestImageForBounds([float, float, float, float])\n    -> vtkGeoImageNode\nC++: virtual vtkGeoImageNode *GetBestImageForBounds(\n    double bounds[4])\n\nRetrieve the most refined image patch that covers the specified\nlatitude and longitude bounds (lat-min, lat-max, long-min,\nlong-max).\n"},
  {"GetSource", PyvtkGeoAlignedImageRepresentation_GetSource, METH_VARARGS,
   "V.GetSource() -> vtkGeoSource\nC++: virtual vtkGeoSource *GetSource()\n\nThe source for this representation. This must be set first before\ncalling GetBestImageForBounds.\n"},
  {"SetSource", PyvtkGeoAlignedImageRepresentation_SetSource, METH_VARARGS,
   "V.SetSource(vtkGeoSource)\nC++: virtual void SetSource(vtkGeoSource *source)\n\nThe source for this representation. This must be set first before\ncalling GetBestImageForBounds.\n"},
  {"SaveDatabase", PyvtkGeoAlignedImageRepresentation_SaveDatabase, METH_VARARGS,
   "V.SaveDatabase(string)\nC++: void SaveDatabase(const char *path)\n\nSerialize the database to the specified directory. Each image is\nstored as a .vti file. The Origin and Spacing of the saved image\ncontain (lat-min, long-min) and (lat-max, long-max),\nrespectively. Files are named based on their level and id within\nthat level.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGeoAlignedImageRepresentation_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoAlignedImageRepresentation", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoAlignedImageRepresentation_StaticNew()
{
  return vtkGeoAlignedImageRepresentation::New();
}

PyObject *PyvtkGeoAlignedImageRepresentation_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoAlignedImageRepresentation_Type, PyvtkGeoAlignedImageRepresentation_Methods,
    "vtkGeoAlignedImageRepresentation",
    PyvtkGeoAlignedImageRepresentation_Doc(), &PyvtkGeoAlignedImageRepresentation_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoAlignedImageRepresentation_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataRepresentation_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGeoAlignedImageRepresentation_Doc()
{
  static const char *docstring[] = {
    "vtkGeoAlignedImageRepresentation - A multi-resolution image tree\n\n",
    "Superclass: vtkDataRepresentation\n\n",
    "vtkGeoAlignedImageRepresentation represents a high resolution image\nover the globle. It has an associated vtkGeoSource which is\nresponsible for fetching new data. This class keeps the fetched data\nin a quad-tree structure organized by latitude and longitude.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGeoAlignedImageRepresentation(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoAlignedImageRepresentation_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoAlignedImageRepresentation", o) != 0)
    {
    Py_DECREF(o);
    }

}

