// python wrapper for vtkGeoAlignedImageSource
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkGeoAlignedImageSource.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoAlignedImageSource(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoAlignedImageSource_ClassNew(); }

#ifndef DECLARED_PyvtkGeoSource_ClassNew
extern "C" { PyObject *PyvtkGeoSource_ClassNew(); }
#define DECLARED_PyvtkGeoSource_ClassNew
#endif

static const char **PyvtkGeoAlignedImageSource_Doc();


static PyObject *
PyvtkGeoAlignedImageSource_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGeoAlignedImageSource::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoAlignedImageSource::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkGeoAlignedImageSource *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoAlignedImageSource::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkGeoAlignedImageSource *tempr = vtkGeoAlignedImageSource::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_FetchRoot(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FetchRoot");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  vtkGeoTreeNode *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode"))
    {
    bool tempr = (ap.IsBound() ?
      op->FetchRoot(temp0) :
      op->vtkGeoAlignedImageSource::FetchRoot(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_FetchChild(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FetchChild");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  vtkGeoTreeNode *temp0 = NULL;
  int temp1;
  vtkGeoTreeNode *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode") &&
      ap.GetValue(temp1) &&
      ap.GetVTKObject(temp2, "vtkGeoTreeNode"))
    {
    bool tempr = (ap.IsBound() ?
      op->FetchChild(temp0, temp1, temp2) :
      op->vtkGeoAlignedImageSource::FetchChild(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_GetImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetImage() :
      op->vtkGeoAlignedImageSource::GetImage());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_SetImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  vtkImageData *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
    {
    if (ap.IsBound())
      {
      op->SetImage(temp0);
      }
    else
      {
      op->vtkGeoAlignedImageSource::SetImage(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_SetLatitudeRange_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLatitudeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  double temp0;
  double temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    if (ap.IsBound())
      {
      op->SetLatitudeRange(temp0, temp1);
      }
    else
      {
      op->vtkGeoAlignedImageSource::SetLatitudeRange(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkGeoAlignedImageSource_SetLatitudeRange_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLatitudeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  double temp0[2];
  const int size0 = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    if (ap.IsBound())
      {
      op->SetLatitudeRange(temp0);
      }
    else
      {
      op->vtkGeoAlignedImageSource::SetLatitudeRange(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkGeoAlignedImageSource_SetLatitudeRange(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 2:
      return PyvtkGeoAlignedImageSource_SetLatitudeRange_s1(self, args);
    case 1:
      return PyvtkGeoAlignedImageSource_SetLatitudeRange_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetLatitudeRange");
  return NULL;
}



static PyObject *
PyvtkGeoAlignedImageSource_GetLatitudeRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLatitudeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetLatitudeRange() :
      op->vtkGeoAlignedImageSource::GetLatitudeRange());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_SetLongitudeRange_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLongitudeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  double temp0;
  double temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    if (ap.IsBound())
      {
      op->SetLongitudeRange(temp0, temp1);
      }
    else
      {
      op->vtkGeoAlignedImageSource::SetLongitudeRange(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkGeoAlignedImageSource_SetLongitudeRange_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLongitudeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  double temp0[2];
  const int size0 = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    if (ap.IsBound())
      {
      op->SetLongitudeRange(temp0);
      }
    else
      {
      op->vtkGeoAlignedImageSource::SetLongitudeRange(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkGeoAlignedImageSource_SetLongitudeRange(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 2:
      return PyvtkGeoAlignedImageSource_SetLongitudeRange_s1(self, args);
    case 1:
      return PyvtkGeoAlignedImageSource_SetLongitudeRange_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetLongitudeRange");
  return NULL;
}



static PyObject *
PyvtkGeoAlignedImageSource_GetLongitudeRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLongitudeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetLongitudeRange() :
      op->vtkGeoAlignedImageSource::GetLongitudeRange());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_SetOverlap(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOverlap");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetOverlap(temp0);
      }
    else
      {
      op->vtkGeoAlignedImageSource::SetOverlap(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_GetOverlapMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverlapMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetOverlapMinValue() :
      op->vtkGeoAlignedImageSource::GetOverlapMinValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_GetOverlapMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverlapMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetOverlapMaxValue() :
      op->vtkGeoAlignedImageSource::GetOverlapMaxValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_GetOverlap(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverlap");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetOverlap() :
      op->vtkGeoAlignedImageSource::GetOverlap());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_SetPowerOfTwoSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPowerOfTwoSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetPowerOfTwoSize(temp0);
      }
    else
      {
      op->vtkGeoAlignedImageSource::SetPowerOfTwoSize(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_GetPowerOfTwoSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPowerOfTwoSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->GetPowerOfTwoSize() :
      op->vtkGeoAlignedImageSource::GetPowerOfTwoSize());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_PowerOfTwoSizeOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PowerOfTwoSizeOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->PowerOfTwoSizeOn();
      }
    else
      {
      op->vtkGeoAlignedImageSource::PowerOfTwoSizeOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageSource_PowerOfTwoSizeOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PowerOfTwoSizeOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageSource *op = static_cast<vtkGeoAlignedImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->PowerOfTwoSizeOff();
      }
    else
      {
      op->vtkGeoAlignedImageSource::PowerOfTwoSizeOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkGeoAlignedImageSource_Methods[] = {
  {"GetClassName", PyvtkGeoAlignedImageSource_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGeoAlignedImageSource_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGeoAlignedImageSource_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoAlignedImageSource\nC++: vtkGeoAlignedImageSource *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGeoAlignedImageSource_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGeoAlignedImageSource\nC++: vtkGeoAlignedImageSource *SafeDownCast(vtkObject* o)\n\n"},
  {"FetchRoot", PyvtkGeoAlignedImageSource_FetchRoot, METH_VARARGS,
   "V.FetchRoot(vtkGeoTreeNode) -> bool\nC++: virtual bool FetchRoot(vtkGeoTreeNode *node)\n\nFetch the root image.\n"},
  {"FetchChild", PyvtkGeoAlignedImageSource_FetchChild, METH_VARARGS,
   "V.FetchChild(vtkGeoTreeNode, int, vtkGeoTreeNode) -> bool\nC++: virtual bool FetchChild(vtkGeoTreeNode *parent, int index,\n    vtkGeoTreeNode *child)\n\nFetch a child image.\n"},
  {"GetImage", PyvtkGeoAlignedImageSource_GetImage, METH_VARARGS,
   "V.GetImage() -> vtkImageData\nC++: vtkImageData *GetImage()\n\nThe high-resolution image to be used to cover the globe.\n"},
  {"SetImage", PyvtkGeoAlignedImageSource_SetImage, METH_VARARGS,
   "V.SetImage(vtkImageData)\nC++: virtual void SetImage(vtkImageData *image)\n\nThe high-resolution image to be used to cover the globe.\n"},
  {"SetLatitudeRange", PyvtkGeoAlignedImageSource_SetLatitudeRange, METH_VARARGS,
   "V.SetLatitudeRange(float, float)\nC++: void SetLatitudeRange(double, double)\nV.SetLatitudeRange((float, float))\nC++: void SetLatitudeRange(double a[2])\n\n"},
  {"GetLatitudeRange", PyvtkGeoAlignedImageSource_GetLatitudeRange, METH_VARARGS,
   "V.GetLatitudeRange() -> (float, float)\nC++: double *GetLatitudeRange()\n\n"},
  {"SetLongitudeRange", PyvtkGeoAlignedImageSource_SetLongitudeRange, METH_VARARGS,
   "V.SetLongitudeRange(float, float)\nC++: void SetLongitudeRange(double, double)\nV.SetLongitudeRange((float, float))\nC++: void SetLongitudeRange(double a[2])\n\n"},
  {"GetLongitudeRange", PyvtkGeoAlignedImageSource_GetLongitudeRange, METH_VARARGS,
   "V.GetLongitudeRange() -> (float, float)\nC++: double *GetLongitudeRange()\n\n"},
  {"SetOverlap", PyvtkGeoAlignedImageSource_SetOverlap, METH_VARARGS,
   "V.SetOverlap(float)\nC++: void SetOverlap(double)\n\nThe overlap of adjacent tiles.\n"},
  {"GetOverlapMinValue", PyvtkGeoAlignedImageSource_GetOverlapMinValue, METH_VARARGS,
   "V.GetOverlapMinValue() -> float\nC++: double GetOverlapMinValue()\n\nThe overlap of adjacent tiles.\n"},
  {"GetOverlapMaxValue", PyvtkGeoAlignedImageSource_GetOverlapMaxValue, METH_VARARGS,
   "V.GetOverlapMaxValue() -> float\nC++: double GetOverlapMaxValue()\n\nThe overlap of adjacent tiles.\n"},
  {"GetOverlap", PyvtkGeoAlignedImageSource_GetOverlap, METH_VARARGS,
   "V.GetOverlap() -> float\nC++: double GetOverlap()\n\nThe overlap of adjacent tiles.\n"},
  {"SetPowerOfTwoSize", PyvtkGeoAlignedImageSource_SetPowerOfTwoSize, METH_VARARGS,
   "V.SetPowerOfTwoSize(bool)\nC++: void SetPowerOfTwoSize(bool a)\n\nWhether to force image sizes to a power of two.\n"},
  {"GetPowerOfTwoSize", PyvtkGeoAlignedImageSource_GetPowerOfTwoSize, METH_VARARGS,
   "V.GetPowerOfTwoSize() -> bool\nC++: bool GetPowerOfTwoSize()\n\nWhether to force image sizes to a power of two.\n"},
  {"PowerOfTwoSizeOn", PyvtkGeoAlignedImageSource_PowerOfTwoSizeOn, METH_VARARGS,
   "V.PowerOfTwoSizeOn()\nC++: void PowerOfTwoSizeOn()\n\nWhether to force image sizes to a power of two.\n"},
  {"PowerOfTwoSizeOff", PyvtkGeoAlignedImageSource_PowerOfTwoSizeOff, METH_VARARGS,
   "V.PowerOfTwoSizeOff()\nC++: void PowerOfTwoSizeOff()\n\nWhether to force image sizes to a power of two.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGeoAlignedImageSource_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoAlignedImageSource", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoAlignedImageSource_StaticNew()
{
  return vtkGeoAlignedImageSource::New();
}

PyObject *PyvtkGeoAlignedImageSource_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoAlignedImageSource_Type, PyvtkGeoAlignedImageSource_Methods,
    "vtkGeoAlignedImageSource",
    PyvtkGeoAlignedImageSource_Doc(), &PyvtkGeoAlignedImageSource_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoAlignedImageSource_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkGeoSource_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGeoAlignedImageSource_Doc()
{
  static const char *docstring[] = {
    "vtkGeoAlignedImageSource - Splits hi-res image into tiles.\n\n",
    "Superclass: vtkGeoSource\n\n",
    "vtkGeoAlignedImageSource uses a high resolution image to generate\ntiles at multiple resolutions in a hierarchy. It should be used as a\nsource in vtkGeoAlignedImageRepresentation.\n\nSee Also:\n\nvtkGeoAlignedImageRepresentation vtkGeoView vtkGeoView2D\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGeoAlignedImageSource(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoAlignedImageSource_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoAlignedImageSource", o) != 0)
    {
    Py_DECREF(o);
    }

}

