// python wrapper for vtkGeoCamera
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkGeoCamera.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoCamera(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoCamera_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkGeoCamera_Doc();


static PyObject *
PyvtkGeoCamera_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGeoCamera::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoCamera::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkGeoCamera *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoCamera::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkGeoCamera *tempr = vtkGeoCamera::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_GetPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetPosition() :
      op->vtkGeoCamera::GetPosition());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_SetLongitude(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLongitude");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetLongitude(temp0);
      }
    else
      {
      op->vtkGeoCamera::SetLongitude(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_GetLongitude(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLongitude");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetLongitude() :
      op->vtkGeoCamera::GetLongitude());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_SetLatitude(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLatitude");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetLatitude(temp0);
      }
    else
      {
      op->vtkGeoCamera::SetLatitude(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_GetLatitude(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLatitude");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetLatitude() :
      op->vtkGeoCamera::GetLatitude());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_SetDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetDistance(temp0);
      }
    else
      {
      op->vtkGeoCamera::SetDistance(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_GetDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetDistance() :
      op->vtkGeoCamera::GetDistance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_SetHeading(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetHeading");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetHeading(temp0);
      }
    else
      {
      op->vtkGeoCamera::SetHeading(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_GetHeading(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHeading");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetHeading() :
      op->vtkGeoCamera::GetHeading());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_SetTilt(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTilt");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetTilt(temp0);
      }
    else
      {
      op->vtkGeoCamera::SetTilt(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_GetTilt(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTilt");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetTilt() :
      op->vtkGeoCamera::GetTilt());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_GetVTKCamera(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVTKCamera");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkCamera *tempr = (ap.IsBound() ?
      op->GetVTKCamera() :
      op->vtkGeoCamera::GetVTKCamera());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_InitializeNodeAnalysis(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InitializeNodeAnalysis");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  int temp0[2];
  int save0[2];
  const int size0 = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
      {
      op->InitializeNodeAnalysis(temp0);
      }
    else
      {
      op->vtkGeoCamera::InitializeNodeAnalysis(temp0);
      }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(0, temp0, size0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_GetNodeCoverage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNodeCoverage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  vtkGeoTerrainNode *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoTerrainNode"))
    {
    double tempr = (ap.IsBound() ?
      op->GetNodeCoverage(temp0) :
      op->vtkGeoCamera::GetNodeCoverage(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_GetLockHeading(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLockHeading");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->GetLockHeading() :
      op->vtkGeoCamera::GetLockHeading());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_SetLockHeading(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLockHeading");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetLockHeading(temp0);
      }
    else
      {
      op->vtkGeoCamera::SetLockHeading(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_LockHeadingOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LockHeadingOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->LockHeadingOn();
      }
    else
      {
      op->vtkGeoCamera::LockHeadingOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_LockHeadingOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LockHeadingOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->LockHeadingOff();
      }
    else
      {
      op->vtkGeoCamera::LockHeadingOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_SetOriginLatitude(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOriginLatitude");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetOriginLatitude(temp0);
      }
    else
      {
      op->vtkGeoCamera::SetOriginLatitude(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_GetOriginLatitude(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOriginLatitude");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetOriginLatitude() :
      op->vtkGeoCamera::GetOriginLatitude());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_SetOriginLongitude(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOriginLongitude");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetOriginLongitude(temp0);
      }
    else
      {
      op->vtkGeoCamera::SetOriginLongitude(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_GetOriginLongitude(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOriginLongitude");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetOriginLongitude() :
      op->vtkGeoCamera::GetOriginLongitude());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_GetOrigin(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOrigin");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetOrigin() :
      op->vtkGeoCamera::GetOrigin());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoCamera_SetOrigin(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOrigin");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoCamera *op = static_cast<vtkGeoCamera *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
    {
    if (ap.IsBound())
      {
      op->SetOrigin(temp0, temp1, temp2);
      }
    else
      {
      op->vtkGeoCamera::SetOrigin(temp0, temp1, temp2);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkGeoCamera_Methods[] = {
  {"GetClassName", PyvtkGeoCamera_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGeoCamera_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGeoCamera_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoCamera\nC++: vtkGeoCamera *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGeoCamera_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGeoCamera\nC++: vtkGeoCamera *SafeDownCast(vtkObject* o)\n\n"},
  {"GetPosition", PyvtkGeoCamera_GetPosition, METH_VARARGS,
   "V.GetPosition() -> (float, float, float)\nC++: double *GetPosition()\n\n"},
  {"SetLongitude", PyvtkGeoCamera_SetLongitude, METH_VARARGS,
   "V.SetLongitude(float)\nC++: void SetLongitude(double longitude)\n\nLongitude is in degrees: (-180->180)\n  Relative to absolute coordinates.\n Rotate Longitude  around z axis (earth axis),\n"},
  {"GetLongitude", PyvtkGeoCamera_GetLongitude, METH_VARARGS,
   "V.GetLongitude() -> float\nC++: double GetLongitude()\n\nLongitude is in degrees: (-180->180)\n  Relative to absolute coordinates.\n Rotate Longitude  around z axis (earth axis),\n"},
  {"SetLatitude", PyvtkGeoCamera_SetLatitude, METH_VARARGS,
   "V.SetLatitude(float)\nC++: void SetLatitude(double latitude)\n\nLatitude is in degrees: (-90->90)\n   Relative to Longitude.\n Rotate Latitude   around x axis by Latitude,\n"},
  {"GetLatitude", PyvtkGeoCamera_GetLatitude, METH_VARARGS,
   "V.GetLatitude() -> float\nC++: double GetLatitude()\n\nLatitude is in degrees: (-90->90)\n   Relative to Longitude.\n Rotate Latitude   around x axis by Latitude,\n"},
  {"SetDistance", PyvtkGeoCamera_SetDistance, METH_VARARGS,
   "V.SetDistance(float)\nC++: void SetDistance(double Distance)\n\nDistance is in Meters\n  Relative to Longitude and Latitude.\n  above sea level   ???? should we make this from center of earth\n????\n                   ???? what about equatorial bulge ????\n"},
  {"GetDistance", PyvtkGeoCamera_GetDistance, METH_VARARGS,
   "V.GetDistance() -> float\nC++: double GetDistance()\n\nDistance is in Meters\n  Relative to Longitude and Latitude.\n  above sea level   ???? should we make this from center of earth\n????\n                   ???? what about equatorial bulge ????\n"},
  {"SetHeading", PyvtkGeoCamera_SetHeading, METH_VARARGS,
   "V.SetHeading(float)\nC++: void SetHeading(double heading)\n\nHeading is in degrees:  (-180->180)\n  Relative to Logitude and Latitude.\n  0 is north.\n  90 is east.       ???? what is the standard ????\n  180 is south.\n-90 is west. Rotate Heading    around -y axis Center,\n"},
  {"GetHeading", PyvtkGeoCamera_GetHeading, METH_VARARGS,
   "V.GetHeading() -> float\nC++: double GetHeading()\n\nHeading is in degrees:  (-180->180)\n  Relative to Logitude and Latitude.\n  0 is north.\n  90 is east.       ???? what is the standard ????\n  180 is south.\n-90 is west. Rotate Heading    around -y axis Center,\n"},
  {"SetTilt", PyvtkGeoCamera_SetTilt, METH_VARARGS,
   "V.SetTilt(float)\nC++: void SetTilt(double tilt)\n\nTilt is also know as pitch. Tilt is in degrees: (0->90)\n  Relative to Longitude, Latitude, and Heading. Rotate Tilt      \naround x axis,\n"},
  {"GetTilt", PyvtkGeoCamera_GetTilt, METH_VARARGS,
   "V.GetTilt() -> float\nC++: double GetTilt()\n\nTilt is also know as pitch. Tilt is in degrees: (0->90)\n  Relative to Longitude, Latitude, and Heading. Rotate Tilt      \naround x axis,\n"},
  {"GetVTKCamera", PyvtkGeoCamera_GetVTKCamera, METH_VARARGS,
   "V.GetVTKCamera() -> vtkCamera\nC++: vtkCamera *GetVTKCamera()\n\nThis vtk camera is updated to match this geo cameras state. It\nshould be treated as a const and should not be modified.\n"},
  {"InitializeNodeAnalysis", PyvtkGeoCamera_InitializeNodeAnalysis, METH_VARARGS,
   "V.InitializeNodeAnalysis([int, int])\nC++: void InitializeNodeAnalysis(int rendererSize[2])\n\nWe precompute some values to speed up update of the terrain.\nUnfortunately, they have to be manually/explicitly updated when\nthe camera or renderer size changes.\n"},
  {"GetNodeCoverage", PyvtkGeoCamera_GetNodeCoverage, METH_VARARGS,
   "V.GetNodeCoverage(vtkGeoTerrainNode) -> float\nC++: double GetNodeCoverage(vtkGeoTerrainNode *node)\n\nThis method estimates how much of the view is covered by the\nsphere. Returns a value from 0 to 1.\n"},
  {"GetLockHeading", PyvtkGeoCamera_GetLockHeading, METH_VARARGS,
   "V.GetLockHeading() -> bool\nC++: bool GetLockHeading()\n\nWhether to lock the heading a particular value, or to let the\nheading \"roam free\" when performing latitude and longitude\nchanges.\n"},
  {"SetLockHeading", PyvtkGeoCamera_SetLockHeading, METH_VARARGS,
   "V.SetLockHeading(bool)\nC++: void SetLockHeading(bool a)\n\nWhether to lock the heading a particular value, or to let the\nheading \"roam free\" when performing latitude and longitude\nchanges.\n"},
  {"LockHeadingOn", PyvtkGeoCamera_LockHeadingOn, METH_VARARGS,
   "V.LockHeadingOn()\nC++: void LockHeadingOn()\n\nWhether to lock the heading a particular value, or to let the\nheading \"roam free\" when performing latitude and longitude\nchanges.\n"},
  {"LockHeadingOff", PyvtkGeoCamera_LockHeadingOff, METH_VARARGS,
   "V.LockHeadingOff()\nC++: void LockHeadingOff()\n\nWhether to lock the heading a particular value, or to let the\nheading \"roam free\" when performing latitude and longitude\nchanges.\n"},
  {"SetOriginLatitude", PyvtkGeoCamera_SetOriginLatitude, METH_VARARGS,
   "V.SetOriginLatitude(float)\nC++: void SetOriginLatitude(double oLat)\n\nThis point is shifted to 0,0,0 to avoid openGL issues.\n"},
  {"GetOriginLatitude", PyvtkGeoCamera_GetOriginLatitude, METH_VARARGS,
   "V.GetOriginLatitude() -> float\nC++: double GetOriginLatitude()\n\nThis point is shifted to 0,0,0 to avoid openGL issues.\n"},
  {"SetOriginLongitude", PyvtkGeoCamera_SetOriginLongitude, METH_VARARGS,
   "V.SetOriginLongitude(float)\nC++: void SetOriginLongitude(double oLat)\n\nThis point is shifted to 0,0,0 to avoid openGL issues.\n"},
  {"GetOriginLongitude", PyvtkGeoCamera_GetOriginLongitude, METH_VARARGS,
   "V.GetOriginLongitude() -> float\nC++: double GetOriginLongitude()\n\nThis point is shifted to 0,0,0 to avoid openGL issues.\n"},
  {"GetOrigin", PyvtkGeoCamera_GetOrigin, METH_VARARGS,
   "V.GetOrigin() -> (float, float, float)\nC++: double *GetOrigin()\n\n"},
  {"SetOrigin", PyvtkGeoCamera_SetOrigin, METH_VARARGS,
   "V.SetOrigin(float, float, float)\nC++: void SetOrigin(double ox, double oy, double oz)\n\nGet the rectilinear cooridinate location of the origin. This is\nused to shift the terrain points.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGeoCamera_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoCamera", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoCamera_StaticNew()
{
  return vtkGeoCamera::New();
}

PyObject *PyvtkGeoCamera_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoCamera_Type, PyvtkGeoCamera_Methods,
    "vtkGeoCamera",
    PyvtkGeoCamera_Doc(), &PyvtkGeoCamera_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoCamera_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGeoCamera_Doc()
{
  static const char *docstring[] = {
    "vtkGeoCamera - Geo interface to a camera.\n\n",
    "Superclass: vtkObject\n\n",
    "I wanted to hide the normal vtkCamera API so I did not make this a\nsubclass.  The camera is a helper object. You can get a pointer to\nthe camera, but it should be treated like a const.\n\nSee Also:\n\nvtkGeoInteractorStyle vtkCamera\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGeoCamera(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoCamera_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoCamera", o) != 0)
    {
    Py_DECREF(o);
    }

}

