// python wrapper for vtkGeoFileImageSource
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkGeoFileImageSource.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoFileImageSource(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoFileImageSource_ClassNew(); }

#ifndef DECLARED_PyvtkGeoSource_ClassNew
extern "C" { PyObject *PyvtkGeoSource_ClassNew(); }
#define DECLARED_PyvtkGeoSource_ClassNew
#endif

static const char **PyvtkGeoFileImageSource_Doc();


static PyObject *
PyvtkGeoFileImageSource_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoFileImageSource *op = static_cast<vtkGeoFileImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGeoFileImageSource::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoFileImageSource_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoFileImageSource *op = static_cast<vtkGeoFileImageSource *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoFileImageSource::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoFileImageSource_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoFileImageSource *op = static_cast<vtkGeoFileImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkGeoFileImageSource *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoFileImageSource::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkGeoFileImageSource_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkGeoFileImageSource *tempr = vtkGeoFileImageSource::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoFileImageSource_FetchRoot(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FetchRoot");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoFileImageSource *op = static_cast<vtkGeoFileImageSource *>(vp);

  vtkGeoTreeNode *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode"))
    {
    bool tempr = (ap.IsBound() ?
      op->FetchRoot(temp0) :
      op->vtkGeoFileImageSource::FetchRoot(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoFileImageSource_FetchChild(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FetchChild");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoFileImageSource *op = static_cast<vtkGeoFileImageSource *>(vp);

  vtkGeoTreeNode *temp0 = NULL;
  int temp1;
  vtkGeoTreeNode *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode") &&
      ap.GetValue(temp1) &&
      ap.GetVTKObject(temp2, "vtkGeoTreeNode"))
    {
    bool tempr = (ap.IsBound() ?
      op->FetchChild(temp0, temp1, temp2) :
      op->vtkGeoFileImageSource::FetchChild(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoFileImageSource_SetPath(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPath");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoFileImageSource *op = static_cast<vtkGeoFileImageSource *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetPath(temp0);
      }
    else
      {
      op->vtkGeoFileImageSource::SetPath(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoFileImageSource_GetPath(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPath");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoFileImageSource *op = static_cast<vtkGeoFileImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    char *tempr = (ap.IsBound() ?
      op->GetPath() :
      op->vtkGeoFileImageSource::GetPath());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkGeoFileImageSource_Methods[] = {
  {"GetClassName", PyvtkGeoFileImageSource_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGeoFileImageSource_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGeoFileImageSource_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoFileImageSource\nC++: vtkGeoFileImageSource *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGeoFileImageSource_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGeoFileImageSource\nC++: vtkGeoFileImageSource *SafeDownCast(vtkObject* o)\n\n"},
  {"FetchRoot", PyvtkGeoFileImageSource_FetchRoot, METH_VARARGS,
   "V.FetchRoot(vtkGeoTreeNode) -> bool\nC++: virtual bool FetchRoot(vtkGeoTreeNode *root)\n\nFetches the root image representing the whole globe.\n"},
  {"FetchChild", PyvtkGeoFileImageSource_FetchChild, METH_VARARGS,
   "V.FetchChild(vtkGeoTreeNode, int, vtkGeoTreeNode) -> bool\nC++: virtual bool FetchChild(vtkGeoTreeNode *node, int index,\n    vtkGeoTreeNode *child)\n\nFetches the child image of a parent from disk.\n"},
  {"SetPath", PyvtkGeoFileImageSource_SetPath, METH_VARARGS,
   "V.SetPath(string)\nC++: void SetPath(char *)\n\nThe path the tiled image database.\n"},
  {"GetPath", PyvtkGeoFileImageSource_GetPath, METH_VARARGS,
   "V.GetPath() -> string\nC++: char *GetPath()\n\nThe path the tiled image database.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGeoFileImageSource_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoFileImageSource", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoFileImageSource_StaticNew()
{
  return vtkGeoFileImageSource::New();
}

PyObject *PyvtkGeoFileImageSource_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoFileImageSource_Type, PyvtkGeoFileImageSource_Methods,
    "vtkGeoFileImageSource",
    PyvtkGeoFileImageSource_Doc(), &PyvtkGeoFileImageSource_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoFileImageSource_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkGeoSource_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGeoFileImageSource_Doc()
{
  static const char *docstring[] = {
    "vtkGeoFileImageSource - A tiled image source on disk.\n\n",
    "Superclass: vtkGeoSource\n\n",
    "vtkGeoFileImageSource is a vtkGeoSource that fetches .vti images from\ndisk in a directory with a certain naming scheme. You may use\nvtkGeoAlignedImageRepresentation's SaveDatabase method to generate an\ndatabase of image tiles in this format.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGeoFileImageSource(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoFileImageSource_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoFileImageSource", o) != 0)
    {
    Py_DECREF(o);
    }

}

