// python wrapper for vtkGeoMath
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkGeoMath.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoMath(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoMath_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkGeoMath_Doc();


static PyObject *
PyvtkGeoMath_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoMath *op = static_cast<vtkGeoMath *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGeoMath::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoMath_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoMath *op = static_cast<vtkGeoMath *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoMath::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoMath_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoMath *op = static_cast<vtkGeoMath *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkGeoMath *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoMath::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkGeoMath_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkGeoMath *tempr = vtkGeoMath::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoMath_EarthRadiusMeters(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "EarthRadiusMeters");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
    {
    double tempr = vtkGeoMath::EarthRadiusMeters();

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoMath_DistanceSquared(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "DistanceSquared");

  double temp0[3];
  double save0[3];
  const int size0 = 3;
  double temp1[3];
  double save1[3];
  const int size1 = 3;
  PyObject *result = NULL;

  if (ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1))
    {
    ap.SaveArray(temp0, save0, size0);
    ap.SaveArray(temp1, save1, size1);

    double tempr = vtkGeoMath::DistanceSquared(temp0, temp1);

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(0, temp0, size0);
      }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(1, temp1, size1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoMath_LongLatAltToRect(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "LongLatAltToRect");

  double temp0[3];
  double save0[3];
  const int size0 = 3;
  double temp1[3];
  double save1[3];
  const int size1 = 3;
  PyObject *result = NULL;

  if (ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1))
    {
    ap.SaveArray(temp0, save0, size0);
    ap.SaveArray(temp1, save1, size1);

    vtkGeoMath::LongLatAltToRect(temp0, temp1);

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(0, temp0, size0);
      }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(1, temp1, size1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkGeoMath_Methods[] = {
  {"GetClassName", PyvtkGeoMath_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGeoMath_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGeoMath_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoMath\nC++: vtkGeoMath *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGeoMath_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGeoMath\nC++: vtkGeoMath *SafeDownCast(vtkObject* o)\n\n"},
  {"EarthRadiusMeters", PyvtkGeoMath_EarthRadiusMeters, METH_VARARGS,
   "V.EarthRadiusMeters() -> float\nC++: static double EarthRadiusMeters()\n\nReturns the average radius of the earth in meters.\n"},
  {"DistanceSquared", PyvtkGeoMath_DistanceSquared, METH_VARARGS,
   "V.DistanceSquared([float, float, float], [float, float, float])\n    -> float\nC++: static double DistanceSquared(double pt0[3], double pt1[3])\n\nReturns the squared distance between two points.\n"},
  {"LongLatAltToRect", PyvtkGeoMath_LongLatAltToRect, METH_VARARGS,
   "V.LongLatAltToRect([float, float, float], [float, float, float])\nC++: static void LongLatAltToRect(double lla[3], double rect[3])\n\nConverts a (longitude, latitude, altitude) triple to world\ncoordinates where the center of the earth is at the origin. Units\nare in meters. Note that having altitude realtive to sea level\ncauses issues.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGeoMath_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInfovisLayoutPython.vtkGeoMath", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoMath_StaticNew()
{
  return vtkGeoMath::New();
}

PyObject *PyvtkGeoMath_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoMath_Type, PyvtkGeoMath_Methods,
    "vtkGeoMath",
    PyvtkGeoMath_Doc(), &PyvtkGeoMath_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoMath_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGeoMath_Doc()
{
  static const char *docstring[] = {
    "vtkGeoMath - Useful geographic calculations\n\n",
    "Superclass: vtkObject\n\n",
    "vtkGeoMath provides some useful geographic calculations.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGeoMath(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoMath_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoMath", o) != 0)
    {
    Py_DECREF(o);
    }

}

