// python wrapper for vtkGeoSphereTransform
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkGeoSphereTransform.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoSphereTransform(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoSphereTransform_ClassNew(); }

#ifndef DECLARED_PyvtkAbstractTransform_ClassNew
extern "C" { PyObject *PyvtkAbstractTransform_ClassNew(); }
#define DECLARED_PyvtkAbstractTransform_ClassNew
#endif

static const char **PyvtkGeoSphereTransform_Doc();


static PyObject *
PyvtkGeoSphereTransform_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoSphereTransform *op = static_cast<vtkGeoSphereTransform *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGeoSphereTransform::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoSphereTransform_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoSphereTransform *op = static_cast<vtkGeoSphereTransform *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoSphereTransform::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoSphereTransform_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoSphereTransform *op = static_cast<vtkGeoSphereTransform *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkGeoSphereTransform *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoSphereTransform::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkGeoSphereTransform_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkGeoSphereTransform *tempr = vtkGeoSphereTransform::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoSphereTransform_Inverse(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Inverse");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoSphereTransform *op = static_cast<vtkGeoSphereTransform *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->Inverse();
      }
    else
      {
      op->vtkGeoSphereTransform::Inverse();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoSphereTransform_InternalTransformPoint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InternalTransformPoint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoSphereTransform *op = static_cast<vtkGeoSphereTransform *>(vp);

  double temp0[3];
  const int size0 = 3;
  double temp1[3];
  double save1[3];
  const int size1 = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1))
    {
    ap.SaveArray(temp1, save1, size1);

    if (ap.IsBound())
      {
      op->InternalTransformPoint(temp0, temp1);
      }
    else
      {
      op->vtkGeoSphereTransform::InternalTransformPoint(temp0, temp1);
      }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(1, temp1, size1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoSphereTransform_InternalTransformDerivative(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InternalTransformDerivative");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoSphereTransform *op = static_cast<vtkGeoSphereTransform *>(vp);

  double temp0[3];
  const int size0 = 3;
  double temp1[3];
  double save1[3];
  const int size1 = 3;
  double temp2[3][3];
  double save2[3][3];
  static int size2[2] = { 3, 3 };
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetNArray(*temp2, 2, size2))
    {
    ap.SaveArray(temp1, save1, size1);
    ap.SaveArray(*temp2, *save2, size2[0]*size2[1]);

    if (ap.IsBound())
      {
      op->InternalTransformDerivative(temp0, temp1, temp2);
      }
    else
      {
      op->vtkGeoSphereTransform::InternalTransformDerivative(temp0, temp1, temp2);
      }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(1, temp1, size1);
      }

    if (ap.ArrayHasChanged(*temp2, *save2, size2[0]*size2[1]) &&
        !ap.ErrorOccurred())
      {
      ap.SetNArray(2, *temp2, 2, size2);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoSphereTransform_MakeTransform(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MakeTransform");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoSphereTransform *op = static_cast<vtkGeoSphereTransform *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkAbstractTransform *tempr = (ap.IsBound() ?
      op->MakeTransform() :
      op->vtkGeoSphereTransform::MakeTransform());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkGeoSphereTransform_SetToRectangular(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetToRectangular");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoSphereTransform *op = static_cast<vtkGeoSphereTransform *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetToRectangular(temp0);
      }
    else
      {
      op->vtkGeoSphereTransform::SetToRectangular(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoSphereTransform_GetToRectangular(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetToRectangular");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoSphereTransform *op = static_cast<vtkGeoSphereTransform *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->GetToRectangular() :
      op->vtkGeoSphereTransform::GetToRectangular());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkGeoSphereTransform_ToRectangularOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ToRectangularOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoSphereTransform *op = static_cast<vtkGeoSphereTransform *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->ToRectangularOn();
      }
    else
      {
      op->vtkGeoSphereTransform::ToRectangularOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoSphereTransform_ToRectangularOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ToRectangularOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoSphereTransform *op = static_cast<vtkGeoSphereTransform *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->ToRectangularOff();
      }
    else
      {
      op->vtkGeoSphereTransform::ToRectangularOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoSphereTransform_SetBaseAltitude(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBaseAltitude");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoSphereTransform *op = static_cast<vtkGeoSphereTransform *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetBaseAltitude(temp0);
      }
    else
      {
      op->vtkGeoSphereTransform::SetBaseAltitude(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkGeoSphereTransform_GetBaseAltitude(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBaseAltitude");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoSphereTransform *op = static_cast<vtkGeoSphereTransform *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetBaseAltitude() :
      op->vtkGeoSphereTransform::GetBaseAltitude());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkGeoSphereTransform_Methods[] = {
  {"GetClassName", PyvtkGeoSphereTransform_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGeoSphereTransform_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGeoSphereTransform_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoSphereTransform\nC++: vtkGeoSphereTransform *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGeoSphereTransform_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGeoSphereTransform\nC++: vtkGeoSphereTransform *SafeDownCast(vtkObject* o)\n\n"},
  {"Inverse", PyvtkGeoSphereTransform_Inverse, METH_VARARGS,
   "V.Inverse()\nC++: virtual void Inverse()\n\nInvert the transformation.\n"},
  {"InternalTransformPoint", PyvtkGeoSphereTransform_InternalTransformPoint, METH_VARARGS,
   "V.InternalTransformPoint((float, float, float), [float, float,\n    float])\nC++: virtual void InternalTransformPoint(const double in[3],\n    double out[3])\n\nThis will calculate the transformation without calling Update.\nMeant for use only within other VTK classes.\n"},
  {"InternalTransformDerivative", PyvtkGeoSphereTransform_InternalTransformDerivative, METH_VARARGS,
   "V.InternalTransformDerivative((float, float, float), [float,\n    float, float], [[float, float, float], [float, float, float],\n    [float, float, float]])\nC++: virtual void InternalTransformDerivative(const double in[3],\n    double out[3], double derivative[3][3])\n\nThis will transform a point and, at the same time, calculate a\n3x3 Jacobian matrix that provides the partial derivatives of the\ntransformation at that point.  This method does not call Update.\nMeant for use only within other VTK classes.\n"},
  {"MakeTransform", PyvtkGeoSphereTransform_MakeTransform, METH_VARARGS,
   "V.MakeTransform() -> vtkAbstractTransform\nC++: virtual vtkAbstractTransform *MakeTransform()\n\nMake another transform of the same type.\n"},
  {"SetToRectangular", PyvtkGeoSphereTransform_SetToRectangular, METH_VARARGS,
   "V.SetToRectangular(bool)\nC++: void SetToRectangular(bool a)\n\nIf on, this transform converts (long,lat,alt) triples to (x,y,z)\nas an offset from the center of the earth. Alt, x, y, and z are\nall be in meters. If off, the transform works in the reverse\ndirection. Initial value is on.\n"},
  {"GetToRectangular", PyvtkGeoSphereTransform_GetToRectangular, METH_VARARGS,
   "V.GetToRectangular() -> bool\nC++: bool GetToRectangular()\n\nIf on, this transform converts (long,lat,alt) triples to (x,y,z)\nas an offset from the center of the earth. Alt, x, y, and z are\nall be in meters. If off, the transform works in the reverse\ndirection. Initial value is on.\n"},
  {"ToRectangularOn", PyvtkGeoSphereTransform_ToRectangularOn, METH_VARARGS,
   "V.ToRectangularOn()\nC++: void ToRectangularOn()\n\nIf on, this transform converts (long,lat,alt) triples to (x,y,z)\nas an offset from the center of the earth. Alt, x, y, and z are\nall be in meters. If off, the transform works in the reverse\ndirection. Initial value is on.\n"},
  {"ToRectangularOff", PyvtkGeoSphereTransform_ToRectangularOff, METH_VARARGS,
   "V.ToRectangularOff()\nC++: void ToRectangularOff()\n\nIf on, this transform converts (long,lat,alt) triples to (x,y,z)\nas an offset from the center of the earth. Alt, x, y, and z are\nall be in meters. If off, the transform works in the reverse\ndirection. Initial value is on.\n"},
  {"SetBaseAltitude", PyvtkGeoSphereTransform_SetBaseAltitude, METH_VARARGS,
   "V.SetBaseAltitude(float)\nC++: void SetBaseAltitude(double a)\n\nThe base altitude to transform coordinates to. This can be useful\nfor transforming lines just above the earth's surface. Default is\n0.\n"},
  {"GetBaseAltitude", PyvtkGeoSphereTransform_GetBaseAltitude, METH_VARARGS,
   "V.GetBaseAltitude() -> float\nC++: double GetBaseAltitude()\n\nThe base altitude to transform coordinates to. This can be useful\nfor transforming lines just above the earth's surface. Default is\n0.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGeoSphereTransform_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoSphereTransform", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoSphereTransform_StaticNew()
{
  return vtkGeoSphereTransform::New();
}

PyObject *PyvtkGeoSphereTransform_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoSphereTransform_Type, PyvtkGeoSphereTransform_Methods,
    "vtkGeoSphereTransform",
    PyvtkGeoSphereTransform_Doc(), &PyvtkGeoSphereTransform_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoSphereTransform_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAbstractTransform_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGeoSphereTransform_Doc()
{
  static const char *docstring[] = {
    "vtkGeoSphereTransform - A transformation between long-lat-alt and\nrect coords\n\n",
    "Superclass: vtkAbstractTransform\n\n",
    "the cartesian coordinate system is the following (if BaseAltitude is\n0),\n- the origin is at the center of the earth\n- the x axis goes from the origin to (longtitude=-90,latitude=0),\n  intersection of equator and the meridian passing just east of\n  Galapagos Islands\n- the y axis goes from the origin to the intersection of Greenwitch\n  meridian and equator (longitude=0,latitude=0)\n- the z axis goes ",
    "from the origin to the Geographic North Pole\n  (latitude=90)\n- therefore the frame is right-handed.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGeoSphereTransform(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoSphereTransform_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoSphereTransform", o) != 0)
    {
    Py_DECREF(o);
    }

}

