// python wrapper for vtkHeatmapItem
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkVector.h"
#include "vtkContextMouseEvent.h"
#include "vtkHeatmapItem.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkHeatmapItem(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkHeatmapItem_ClassNew(); }

#ifndef DECLARED_PyvtkContextItem_ClassNew
extern "C" { PyObject *PyvtkContextItem_ClassNew(); }
#define DECLARED_PyvtkContextItem_ClassNew
#endif

static const char **PyvtkHeatmapItem_Doc();


static PyObject *
PyvtkHeatmapItem_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkHeatmapItem::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkHeatmapItem::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkHeatmapItem *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkHeatmapItem::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkHeatmapItem *tempr = vtkHeatmapItem::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_SetTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  vtkTable *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkTable"))
    {
    if (ap.IsBound())
      {
      op->SetTable(temp0);
      }
    else
      {
      op->vtkHeatmapItem::SetTable(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_GetTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTable *tempr = (ap.IsBound() ?
      op->GetTable() :
      op->vtkHeatmapItem::GetTable());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_GetRowNames(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRowNames");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkStringArray *tempr = (ap.IsBound() ?
      op->GetRowNames() :
      op->vtkHeatmapItem::GetRowNames());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_GetNameColumn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNameColumn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkStdString tempr = (ap.IsBound() ?
      op->GetNameColumn() :
      op->vtkHeatmapItem::GetNameColumn());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_SetNameColumn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNameColumn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  vtkStdString temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetNameColumn(temp0);
      }
    else
      {
      op->vtkHeatmapItem::SetNameColumn(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_SetOrientation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOrientation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetOrientation(temp0);
      }
    else
      {
      op->vtkHeatmapItem::SetOrientation(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_GetOrientation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOrientation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetOrientation() :
      op->vtkHeatmapItem::GetOrientation());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_GetTextAngleForOrientation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTextAngleForOrientation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    double tempr = (ap.IsBound() ?
      op->GetTextAngleForOrientation(temp0) :
      op->vtkHeatmapItem::GetTextAngleForOrientation(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_SetPosition_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  float temp0;
  float temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    if (ap.IsBound())
      {
      op->SetPosition(temp0, temp1);
      }
    else
      {
      op->vtkHeatmapItem::SetPosition(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkHeatmapItem_SetPosition_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  float temp0[2];
  const int size0 = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    if (ap.IsBound())
      {
      op->SetPosition(temp0);
      }
    else
      {
      op->vtkHeatmapItem::SetPosition(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkHeatmapItem_SetPosition_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  vtkVector2f *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkVector2f"))
    {
    if (ap.IsBound())
      {
      op->SetPosition(*temp0);
      }
    else
      {
      op->vtkHeatmapItem::SetPosition(*temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkHeatmapItem_SetPosition_Methods[] = {
  {NULL, PyvtkHeatmapItem_SetPosition_s2, METH_VARARGS,
   "@P *f"},
  {NULL, PyvtkHeatmapItem_SetPosition_s3, METH_VARARGS,
   "@W vtkVector2f"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkHeatmapItem_SetPosition(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkHeatmapItem_SetPosition_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 2:
      return PyvtkHeatmapItem_SetPosition_s1(self, args);
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetPosition");
  return NULL;
}



static PyObject *
PyvtkHeatmapItem_GetPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    float *tempr = (ap.IsBound() ?
      op->GetPosition() :
      op->vtkHeatmapItem::GetPosition());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_GetPositionVector(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPositionVector");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkVector2f tempr = (ap.IsBound() ?
      op->GetPositionVector() :
      op->vtkHeatmapItem::GetPositionVector());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildSpecialObject(&tempr, "vtkVector2f");
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_GetCellHeight(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCellHeight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetCellHeight() :
      op->vtkHeatmapItem::GetCellHeight());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_SetCellHeight(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCellHeight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetCellHeight(temp0);
      }
    else
      {
      op->vtkHeatmapItem::SetCellHeight(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_GetCellWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCellWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetCellWidth() :
      op->vtkHeatmapItem::GetCellWidth());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_SetCellWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCellWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetCellWidth(temp0);
      }
    else
      {
      op->vtkHeatmapItem::SetCellWidth(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_GetBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  double temp0[4];
  double save0[4];
  const int size0 = 4;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
      {
      op->GetBounds(temp0);
      }
    else
      {
      op->vtkHeatmapItem::GetBounds(temp0);
      }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(0, temp0, size0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_MarkRowAsBlank(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MarkRowAsBlank");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  std::string temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->MarkRowAsBlank(temp0);
      }
    else
      {
      op->vtkHeatmapItem::MarkRowAsBlank(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_Paint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Paint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  vtkContext2D *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkContext2D"))
    {
    bool tempr = (ap.IsBound() ?
      op->Paint(temp0) :
      op->vtkHeatmapItem::Paint(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_GetRowLabelWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRowLabelWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    float tempr = (ap.IsBound() ?
      op->GetRowLabelWidth() :
      op->vtkHeatmapItem::GetRowLabelWidth());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_GetColumnLabelWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetColumnLabelWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    float tempr = (ap.IsBound() ?
      op->GetColumnLabelWidth() :
      op->vtkHeatmapItem::GetColumnLabelWidth());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHeatmapItem_Hit(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Hit");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  vtkContextMouseEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextMouseEvent"))
    {
    bool tempr = (ap.IsBound() ?
      op->Hit(*temp0) :
      op->vtkHeatmapItem::Hit(*temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkHeatmapItem_MouseMoveEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MouseMoveEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  vtkContextMouseEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextMouseEvent"))
    {
    bool tempr = (ap.IsBound() ?
      op->MouseMoveEvent(*temp0) :
      op->vtkHeatmapItem::MouseMoveEvent(*temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkHeatmapItem_MouseDoubleClickEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MouseDoubleClickEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHeatmapItem *op = static_cast<vtkHeatmapItem *>(vp);

  vtkContextMouseEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextMouseEvent"))
    {
    bool tempr = (ap.IsBound() ?
      op->MouseDoubleClickEvent(*temp0) :
      op->vtkHeatmapItem::MouseDoubleClickEvent(*temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkHeatmapItem_Methods[] = {
  {"GetClassName", PyvtkHeatmapItem_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkHeatmapItem_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkHeatmapItem_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkHeatmapItem\nC++: vtkHeatmapItem *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkHeatmapItem_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkHeatmapItem\nC++: vtkHeatmapItem *SafeDownCast(vtkObject* o)\n\n"},
  {"SetTable", PyvtkHeatmapItem_SetTable, METH_VARARGS,
   "V.SetTable(vtkTable)\nC++: virtual void SetTable(vtkTable *table)\n\nSet the table that this item draws.  The first column of the\ntable must contain the names of the rows.\n"},
  {"GetTable", PyvtkHeatmapItem_GetTable, METH_VARARGS,
   "V.GetTable() -> vtkTable\nC++: vtkTable *GetTable()\n\nGet the table that this item draws.\n"},
  {"GetRowNames", PyvtkHeatmapItem_GetRowNames, METH_VARARGS,
   "V.GetRowNames() -> vtkStringArray\nC++: vtkStringArray *GetRowNames()\n\nGet the table that this item draws.\n"},
  {"GetNameColumn", PyvtkHeatmapItem_GetNameColumn, METH_VARARGS,
   "V.GetNameColumn() -> string\nC++: vtkStdString GetNameColumn()\n\nGet/Set the name of the column that specifies the name of this\ntable's rows.  By default, we assume this column will be named\n\"name\".  If no such column can be found, we then assume that the\n1st column in the table names the rows.\n"},
  {"SetNameColumn", PyvtkHeatmapItem_SetNameColumn, METH_VARARGS,
   "V.SetNameColumn(string)\nC++: void SetNameColumn(vtkStdString a)\n\nGet/Set the name of the column that specifies the name of this\ntable's rows.  By default, we assume this column will be named\n\"name\".  If no such column can be found, we then assume that the\n1st column in the table names the rows.\n"},
  {"SetOrientation", PyvtkHeatmapItem_SetOrientation, METH_VARARGS,
   "V.SetOrientation(int)\nC++: void SetOrientation(int orientation)\n\nSet which way the table should face within the visualization.\n"},
  {"GetOrientation", PyvtkHeatmapItem_GetOrientation, METH_VARARGS,
   "V.GetOrientation() -> int\nC++: int GetOrientation()\n\nGet the current heatmap orientation.\n"},
  {"GetTextAngleForOrientation", PyvtkHeatmapItem_GetTextAngleForOrientation, METH_VARARGS,
   "V.GetTextAngleForOrientation(int) -> float\nC++: double GetTextAngleForOrientation(int orientation)\n\nGet the angle that row labels should be rotated for the\ncorreponding heatmap orientation.  For the default orientation\n(LEFT_TO_RIGHT), this is 0 degrees.\n"},
  {"SetPosition", PyvtkHeatmapItem_SetPosition, METH_VARARGS,
   "V.SetPosition(float, float)\nC++: void SetPosition(float, float)\nV.SetPosition((float, float))\nC++: void SetPosition(float a[2])\nV.SetPosition(vtkVector2f)\nC++: void SetPosition(const vtkVector2f &pos)\n\n"},
  {"GetPosition", PyvtkHeatmapItem_GetPosition, METH_VARARGS,
   "V.GetPosition() -> (float, float)\nC++: float *GetPosition()\n\n"},
  {"GetPositionVector", PyvtkHeatmapItem_GetPositionVector, METH_VARARGS,
   "V.GetPositionVector() -> vtkVector2f\nC++: vtkVector2f GetPositionVector()\n\nGet position of the heatmap.\n"},
  {"GetCellHeight", PyvtkHeatmapItem_GetCellHeight, METH_VARARGS,
   "V.GetCellHeight() -> float\nC++: double GetCellHeight()\n\nGet/Set the height of the cells in our heatmap. Default is 18\npixels.\n"},
  {"SetCellHeight", PyvtkHeatmapItem_SetCellHeight, METH_VARARGS,
   "V.SetCellHeight(float)\nC++: void SetCellHeight(double a)\n\nGet/Set the height of the cells in our heatmap. Default is 18\npixels.\n"},
  {"GetCellWidth", PyvtkHeatmapItem_GetCellWidth, METH_VARARGS,
   "V.GetCellWidth() -> float\nC++: double GetCellWidth()\n\nGet/Set the width of the cells in our heatmap. Default is 36\npixels.\n"},
  {"SetCellWidth", PyvtkHeatmapItem_SetCellWidth, METH_VARARGS,
   "V.SetCellWidth(float)\nC++: void SetCellWidth(double a)\n\nGet/Set the width of the cells in our heatmap. Default is 36\npixels.\n"},
  {"GetBounds", PyvtkHeatmapItem_GetBounds, METH_VARARGS,
   "V.GetBounds([float, float, float, float])\nC++: virtual void GetBounds(double bounds[4])\n\nGet the bounds for this item as (Xmin,Xmax,Ymin,Ymax).\n"},
  {"MarkRowAsBlank", PyvtkHeatmapItem_MarkRowAsBlank, METH_VARARGS,
   "V.MarkRowAsBlank(string)\nC++: void MarkRowAsBlank(std::string rowName)\n\nMark a row as blank, meaning that no cells will be drawn for it.\nUsed by vtkTreeHeatmapItem to represent missing data.\n"},
  {"Paint", PyvtkHeatmapItem_Paint, METH_VARARGS,
   "V.Paint(vtkContext2D) -> bool\nC++: virtual bool Paint(vtkContext2D *painter)\n\nPaints the table as a heatmap.\n"},
  {"GetRowLabelWidth", PyvtkHeatmapItem_GetRowLabelWidth, METH_VARARGS,
   "V.GetRowLabelWidth() -> float\nC++: float GetRowLabelWidth()\n\nGet the width of the largest row or column label drawn by this\nheatmap.\n"},
  {"GetColumnLabelWidth", PyvtkHeatmapItem_GetColumnLabelWidth, METH_VARARGS,
   "V.GetColumnLabelWidth() -> float\nC++: float GetColumnLabelWidth()\n\nGet the width of the largest row or column label drawn by this\nheatmap.\n"},
  {"Hit", PyvtkHeatmapItem_Hit, METH_VARARGS,
   "V.Hit(vtkContextMouseEvent) -> bool\nC++: virtual bool Hit(const vtkContextMouseEvent &mouse)\n\nReturns true if the transform is interactive, false otherwise.\n"},
  {"MouseMoveEvent", PyvtkHeatmapItem_MouseMoveEvent, METH_VARARGS,
   "V.MouseMoveEvent(vtkContextMouseEvent) -> bool\nC++: virtual bool MouseMoveEvent(\n    const vtkContextMouseEvent &event)\n\nDisplay a tooltip when the user mouses over a cell in the\nheatmap.\n"},
  {"MouseDoubleClickEvent", PyvtkHeatmapItem_MouseDoubleClickEvent, METH_VARARGS,
   "V.MouseDoubleClickEvent(vtkContextMouseEvent) -> bool\nC++: virtual bool MouseDoubleClickEvent(\n    const vtkContextMouseEvent &event)\n\nDisplay a legend for a column of data.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkHeatmapItem_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkViewsInfovisPython.vtkHeatmapItem", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkHeatmapItem_StaticNew()
{
  return vtkHeatmapItem::New();
}

PyObject *PyvtkHeatmapItem_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkHeatmapItem_Type, PyvtkHeatmapItem_Methods,
    "vtkHeatmapItem",
    PyvtkHeatmapItem_Doc(), &PyvtkHeatmapItem_StaticNew);

  PyTypeObject *pytype = &PyvtkHeatmapItem_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkContextItem_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 4; c++)
    {
    static const struct { const char *name; int value; }
      constants[4] = {
        { "LEFT_TO_RIGHT", vtkHeatmapItem::LEFT_TO_RIGHT },
        { "UP_TO_DOWN", vtkHeatmapItem::UP_TO_DOWN },
        { "RIGHT_TO_LEFT", vtkHeatmapItem::RIGHT_TO_LEFT },
        { "DOWN_TO_UP", vtkHeatmapItem::DOWN_TO_UP },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
      {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
      }
    }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkHeatmapItem_Doc()
{
  static const char *docstring[] = {
    "vtkHeatmapItem - A 2D graphics item for rendering a heatmap\n\n",
    "Superclass: vtkContextItem\n\n",
    "This item draws a heatmap as a part of a vtkContextScene.\n\n.SEE ALSO vtkTable\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkHeatmapItem(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkHeatmapItem_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkHeatmapItem", o) != 0)
    {
    Py_DECREF(o);
    }

}

