// python wrapper for vtkHierarchicalDataSetGeometryFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkHierarchicalDataSetGeometryFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkHierarchicalDataSetGeometryFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkHierarchicalDataSetGeometryFilter_ClassNew(); }

#ifndef DECLARED_PyvtkCompositeDataGeometryFilter_ClassNew
extern "C" { PyObject *PyvtkCompositeDataGeometryFilter_ClassNew(); }
#define DECLARED_PyvtkCompositeDataGeometryFilter_ClassNew
#endif

static const char **PyvtkHierarchicalDataSetGeometryFilter_Doc();


static PyObject *
PyvtkHierarchicalDataSetGeometryFilter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalDataSetGeometryFilter *op = static_cast<vtkHierarchicalDataSetGeometryFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkHierarchicalDataSetGeometryFilter::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHierarchicalDataSetGeometryFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalDataSetGeometryFilter *op = static_cast<vtkHierarchicalDataSetGeometryFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkHierarchicalDataSetGeometryFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHierarchicalDataSetGeometryFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalDataSetGeometryFilter *op = static_cast<vtkHierarchicalDataSetGeometryFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkHierarchicalDataSetGeometryFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkHierarchicalDataSetGeometryFilter::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkHierarchicalDataSetGeometryFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkHierarchicalDataSetGeometryFilter *tempr = vtkHierarchicalDataSetGeometryFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkHierarchicalDataSetGeometryFilter_Methods[] = {
  {"GetClassName", PyvtkHierarchicalDataSetGeometryFilter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkHierarchicalDataSetGeometryFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkHierarchicalDataSetGeometryFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkHierarchicalDataSetGeometryFilter\nC++: vtkHierarchicalDataSetGeometryFilter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkHierarchicalDataSetGeometryFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkHierarchicalDataSetGeometryFilter\nC++: vtkHierarchicalDataSetGeometryFilter *SafeDownCast(\n    vtkObject* o)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkHierarchicalDataSetGeometryFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersGeometryPython.vtkHierarchicalDataSetGeometryFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkHierarchicalDataSetGeometryFilter_StaticNew()
{
  return vtkHierarchicalDataSetGeometryFilter::New();
}

PyObject *PyvtkHierarchicalDataSetGeometryFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkHierarchicalDataSetGeometryFilter_Type, PyvtkHierarchicalDataSetGeometryFilter_Methods,
    "vtkHierarchicalDataSetGeometryFilter",
    PyvtkHierarchicalDataSetGeometryFilter_Doc(), &PyvtkHierarchicalDataSetGeometryFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkHierarchicalDataSetGeometryFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkCompositeDataGeometryFilter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkHierarchicalDataSetGeometryFilter_Doc()
{
  static const char *docstring[] = {
    "vtkHierarchicalDataSetGeometryFilter - extract geometry from\nhierarchical data\n\n",
    "Superclass: vtkCompositeDataGeometryFilter\n\n",
    "Legacy class. Use vtkCompositeDataGeometryFilter instead.\n\nSee Also:\n\nvtkCompositeDataGeometryFilter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkHierarchicalDataSetGeometryFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkHierarchicalDataSetGeometryFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkHierarchicalDataSetGeometryFilter", o) != 0)
    {
    Py_DECREF(o);
    }

}

