// python wrapper for vtkHighestDensityRegionsStatistics
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkHighestDensityRegionsStatistics.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkHighestDensityRegionsStatistics(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkHighestDensityRegionsStatistics_ClassNew(); }

#ifndef DECLARED_PyvtkStatisticsAlgorithm_ClassNew
extern "C" { PyObject *PyvtkStatisticsAlgorithm_ClassNew(); }
#define DECLARED_PyvtkStatisticsAlgorithm_ClassNew
#endif

static const char **PyvtkHighestDensityRegionsStatistics_Doc();


static PyObject *
PyvtkHighestDensityRegionsStatistics_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHighestDensityRegionsStatistics *op = static_cast<vtkHighestDensityRegionsStatistics *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkHighestDensityRegionsStatistics::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHighestDensityRegionsStatistics_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHighestDensityRegionsStatistics *op = static_cast<vtkHighestDensityRegionsStatistics *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkHighestDensityRegionsStatistics::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHighestDensityRegionsStatistics_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHighestDensityRegionsStatistics *op = static_cast<vtkHighestDensityRegionsStatistics *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkHighestDensityRegionsStatistics *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkHighestDensityRegionsStatistics::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkHighestDensityRegionsStatistics_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkHighestDensityRegionsStatistics *tempr = vtkHighestDensityRegionsStatistics::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHighestDensityRegionsStatistics_Aggregate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Aggregate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHighestDensityRegionsStatistics *op = static_cast<vtkHighestDensityRegionsStatistics *>(vp);

  vtkDataObjectCollection *temp0 = NULL;
  vtkMultiBlockDataSet *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkDataObjectCollection") &&
      ap.GetVTKObject(temp1, "vtkMultiBlockDataSet"))
    {
    if (ap.IsBound())
      {
      op->Aggregate(temp0, temp1);
      }
    else
      {
      op->vtkHighestDensityRegionsStatistics::Aggregate(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHighestDensityRegionsStatistics_SetSigma(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSigma");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHighestDensityRegionsStatistics *op = static_cast<vtkHighestDensityRegionsStatistics *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetSigma(temp0);
      }
    else
      {
      op->vtkHighestDensityRegionsStatistics::SetSigma(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHighestDensityRegionsStatistics_GetSmoothHC1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSmoothHC1");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHighestDensityRegionsStatistics *op = static_cast<vtkHighestDensityRegionsStatistics *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetSmoothHC1() :
      op->vtkHighestDensityRegionsStatistics::GetSmoothHC1());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkHighestDensityRegionsStatistics_SetSmoothHC1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSmoothHC1");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHighestDensityRegionsStatistics *op = static_cast<vtkHighestDensityRegionsStatistics *>(vp);

  double temp0[2];
  const int size0 = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    if (ap.IsBound())
      {
      op->SetSmoothHC1(temp0);
      }
    else
      {
      op->vtkHighestDensityRegionsStatistics::SetSmoothHC1(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHighestDensityRegionsStatistics_GetSmoothHC2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSmoothHC2");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHighestDensityRegionsStatistics *op = static_cast<vtkHighestDensityRegionsStatistics *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetSmoothHC2() :
      op->vtkHighestDensityRegionsStatistics::GetSmoothHC2());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkHighestDensityRegionsStatistics_SetSmoothHC2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSmoothHC2");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHighestDensityRegionsStatistics *op = static_cast<vtkHighestDensityRegionsStatistics *>(vp);

  double temp0[2];
  const int size0 = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    if (ap.IsBound())
      {
      op->SetSmoothHC2(temp0);
      }
    else
      {
      op->vtkHighestDensityRegionsStatistics::SetSmoothHC2(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHighestDensityRegionsStatistics_ComputeHDR_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ComputeHDR");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHighestDensityRegionsStatistics *op = static_cast<vtkHighestDensityRegionsStatistics *>(vp);

  vtkDataArray *temp0 = NULL;
  vtkDataArray *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkDataArray") &&
      ap.GetVTKObject(temp1, "vtkDataArray"))
    {
    double tempr = (ap.IsBound() ?
      op->ComputeHDR(temp0, temp1) :
      op->vtkHighestDensityRegionsStatistics::ComputeHDR(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyObject *
PyvtkHighestDensityRegionsStatistics_ComputeHDR_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ComputeHDR");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHighestDensityRegionsStatistics *op = static_cast<vtkHighestDensityRegionsStatistics *>(vp);

  vtkDataArray *temp0 = NULL;
  vtkDataArray *temp1 = NULL;
  vtkDataArray *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkDataArray") &&
      ap.GetVTKObject(temp1, "vtkDataArray") &&
      ap.GetVTKObject(temp2, "vtkDataArray"))
    {
    double tempr = (ap.IsBound() ?
      op->ComputeHDR(temp0, temp1, temp2) :
      op->vtkHighestDensityRegionsStatistics::ComputeHDR(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyObject *
PyvtkHighestDensityRegionsStatistics_ComputeHDR(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 2:
      return PyvtkHighestDensityRegionsStatistics_ComputeHDR_s1(self, args);
    case 3:
      return PyvtkHighestDensityRegionsStatistics_ComputeHDR_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "ComputeHDR");
  return NULL;
}


static PyMethodDef PyvtkHighestDensityRegionsStatistics_Methods[] = {
  {"GetClassName", PyvtkHighestDensityRegionsStatistics_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkHighestDensityRegionsStatistics_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkHighestDensityRegionsStatistics_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkHighestDensityRegionsStatistics\nC++: vtkHighestDensityRegionsStatistics *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkHighestDensityRegionsStatistics_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkHighestDensityRegionsStatistics\nC++: vtkHighestDensityRegionsStatistics *SafeDownCast(\n    vtkObject* o)\n\n"},
  {"Aggregate", PyvtkHighestDensityRegionsStatistics_Aggregate, METH_VARARGS,
   "V.Aggregate(vtkDataObjectCollection, vtkMultiBlockDataSet)\nC++: virtual void Aggregate(vtkDataObjectCollection *,\n    vtkMultiBlockDataSet *)\n\nGiven a collection of models, calculate aggregate model\n"},
  {"SetSigma", PyvtkHighestDensityRegionsStatistics_SetSigma, METH_VARARGS,
   "V.SetSigma(float)\nC++: void SetSigma(double sigma)\n\nH is a positive matrix that defines the smooth direction. In a\nclassical HDR, we don't set a specific smooth direction for the H\nmatrix parameter (SmoothHC1, SmoothHC2). That mean H will be in a\ndiagonal form and equal to sigma * Id.\n"},
  {"GetSmoothHC1", PyvtkHighestDensityRegionsStatistics_GetSmoothHC1, METH_VARARGS,
   "V.GetSmoothHC1() -> (float, float)\nC++: double *GetSmoothHC1()\n\nGet Smooth H matrix parameter of the HDR.\n"},
  {"SetSmoothHC1", PyvtkHighestDensityRegionsStatistics_SetSmoothHC1, METH_VARARGS,
   "V.SetSmoothHC1((float, float))\nC++: void SetSmoothHC1(double a[2])\n\nGet Smooth H matrix parameter of the HDR.\n"},
  {"GetSmoothHC2", PyvtkHighestDensityRegionsStatistics_GetSmoothHC2, METH_VARARGS,
   "V.GetSmoothHC2() -> (float, float)\nC++: double *GetSmoothHC2()\n\nGet Smooth H matrix parameter of the HDR.\n"},
  {"SetSmoothHC2", PyvtkHighestDensityRegionsStatistics_SetSmoothHC2, METH_VARARGS,
   "V.SetSmoothHC2((float, float))\nC++: void SetSmoothHC2(double a[2])\n\nGet Smooth H matrix parameter of the HDR.\n"},
  {"ComputeHDR", PyvtkHighestDensityRegionsStatistics_ComputeHDR, METH_VARARGS,
   "V.ComputeHDR(vtkDataArray, vtkDataArray) -> float\nC++: double ComputeHDR(vtkDataArray *inObservations,\n    vtkDataArray *outDensity)\nV.ComputeHDR(vtkDataArray, vtkDataArray, vtkDataArray) -> float\nC++: double ComputeHDR(vtkDataArray *inObs, vtkDataArray *inPOI,\n    vtkDataArray *outDensity)\n\nFill outDensity with density vector that is computed from\ninObservations values. This method uses a Gaussian kernel. For n\nobservations and with X an observation point: f(X) = (1 / n) *\nSum(KH(X -Xi)) for (i = 1 to n). Look ComputeSmoothGaussianKernel\nfor KH kernel definition.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkHighestDensityRegionsStatistics_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersStatisticsPython.vtkHighestDensityRegionsStatistics", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkHighestDensityRegionsStatistics_StaticNew()
{
  return vtkHighestDensityRegionsStatistics::New();
}

PyObject *PyvtkHighestDensityRegionsStatistics_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkHighestDensityRegionsStatistics_Type, PyvtkHighestDensityRegionsStatistics_Methods,
    "vtkHighestDensityRegionsStatistics",
    PyvtkHighestDensityRegionsStatistics_Doc(), &PyvtkHighestDensityRegionsStatistics_StaticNew);

  PyTypeObject *pytype = &PyvtkHighestDensityRegionsStatistics_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkStatisticsAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkHighestDensityRegionsStatistics_Doc()
{
  static const char *docstring[] = {
    "vtkHighestDensityRegionsStatistics - Compute a random vector of\n\n",
    "Superclass: vtkStatisticsAlgorithm\n\n",
    "Given a selection of pairs of columns of interest, this class\nprovides the following functionalities, depending on the chosen\nexecution options:\n* Learn: calculates density estimator f of a random vector using a\n  smooth gaussian kernel. The output metadata on port OUTPUT_MODEL is\na multiblock dataset containing at one vtkTable holding three columns\nwhich are for the first columns the input column",
    "s of interest and for\nthe last columns the density estimators of each input pair of columns\nof interest.\n* Derive: calculate normalized (as a percentage) quantiles coming\n  from Learn output. The second block of the multibloc dataset\n  contains a vtkTable holding some pairs of columns which are for the\nsecond one the quantiles ordered from the stronger to the lower and\n  for the first one the corr",
    "espondand quantile index.\n* Assess: not implemented.\n* Test: not implemented.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkHighestDensityRegionsStatistics(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkHighestDensityRegionsStatistics_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkHighestDensityRegionsStatistics", o) != 0)
    {
    Py_DECREF(o);
    }

}

