// python wrapper for vtkHyperOctreeFractalSource
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkHyperOctreeFractalSource.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkHyperOctreeFractalSource(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkHyperOctreeFractalSource_ClassNew(); }

#ifndef DECLARED_PyvtkHyperOctreeAlgorithm_ClassNew
extern "C" { PyObject *PyvtkHyperOctreeAlgorithm_ClassNew(); }
#define DECLARED_PyvtkHyperOctreeAlgorithm_ClassNew
#endif

static const char **PyvtkHyperOctreeFractalSource_Doc();


static PyObject *
PyvtkHyperOctreeFractalSource_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkHyperOctreeFractalSource::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkHyperOctreeFractalSource::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkHyperOctreeFractalSource *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkHyperOctreeFractalSource::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkHyperOctreeFractalSource *tempr = vtkHyperOctreeFractalSource::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_GetMaximumLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetMaximumLevel() :
      op->vtkHyperOctreeFractalSource::GetMaximumLevel());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_SetMaximumLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaximumLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetMaximumLevel(temp0);
      }
    else
      {
      op->vtkHyperOctreeFractalSource::SetMaximumLevel(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_SetMinimumLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMinimumLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetMinimumLevel(temp0);
      }
    else
      {
      op->vtkHyperOctreeFractalSource::SetMinimumLevel(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_GetMinimumLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMinimumLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetMinimumLevel() :
      op->vtkHyperOctreeFractalSource::GetMinimumLevel());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_SetProjectionAxes_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetProjectionAxes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
    {
    if (ap.IsBound())
      {
      op->SetProjectionAxes(temp0, temp1, temp2);
      }
    else
      {
      op->vtkHyperOctreeFractalSource::SetProjectionAxes(temp0, temp1, temp2);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkHyperOctreeFractalSource_SetProjectionAxes_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetProjectionAxes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  int temp0[3];
  int save0[3];
  const int size0 = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
      {
      op->SetProjectionAxes(temp0);
      }
    else
      {
      op->vtkHyperOctreeFractalSource::SetProjectionAxes(temp0);
      }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(0, temp0, size0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkHyperOctreeFractalSource_SetProjectionAxes(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 3:
      return PyvtkHyperOctreeFractalSource_SetProjectionAxes_s1(self, args);
    case 1:
      return PyvtkHyperOctreeFractalSource_SetProjectionAxes_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetProjectionAxes");
  return NULL;
}



static PyObject *
PyvtkHyperOctreeFractalSource_GetProjectionAxes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProjectionAxes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int *tempr = (ap.IsBound() ?
      op->GetProjectionAxes() :
      op->vtkHyperOctreeFractalSource::GetProjectionAxes());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_SetOriginCX_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOriginCX");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
    {
    if (ap.IsBound())
      {
      op->SetOriginCX(temp0, temp1, temp2, temp3);
      }
    else
      {
      op->vtkHyperOctreeFractalSource::SetOriginCX(temp0, temp1, temp2, temp3);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkHyperOctreeFractalSource_SetOriginCX_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOriginCX");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  double temp0[4];
  const int size0 = 4;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    if (ap.IsBound())
      {
      op->SetOriginCX(temp0);
      }
    else
      {
      op->vtkHyperOctreeFractalSource::SetOriginCX(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkHyperOctreeFractalSource_SetOriginCX(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 4:
      return PyvtkHyperOctreeFractalSource_SetOriginCX_s1(self, args);
    case 1:
      return PyvtkHyperOctreeFractalSource_SetOriginCX_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetOriginCX");
  return NULL;
}



static PyObject *
PyvtkHyperOctreeFractalSource_GetOriginCX(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOriginCX");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  int sizer = 4;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetOriginCX() :
      op->vtkHyperOctreeFractalSource::GetOriginCX());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_SetSizeCX_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSizeCX");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
    {
    if (ap.IsBound())
      {
      op->SetSizeCX(temp0, temp1, temp2, temp3);
      }
    else
      {
      op->vtkHyperOctreeFractalSource::SetSizeCX(temp0, temp1, temp2, temp3);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkHyperOctreeFractalSource_SetSizeCX_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSizeCX");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  double temp0[4];
  const int size0 = 4;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    if (ap.IsBound())
      {
      op->SetSizeCX(temp0);
      }
    else
      {
      op->vtkHyperOctreeFractalSource::SetSizeCX(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkHyperOctreeFractalSource_SetSizeCX(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 4:
      return PyvtkHyperOctreeFractalSource_SetSizeCX_s1(self, args);
    case 1:
      return PyvtkHyperOctreeFractalSource_SetSizeCX_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetSizeCX");
  return NULL;
}



static PyObject *
PyvtkHyperOctreeFractalSource_GetSizeCX(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSizeCX");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  int sizer = 4;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetSizeCX() :
      op->vtkHyperOctreeFractalSource::GetSizeCX());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_SetMaximumNumberOfIterations(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaximumNumberOfIterations");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  unsigned short temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetMaximumNumberOfIterations(temp0);
      }
    else
      {
      op->vtkHyperOctreeFractalSource::SetMaximumNumberOfIterations(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_GetMaximumNumberOfIterationsMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumNumberOfIterationsMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    unsigned short tempr = (ap.IsBound() ?
      op->GetMaximumNumberOfIterationsMinValue() :
      op->vtkHyperOctreeFractalSource::GetMaximumNumberOfIterationsMinValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_GetMaximumNumberOfIterationsMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumNumberOfIterationsMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    unsigned short tempr = (ap.IsBound() ?
      op->GetMaximumNumberOfIterationsMaxValue() :
      op->vtkHyperOctreeFractalSource::GetMaximumNumberOfIterationsMaxValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_GetMaximumNumberOfIterations(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumNumberOfIterations");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    unsigned char tempr = (ap.IsBound() ?
      op->GetMaximumNumberOfIterations() :
      op->vtkHyperOctreeFractalSource::GetMaximumNumberOfIterations());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_SetDimension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetDimension(temp0);
      }
    else
      {
      op->vtkHyperOctreeFractalSource::SetDimension(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_GetDimensionMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDimensionMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetDimensionMinValue() :
      op->vtkHyperOctreeFractalSource::GetDimensionMinValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_GetDimensionMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDimensionMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetDimensionMaxValue() :
      op->vtkHyperOctreeFractalSource::GetDimensionMaxValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_GetDimension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetDimension() :
      op->vtkHyperOctreeFractalSource::GetDimension());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_SetSpanThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSpanThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetSpanThreshold(temp0);
      }
    else
      {
      op->vtkHyperOctreeFractalSource::SetSpanThreshold(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkHyperOctreeFractalSource_GetSpanThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSpanThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHyperOctreeFractalSource *op = static_cast<vtkHyperOctreeFractalSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetSpanThreshold() :
      op->vtkHyperOctreeFractalSource::GetSpanThreshold());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkHyperOctreeFractalSource_Methods[] = {
  {"GetClassName", PyvtkHyperOctreeFractalSource_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkHyperOctreeFractalSource_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkHyperOctreeFractalSource_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkHyperOctreeFractalSource\nC++: vtkHyperOctreeFractalSource *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkHyperOctreeFractalSource_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkHyperOctreeFractalSource\nC++: vtkHyperOctreeFractalSource *SafeDownCast(vtkObject* o)\n\n"},
  {"GetMaximumLevel", PyvtkHyperOctreeFractalSource_GetMaximumLevel, METH_VARARGS,
   "V.GetMaximumLevel() -> int\nC++: int GetMaximumLevel()\n\nReturn the maximum number of levels of the hyperoctree.\n\\post positive_result: result>=1\n"},
  {"SetMaximumLevel", PyvtkHyperOctreeFractalSource_SetMaximumLevel, METH_VARARGS,
   "V.SetMaximumLevel(int)\nC++: void SetMaximumLevel(int levels)\n\nSet the maximum number of levels of the hyperoctree. If\nGetMinLevels()>=levels, GetMinLevels() is changed to levels-1.\n\\pre positive_levels: levels>=1\n\\post is_set: this->GetLevels()==levels\n\\post min_is_valid: this->GetMinLevels()<this->GetLevels()\n"},
  {"SetMinimumLevel", PyvtkHyperOctreeFractalSource_SetMinimumLevel, METH_VARARGS,
   "V.SetMinimumLevel(int)\nC++: void SetMinimumLevel(int level)\n\nReturn the minimal number of levels of systematic subdivision.\n\\post positive_result: result>=0\n"},
  {"GetMinimumLevel", PyvtkHyperOctreeFractalSource_GetMinimumLevel, METH_VARARGS,
   "V.GetMinimumLevel() -> int\nC++: int GetMinimumLevel()\n\nReturn the minimal number of levels of systematic subdivision.\n\\post positive_result: result>=0\n"},
  {"SetProjectionAxes", PyvtkHyperOctreeFractalSource_SetProjectionAxes, METH_VARARGS,
   "V.SetProjectionAxes(int, int, int)\nC++: void SetProjectionAxes(int x, int y, int z)\nV.SetProjectionAxes([int, int, int])\nC++: void SetProjectionAxes(int a[3])\n\nSet the projection from  the 4D space (4 parameters / 2 imaginary\nnumbers) to the axes of the 3D Volume. 0=C_Real, 1=C_Imaginary,\n2=X_Real, 4=X_Imaginary\n"},
  {"GetProjectionAxes", PyvtkHyperOctreeFractalSource_GetProjectionAxes, METH_VARARGS,
   "V.GetProjectionAxes() -> (int, int, int)\nC++: int *GetProjectionAxes()\n\n"},
  {"SetOriginCX", PyvtkHyperOctreeFractalSource_SetOriginCX, METH_VARARGS,
   "V.SetOriginCX(float, float, float, float)\nC++: void SetOriginCX(double, double, double, double)\nV.SetOriginCX((float, float, float, float))\nC++: void SetOriginCX(double a[4])\n\n"},
  {"GetOriginCX", PyvtkHyperOctreeFractalSource_GetOriginCX, METH_VARARGS,
   "V.GetOriginCX() -> (float, float, float, float)\nC++: double *GetOriginCX()\n\n"},
  {"SetSizeCX", PyvtkHyperOctreeFractalSource_SetSizeCX, METH_VARARGS,
   "V.SetSizeCX(float, float, float, float)\nC++: void SetSizeCX(double, double, double, double)\nV.SetSizeCX((float, float, float, float))\nC++: void SetSizeCX(double a[4])\n\n"},
  {"GetSizeCX", PyvtkHyperOctreeFractalSource_GetSizeCX, METH_VARARGS,
   "V.GetSizeCX() -> (float, float, float, float)\nC++: double *GetSizeCX()\n\n"},
  {"SetMaximumNumberOfIterations", PyvtkHyperOctreeFractalSource_SetMaximumNumberOfIterations, METH_VARARGS,
   "V.SetMaximumNumberOfIterations(int)\nC++: void SetMaximumNumberOfIterations(unsigned short)\n\nThe maximum number of cycles run to see if the value goes over 2\n"},
  {"GetMaximumNumberOfIterationsMinValue", PyvtkHyperOctreeFractalSource_GetMaximumNumberOfIterationsMinValue, METH_VARARGS,
   "V.GetMaximumNumberOfIterationsMinValue() -> int\nC++: unsigned short GetMaximumNumberOfIterationsMinValue()\n\nThe maximum number of cycles run to see if the value goes over 2\n"},
  {"GetMaximumNumberOfIterationsMaxValue", PyvtkHyperOctreeFractalSource_GetMaximumNumberOfIterationsMaxValue, METH_VARARGS,
   "V.GetMaximumNumberOfIterationsMaxValue() -> int\nC++: unsigned short GetMaximumNumberOfIterationsMaxValue()\n\nThe maximum number of cycles run to see if the value goes over 2\n"},
  {"GetMaximumNumberOfIterations", PyvtkHyperOctreeFractalSource_GetMaximumNumberOfIterations, METH_VARARGS,
   "V.GetMaximumNumberOfIterations() -> int\nC++: unsigned char GetMaximumNumberOfIterations()\n\nThe maximum number of cycles run to see if the value goes over 2\n"},
  {"SetDimension", PyvtkHyperOctreeFractalSource_SetDimension, METH_VARARGS,
   "V.SetDimension(int)\nC++: void SetDimension(int)\n\nCreate a 2D or 3D fractal.\n"},
  {"GetDimensionMinValue", PyvtkHyperOctreeFractalSource_GetDimensionMinValue, METH_VARARGS,
   "V.GetDimensionMinValue() -> int\nC++: int GetDimensionMinValue()\n\nCreate a 2D or 3D fractal.\n"},
  {"GetDimensionMaxValue", PyvtkHyperOctreeFractalSource_GetDimensionMaxValue, METH_VARARGS,
   "V.GetDimensionMaxValue() -> int\nC++: int GetDimensionMaxValue()\n\nCreate a 2D or 3D fractal.\n"},
  {"GetDimension", PyvtkHyperOctreeFractalSource_GetDimension, METH_VARARGS,
   "V.GetDimension() -> int\nC++: int GetDimension()\n\nCreate a 2D or 3D fractal.\n"},
  {"SetSpanThreshold", PyvtkHyperOctreeFractalSource_SetSpanThreshold, METH_VARARGS,
   "V.SetSpanThreshold(float)\nC++: void SetSpanThreshold(double a)\n\nControls when a leaf gets subdivided.  If the corner values span\na larger range than this value, the leaf is subdivided.  This\ndefaults to 2.\n"},
  {"GetSpanThreshold", PyvtkHyperOctreeFractalSource_GetSpanThreshold, METH_VARARGS,
   "V.GetSpanThreshold() -> float\nC++: double GetSpanThreshold()\n\nControls when a leaf gets subdivided.  If the corner values span\na larger range than this value, the leaf is subdivided.  This\ndefaults to 2.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkHyperOctreeFractalSource_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersSourcesPython.vtkHyperOctreeFractalSource", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkHyperOctreeFractalSource_StaticNew()
{
  return vtkHyperOctreeFractalSource::New();
}

PyObject *PyvtkHyperOctreeFractalSource_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkHyperOctreeFractalSource_Type, PyvtkHyperOctreeFractalSource_Methods,
    "vtkHyperOctreeFractalSource",
    PyvtkHyperOctreeFractalSource_Doc(), &PyvtkHyperOctreeFractalSource_StaticNew);

  PyTypeObject *pytype = &PyvtkHyperOctreeFractalSource_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkHyperOctreeAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkHyperOctreeFractalSource_Doc()
{
  static const char *docstring[] = {
    "vtkHyperOctreeFractalSource - Create an octree from a fractal.\n\n",
    "Superclass: vtkHyperOctreeAlgorithm\n\n",
    "See Also:\n\nvtkHyperOctreeSampleFunction\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkHyperOctreeFractalSource(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkHyperOctreeFractalSource_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkHyperOctreeFractalSource", o) != 0)
    {
    Py_DECREF(o);
    }

}

