// python wrapper for vtkImageCityBlockDistance
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkImageCityBlockDistance.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageCityBlockDistance(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImageCityBlockDistance_ClassNew(); }

#ifndef DECLARED_PyvtkImageDecomposeFilter_ClassNew
extern "C" { PyObject *PyvtkImageDecomposeFilter_ClassNew(); }
#define DECLARED_PyvtkImageDecomposeFilter_ClassNew
#endif

static const char **PyvtkImageCityBlockDistance_Doc();


static PyObject *
PyvtkImageCityBlockDistance_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageCityBlockDistance *op = static_cast<vtkImageCityBlockDistance *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkImageCityBlockDistance::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageCityBlockDistance_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageCityBlockDistance *op = static_cast<vtkImageCityBlockDistance *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageCityBlockDistance::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageCityBlockDistance_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageCityBlockDistance *op = static_cast<vtkImageCityBlockDistance *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkImageCityBlockDistance *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageCityBlockDistance::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkImageCityBlockDistance_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkImageCityBlockDistance *tempr = vtkImageCityBlockDistance::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkImageCityBlockDistance_Methods[] = {
  {"GetClassName", PyvtkImageCityBlockDistance_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkImageCityBlockDistance_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkImageCityBlockDistance_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageCityBlockDistance\nC++: vtkImageCityBlockDistance *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkImageCityBlockDistance_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkImageCityBlockDistance\nC++: vtkImageCityBlockDistance *SafeDownCast(vtkObject* o)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImageCityBlockDistance_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingGeneralPython.vtkImageCityBlockDistance", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageCityBlockDistance_StaticNew()
{
  return vtkImageCityBlockDistance::New();
}

PyObject *PyvtkImageCityBlockDistance_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImageCityBlockDistance_Type, PyvtkImageCityBlockDistance_Methods,
    "vtkImageCityBlockDistance",
    PyvtkImageCityBlockDistance_Doc(), &PyvtkImageCityBlockDistance_StaticNew);

  PyTypeObject *pytype = &PyvtkImageCityBlockDistance_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageDecomposeFilter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImageCityBlockDistance_Doc()
{
  static const char *docstring[] = {
    "vtkImageCityBlockDistance - 1,2 or 3D distance map.\n\n",
    "Superclass: vtkImageDecomposeFilter\n\n",
    "vtkImageCityBlockDistance creates a distance map using the city block\n(Manhatten) distance measure.  The input is a mask.  Zero values are\nconsidered boundaries.  The output pixel is the minimum of the input\npixel and the distance to a boundary (or neighbor value + 1 unit).\ndistance values are calculated in pixels. The filter works by taking\n6 passes (for 3d distance map): 2 along each axis (forwa",
    "rd and\nbackward). Each pass keeps a running minimum distance. For some\nreason, I preserve the sign if the distance.  If the input mask is\ninitially negative, the output distances will be negative. Distances\nmaps can have inside (negative regions) and outsides (positive\nregions).\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImageCityBlockDistance(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageCityBlockDistance_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageCityBlockDistance", o) != 0)
    {
    Py_DECREF(o);
    }

}

