// python wrapper for vtkImageConstantPad
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkImageConstantPad.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageConstantPad(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImageConstantPad_ClassNew(); }

#ifndef DECLARED_PyvtkImagePadFilter_ClassNew
extern "C" { PyObject *PyvtkImagePadFilter_ClassNew(); }
#define DECLARED_PyvtkImagePadFilter_ClassNew
#endif

static const char **PyvtkImageConstantPad_Doc();


static PyObject *
PyvtkImageConstantPad_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConstantPad *op = static_cast<vtkImageConstantPad *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkImageConstantPad::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageConstantPad_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConstantPad *op = static_cast<vtkImageConstantPad *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageConstantPad::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageConstantPad_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConstantPad *op = static_cast<vtkImageConstantPad *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkImageConstantPad *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageConstantPad::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkImageConstantPad_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkImageConstantPad *tempr = vtkImageConstantPad::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageConstantPad_SetConstant(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetConstant");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConstantPad *op = static_cast<vtkImageConstantPad *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetConstant(temp0);
      }
    else
      {
      op->vtkImageConstantPad::SetConstant(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkImageConstantPad_GetConstant(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetConstant");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConstantPad *op = static_cast<vtkImageConstantPad *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetConstant() :
      op->vtkImageConstantPad::GetConstant());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkImageConstantPad_Methods[] = {
  {"GetClassName", PyvtkImageConstantPad_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkImageConstantPad_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkImageConstantPad_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageConstantPad\nC++: vtkImageConstantPad *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkImageConstantPad_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkImageConstantPad\nC++: vtkImageConstantPad *SafeDownCast(vtkObject* o)\n\n"},
  {"SetConstant", PyvtkImageConstantPad_SetConstant, METH_VARARGS,
   "V.SetConstant(float)\nC++: void SetConstant(double a)\n\nSet/Get the pad value.\n"},
  {"GetConstant", PyvtkImageConstantPad_GetConstant, METH_VARARGS,
   "V.GetConstant() -> float\nC++: double GetConstant()\n\nSet/Get the pad value.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImageConstantPad_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingCorePython.vtkImageConstantPad", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageConstantPad_StaticNew()
{
  return vtkImageConstantPad::New();
}

PyObject *PyvtkImageConstantPad_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImageConstantPad_Type, PyvtkImageConstantPad_Methods,
    "vtkImageConstantPad",
    PyvtkImageConstantPad_Doc(), &PyvtkImageConstantPad_StaticNew);

  PyTypeObject *pytype = &PyvtkImageConstantPad_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImagePadFilter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImageConstantPad_Doc()
{
  static const char *docstring[] = {
    "vtkImageConstantPad - Makes image larger by padding with constant.\n\n",
    "Superclass: vtkImagePadFilter\n\n",
    "vtkImageConstantPad changes the image extent of its input. Any pixels\noutside of the original image extent are filled with a constant value\n(default is 0.0).\n\nSee Also:\n\nvtkImageWrapPad vtkImageMirrorPad\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImageConstantPad(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageConstantPad_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageConstantPad", o) != 0)
    {
    Py_DECREF(o);
    }

}

