// python wrapper for vtkImageDilateErode3D
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkImageDilateErode3D.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageDilateErode3D(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImageDilateErode3D_ClassNew(); }

#ifndef DECLARED_PyvtkImageSpatialAlgorithm_ClassNew
extern "C" { PyObject *PyvtkImageSpatialAlgorithm_ClassNew(); }
#define DECLARED_PyvtkImageSpatialAlgorithm_ClassNew
#endif

static const char **PyvtkImageDilateErode3D_Doc();


static PyObject *
PyvtkImageDilateErode3D_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageDilateErode3D *op = static_cast<vtkImageDilateErode3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkImageDilateErode3D::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageDilateErode3D_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageDilateErode3D *op = static_cast<vtkImageDilateErode3D *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageDilateErode3D::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageDilateErode3D_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageDilateErode3D *op = static_cast<vtkImageDilateErode3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkImageDilateErode3D *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageDilateErode3D::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkImageDilateErode3D_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkImageDilateErode3D *tempr = vtkImageDilateErode3D::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageDilateErode3D_SetKernelSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetKernelSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageDilateErode3D *op = static_cast<vtkImageDilateErode3D *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
    {
    if (ap.IsBound())
      {
      op->SetKernelSize(temp0, temp1, temp2);
      }
    else
      {
      op->vtkImageDilateErode3D::SetKernelSize(temp0, temp1, temp2);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkImageDilateErode3D_SetDilateValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDilateValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageDilateErode3D *op = static_cast<vtkImageDilateErode3D *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetDilateValue(temp0);
      }
    else
      {
      op->vtkImageDilateErode3D::SetDilateValue(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkImageDilateErode3D_GetDilateValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDilateValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageDilateErode3D *op = static_cast<vtkImageDilateErode3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetDilateValue() :
      op->vtkImageDilateErode3D::GetDilateValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageDilateErode3D_SetErodeValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetErodeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageDilateErode3D *op = static_cast<vtkImageDilateErode3D *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetErodeValue(temp0);
      }
    else
      {
      op->vtkImageDilateErode3D::SetErodeValue(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkImageDilateErode3D_GetErodeValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetErodeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageDilateErode3D *op = static_cast<vtkImageDilateErode3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetErodeValue() :
      op->vtkImageDilateErode3D::GetErodeValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkImageDilateErode3D_Methods[] = {
  {"GetClassName", PyvtkImageDilateErode3D_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\nConstruct an instance of vtkImageDilateErode3D filter. By default\nzero values are dilated.\n"},
  {"IsA", PyvtkImageDilateErode3D_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\nConstruct an instance of vtkImageDilateErode3D filter. By default\nzero values are dilated.\n"},
  {"NewInstance", PyvtkImageDilateErode3D_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageDilateErode3D\nC++: vtkImageDilateErode3D *NewInstance()\n\nConstruct an instance of vtkImageDilateErode3D filter. By default\nzero values are dilated.\n"},
  {"SafeDownCast", PyvtkImageDilateErode3D_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkImageDilateErode3D\nC++: vtkImageDilateErode3D *SafeDownCast(vtkObject* o)\n\nConstruct an instance of vtkImageDilateErode3D filter. By default\nzero values are dilated.\n"},
  {"SetKernelSize", PyvtkImageDilateErode3D_SetKernelSize, METH_VARARGS,
   "V.SetKernelSize(int, int, int)\nC++: void SetKernelSize(int size0, int size1, int size2)\n\nThis method sets the size of the neighborhood.  It also sets the\ndefault middle of the neighborhood and computes the elliptical\nfoot print.\n"},
  {"SetDilateValue", PyvtkImageDilateErode3D_SetDilateValue, METH_VARARGS,
   "V.SetDilateValue(float)\nC++: void SetDilateValue(double a)\n\nSet/Get the Dilate and Erode values to be used by this filter.\n"},
  {"GetDilateValue", PyvtkImageDilateErode3D_GetDilateValue, METH_VARARGS,
   "V.GetDilateValue() -> float\nC++: double GetDilateValue()\n\nSet/Get the Dilate and Erode values to be used by this filter.\n"},
  {"SetErodeValue", PyvtkImageDilateErode3D_SetErodeValue, METH_VARARGS,
   "V.SetErodeValue(float)\nC++: void SetErodeValue(double a)\n\nSet/Get the Dilate and Erode values to be used by this filter.\n"},
  {"GetErodeValue", PyvtkImageDilateErode3D_GetErodeValue, METH_VARARGS,
   "V.GetErodeValue() -> float\nC++: double GetErodeValue()\n\nSet/Get the Dilate and Erode values to be used by this filter.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImageDilateErode3D_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingMorphologicalPython.vtkImageDilateErode3D", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageDilateErode3D_StaticNew()
{
  return vtkImageDilateErode3D::New();
}

PyObject *PyvtkImageDilateErode3D_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImageDilateErode3D_Type, PyvtkImageDilateErode3D_Methods,
    "vtkImageDilateErode3D",
    PyvtkImageDilateErode3D_Doc(), &PyvtkImageDilateErode3D_StaticNew);

  PyTypeObject *pytype = &PyvtkImageDilateErode3D_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageSpatialAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImageDilateErode3D_Doc()
{
  static const char *docstring[] = {
    "vtkImageDilateErode3D - Dilates one value and erodes another.\n\n",
    "Superclass: vtkImageSpatialAlgorithm\n\n",
    "vtkImageDilateErode3D will dilate one value and erode another. It\nuses an elliptical foot print, and only erodes/dilates on the\nboundary of the two values.  The filter is restricted to the X, Y,\nand Z axes for now.  It can degenerate to a 2 or 1 dimensional filter\nby setting the kernel size to 1 for a specific axis.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImageDilateErode3D(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageDilateErode3D_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageDilateErode3D", o) != 0)
    {
    Py_DECREF(o);
    }

}

