// python wrapper for vtkImageHistogramStatistics
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkImageHistogramStatistics.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageHistogramStatistics(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImageHistogramStatistics_ClassNew(); }

#ifndef DECLARED_PyvtkImageHistogram_ClassNew
extern "C" { PyObject *PyvtkImageHistogram_ClassNew(); }
#define DECLARED_PyvtkImageHistogram_ClassNew
#endif

static const char **PyvtkImageHistogramStatistics_Doc();


static PyObject *
PyvtkImageHistogramStatistics_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkImageHistogramStatistics::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageHistogramStatistics_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageHistogramStatistics::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageHistogramStatistics_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkImageHistogramStatistics *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageHistogramStatistics::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkImageHistogramStatistics_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkImageHistogramStatistics *tempr = vtkImageHistogramStatistics::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageHistogramStatistics_GetMinimum(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMinimum");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetMinimum() :
      op->vtkImageHistogramStatistics::GetMinimum());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageHistogramStatistics_GetMaximum(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximum");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetMaximum() :
      op->vtkImageHistogramStatistics::GetMaximum());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageHistogramStatistics_GetMean(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMean");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetMean() :
      op->vtkImageHistogramStatistics::GetMean());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageHistogramStatistics_GetMedian(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMedian");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetMedian() :
      op->vtkImageHistogramStatistics::GetMedian());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageHistogramStatistics_GetStandardDeviation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStandardDeviation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetStandardDeviation() :
      op->vtkImageHistogramStatistics::GetStandardDeviation());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageHistogramStatistics_SetAutoRangePercentiles_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoRangePercentiles");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  double temp0;
  double temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    if (ap.IsBound())
      {
      op->SetAutoRangePercentiles(temp0, temp1);
      }
    else
      {
      op->vtkImageHistogramStatistics::SetAutoRangePercentiles(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkImageHistogramStatistics_SetAutoRangePercentiles_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoRangePercentiles");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  double temp0[2];
  const int size0 = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    if (ap.IsBound())
      {
      op->SetAutoRangePercentiles(temp0);
      }
    else
      {
      op->vtkImageHistogramStatistics::SetAutoRangePercentiles(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkImageHistogramStatistics_SetAutoRangePercentiles(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 2:
      return PyvtkImageHistogramStatistics_SetAutoRangePercentiles_s1(self, args);
    case 1:
      return PyvtkImageHistogramStatistics_SetAutoRangePercentiles_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetAutoRangePercentiles");
  return NULL;
}



static PyObject *
PyvtkImageHistogramStatistics_GetAutoRangePercentiles(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutoRangePercentiles");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetAutoRangePercentiles() :
      op->vtkImageHistogramStatistics::GetAutoRangePercentiles());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkImageHistogramStatistics_SetAutoRangeExpansionFactors_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoRangeExpansionFactors");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  double temp0;
  double temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    if (ap.IsBound())
      {
      op->SetAutoRangeExpansionFactors(temp0, temp1);
      }
    else
      {
      op->vtkImageHistogramStatistics::SetAutoRangeExpansionFactors(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkImageHistogramStatistics_SetAutoRangeExpansionFactors_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoRangeExpansionFactors");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  double temp0[2];
  const int size0 = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    if (ap.IsBound())
      {
      op->SetAutoRangeExpansionFactors(temp0);
      }
    else
      {
      op->vtkImageHistogramStatistics::SetAutoRangeExpansionFactors(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkImageHistogramStatistics_SetAutoRangeExpansionFactors(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 2:
      return PyvtkImageHistogramStatistics_SetAutoRangeExpansionFactors_s1(self, args);
    case 1:
      return PyvtkImageHistogramStatistics_SetAutoRangeExpansionFactors_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetAutoRangeExpansionFactors");
  return NULL;
}



static PyObject *
PyvtkImageHistogramStatistics_GetAutoRangeExpansionFactors(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutoRangeExpansionFactors");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetAutoRangeExpansionFactors() :
      op->vtkImageHistogramStatistics::GetAutoRangeExpansionFactors());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkImageHistogramStatistics_GetAutoRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutoRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageHistogramStatistics *op = static_cast<vtkImageHistogramStatistics *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetAutoRange() :
      op->vtkImageHistogramStatistics::GetAutoRange());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}

static PyMethodDef PyvtkImageHistogramStatistics_Methods[] = {
  {"GetClassName", PyvtkImageHistogramStatistics_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkImageHistogramStatistics_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkImageHistogramStatistics_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageHistogramStatistics\nC++: vtkImageHistogramStatistics *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkImageHistogramStatistics_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkImageHistogramStatistics\nC++: vtkImageHistogramStatistics *SafeDownCast(vtkObject* o)\n\n"},
  {"GetMinimum", PyvtkImageHistogramStatistics_GetMinimum, METH_VARARGS,
   "V.GetMinimum() -> float\nC++: double GetMinimum()\n\nGet the minimum value present in the image.  This value is\ncomputed when Update() is called.\n"},
  {"GetMaximum", PyvtkImageHistogramStatistics_GetMaximum, METH_VARARGS,
   "V.GetMaximum() -> float\nC++: double GetMaximum()\n\nGet the maximum value present in the image.  This value is\ncomputed when Update() is called.\n"},
  {"GetMean", PyvtkImageHistogramStatistics_GetMean, METH_VARARGS,
   "V.GetMean() -> float\nC++: double GetMean()\n\nGet the mean value of the image.  This value is computed when\nUpdate() is called.\n"},
  {"GetMedian", PyvtkImageHistogramStatistics_GetMedian, METH_VARARGS,
   "V.GetMedian() -> float\nC++: double GetMedian()\n\nGet the median value.  This is computed when Update() is called.\n"},
  {"GetStandardDeviation", PyvtkImageHistogramStatistics_GetStandardDeviation, METH_VARARGS,
   "V.GetStandardDeviation() -> float\nC++: double GetStandardDeviation()\n\nGet the standard deviation of the values in the image.  This is\ncomputed when Update() is called.\n"},
  {"SetAutoRangePercentiles", PyvtkImageHistogramStatistics_SetAutoRangePercentiles, METH_VARARGS,
   "V.SetAutoRangePercentiles(float, float)\nC++: void SetAutoRangePercentiles(double, double)\nV.SetAutoRangePercentiles((float, float))\nC++: void SetAutoRangePercentiles(double a[2])\n\n"},
  {"GetAutoRangePercentiles", PyvtkImageHistogramStatistics_GetAutoRangePercentiles, METH_VARARGS,
   "V.GetAutoRangePercentiles() -> (float, float)\nC++: double *GetAutoRangePercentiles()\n\n"},
  {"SetAutoRangeExpansionFactors", PyvtkImageHistogramStatistics_SetAutoRangeExpansionFactors, METH_VARARGS,
   "V.SetAutoRangeExpansionFactors(float, float)\nC++: void SetAutoRangeExpansionFactors(double, double)\nV.SetAutoRangeExpansionFactors((float, float))\nC++: void SetAutoRangeExpansionFactors(double a[2])\n\n"},
  {"GetAutoRangeExpansionFactors", PyvtkImageHistogramStatistics_GetAutoRangeExpansionFactors, METH_VARARGS,
   "V.GetAutoRangeExpansionFactors() -> (float, float)\nC++: double *GetAutoRangeExpansionFactors()\n\n"},
  {"GetAutoRange", PyvtkImageHistogramStatistics_GetAutoRange, METH_VARARGS,
   "V.GetAutoRange() -> (float, float)\nC++: double *GetAutoRange()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImageHistogramStatistics_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingStatisticsPython.vtkImageHistogramStatistics", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageHistogramStatistics_StaticNew()
{
  return vtkImageHistogramStatistics::New();
}

PyObject *PyvtkImageHistogramStatistics_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImageHistogramStatistics_Type, PyvtkImageHistogramStatistics_Methods,
    "vtkImageHistogramStatistics",
    PyvtkImageHistogramStatistics_Doc(), &PyvtkImageHistogramStatistics_StaticNew);

  PyTypeObject *pytype = &PyvtkImageHistogramStatistics_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageHistogram_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImageHistogramStatistics_Doc()
{
  static const char *docstring[] = {
    "vtkImageHistogramStatistics - Compute statistics for an image\n\n",
    "Superclass: vtkImageHistogram\n\n",
    "vtkImageHistogramStatistics computes statistics such as mean, median,\nand standard deviation.  These statistics are computed from the\nhistogram of the image, rather than from the image itself, because\nthis is more efficient than computing the statistics while traversing\nthe pixels. If the input image is of type float or double, then the\nprecision of the Mean, Median, and StandardDeviation will dep",
    "end on\nthe number of histogram bins.  By default, 65536 bins are used for\nfloat data, giving at least 16 bits of precision.\n\nThanks:\n\nThanks to David Gobbi at the Seaman Family MR Centre and Dept. of\nClinical Neurosciences, Foothills Medical Centre, Calgary, for\nproviding this class.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImageHistogramStatistics(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageHistogramStatistics_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageHistogramStatistics", o) != 0)
    {
    Py_DECREF(o);
    }

}

