// python wrapper for vtkImageIterateFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkImageIterateFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageIterateFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImageIterateFilter_ClassNew(); }

#ifndef DECLARED_PyvtkThreadedImageAlgorithm_ClassNew
extern "C" { PyObject *PyvtkThreadedImageAlgorithm_ClassNew(); }
#define DECLARED_PyvtkThreadedImageAlgorithm_ClassNew
#endif

static const char **PyvtkImageIterateFilter_Doc();


static PyObject *
PyvtkImageIterateFilter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageIterateFilter *op = static_cast<vtkImageIterateFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkImageIterateFilter::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageIterateFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageIterateFilter *op = static_cast<vtkImageIterateFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageIterateFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageIterateFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageIterateFilter *op = static_cast<vtkImageIterateFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkImageIterateFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageIterateFilter::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkImageIterateFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkImageIterateFilter *tempr = vtkImageIterateFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageIterateFilter_GetIteration(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIteration");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageIterateFilter *op = static_cast<vtkImageIterateFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetIteration() :
      op->vtkImageIterateFilter::GetIteration());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageIterateFilter_GetNumberOfIterations(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfIterations");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageIterateFilter *op = static_cast<vtkImageIterateFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfIterations() :
      op->vtkImageIterateFilter::GetNumberOfIterations());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkImageIterateFilter_Methods[] = {
  {"GetClassName", PyvtkImageIterateFilter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkImageIterateFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkImageIterateFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageIterateFilter\nC++: vtkImageIterateFilter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkImageIterateFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkImageIterateFilter\nC++: vtkImageIterateFilter *SafeDownCast(vtkObject* o)\n\n"},
  {"GetIteration", PyvtkImageIterateFilter_GetIteration, METH_VARARGS,
   "V.GetIteration() -> int\nC++: int GetIteration()\n\nGet which iteration is current being performed. Normally the user\nwill not access this method.\n"},
  {"GetNumberOfIterations", PyvtkImageIterateFilter_GetNumberOfIterations, METH_VARARGS,
   "V.GetNumberOfIterations() -> int\nC++: int GetNumberOfIterations()\n\nGet which iteration is current being performed. Normally the user\nwill not access this method.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImageIterateFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingCorePython.vtkImageIterateFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkImageIterateFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImageIterateFilter_Type, PyvtkImageIterateFilter_Methods,
    "vtkImageIterateFilter",
    PyvtkImageIterateFilter_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkImageIterateFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkThreadedImageAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImageIterateFilter_Doc()
{
  static const char *docstring[] = {
    "vtkImageIterateFilter - Multiple executes per update.\n\n",
    "Superclass: vtkThreadedImageAlgorithm\n\n",
    "vtkImageIterateFilter is a filter superclass that supports calling\nexecute multiple times per update.  The largest hack/open issue is\nthat the input and output caches are temporarily changed to \"fool\"\nthe subclasses.  I believe the correct solution is to pass the in and\nout cache to the subclasses methods as arguments.  Now the data is\npasses.  Can the caches be passed, and data retrieved from the",
    " cache?\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImageIterateFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageIterateFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageIterateFilter", o) != 0)
    {
    Py_DECREF(o);
    }

}

