// python wrapper for vtkImageOrthoPlanes
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkImageOrthoPlanes.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageOrthoPlanes(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImageOrthoPlanes_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkImageOrthoPlanes_Doc();


static PyObject *
PyvtkImageOrthoPlanes_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageOrthoPlanes *op = static_cast<vtkImageOrthoPlanes *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkImageOrthoPlanes::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageOrthoPlanes_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageOrthoPlanes *op = static_cast<vtkImageOrthoPlanes *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageOrthoPlanes::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageOrthoPlanes_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageOrthoPlanes *op = static_cast<vtkImageOrthoPlanes *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkImageOrthoPlanes *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageOrthoPlanes::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkImageOrthoPlanes_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkImageOrthoPlanes *tempr = vtkImageOrthoPlanes::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageOrthoPlanes_SetPlane(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPlane");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageOrthoPlanes *op = static_cast<vtkImageOrthoPlanes *>(vp);

  int temp0;
  vtkImagePlaneWidget *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkImagePlaneWidget"))
    {
    if (ap.IsBound())
      {
      op->SetPlane(temp0, temp1);
      }
    else
      {
      op->vtkImageOrthoPlanes::SetPlane(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkImageOrthoPlanes_GetPlane(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPlane");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageOrthoPlanes *op = static_cast<vtkImageOrthoPlanes *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    vtkImagePlaneWidget *tempr = (ap.IsBound() ?
      op->GetPlane(temp0) :
      op->vtkImageOrthoPlanes::GetPlane(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageOrthoPlanes_ResetPlanes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResetPlanes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageOrthoPlanes *op = static_cast<vtkImageOrthoPlanes *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->ResetPlanes();
      }
    else
      {
      op->vtkImageOrthoPlanes::ResetPlanes();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkImageOrthoPlanes_GetTransform(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTransform");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageOrthoPlanes *op = static_cast<vtkImageOrthoPlanes *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTransform *tempr = (ap.IsBound() ?
      op->GetTransform() :
      op->vtkImageOrthoPlanes::GetTransform());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageOrthoPlanes_HandlePlaneEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HandlePlaneEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageOrthoPlanes *op = static_cast<vtkImageOrthoPlanes *>(vp);

  vtkImagePlaneWidget *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImagePlaneWidget"))
    {
    if (ap.IsBound())
      {
      op->HandlePlaneEvent(temp0);
      }
    else
      {
      op->vtkImageOrthoPlanes::HandlePlaneEvent(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkImageOrthoPlanes_Methods[] = {
  {"GetClassName", PyvtkImageOrthoPlanes_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkImageOrthoPlanes_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkImageOrthoPlanes_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageOrthoPlanes\nC++: vtkImageOrthoPlanes *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkImageOrthoPlanes_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkImageOrthoPlanes\nC++: vtkImageOrthoPlanes *SafeDownCast(vtkObject* o)\n\n"},
  {"SetPlane", PyvtkImageOrthoPlanes_SetPlane, METH_VARARGS,
   "V.SetPlane(int, vtkImagePlaneWidget)\nC++: void SetPlane(int i, vtkImagePlaneWidget *imagePlaneWidget)\n\nYou must set three planes for the widget.\n"},
  {"GetPlane", PyvtkImageOrthoPlanes_GetPlane, METH_VARARGS,
   "V.GetPlane(int) -> vtkImagePlaneWidget\nC++: vtkImagePlaneWidget *GetPlane(int i)\n\nYou must set three planes for the widget.\n"},
  {"ResetPlanes", PyvtkImageOrthoPlanes_ResetPlanes, METH_VARARGS,
   "V.ResetPlanes()\nC++: void ResetPlanes()\n\nReset the planes to original scale, rotation, and location.\n"},
  {"GetTransform", PyvtkImageOrthoPlanes_GetTransform, METH_VARARGS,
   "V.GetTransform() -> vtkTransform\nC++: vtkTransform *GetTransform()\n\nGet the transform for the planes.\n"},
  {"HandlePlaneEvent", PyvtkImageOrthoPlanes_HandlePlaneEvent, METH_VARARGS,
   "V.HandlePlaneEvent(vtkImagePlaneWidget)\nC++: void HandlePlaneEvent(vtkImagePlaneWidget *imagePlaneWidget)\n\nA public method to be used only by the event callback.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImageOrthoPlanes_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInteractionWidgetsPython.vtkImageOrthoPlanes", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageOrthoPlanes_StaticNew()
{
  return vtkImageOrthoPlanes::New();
}

PyObject *PyvtkImageOrthoPlanes_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImageOrthoPlanes_Type, PyvtkImageOrthoPlanes_Methods,
    "vtkImageOrthoPlanes",
    PyvtkImageOrthoPlanes_Doc(), &PyvtkImageOrthoPlanes_StaticNew);

  PyTypeObject *pytype = &PyvtkImageOrthoPlanes_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImageOrthoPlanes_Doc()
{
  static const char *docstring[] = {
    "vtkImageOrthoPlanes - Connect three vtkImagePlaneWidgets together\n\n",
    "Superclass: vtkObject\n\n",
    "vtkImageOrthoPlanes is an event observer class that listens to the\nevents from three vtkImagePlaneWidgets and keeps their orientations\nand scales synchronized.\n\nSee Also:\n\nvtkImagePlaneWidget\n\nThanks:\n\nThanks to Atamai Inc. for developing and contributing this class.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImageOrthoPlanes(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageOrthoPlanes_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageOrthoPlanes", o) != 0)
    {
    Py_DECREF(o);
    }

}

