// python wrapper for vtkImageSliceCollection
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkImageSliceCollection.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageSliceCollection(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImageSliceCollection_ClassNew(); }

#ifndef DECLARED_PyvtkPropCollection_ClassNew
extern "C" { PyObject *PyvtkPropCollection_ClassNew(); }
#define DECLARED_PyvtkPropCollection_ClassNew
#endif

static const char **PyvtkImageSliceCollection_Doc();


static PyObject *
PyvtkImageSliceCollection_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSliceCollection *op = static_cast<vtkImageSliceCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkImageSliceCollection::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageSliceCollection_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSliceCollection *op = static_cast<vtkImageSliceCollection *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageSliceCollection::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageSliceCollection_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSliceCollection *op = static_cast<vtkImageSliceCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkImageSliceCollection *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageSliceCollection::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkImageSliceCollection_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkImageSliceCollection *tempr = vtkImageSliceCollection::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageSliceCollection_Sort(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Sort");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSliceCollection *op = static_cast<vtkImageSliceCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->Sort();
      }
    else
      {
      op->vtkImageSliceCollection::Sort();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkImageSliceCollection_AddItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSliceCollection *op = static_cast<vtkImageSliceCollection *>(vp);

  vtkImageSlice *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageSlice"))
    {
    if (ap.IsBound())
      {
      op->AddItem(temp0);
      }
    else
      {
      op->vtkImageSliceCollection::AddItem(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkImageSliceCollection_GetNextImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNextImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSliceCollection *op = static_cast<vtkImageSliceCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkImageSlice *tempr = (ap.IsBound() ?
      op->GetNextImage() :
      op->vtkImageSliceCollection::GetNextImage());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageSliceCollection_GetNextItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNextItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSliceCollection *op = static_cast<vtkImageSliceCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkImageSlice *tempr = (ap.IsBound() ?
      op->GetNextItem() :
      op->vtkImageSliceCollection::GetNextItem());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkImageSliceCollection_Methods[] = {
  {"GetClassName", PyvtkImageSliceCollection_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkImageSliceCollection_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkImageSliceCollection_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageSliceCollection\nC++: vtkImageSliceCollection *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkImageSliceCollection_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkImageSliceCollection\nC++: vtkImageSliceCollection *SafeDownCast(vtkObject* o)\n\n"},
  {"Sort", PyvtkImageSliceCollection_Sort, METH_VARARGS,
   "V.Sort()\nC++: void Sort()\n\nSorts the vtkImageSliceCollection by layer number.  Smaller layer\nnumbers are first. Layer numbers can be any integer value. Items\nwith the same layer number will be kept in the same relative\norder as before the sort.\n"},
  {"AddItem", PyvtkImageSliceCollection_AddItem, METH_VARARGS,
   "V.AddItem(vtkImageSlice)\nC++: void AddItem(vtkImageSlice *a)\n\nAdd an image to the list.  The new image is inserted in the list\naccording to its layer number.\n"},
  {"GetNextImage", PyvtkImageSliceCollection_GetNextImage, METH_VARARGS,
   "V.GetNextImage() -> vtkImageSlice\nC++: vtkImageSlice *GetNextImage()\n\nStandard Collection methods.  You must call InitTraversal before\ncalling GetNextImage.  If possible, you should use the\nGetNextImage method that takes a collection iterator instead.\n"},
  {"GetNextItem", PyvtkImageSliceCollection_GetNextItem, METH_VARARGS,
   "V.GetNextItem() -> vtkImageSlice\nC++: vtkImageSlice *GetNextItem()\n\nAccess routine provided for compatibility with previous versions\nof VTK.  Please use the GetNextImage() variant where possible.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImageSliceCollection_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingImagePython.vtkImageSliceCollection", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageSliceCollection_StaticNew()
{
  return vtkImageSliceCollection::New();
}

PyObject *PyvtkImageSliceCollection_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImageSliceCollection_Type, PyvtkImageSliceCollection_Methods,
    "vtkImageSliceCollection",
    PyvtkImageSliceCollection_Doc(), &PyvtkImageSliceCollection_StaticNew);

  PyTypeObject *pytype = &PyvtkImageSliceCollection_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPropCollection_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImageSliceCollection_Doc()
{
  static const char *docstring[] = {
    "vtkImageSliceCollection - a sorted list of image slice objects\n\n",
    "Superclass: vtkPropCollection\n\n",
    "vtkImageSliceCollection is a vtkPropCollection that maintains a list\nof vtkImageSlice objects that are sorted by LayerNumber. This allows\nthe images to be rendered in the correct order.\n\nSee Also:\n\nvtkImageSlice vtkImageAssembly\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImageSliceCollection(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageSliceCollection_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageSliceCollection", o) != 0)
    {
    Py_DECREF(o);
    }

}

