// python wrapper for vtkImageStencilAlgorithm
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkInformationVector.h"
#include "vtkImageStencilAlgorithm.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageStencilAlgorithm(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImageStencilAlgorithm_ClassNew(); }

#ifndef DECLARED_PyvtkAlgorithm_ClassNew
extern "C" { PyObject *PyvtkAlgorithm_ClassNew(); }
#define DECLARED_PyvtkAlgorithm_ClassNew
#endif

static const char **PyvtkImageStencilAlgorithm_Doc();


static PyObject *
PyvtkImageStencilAlgorithm_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStencilAlgorithm *op = static_cast<vtkImageStencilAlgorithm *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkImageStencilAlgorithm::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageStencilAlgorithm_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStencilAlgorithm *op = static_cast<vtkImageStencilAlgorithm *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageStencilAlgorithm::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageStencilAlgorithm_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStencilAlgorithm *op = static_cast<vtkImageStencilAlgorithm *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkImageStencilAlgorithm *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageStencilAlgorithm::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkImageStencilAlgorithm_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkImageStencilAlgorithm *tempr = vtkImageStencilAlgorithm::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkImageStencilAlgorithm_SetOutput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStencilAlgorithm *op = static_cast<vtkImageStencilAlgorithm *>(vp);

  vtkImageStencilData *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageStencilData"))
    {
    if (ap.IsBound())
      {
      op->SetOutput(temp0);
      }
    else
      {
      op->vtkImageStencilAlgorithm::SetOutput(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkImageStencilAlgorithm_GetOutput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStencilAlgorithm *op = static_cast<vtkImageStencilAlgorithm *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkImageStencilData *tempr = (ap.IsBound() ?
      op->GetOutput() :
      op->vtkImageStencilAlgorithm::GetOutput());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkImageStencilAlgorithm_Methods[] = {
  {"GetClassName", PyvtkImageStencilAlgorithm_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkImageStencilAlgorithm_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkImageStencilAlgorithm_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageStencilAlgorithm\nC++: vtkImageStencilAlgorithm *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkImageStencilAlgorithm_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkImageStencilAlgorithm\nC++: vtkImageStencilAlgorithm *SafeDownCast(vtkObject* o)\n\n"},
  {"SetOutput", PyvtkImageStencilAlgorithm_SetOutput, METH_VARARGS,
   "V.SetOutput(vtkImageStencilData)\nC++: void SetOutput(vtkImageStencilData *output)\n\nGet or set the output for this source.\n"},
  {"GetOutput", PyvtkImageStencilAlgorithm_GetOutput, METH_VARARGS,
   "V.GetOutput() -> vtkImageStencilData\nC++: vtkImageStencilData *GetOutput()\n\nGet or set the output for this source.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImageStencilAlgorithm_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingCorePython.vtkImageStencilAlgorithm", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageStencilAlgorithm_StaticNew()
{
  return vtkImageStencilAlgorithm::New();
}

PyObject *PyvtkImageStencilAlgorithm_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImageStencilAlgorithm_Type, PyvtkImageStencilAlgorithm_Methods,
    "vtkImageStencilAlgorithm",
    PyvtkImageStencilAlgorithm_Doc(), &PyvtkImageStencilAlgorithm_StaticNew);

  PyTypeObject *pytype = &PyvtkImageStencilAlgorithm_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImageStencilAlgorithm_Doc()
{
  static const char *docstring[] = {
    "vtkImageStencilAlgorithm - producer of vtkImageStencilData\n\n",
    "Superclass: vtkAlgorithm\n\n",
    "vtkImageStencilAlgorithm is a superclass for filters that generate\nthe special vtkImageStencilData type.  This data type is a special\nrepresentation of a binary image that can be used as a mask by\nseveral imaging filters.\n\nSee Also:\n\nvtkImageStencilData vtkImageStencilSource\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImageStencilAlgorithm(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageStencilAlgorithm_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageStencilAlgorithm", o) != 0)
    {
    Py_DECREF(o);
    }

}

