// python wrapper for vtkIncrementalForceLayout
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkVector.h"
#include "vtkIncrementalForceLayout.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkIncrementalForceLayout(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkIncrementalForceLayout_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkIncrementalForceLayout_Doc();


static PyObject *
PyvtkIncrementalForceLayout_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkIncrementalForceLayout::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkIncrementalForceLayout::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkIncrementalForceLayout *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkIncrementalForceLayout::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkIncrementalForceLayout *tempr = vtkIncrementalForceLayout::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_SetGraph(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGraph");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  vtkGraph *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGraph"))
    {
    if (ap.IsBound())
      {
      op->SetGraph(temp0);
      }
    else
      {
      op->vtkIncrementalForceLayout::SetGraph(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_GetGraph(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGraph");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkGraph *tempr = (ap.IsBound() ?
      op->GetGraph() :
      op->vtkIncrementalForceLayout::GetGraph());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_SetFixed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFixed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  vtkIdType temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetFixed(temp0);
      }
    else
      {
      op->vtkIncrementalForceLayout::SetFixed(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_GetFixed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFixed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetFixed() :
      op->vtkIncrementalForceLayout::GetFixed());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_SetAlpha(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAlpha");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetAlpha(temp0);
      }
    else
      {
      op->vtkIncrementalForceLayout::SetAlpha(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_GetAlpha(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAlpha");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    float tempr = (ap.IsBound() ?
      op->GetAlpha() :
      op->vtkIncrementalForceLayout::GetAlpha());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_SetTheta(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTheta");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetTheta(temp0);
      }
    else
      {
      op->vtkIncrementalForceLayout::SetTheta(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_GetTheta(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTheta");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    float tempr = (ap.IsBound() ?
      op->GetTheta() :
      op->vtkIncrementalForceLayout::GetTheta());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_SetCharge(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCharge");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetCharge(temp0);
      }
    else
      {
      op->vtkIncrementalForceLayout::SetCharge(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_GetCharge(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCharge");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    float tempr = (ap.IsBound() ?
      op->GetCharge() :
      op->vtkIncrementalForceLayout::GetCharge());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_SetStrength(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStrength");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetStrength(temp0);
      }
    else
      {
      op->vtkIncrementalForceLayout::SetStrength(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_GetStrength(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStrength");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    float tempr = (ap.IsBound() ?
      op->GetStrength() :
      op->vtkIncrementalForceLayout::GetStrength());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_SetDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetDistance(temp0);
      }
    else
      {
      op->vtkIncrementalForceLayout::SetDistance(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_GetDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    float tempr = (ap.IsBound() ?
      op->GetDistance() :
      op->vtkIncrementalForceLayout::GetDistance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_SetGravity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGravity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetGravity(temp0);
      }
    else
      {
      op->vtkIncrementalForceLayout::SetGravity(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_GetGravity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGravity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    float tempr = (ap.IsBound() ?
      op->GetGravity() :
      op->vtkIncrementalForceLayout::GetGravity());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_SetFriction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFriction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetFriction(temp0);
      }
    else
      {
      op->vtkIncrementalForceLayout::SetFriction(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_GetFriction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFriction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    float tempr = (ap.IsBound() ?
      op->GetFriction() :
      op->vtkIncrementalForceLayout::GetFriction());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_SetGravityPoint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGravityPoint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  vtkVector2f *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkVector2f"))
    {
    if (ap.IsBound())
      {
      op->SetGravityPoint(*temp0);
      }
    else
      {
      op->vtkIncrementalForceLayout::SetGravityPoint(*temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_GetGravityPoint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGravityPoint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkVector2f tempr = (ap.IsBound() ?
      op->GetGravityPoint() :
      op->vtkIncrementalForceLayout::GetGravityPoint());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildSpecialObject(&tempr, "vtkVector2f");
      }
    }

  return result;
}


static PyObject *
PyvtkIncrementalForceLayout_UpdatePositions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdatePositions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIncrementalForceLayout *op = static_cast<vtkIncrementalForceLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->UpdatePositions();
      }
    else
      {
      op->vtkIncrementalForceLayout::UpdatePositions();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkIncrementalForceLayout_Methods[] = {
  {"GetClassName", PyvtkIncrementalForceLayout_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkIncrementalForceLayout_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkIncrementalForceLayout_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkIncrementalForceLayout\nC++: vtkIncrementalForceLayout *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkIncrementalForceLayout_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkIncrementalForceLayout\nC++: vtkIncrementalForceLayout *SafeDownCast(vtkObject* o)\n\n"},
  {"SetGraph", PyvtkIncrementalForceLayout_SetGraph, METH_VARARGS,
   "V.SetGraph(vtkGraph)\nC++: virtual void SetGraph(vtkGraph *g)\n\nSet the graph to be positioned.\n"},
  {"GetGraph", PyvtkIncrementalForceLayout_GetGraph, METH_VARARGS,
   "V.GetGraph() -> vtkGraph\nC++: vtkGraph *GetGraph()\n\nSet the graph to be positioned.\n"},
  {"SetFixed", PyvtkIncrementalForceLayout_SetFixed, METH_VARARGS,
   "V.SetFixed(int)\nC++: virtual void SetFixed(vtkIdType fixed)\n\nSet the id of the vertex that will not move during the\nsimulation. Set to -1 to allow all the vertices to move.\n"},
  {"GetFixed", PyvtkIncrementalForceLayout_GetFixed, METH_VARARGS,
   "V.GetFixed() -> int\nC++: vtkIdType GetFixed()\n\nSet the id of the vertex that will not move during the\nsimulation. Set to -1 to allow all the vertices to move.\n"},
  {"SetAlpha", PyvtkIncrementalForceLayout_SetAlpha, METH_VARARGS,
   "V.SetAlpha(float)\nC++: void SetAlpha(float a)\n\nSet the level of activity in the simulation. Default is 0.1.\n"},
  {"GetAlpha", PyvtkIncrementalForceLayout_GetAlpha, METH_VARARGS,
   "V.GetAlpha() -> float\nC++: float GetAlpha()\n\nSet the level of activity in the simulation. Default is 0.1.\n"},
  {"SetTheta", PyvtkIncrementalForceLayout_SetTheta, METH_VARARGS,
   "V.SetTheta(float)\nC++: void SetTheta(float a)\n\nSet the Barnes-Hut threshold for the simulation. Higher values\nwill speed the simulation at the expense of some accuracy.\nDefault is 0.8.\n"},
  {"GetTheta", PyvtkIncrementalForceLayout_GetTheta, METH_VARARGS,
   "V.GetTheta() -> float\nC++: float GetTheta()\n\nSet the Barnes-Hut threshold for the simulation. Higher values\nwill speed the simulation at the expense of some accuracy.\nDefault is 0.8.\n"},
  {"SetCharge", PyvtkIncrementalForceLayout_SetCharge, METH_VARARGS,
   "V.SetCharge(float)\nC++: void SetCharge(float a)\n\nSet the charge of each vertex. Higher negative values will repel\nvertices from each other more strongly. Default is -30.\n"},
  {"GetCharge", PyvtkIncrementalForceLayout_GetCharge, METH_VARARGS,
   "V.GetCharge() -> float\nC++: float GetCharge()\n\nSet the charge of each vertex. Higher negative values will repel\nvertices from each other more strongly. Default is -30.\n"},
  {"SetStrength", PyvtkIncrementalForceLayout_SetStrength, METH_VARARGS,
   "V.SetStrength(float)\nC++: void SetStrength(float a)\n\nSet the rigitity of links in the simulation. Default is 2.\n"},
  {"GetStrength", PyvtkIncrementalForceLayout_GetStrength, METH_VARARGS,
   "V.GetStrength() -> float\nC++: float GetStrength()\n\nSet the rigitity of links in the simulation. Default is 2.\n"},
  {"SetDistance", PyvtkIncrementalForceLayout_SetDistance, METH_VARARGS,
   "V.SetDistance(float)\nC++: void SetDistance(float a)\n\nSet the resting distance of each link in scene units, which is\nequal to pixels when there is no scene scaling. Default is 20.\n"},
  {"GetDistance", PyvtkIncrementalForceLayout_GetDistance, METH_VARARGS,
   "V.GetDistance() -> float\nC++: float GetDistance()\n\nSet the resting distance of each link in scene units, which is\nequal to pixels when there is no scene scaling. Default is 20.\n"},
  {"SetGravity", PyvtkIncrementalForceLayout_SetGravity, METH_VARARGS,
   "V.SetGravity(float)\nC++: void SetGravity(float a)\n\nSet the amount of gravitational pull toward the gravity point.\nDefault is 0.01.\n"},
  {"GetGravity", PyvtkIncrementalForceLayout_GetGravity, METH_VARARGS,
   "V.GetGravity() -> float\nC++: float GetGravity()\n\nSet the amount of gravitational pull toward the gravity point.\nDefault is 0.01.\n"},
  {"SetFriction", PyvtkIncrementalForceLayout_SetFriction, METH_VARARGS,
   "V.SetFriction(float)\nC++: void SetFriction(float a)\n\nSet the multiplier for scaling down velocity in the simulation,\nwhere values closer to 1 are more frictionless. Default is 0.95.\n"},
  {"GetFriction", PyvtkIncrementalForceLayout_GetFriction, METH_VARARGS,
   "V.GetFriction() -> float\nC++: float GetFriction()\n\nSet the multiplier for scaling down velocity in the simulation,\nwhere values closer to 1 are more frictionless. Default is 0.95.\n"},
  {"SetGravityPoint", PyvtkIncrementalForceLayout_SetGravityPoint, METH_VARARGS,
   "V.SetGravityPoint(vtkVector2f)\nC++: virtual void SetGravityPoint(const vtkVector2f &point)\n\nSet the gravity point where all vertices will migrate. Generally\nthis should be set to the location in the center of the scene.\nDefault location is (200, 200).\n"},
  {"GetGravityPoint", PyvtkIncrementalForceLayout_GetGravityPoint, METH_VARARGS,
   "V.GetGravityPoint() -> vtkVector2f\nC++: virtual vtkVector2f GetGravityPoint()\n\nSet the gravity point where all vertices will migrate. Generally\nthis should be set to the location in the center of the scene.\nDefault location is (200, 200).\n"},
  {"UpdatePositions", PyvtkIncrementalForceLayout_UpdatePositions, METH_VARARGS,
   "V.UpdatePositions()\nC++: void UpdatePositions()\n\nPerform one iteration of the force-directed layout.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkIncrementalForceLayout_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInfovisLayoutPython.vtkIncrementalForceLayout", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkIncrementalForceLayout_StaticNew()
{
  return vtkIncrementalForceLayout::New();
}

PyObject *PyvtkIncrementalForceLayout_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkIncrementalForceLayout_Type, PyvtkIncrementalForceLayout_Methods,
    "vtkIncrementalForceLayout",
    PyvtkIncrementalForceLayout_Doc(), &PyvtkIncrementalForceLayout_StaticNew);

  PyTypeObject *pytype = &PyvtkIncrementalForceLayout_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkIncrementalForceLayout_Doc()
{
  static const char *docstring[] = {
    "vtkIncrementalForceLayout - incremental force-directed layout.\n\n",
    "Superclass: vtkObject\n\n",
    "Performs an incremental force-directed layout of a graph. Set the\ngraph then iteratively execute UpdatePositions() to update the vertex\npositions. Note that this directly modifies the vertex locations in\nthe graph.\n\nThis layout is modeled after D3's force layout described at\nhttps://github.com/mbostock/d3/wiki/Force-Layout\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkIncrementalForceLayout(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkIncrementalForceLayout_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkIncrementalForceLayout", o) != 0)
    {
    Py_DECREF(o);
    }

}

