// python wrapper for vtkJPEGWriter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkJPEGWriter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkJPEGWriter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkJPEGWriter_ClassNew(); }

#ifndef DECLARED_PyvtkImageWriter_ClassNew
extern "C" { PyObject *PyvtkImageWriter_ClassNew(); }
#define DECLARED_PyvtkImageWriter_ClassNew
#endif

static const char **PyvtkJPEGWriter_Doc();


static PyObject *
PyvtkJPEGWriter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkJPEGWriter::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkJPEGWriter::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkJPEGWriter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkJPEGWriter::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkJPEGWriter *tempr = vtkJPEGWriter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_Write(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Write");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->Write();
      }
    else
      {
      op->vtkJPEGWriter::Write();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_SetQuality(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQuality");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetQuality(temp0);
      }
    else
      {
      op->vtkJPEGWriter::SetQuality(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_GetQualityMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQualityMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetQualityMinValue() :
      op->vtkJPEGWriter::GetQualityMinValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_GetQualityMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQualityMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetQualityMaxValue() :
      op->vtkJPEGWriter::GetQualityMaxValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_GetQuality(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQuality");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetQuality() :
      op->vtkJPEGWriter::GetQuality());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_SetProgressive(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetProgressive");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetProgressive(temp0);
      }
    else
      {
      op->vtkJPEGWriter::SetProgressive(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_GetProgressive(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProgressive");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    unsigned int tempr = (ap.IsBound() ?
      op->GetProgressive() :
      op->vtkJPEGWriter::GetProgressive());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_ProgressiveOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ProgressiveOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->ProgressiveOn();
      }
    else
      {
      op->vtkJPEGWriter::ProgressiveOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_ProgressiveOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ProgressiveOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->ProgressiveOff();
      }
    else
      {
      op->vtkJPEGWriter::ProgressiveOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_SetWriteToMemory(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetWriteToMemory");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetWriteToMemory(temp0);
      }
    else
      {
      op->vtkJPEGWriter::SetWriteToMemory(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_GetWriteToMemory(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetWriteToMemory");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    unsigned int tempr = (ap.IsBound() ?
      op->GetWriteToMemory() :
      op->vtkJPEGWriter::GetWriteToMemory());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_WriteToMemoryOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "WriteToMemoryOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->WriteToMemoryOn();
      }
    else
      {
      op->vtkJPEGWriter::WriteToMemoryOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_WriteToMemoryOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "WriteToMemoryOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->WriteToMemoryOff();
      }
    else
      {
      op->vtkJPEGWriter::WriteToMemoryOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_SetResult(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetResult");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  vtkUnsignedCharArray *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkUnsignedCharArray"))
    {
    if (ap.IsBound())
      {
      op->SetResult(temp0);
      }
    else
      {
      op->vtkJPEGWriter::SetResult(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkJPEGWriter_GetResult(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetResult");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkJPEGWriter *op = static_cast<vtkJPEGWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkUnsignedCharArray *tempr = (ap.IsBound() ?
      op->GetResult() :
      op->vtkJPEGWriter::GetResult());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkJPEGWriter_Methods[] = {
  {"GetClassName", PyvtkJPEGWriter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkJPEGWriter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkJPEGWriter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkJPEGWriter\nC++: vtkJPEGWriter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkJPEGWriter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkJPEGWriter\nC++: vtkJPEGWriter *SafeDownCast(vtkObject* o)\n\n"},
  {"Write", PyvtkJPEGWriter_Write, METH_VARARGS,
   "V.Write()\nC++: virtual void Write()\n\nThe main interface which triggers the writer to start.\n"},
  {"SetQuality", PyvtkJPEGWriter_SetQuality, METH_VARARGS,
   "V.SetQuality(int)\nC++: void SetQuality(int)\n\nCompression quality. 0 = Low quality, 100 = High quality\n"},
  {"GetQualityMinValue", PyvtkJPEGWriter_GetQualityMinValue, METH_VARARGS,
   "V.GetQualityMinValue() -> int\nC++: int GetQualityMinValue()\n\nCompression quality. 0 = Low quality, 100 = High quality\n"},
  {"GetQualityMaxValue", PyvtkJPEGWriter_GetQualityMaxValue, METH_VARARGS,
   "V.GetQualityMaxValue() -> int\nC++: int GetQualityMaxValue()\n\nCompression quality. 0 = Low quality, 100 = High quality\n"},
  {"GetQuality", PyvtkJPEGWriter_GetQuality, METH_VARARGS,
   "V.GetQuality() -> int\nC++: int GetQuality()\n\nCompression quality. 0 = Low quality, 100 = High quality\n"},
  {"SetProgressive", PyvtkJPEGWriter_SetProgressive, METH_VARARGS,
   "V.SetProgressive(int)\nC++: void SetProgressive(unsigned int a)\n\nProgressive JPEG generation.\n"},
  {"GetProgressive", PyvtkJPEGWriter_GetProgressive, METH_VARARGS,
   "V.GetProgressive() -> int\nC++: unsigned int GetProgressive()\n\nProgressive JPEG generation.\n"},
  {"ProgressiveOn", PyvtkJPEGWriter_ProgressiveOn, METH_VARARGS,
   "V.ProgressiveOn()\nC++: void ProgressiveOn()\n\nProgressive JPEG generation.\n"},
  {"ProgressiveOff", PyvtkJPEGWriter_ProgressiveOff, METH_VARARGS,
   "V.ProgressiveOff()\nC++: void ProgressiveOff()\n\nProgressive JPEG generation.\n"},
  {"SetWriteToMemory", PyvtkJPEGWriter_SetWriteToMemory, METH_VARARGS,
   "V.SetWriteToMemory(int)\nC++: void SetWriteToMemory(unsigned int a)\n\nWrite the image to memory (a vtkUnsignedCharArray)\n"},
  {"GetWriteToMemory", PyvtkJPEGWriter_GetWriteToMemory, METH_VARARGS,
   "V.GetWriteToMemory() -> int\nC++: unsigned int GetWriteToMemory()\n\nWrite the image to memory (a vtkUnsignedCharArray)\n"},
  {"WriteToMemoryOn", PyvtkJPEGWriter_WriteToMemoryOn, METH_VARARGS,
   "V.WriteToMemoryOn()\nC++: void WriteToMemoryOn()\n\nWrite the image to memory (a vtkUnsignedCharArray)\n"},
  {"WriteToMemoryOff", PyvtkJPEGWriter_WriteToMemoryOff, METH_VARARGS,
   "V.WriteToMemoryOff()\nC++: void WriteToMemoryOff()\n\nWrite the image to memory (a vtkUnsignedCharArray)\n"},
  {"SetResult", PyvtkJPEGWriter_SetResult, METH_VARARGS,
   "V.SetResult(vtkUnsignedCharArray)\nC++: virtual void SetResult(vtkUnsignedCharArray *)\n\nWhen writing to memory this is the result, it will be NULL until\nthe data is written the first time\n"},
  {"GetResult", PyvtkJPEGWriter_GetResult, METH_VARARGS,
   "V.GetResult() -> vtkUnsignedCharArray\nC++: vtkUnsignedCharArray *GetResult()\n\nWhen writing to memory this is the result, it will be NULL until\nthe data is written the first time\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkJPEGWriter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOImagePython.vtkJPEGWriter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkJPEGWriter_StaticNew()
{
  return vtkJPEGWriter::New();
}

PyObject *PyvtkJPEGWriter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkJPEGWriter_Type, PyvtkJPEGWriter_Methods,
    "vtkJPEGWriter",
    PyvtkJPEGWriter_Doc(), &PyvtkJPEGWriter_StaticNew);

  PyTypeObject *pytype = &PyvtkJPEGWriter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageWriter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkJPEGWriter_Doc()
{
  static const char *docstring[] = {
    "vtkJPEGWriter - Writes JPEG files.\n\n",
    "Superclass: vtkImageWriter\n\n",
    "vtkJPEGWriter writes JPEG files. It supports 1 and 3 component data\nof unsigned char. It relies on the IJG's libjpeg.  Thanks to IJG for\nsupplying a public jpeg IO library.\n\nSee Also:\n\nvtkJPEGReader\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkJPEGWriter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkJPEGWriter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkJPEGWriter", o) != 0)
    {
    Py_DECREF(o);
    }

}

