// python wrapper for vtkKochanekSpline
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkKochanekSpline.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkKochanekSpline(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkKochanekSpline_ClassNew(); }

#ifndef DECLARED_PyvtkSpline_ClassNew
extern "C" { PyObject *PyvtkSpline_ClassNew(); }
#define DECLARED_PyvtkSpline_ClassNew
#endif

static const char **PyvtkKochanekSpline_Doc();


static PyObject *
PyvtkKochanekSpline_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkKochanekSpline *op = static_cast<vtkKochanekSpline *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkKochanekSpline::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkKochanekSpline_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkKochanekSpline *op = static_cast<vtkKochanekSpline *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkKochanekSpline::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkKochanekSpline_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkKochanekSpline *op = static_cast<vtkKochanekSpline *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkKochanekSpline *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkKochanekSpline::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkKochanekSpline_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkKochanekSpline *tempr = vtkKochanekSpline::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkKochanekSpline_Compute(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Compute");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkKochanekSpline *op = static_cast<vtkKochanekSpline *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->Compute();
      }
    else
      {
      op->vtkKochanekSpline::Compute();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkKochanekSpline_Evaluate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Evaluate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkKochanekSpline *op = static_cast<vtkKochanekSpline *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    double tempr = (ap.IsBound() ?
      op->Evaluate(temp0) :
      op->vtkKochanekSpline::Evaluate(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkKochanekSpline_SetDefaultBias(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDefaultBias");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkKochanekSpline *op = static_cast<vtkKochanekSpline *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetDefaultBias(temp0);
      }
    else
      {
      op->vtkKochanekSpline::SetDefaultBias(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkKochanekSpline_GetDefaultBias(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultBias");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkKochanekSpline *op = static_cast<vtkKochanekSpline *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetDefaultBias() :
      op->vtkKochanekSpline::GetDefaultBias());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkKochanekSpline_SetDefaultTension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDefaultTension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkKochanekSpline *op = static_cast<vtkKochanekSpline *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetDefaultTension(temp0);
      }
    else
      {
      op->vtkKochanekSpline::SetDefaultTension(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkKochanekSpline_GetDefaultTension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultTension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkKochanekSpline *op = static_cast<vtkKochanekSpline *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetDefaultTension() :
      op->vtkKochanekSpline::GetDefaultTension());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkKochanekSpline_SetDefaultContinuity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDefaultContinuity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkKochanekSpline *op = static_cast<vtkKochanekSpline *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetDefaultContinuity(temp0);
      }
    else
      {
      op->vtkKochanekSpline::SetDefaultContinuity(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkKochanekSpline_GetDefaultContinuity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultContinuity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkKochanekSpline *op = static_cast<vtkKochanekSpline *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetDefaultContinuity() :
      op->vtkKochanekSpline::GetDefaultContinuity());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkKochanekSpline_DeepCopy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DeepCopy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkKochanekSpline *op = static_cast<vtkKochanekSpline *>(vp);

  vtkSpline *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSpline"))
    {
    if (ap.IsBound())
      {
      op->DeepCopy(temp0);
      }
    else
      {
      op->vtkKochanekSpline::DeepCopy(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkKochanekSpline_Methods[] = {
  {"GetClassName", PyvtkKochanekSpline_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkKochanekSpline_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkKochanekSpline_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkKochanekSpline\nC++: vtkKochanekSpline *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkKochanekSpline_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkKochanekSpline\nC++: vtkKochanekSpline *SafeDownCast(vtkObject* o)\n\n"},
  {"Compute", PyvtkKochanekSpline_Compute, METH_VARARGS,
   "V.Compute()\nC++: void Compute()\n\nCompute Kochanek Spline coefficients.\n"},
  {"Evaluate", PyvtkKochanekSpline_Evaluate, METH_VARARGS,
   "V.Evaluate(float) -> float\nC++: double Evaluate(double t)\n\nEvaluate a 1D Kochanek spline.\n"},
  {"SetDefaultBias", PyvtkKochanekSpline_SetDefaultBias, METH_VARARGS,
   "V.SetDefaultBias(float)\nC++: void SetDefaultBias(double a)\n\nSet the bias for all points. Default is 0.\n"},
  {"GetDefaultBias", PyvtkKochanekSpline_GetDefaultBias, METH_VARARGS,
   "V.GetDefaultBias() -> float\nC++: double GetDefaultBias()\n\nSet the bias for all points. Default is 0.\n"},
  {"SetDefaultTension", PyvtkKochanekSpline_SetDefaultTension, METH_VARARGS,
   "V.SetDefaultTension(float)\nC++: void SetDefaultTension(double a)\n\nSet the tension for all points. Default is 0.\n"},
  {"GetDefaultTension", PyvtkKochanekSpline_GetDefaultTension, METH_VARARGS,
   "V.GetDefaultTension() -> float\nC++: double GetDefaultTension()\n\nSet the tension for all points. Default is 0.\n"},
  {"SetDefaultContinuity", PyvtkKochanekSpline_SetDefaultContinuity, METH_VARARGS,
   "V.SetDefaultContinuity(float)\nC++: void SetDefaultContinuity(double a)\n\nSet the continuity for all points. Default is 0.\n"},
  {"GetDefaultContinuity", PyvtkKochanekSpline_GetDefaultContinuity, METH_VARARGS,
   "V.GetDefaultContinuity() -> float\nC++: double GetDefaultContinuity()\n\nSet the continuity for all points. Default is 0.\n"},
  {"DeepCopy", PyvtkKochanekSpline_DeepCopy, METH_VARARGS,
   "V.DeepCopy(vtkSpline)\nC++: virtual void DeepCopy(vtkSpline *s)\n\nDeep copy of cardinal spline data.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkKochanekSpline_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonComputationalGeometryPython.vtkKochanekSpline", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkKochanekSpline_StaticNew()
{
  return vtkKochanekSpline::New();
}

PyObject *PyvtkKochanekSpline_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkKochanekSpline_Type, PyvtkKochanekSpline_Methods,
    "vtkKochanekSpline",
    PyvtkKochanekSpline_Doc(), &PyvtkKochanekSpline_StaticNew);

  PyTypeObject *pytype = &PyvtkKochanekSpline_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSpline_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkKochanekSpline_Doc()
{
  static const char *docstring[] = {
    "vtkKochanekSpline - computes an interpolating spline using a Kochanek\nbasis.\n\n",
    "Superclass: vtkSpline\n\n",
    "Implements the Kochenek interpolating spline described in: Kochanek,\nD., Bartels, R., \"Interpolating Splines with Local Tension,\nContinuity, and Bias Control,\" Computer Graphics, vol. 18, no. 3, pp.\n33-41, July 1984. These splines give the user more control over the\nshape of the curve than the cardinal splines implemented in\nvtkCardinalSpline. Three parameters can be specified. All have a\nrange fr",
    "om -1 to 1.\n\nTension controls how sharply the curve bends at an input point. A\nvalue of -1 produces more slack in the curve. A value of 1 tightens\nthe curve.\n\nContinuity controls the continuity of the first derivative at input\npoints.\n\nBias controls the direction of the curve at it passes through an\ninput point. A value of -1 undershoots the point while a value of 1\novershoots the point.\n\nThese th",
    "ree parameters give the user broad control over the shape of\nthe interpolating spline. The original Kochanek paper describes the\neffects nicely and is recommended reading.\n\nSee Also:\n\nvtkSpline vtkCardinalSpline\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkKochanekSpline(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkKochanekSpline_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkKochanekSpline", o) != 0)
    {
    Py_DECREF(o);
    }

}

