// python wrapper for vtkMNITagPointWriter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkMNITagPointWriter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMNITagPointWriter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkMNITagPointWriter_ClassNew(); }

#ifndef DECLARED_PyvtkWriter_ClassNew
extern "C" { PyObject *PyvtkWriter_ClassNew(); }
#define DECLARED_PyvtkWriter_ClassNew
#endif

static const char **PyvtkMNITagPointWriter_Doc();


static PyObject *
PyvtkMNITagPointWriter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkMNITagPointWriter::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMNITagPointWriter::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkMNITagPointWriter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMNITagPointWriter::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkMNITagPointWriter *tempr = vtkMNITagPointWriter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_GetFileExtensions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileExtensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetFileExtensions() :
      op->vtkMNITagPointWriter::GetFileExtensions());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_GetDescriptiveName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDescriptiveName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetDescriptiveName() :
      op->vtkMNITagPointWriter::GetDescriptiveName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_SetPoints_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  int temp0;
  vtkPoints *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkPoints"))
    {
    if (ap.IsBound())
      {
      op->SetPoints(temp0, temp1);
      }
    else
      {
      op->vtkMNITagPointWriter::SetPoints(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkMNITagPointWriter_SetPoints_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  vtkPoints *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPoints"))
    {
    if (ap.IsBound())
      {
      op->SetPoints(temp0);
      }
    else
      {
      op->vtkMNITagPointWriter::SetPoints(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkMNITagPointWriter_SetPoints(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 2:
      return PyvtkMNITagPointWriter_SetPoints_s1(self, args);
    case 1:
      return PyvtkMNITagPointWriter_SetPoints_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetPoints");
  return NULL;
}



static PyObject *
PyvtkMNITagPointWriter_GetPoints_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    vtkPoints *tempr = (ap.IsBound() ?
      op->GetPoints(temp0) :
      op->vtkMNITagPointWriter::GetPoints(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyObject *
PyvtkMNITagPointWriter_GetPoints_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkPoints *tempr = (ap.IsBound() ?
      op->GetPoints() :
      op->vtkMNITagPointWriter::GetPoints());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyObject *
PyvtkMNITagPointWriter_GetPoints(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 1:
      return PyvtkMNITagPointWriter_GetPoints_s1(self, args);
    case 0:
      return PyvtkMNITagPointWriter_GetPoints_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "GetPoints");
  return NULL;
}



static PyObject *
PyvtkMNITagPointWriter_SetLabelText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLabelText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  vtkStringArray *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkStringArray"))
    {
    if (ap.IsBound())
      {
      op->SetLabelText(temp0);
      }
    else
      {
      op->vtkMNITagPointWriter::SetLabelText(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_GetLabelText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLabelText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkStringArray *tempr = (ap.IsBound() ?
      op->GetLabelText() :
      op->vtkMNITagPointWriter::GetLabelText());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_SetWeights(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetWeights");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  vtkDoubleArray *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDoubleArray"))
    {
    if (ap.IsBound())
      {
      op->SetWeights(temp0);
      }
    else
      {
      op->vtkMNITagPointWriter::SetWeights(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_GetWeights(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetWeights");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkDoubleArray *tempr = (ap.IsBound() ?
      op->GetWeights() :
      op->vtkMNITagPointWriter::GetWeights());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_SetStructureIds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStructureIds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  vtkIntArray *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkIntArray"))
    {
    if (ap.IsBound())
      {
      op->SetStructureIds(temp0);
      }
    else
      {
      op->vtkMNITagPointWriter::SetStructureIds(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_GetStructureIds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructureIds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkIntArray *tempr = (ap.IsBound() ?
      op->GetStructureIds() :
      op->vtkMNITagPointWriter::GetStructureIds());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_SetPatientIds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPatientIds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  vtkIntArray *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkIntArray"))
    {
    if (ap.IsBound())
      {
      op->SetPatientIds(temp0);
      }
    else
      {
      op->vtkMNITagPointWriter::SetPatientIds(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_GetPatientIds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPatientIds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkIntArray *tempr = (ap.IsBound() ?
      op->GetPatientIds() :
      op->vtkMNITagPointWriter::GetPatientIds());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_SetComments(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetComments");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetComments(temp0);
      }
    else
      {
      op->vtkMNITagPointWriter::SetComments(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_GetComments(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetComments");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    char *tempr = (ap.IsBound() ?
      op->GetComments() :
      op->vtkMNITagPointWriter::GetComments());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_Write(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Write");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->Write() :
      op->vtkMNITagPointWriter::Write());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_GetMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    unsigned long tempr = (ap.IsBound() ?
      op->GetMTime() :
      op->vtkMNITagPointWriter::GetMTime());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetFileName(temp0);
      }
    else
      {
      op->vtkMNITagPointWriter::SetFileName(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkMNITagPointWriter_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMNITagPointWriter *op = static_cast<vtkMNITagPointWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkMNITagPointWriter::GetFileName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkMNITagPointWriter_Methods[] = {
  {"GetClassName", PyvtkMNITagPointWriter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkMNITagPointWriter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkMNITagPointWriter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMNITagPointWriter\nC++: vtkMNITagPointWriter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkMNITagPointWriter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkMNITagPointWriter\nC++: vtkMNITagPointWriter *SafeDownCast(vtkObject* o)\n\n"},
  {"GetFileExtensions", PyvtkMNITagPointWriter_GetFileExtensions, METH_VARARGS,
   "V.GetFileExtensions() -> string\nC++: virtual const char *GetFileExtensions()\n\nGet the entension for this file format.\n"},
  {"GetDescriptiveName", PyvtkMNITagPointWriter_GetDescriptiveName, METH_VARARGS,
   "V.GetDescriptiveName() -> string\nC++: virtual const char *GetDescriptiveName()\n\nGet the name of this file format.\n"},
  {"SetPoints", PyvtkMNITagPointWriter_SetPoints, METH_VARARGS,
   "V.SetPoints(int, vtkPoints)\nC++: virtual void SetPoints(int port, vtkPoints *points)\nV.SetPoints(vtkPoints)\nC++: virtual void SetPoints(vtkPoints *points)\n\nSet the points (unless you set them as inputs).\n"},
  {"GetPoints", PyvtkMNITagPointWriter_GetPoints, METH_VARARGS,
   "V.GetPoints(int) -> vtkPoints\nC++: virtual vtkPoints *GetPoints(int port)\nV.GetPoints() -> vtkPoints\nC++: virtual vtkPoints *GetPoints()\n\nSet the points (unless you set them as inputs).\n"},
  {"SetLabelText", PyvtkMNITagPointWriter_SetLabelText, METH_VARARGS,
   "V.SetLabelText(vtkStringArray)\nC++: virtual void SetLabelText(vtkStringArray *a)\n\nSet the labels (unless the input PointData has an array called\nLabelText). Labels are optional.\n"},
  {"GetLabelText", PyvtkMNITagPointWriter_GetLabelText, METH_VARARGS,
   "V.GetLabelText() -> vtkStringArray\nC++: vtkStringArray *GetLabelText()\n\nSet the labels (unless the input PointData has an array called\nLabelText). Labels are optional.\n"},
  {"SetWeights", PyvtkMNITagPointWriter_SetWeights, METH_VARARGS,
   "V.SetWeights(vtkDoubleArray)\nC++: virtual void SetWeights(vtkDoubleArray *a)\n\nSet the weights (unless the input PointData has an array called\nWeights).  Weights are optional.\n"},
  {"GetWeights", PyvtkMNITagPointWriter_GetWeights, METH_VARARGS,
   "V.GetWeights() -> vtkDoubleArray\nC++: vtkDoubleArray *GetWeights()\n\nSet the weights (unless the input PointData has an array called\nWeights).  Weights are optional.\n"},
  {"SetStructureIds", PyvtkMNITagPointWriter_SetStructureIds, METH_VARARGS,
   "V.SetStructureIds(vtkIntArray)\nC++: virtual void SetStructureIds(vtkIntArray *a)\n\nSet the structure ids (unless the input PointData has an array\ncalled StructureIds).  These are optional.\n"},
  {"GetStructureIds", PyvtkMNITagPointWriter_GetStructureIds, METH_VARARGS,
   "V.GetStructureIds() -> vtkIntArray\nC++: vtkIntArray *GetStructureIds()\n\nSet the structure ids (unless the input PointData has an array\ncalled StructureIds).  These are optional.\n"},
  {"SetPatientIds", PyvtkMNITagPointWriter_SetPatientIds, METH_VARARGS,
   "V.SetPatientIds(vtkIntArray)\nC++: virtual void SetPatientIds(vtkIntArray *a)\n\nSet the structure ids (unless the input PointData has an array\ncalled PatientIds).  These are optional.\n"},
  {"GetPatientIds", PyvtkMNITagPointWriter_GetPatientIds, METH_VARARGS,
   "V.GetPatientIds() -> vtkIntArray\nC++: vtkIntArray *GetPatientIds()\n\nSet the structure ids (unless the input PointData has an array\ncalled PatientIds).  These are optional.\n"},
  {"SetComments", PyvtkMNITagPointWriter_SetComments, METH_VARARGS,
   "V.SetComments(string)\nC++: void SetComments(char *)\n\nSet comments to be added to the file.\n"},
  {"GetComments", PyvtkMNITagPointWriter_GetComments, METH_VARARGS,
   "V.GetComments() -> string\nC++: char *GetComments()\n\nSet comments to be added to the file.\n"},
  {"Write", PyvtkMNITagPointWriter_Write, METH_VARARGS,
   "V.Write() -> int\nC++: virtual int Write()\n\nWrite the file.\n"},
  {"GetMTime", PyvtkMNITagPointWriter_GetMTime, METH_VARARGS,
   "V.GetMTime() -> int\nC++: virtual unsigned long GetMTime()\n\nGet the MTime.\n"},
  {"SetFileName", PyvtkMNITagPointWriter_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: void SetFileName(char *)\n\nSpecify file name of vtk polygon data file to write.\n"},
  {"GetFileName", PyvtkMNITagPointWriter_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: char *GetFileName()\n\nSpecify file name of vtk polygon data file to write.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkMNITagPointWriter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOMINCPython.vtkMNITagPointWriter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMNITagPointWriter_StaticNew()
{
  return vtkMNITagPointWriter::New();
}

PyObject *PyvtkMNITagPointWriter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkMNITagPointWriter_Type, PyvtkMNITagPointWriter_Methods,
    "vtkMNITagPointWriter",
    PyvtkMNITagPointWriter_Doc(), &PyvtkMNITagPointWriter_StaticNew);

  PyTypeObject *pytype = &PyvtkMNITagPointWriter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkWriter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkMNITagPointWriter_Doc()
{
  static const char *docstring[] = {
    "vtkMNITagPointWriter - A writer for MNI tag point files.\n\n",
    "Superclass: vtkWriter\n\n",
    "The MNI .tag file format is used to store tag points, for use in\neither registration or labelling of data volumes.  This file format\nwas developed at the McConnell Brain Imaging Centre at the Montreal\nNeurological Institute and is used by their software. Tag points can\nbe stored for either one volume or two volumes, and this filter can\ntake one or two inputs.  Alternatively, the points to be writt",
    "en can\nbe specified by calling SetPoints().\n\nSee Also:\n\nvtkMINCImageReader vtkMNIObjectReader vtkMNITransformReader\n\nThanks:\n\nThanks to David Gobbi for contributing this class to VTK.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkMNITagPointWriter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMNITagPointWriter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMNITagPointWriter", o) != 0)
    {
    Py_DECREF(o);
    }

}

