// python wrapper for vtkNetCDFCAMReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkNetCDFCAMReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkNetCDFCAMReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkNetCDFCAMReader_ClassNew(); }

#ifndef DECLARED_PyvtkUnstructuredGridAlgorithm_ClassNew
extern "C" { PyObject *PyvtkUnstructuredGridAlgorithm_ClassNew(); }
#define DECLARED_PyvtkUnstructuredGridAlgorithm_ClassNew
#endif

static const char **PyvtkNetCDFCAMReader_Doc();


static PyObject *
PyvtkNetCDFCAMReader_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkNetCDFCAMReader::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkNetCDFCAMReader::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkNetCDFCAMReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkNetCDFCAMReader::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkNetCDFCAMReader *tempr = vtkNetCDFCAMReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_CanReadFile(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "CanReadFile");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = vtkNetCDFCAMReader::CanReadFile(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetFileName(temp0);
      }
    else
      {
      op->vtkNetCDFCAMReader::SetFileName(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkNetCDFCAMReader::GetFileName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SetConnectivityFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetConnectivityFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetConnectivityFileName(temp0);
      }
    else
      {
      op->vtkNetCDFCAMReader::SetConnectivityFileName(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetConnectivityFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetConnectivityFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    char *tempr = (ap.IsBound() ?
      op->GetConnectivityFileName() :
      op->vtkNetCDFCAMReader::GetConnectivityFileName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SingleLevelOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SingleLevelOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SingleLevelOn();
      }
    else
      {
      op->vtkNetCDFCAMReader::SingleLevelOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SingleLevelOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SingleLevelOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SingleLevelOff();
      }
    else
      {
      op->vtkNetCDFCAMReader::SingleLevelOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SetSingleLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSingleLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetSingleLevel(temp0);
      }
    else
      {
      op->vtkNetCDFCAMReader::SetSingleLevel(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetSingleLevelMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSingleLevelMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetSingleLevelMinValue() :
      op->vtkNetCDFCAMReader::GetSingleLevelMinValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetSingleLevelMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSingleLevelMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetSingleLevelMaxValue() :
      op->vtkNetCDFCAMReader::GetSingleLevelMaxValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetSingleLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSingleLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetSingleLevel() :
      op->vtkNetCDFCAMReader::GetSingleLevel());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


#if !defined(VTK_LEGACY_REMOVE)
static PyObject *
PyvtkNetCDFCAMReader_SetCellLayerRight(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCellLayerRight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetCellLayerRight(temp0);
      }
    else
      {
      op->vtkNetCDFCAMReader::SetCellLayerRight(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}
#endif


#if !defined(VTK_LEGACY_REMOVE)
static PyObject *
PyvtkNetCDFCAMReader_GetCellLayerRight(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCellLayerRight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetCellLayerRight() :
      op->vtkNetCDFCAMReader::GetCellLayerRight());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}
#endif

static PyMethodDef PyvtkNetCDFCAMReader_Methods[] = {
  {"GetClassName", PyvtkNetCDFCAMReader_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkNetCDFCAMReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkNetCDFCAMReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkNetCDFCAMReader\nC++: vtkNetCDFCAMReader *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkNetCDFCAMReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkNetCDFCAMReader\nC++: vtkNetCDFCAMReader *SafeDownCast(vtkObject* o)\n\n"},
  {"CanReadFile", PyvtkNetCDFCAMReader_CanReadFile, METH_VARARGS,
   "V.CanReadFile(string) -> int\nC++: static int CanReadFile(const char *fileName)\n\nReturns 1 if this file can be read and 0 if the file cannot be\nread. Because NetCDF CAM files come in pairs and we only check\none of the files, the result is not definitive.  Invalid files\nmay still return 1 although a valid file will never return 0.\n"},
  {"SetFileName", PyvtkNetCDFCAMReader_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: void SetFileName(const char *fileName)\n\n"},
  {"GetFileName", PyvtkNetCDFCAMReader_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: char *GetFileName()\n\n"},
  {"SetConnectivityFileName", PyvtkNetCDFCAMReader_SetConnectivityFileName, METH_VARARGS,
   "V.SetConnectivityFileName(string)\nC++: void SetConnectivityFileName(const char *fileName)\n\n"},
  {"GetConnectivityFileName", PyvtkNetCDFCAMReader_GetConnectivityFileName, METH_VARARGS,
   "V.GetConnectivityFileName() -> string\nC++: char *GetConnectivityFileName()\n\n"},
  {"SingleLevelOn", PyvtkNetCDFCAMReader_SingleLevelOn, METH_VARARGS,
   "V.SingleLevelOn()\nC++: void SingleLevelOn()\n\nSet whether or not to read a single level.  A value of one\nindicates that only a single level will be read in. The NetCDF\nvariables loaded will then be ones with dimensions of (time,\nncols).  This will result in a surface grid. Otherwise a\nvolumetric grid will be created (if lev > 1) and the variables\nwith dimensions of (time, lev, ncols) will be read in. By\ndefault, SingleLevel = 0.\n"},
  {"SingleLevelOff", PyvtkNetCDFCAMReader_SingleLevelOff, METH_VARARGS,
   "V.SingleLevelOff()\nC++: void SingleLevelOff()\n\nSet whether or not to read a single level.  A value of one\nindicates that only a single level will be read in. The NetCDF\nvariables loaded will then be ones with dimensions of (time,\nncols).  This will result in a surface grid. Otherwise a\nvolumetric grid will be created (if lev > 1) and the variables\nwith dimensions of (time, lev, ncols) will be read in. By\ndefault, SingleLevel = 0.\n"},
  {"SetSingleLevel", PyvtkNetCDFCAMReader_SetSingleLevel, METH_VARARGS,
   "V.SetSingleLevel(int)\nC++: void SetSingleLevel(int)\n\nSet whether or not to read a single level.  A value of one\nindicates that only a single level will be read in. The NetCDF\nvariables loaded will then be ones with dimensions of (time,\nncols).  This will result in a surface grid. Otherwise a\nvolumetric grid will be created (if lev > 1) and the variables\nwith dimensions of (time, lev, ncols) will be read in. By\ndefault, SingleLevel = 0.\n"},
  {"GetSingleLevelMinValue", PyvtkNetCDFCAMReader_GetSingleLevelMinValue, METH_VARARGS,
   "V.GetSingleLevelMinValue() -> int\nC++: int GetSingleLevelMinValue()\n\nSet whether or not to read a single level.  A value of one\nindicates that only a single level will be read in. The NetCDF\nvariables loaded will then be ones with dimensions of (time,\nncols).  This will result in a surface grid. Otherwise a\nvolumetric grid will be created (if lev > 1) and the variables\nwith dimensions of (time, lev, ncols) will be read in. By\ndefault, SingleLevel = 0.\n"},
  {"GetSingleLevelMaxValue", PyvtkNetCDFCAMReader_GetSingleLevelMaxValue, METH_VARARGS,
   "V.GetSingleLevelMaxValue() -> int\nC++: int GetSingleLevelMaxValue()\n\nSet whether or not to read a single level.  A value of one\nindicates that only a single level will be read in. The NetCDF\nvariables loaded will then be ones with dimensions of (time,\nncols).  This will result in a surface grid. Otherwise a\nvolumetric grid will be created (if lev > 1) and the variables\nwith dimensions of (time, lev, ncols) will be read in. By\ndefault, SingleLevel = 0.\n"},
  {"GetSingleLevel", PyvtkNetCDFCAMReader_GetSingleLevel, METH_VARARGS,
   "V.GetSingleLevel() -> int\nC++: int GetSingleLevel()\n\nSet whether or not to read a single level.  A value of one\nindicates that only a single level will be read in. The NetCDF\nvariables loaded will then be ones with dimensions of (time,\nncols).  This will result in a surface grid. Otherwise a\nvolumetric grid will be created (if lev > 1) and the variables\nwith dimensions of (time, lev, ncols) will be read in. By\ndefault, SingleLevel = 0.\n"},
#if !defined(VTK_LEGACY_REMOVE)
  {"SetCellLayerRight", PyvtkNetCDFCAMReader_SetCellLayerRight, METH_VARARGS,
   "V.SetCellLayerRight(int)\nC++: void SetCellLayerRight(int)\n\nSpecify which \"side\" of the domain to add the connecting cells\nat.  0 indicates left side and 1 indicates right side. The\ndefault is the right side.@deprecated This method is no longer\nsupported. The reader automatically decides which side to pad\ncells on. Using this method has no effect.\n"},
#endif
#if !defined(VTK_LEGACY_REMOVE)
  {"GetCellLayerRight", PyvtkNetCDFCAMReader_GetCellLayerRight, METH_VARARGS,
   "V.GetCellLayerRight() -> int\nC++: int GetCellLayerRight()\n\nSpecify which \"side\" of the domain to add the connecting cells\nat.  0 indicates left side and 1 indicates right side. The\ndefault is the right side.@deprecated This method is no longer\nsupported. The reader automatically decides which side to pad\ncells on. Using this method has no effect.\n"},
#endif
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkNetCDFCAMReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIONetCDFPython.vtkNetCDFCAMReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkNetCDFCAMReader_StaticNew()
{
  return vtkNetCDFCAMReader::New();
}

PyObject *PyvtkNetCDFCAMReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkNetCDFCAMReader_Type, PyvtkNetCDFCAMReader_Methods,
    "vtkNetCDFCAMReader",
    PyvtkNetCDFCAMReader_Doc(), &PyvtkNetCDFCAMReader_StaticNew);

  PyTypeObject *pytype = &PyvtkNetCDFCAMReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkUnstructuredGridAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkNetCDFCAMReader_Doc()
{
  static const char *docstring[] = {
    "vtkNetCDFCAMReader - Read unstructured NetCDF CAM files.\n\n",
    "Superclass: vtkUnstructuredGridAlgorithm\n\n",
    "Reads in a NetCDF CAM (Community Atmospheric Model) file and produces\nand unstructured grid.  The grid is actually unstructured in the X\nand Y directions and rectilinear in the Z direction with all hex\ncells.  The reader requires 2 NetCDF files.  The first is the cell\nconnectivity file which has the quad connectivity in the plane. The\nother connectivity file has all of the point and field informat",
    "ion.\nCurrently this reader ignores time that may exist in the points file.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkNetCDFCAMReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkNetCDFCAMReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkNetCDFCAMReader", o) != 0)
    {
    Py_DECREF(o);
    }

}

