// python wrapper for vtkOpenGLContextBufferId
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkOpenGLContextBufferId.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOpenGLContextBufferId(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOpenGLContextBufferId_ClassNew(); }

#ifndef DECLARED_PyvtkAbstractContextBufferId_ClassNew
extern "C" { PyObject *PyvtkAbstractContextBufferId_ClassNew(); }
#define DECLARED_PyvtkAbstractContextBufferId_ClassNew
#endif

static const char **PyvtkOpenGLContextBufferId_Doc();


static PyObject *
PyvtkOpenGLContextBufferId_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLContextBufferId *op = static_cast<vtkOpenGLContextBufferId *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkOpenGLContextBufferId::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLContextBufferId_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLContextBufferId *op = static_cast<vtkOpenGLContextBufferId *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOpenGLContextBufferId::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLContextBufferId_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLContextBufferId *op = static_cast<vtkOpenGLContextBufferId *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkOpenGLContextBufferId *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOpenGLContextBufferId::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLContextBufferId_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkOpenGLContextBufferId *tempr = vtkOpenGLContextBufferId::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLContextBufferId_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLContextBufferId *op = static_cast<vtkOpenGLContextBufferId *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->ReleaseGraphicsResources();
      }
    else
      {
      op->vtkOpenGLContextBufferId::ReleaseGraphicsResources();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLContextBufferId_SetContext(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetContext");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLContextBufferId *op = static_cast<vtkOpenGLContextBufferId *>(vp);

  vtkRenderWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderWindow"))
    {
    if (ap.IsBound())
      {
      op->SetContext(temp0);
      }
    else
      {
      op->vtkOpenGLContextBufferId::SetContext(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLContextBufferId_GetContext(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetContext");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLContextBufferId *op = static_cast<vtkOpenGLContextBufferId *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkRenderWindow *tempr = (ap.IsBound() ?
      op->GetContext() :
      op->vtkOpenGLContextBufferId::GetContext());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLContextBufferId_IsSupported(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsSupported");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLContextBufferId *op = static_cast<vtkOpenGLContextBufferId *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->IsSupported() :
      op->vtkOpenGLContextBufferId::IsSupported());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLContextBufferId_Allocate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Allocate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLContextBufferId *op = static_cast<vtkOpenGLContextBufferId *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->Allocate();
      }
    else
      {
      op->vtkOpenGLContextBufferId::Allocate();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLContextBufferId_IsAllocated(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsAllocated");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLContextBufferId *op = static_cast<vtkOpenGLContextBufferId *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->IsAllocated() :
      op->vtkOpenGLContextBufferId::IsAllocated());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLContextBufferId_SetValues(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetValues");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLContextBufferId *op = static_cast<vtkOpenGLContextBufferId *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    if (ap.IsBound())
      {
      op->SetValues(temp0, temp1);
      }
    else
      {
      op->vtkOpenGLContextBufferId::SetValues(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLContextBufferId_GetPickedItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPickedItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLContextBufferId *op = static_cast<vtkOpenGLContextBufferId *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetPickedItem(temp0, temp1) :
      op->vtkOpenGLContextBufferId::GetPickedItem(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkOpenGLContextBufferId_Methods[] = {
  {"GetClassName", PyvtkOpenGLContextBufferId_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkOpenGLContextBufferId_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkOpenGLContextBufferId_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOpenGLContextBufferId\nC++: vtkOpenGLContextBufferId *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkOpenGLContextBufferId_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkOpenGLContextBufferId\nC++: vtkOpenGLContextBufferId *SafeDownCast(vtkObject* o)\n\n"},
  {"ReleaseGraphicsResources", PyvtkOpenGLContextBufferId_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources()\nC++: virtual void ReleaseGraphicsResources()\n\nRelease any graphics resources that are being consumed by this\nobject.\n"},
  {"SetContext", PyvtkOpenGLContextBufferId_SetContext, METH_VARARGS,
   "V.SetContext(vtkRenderWindow)\nC++: virtual void SetContext(vtkRenderWindow *context)\n\nSet/Get the OpenGL context owning the texture object resource.\n"},
  {"GetContext", PyvtkOpenGLContextBufferId_GetContext, METH_VARARGS,
   "V.GetContext() -> vtkRenderWindow\nC++: virtual vtkRenderWindow *GetContext()\n\nSet/Get the OpenGL context owning the texture object resource.\n"},
  {"IsSupported", PyvtkOpenGLContextBufferId_IsSupported, METH_VARARGS,
   "V.IsSupported() -> bool\nC++: virtual bool IsSupported()\n\nReturns if the context supports the required extensions.\n\\pre context_is_set: this->GetContext()!=0\n"},
  {"Allocate", PyvtkOpenGLContextBufferId_Allocate, METH_VARARGS,
   "V.Allocate()\nC++: virtual void Allocate()\n\nAllocate the memory for at least Width*Height elements.\n\\pre positive_width: GetWidth()>0\n\\pre positive_height: GetHeight()>0\n\\pre context_is_set: this->GetContext()!=0\n"},
  {"IsAllocated", PyvtkOpenGLContextBufferId_IsAllocated, METH_VARARGS,
   "V.IsAllocated() -> bool\nC++: virtual bool IsAllocated()\n\nTell if the buffer has been allocated.\n"},
  {"SetValues", PyvtkOpenGLContextBufferId_SetValues, METH_VARARGS,
   "V.SetValues(int, int)\nC++: virtual void SetValues(int srcXmin, int srcYmin)\n\nCopy the contents of the current read buffer to the internal\ntexture starting at lower left corner of the framebuffer\n(srcXmin,srcYmin).\n\\pre is_allocated: this->IsAllocated()\n"},
  {"GetPickedItem", PyvtkOpenGLContextBufferId_GetPickedItem, METH_VARARGS,
   "V.GetPickedItem(int, int) -> int\nC++: virtual vtkIdType GetPickedItem(int x, int y)\n\nReturn item under abscissa x and ordinate y. Abscissa go from\nleft to right. Ordinate go from bottom to top. The return value\nis -1 if there is no item.\n\\pre is_allocated: IsAllocated()\n\\post valid_result: result>=-1\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOpenGLContextBufferId_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingContextOpenGL2Python.vtkOpenGLContextBufferId", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOpenGLContextBufferId_StaticNew()
{
  return vtkOpenGLContextBufferId::New();
}

PyObject *PyvtkOpenGLContextBufferId_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOpenGLContextBufferId_Type, PyvtkOpenGLContextBufferId_Methods,
    "vtkOpenGLContextBufferId",
    PyvtkOpenGLContextBufferId_Doc(), &PyvtkOpenGLContextBufferId_StaticNew);

  PyTypeObject *pytype = &PyvtkOpenGLContextBufferId_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAbstractContextBufferId_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOpenGLContextBufferId_Doc()
{
  static const char *docstring[] = {
    "vtkOpenGLContextBufferId - 2D array of ids stored in VRAM.\n\n",
    "Superclass: vtkAbstractContextBufferId\n\n",
    "An 2D array where each element is the id of an entity drawn at the\ngiven pixel.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOpenGLContextBufferId(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOpenGLContextBufferId_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOpenGLContextBufferId", o) != 0)
    {
    Py_DECREF(o);
    }

}

