// python wrapper for vtkOpenGLShaderCache
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkOpenGLShaderCache.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOpenGLShaderCache(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOpenGLShaderCache_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkOpenGLShaderCache_Doc();


static PyObject *
PyvtkOpenGLShaderCache_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLShaderCache *op = static_cast<vtkOpenGLShaderCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkOpenGLShaderCache::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLShaderCache_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLShaderCache *op = static_cast<vtkOpenGLShaderCache *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOpenGLShaderCache::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLShaderCache_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLShaderCache *op = static_cast<vtkOpenGLShaderCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkOpenGLShaderCache *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOpenGLShaderCache::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLShaderCache_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkOpenGLShaderCache *tempr = vtkOpenGLShaderCache::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLShaderCache_ReadyShaderProgram_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReadyShaderProgram");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLShaderCache *op = static_cast<vtkOpenGLShaderCache *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  char *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
    {
    vtkShaderProgram *tempr = (ap.IsBound() ?
      op->ReadyShaderProgram(temp0, temp1, temp2) :
      op->vtkOpenGLShaderCache::ReadyShaderProgram(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyObject *
PyvtkOpenGLShaderCache_ReadyShaderProgram_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReadyShaderProgram");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLShaderCache *op = static_cast<vtkOpenGLShaderCache *>(vp);

  vtkShaderProgram *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkShaderProgram"))
    {
    vtkShaderProgram *tempr = (ap.IsBound() ?
      op->ReadyShaderProgram(temp0) :
      op->vtkOpenGLShaderCache::ReadyShaderProgram(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyObject *
PyvtkOpenGLShaderCache_ReadyShaderProgram(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 3:
      return PyvtkOpenGLShaderCache_ReadyShaderProgram_s1(self, args);
    case 1:
      return PyvtkOpenGLShaderCache_ReadyShaderProgram_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "ReadyShaderProgram");
  return NULL;
}



static PyObject *
PyvtkOpenGLShaderCache_ReleaseCurrentShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseCurrentShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLShaderCache *op = static_cast<vtkOpenGLShaderCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->ReleaseCurrentShader();
      }
    else
      {
      op->vtkOpenGLShaderCache::ReleaseCurrentShader();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLShaderCache_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLShaderCache *op = static_cast<vtkOpenGLShaderCache *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
    {
    if (ap.IsBound())
      {
      op->ReleaseGraphicsResources(temp0);
      }
    else
      {
      op->vtkOpenGLShaderCache::ReleaseGraphicsResources(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLShaderCache_ClearLastShaderBound(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ClearLastShaderBound");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLShaderCache *op = static_cast<vtkOpenGLShaderCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->ClearLastShaderBound();
      }
    else
      {
      op->vtkOpenGLShaderCache::ClearLastShaderBound();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLShaderCache_GetLastShaderBound(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastShaderBound");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLShaderCache *op = static_cast<vtkOpenGLShaderCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkShaderProgram *tempr = (ap.IsBound() ?
      op->GetLastShaderBound() :
      op->vtkOpenGLShaderCache::GetLastShaderBound());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkOpenGLShaderCache_Methods[] = {
  {"GetClassName", PyvtkOpenGLShaderCache_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkOpenGLShaderCache_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkOpenGLShaderCache_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOpenGLShaderCache\nC++: vtkOpenGLShaderCache *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkOpenGLShaderCache_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkOpenGLShaderCache\nC++: vtkOpenGLShaderCache *SafeDownCast(vtkObject* o)\n\n"},
  {"ReadyShaderProgram", PyvtkOpenGLShaderCache_ReadyShaderProgram, METH_VARARGS,
   "V.ReadyShaderProgram(string, string, string) -> vtkShaderProgram\nC++: virtual vtkShaderProgram *ReadyShaderProgram(\n    const char *vertexCode, const char *fragmentCode,\n    const char *geometryCode)\nV.ReadyShaderProgram(vtkShaderProgram) -> vtkShaderProgram\nC++: virtual vtkShaderProgram *ReadyShaderProgram(\n    vtkShaderProgram *shader)\n\n"},
  {"ReleaseCurrentShader", PyvtkOpenGLShaderCache_ReleaseCurrentShader, METH_VARARGS,
   "V.ReleaseCurrentShader()\nC++: void ReleaseCurrentShader()\n\nRelease the current shader.  Basically go back to having no\nshaders loaded.  This is useful for old legacy code that relies\non no shaders being loaded.\n"},
  {"ReleaseGraphicsResources", PyvtkOpenGLShaderCache_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: virtual void ReleaseGraphicsResources(vtkWindow *win)\n\nFree up any resources being used by the provided shader\n"},
  {"ClearLastShaderBound", PyvtkOpenGLShaderCache_ClearLastShaderBound, METH_VARARGS,
   "V.ClearLastShaderBound()\nC++: virtual void ClearLastShaderBound()\n\nGet/Clear the last Shader bound, called by shaders as they\nrelease their graphics resources\n"},
  {"GetLastShaderBound", PyvtkOpenGLShaderCache_GetLastShaderBound, METH_VARARGS,
   "V.GetLastShaderBound() -> vtkShaderProgram\nC++: vtkShaderProgram *GetLastShaderBound()\n\nGet/Clear the last Shader bound, called by shaders as they\nrelease their graphics resources\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOpenGLShaderCache_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkOpenGLShaderCache", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOpenGLShaderCache_StaticNew()
{
  return vtkOpenGLShaderCache::New();
}

PyObject *PyvtkOpenGLShaderCache_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOpenGLShaderCache_Type, PyvtkOpenGLShaderCache_Methods,
    "vtkOpenGLShaderCache",
    PyvtkOpenGLShaderCache_Doc(), &PyvtkOpenGLShaderCache_StaticNew);

  PyTypeObject *pytype = &PyvtkOpenGLShaderCache_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOpenGLShaderCache_Doc()
{
  static const char *docstring[] = {
    "vtkOpenGLShaderCache - manage Shader Programs within a context\n\n",
    "Superclass: vtkObject\n\n",
    "vtkOpenGLShaderCache manages shader program compilation and binding\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOpenGLShaderCache(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOpenGLShaderCache_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOpenGLShaderCache", o) != 0)
    {
    Py_DECREF(o);
    }

}

