// python wrapper for vtkOpenGLVertexArrayObject
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkOpenGLVertexArrayObject.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOpenGLVertexArrayObject(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOpenGLVertexArrayObject_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkOpenGLVertexArrayObject_Doc();


static PyObject *
PyvtkOpenGLVertexArrayObject_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexArrayObject *op = static_cast<vtkOpenGLVertexArrayObject *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkOpenGLVertexArrayObject::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexArrayObject_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexArrayObject *op = static_cast<vtkOpenGLVertexArrayObject *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOpenGLVertexArrayObject::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexArrayObject_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexArrayObject *op = static_cast<vtkOpenGLVertexArrayObject *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkOpenGLVertexArrayObject *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOpenGLVertexArrayObject::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexArrayObject_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkOpenGLVertexArrayObject *tempr = vtkOpenGLVertexArrayObject::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexArrayObject_Bind(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Bind");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexArrayObject *op = static_cast<vtkOpenGLVertexArrayObject *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->Bind();
      }
    else
      {
      op->vtkOpenGLVertexArrayObject::Bind();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexArrayObject_Release(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Release");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexArrayObject *op = static_cast<vtkOpenGLVertexArrayObject *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->Release();
      }
    else
      {
      op->vtkOpenGLVertexArrayObject::Release();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexArrayObject_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexArrayObject *op = static_cast<vtkOpenGLVertexArrayObject *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->ReleaseGraphicsResources();
      }
    else
      {
      op->vtkOpenGLVertexArrayObject::ReleaseGraphicsResources();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexArrayObject_ShaderProgramChanged(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ShaderProgramChanged");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexArrayObject *op = static_cast<vtkOpenGLVertexArrayObject *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->ShaderProgramChanged();
      }
    else
      {
      op->vtkOpenGLVertexArrayObject::ShaderProgramChanged();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexArrayObject_AddAttributeArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddAttributeArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexArrayObject *op = static_cast<vtkOpenGLVertexArrayObject *>(vp);

  vtkShaderProgram *temp0 = NULL;
  vtkOpenGLBufferObject *temp1 = NULL;
  std::string temp2;
  int temp3;
  size_t temp4;
  int temp5;
  int temp6;
  bool temp7 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(8) &&
      ap.GetVTKObject(temp0, "vtkShaderProgram") &&
      ap.GetVTKObject(temp1, "vtkOpenGLBufferObject") &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetValue(temp5) &&
      ap.GetValue(temp6) &&
      ap.GetValue(temp7))
    {
    bool tempr = (ap.IsBound() ?
      op->AddAttributeArray(temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7) :
      op->vtkOpenGLVertexArrayObject::AddAttributeArray(temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexArrayObject_AddAttributeArrayWithDivisor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddAttributeArrayWithDivisor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexArrayObject *op = static_cast<vtkOpenGLVertexArrayObject *>(vp);

  vtkShaderProgram *temp0 = NULL;
  vtkOpenGLBufferObject *temp1 = NULL;
  std::string temp2;
  int temp3;
  size_t temp4;
  int temp5;
  int temp6;
  bool temp7 = false;
  int temp8;
  bool temp9 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(10) &&
      ap.GetVTKObject(temp0, "vtkShaderProgram") &&
      ap.GetVTKObject(temp1, "vtkOpenGLBufferObject") &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetValue(temp5) &&
      ap.GetValue(temp6) &&
      ap.GetValue(temp7) &&
      ap.GetValue(temp8) &&
      ap.GetValue(temp9))
    {
    bool tempr = (ap.IsBound() ?
      op->AddAttributeArrayWithDivisor(temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7, temp8, temp9) :
      op->vtkOpenGLVertexArrayObject::AddAttributeArrayWithDivisor(temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7, temp8, temp9));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexArrayObject_AddAttributeMatrixWithDivisor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddAttributeMatrixWithDivisor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexArrayObject *op = static_cast<vtkOpenGLVertexArrayObject *>(vp);

  vtkShaderProgram *temp0 = NULL;
  vtkOpenGLBufferObject *temp1 = NULL;
  std::string temp2;
  int temp3;
  size_t temp4;
  int temp5;
  int temp6;
  bool temp7 = false;
  int temp8;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(9) &&
      ap.GetVTKObject(temp0, "vtkShaderProgram") &&
      ap.GetVTKObject(temp1, "vtkOpenGLBufferObject") &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetValue(temp5) &&
      ap.GetValue(temp6) &&
      ap.GetValue(temp7) &&
      ap.GetValue(temp8))
    {
    bool tempr = (ap.IsBound() ?
      op->AddAttributeMatrixWithDivisor(temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7, temp8) :
      op->vtkOpenGLVertexArrayObject::AddAttributeMatrixWithDivisor(temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7, temp8));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexArrayObject_RemoveAttributeArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAttributeArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexArrayObject *op = static_cast<vtkOpenGLVertexArrayObject *>(vp);

  std::string temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    bool tempr = (ap.IsBound() ?
      op->RemoveAttributeArray(temp0) :
      op->vtkOpenGLVertexArrayObject::RemoveAttributeArray(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexArrayObject_SetForceEmulation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetForceEmulation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexArrayObject *op = static_cast<vtkOpenGLVertexArrayObject *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetForceEmulation(temp0);
      }
    else
      {
      op->vtkOpenGLVertexArrayObject::SetForceEmulation(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkOpenGLVertexArrayObject_Methods[] = {
  {"GetClassName", PyvtkOpenGLVertexArrayObject_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkOpenGLVertexArrayObject_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkOpenGLVertexArrayObject_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOpenGLVertexArrayObject\nC++: vtkOpenGLVertexArrayObject *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkOpenGLVertexArrayObject_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkOpenGLVertexArrayObject\nC++: vtkOpenGLVertexArrayObject *SafeDownCast(vtkObject* o)\n\n"},
  {"Bind", PyvtkOpenGLVertexArrayObject_Bind, METH_VARARGS,
   "V.Bind()\nC++: void Bind()\n\n"},
  {"Release", PyvtkOpenGLVertexArrayObject_Release, METH_VARARGS,
   "V.Release()\nC++: void Release()\n\n"},
  {"ReleaseGraphicsResources", PyvtkOpenGLVertexArrayObject_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources()\nC++: void ReleaseGraphicsResources()\n\n"},
  {"ShaderProgramChanged", PyvtkOpenGLVertexArrayObject_ShaderProgramChanged, METH_VARARGS,
   "V.ShaderProgramChanged()\nC++: void ShaderProgramChanged()\n\n"},
  {"AddAttributeArray", PyvtkOpenGLVertexArrayObject_AddAttributeArray, METH_VARARGS,
   "V.AddAttributeArray(vtkShaderProgram, vtkOpenGLBufferObject,\n    string, int, int, int, int, bool) -> bool\nC++: bool AddAttributeArray(vtkShaderProgram *program,\n    vtkOpenGLBufferObject *buffer, const std::string &name,\n    int offset, size_t stride, int elementType,\n    int elementTupleSize, bool normalize)\n\n"},
  {"AddAttributeArrayWithDivisor", PyvtkOpenGLVertexArrayObject_AddAttributeArrayWithDivisor, METH_VARARGS,
   "V.AddAttributeArrayWithDivisor(vtkShaderProgram,\n    vtkOpenGLBufferObject, string, int, int, int, int, bool, int,\n    bool) -> bool\nC++: bool AddAttributeArrayWithDivisor(vtkShaderProgram *program,\n    vtkOpenGLBufferObject *buffer, const std::string &name,\n    int offset, size_t stride, int elementType,\n    int elementTupleSize, bool normalize, int divisor,\n    bool isMatrix)\n\n"},
  {"AddAttributeMatrixWithDivisor", PyvtkOpenGLVertexArrayObject_AddAttributeMatrixWithDivisor, METH_VARARGS,
   "V.AddAttributeMatrixWithDivisor(vtkShaderProgram,\n    vtkOpenGLBufferObject, string, int, int, int, int, bool, int)\n    -> bool\nC++: bool AddAttributeMatrixWithDivisor(vtkShaderProgram *program,\n     vtkOpenGLBufferObject *buffer, const std::string &name,\n    int offset, size_t stride, int elementType,\n    int elementTupleSize, bool normalize, int divisor)\n\n"},
  {"RemoveAttributeArray", PyvtkOpenGLVertexArrayObject_RemoveAttributeArray, METH_VARARGS,
   "V.RemoveAttributeArray(string) -> bool\nC++: bool RemoveAttributeArray(const std::string &name)\n\n"},
  {"SetForceEmulation", PyvtkOpenGLVertexArrayObject_SetForceEmulation, METH_VARARGS,
   "V.SetForceEmulation(bool)\nC++: void SetForceEmulation(bool val)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOpenGLVertexArrayObject_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkOpenGLVertexArrayObject", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOpenGLVertexArrayObject_StaticNew()
{
  return vtkOpenGLVertexArrayObject::New();
}

PyObject *PyvtkOpenGLVertexArrayObject_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOpenGLVertexArrayObject_Type, PyvtkOpenGLVertexArrayObject_Methods,
    "vtkOpenGLVertexArrayObject",
    PyvtkOpenGLVertexArrayObject_Doc(), &PyvtkOpenGLVertexArrayObject_StaticNew);

  PyTypeObject *pytype = &PyvtkOpenGLVertexArrayObject_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOpenGLVertexArrayObject_Doc()
{
  static const char *docstring[] = {
    "vtkOpenGLVertexArrayObject - no description provided.\n\n",
    "Superclass: vtkObject\n\n",
    "\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOpenGLVertexArrayObject(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOpenGLVertexArrayObject_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOpenGLVertexArrayObject", o) != 0)
    {
    Py_DECREF(o);
    }

}

