// python wrapper for vtkOpenGLVertexBufferObject
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkOpenGLVertexBufferObject.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOpenGLVertexBufferObject(PyObject *); }

static const char **Pyvtkucfloat_Doc();

static PyMethodDef Pyvtkucfloat_Methods[] = {
  {NULL, NULL, 0, NULL}
};


static PyObject *
Pyvtkucfloat_vtkucfloat(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkucfloat");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
    {
    vtkucfloat *op = new vtkucfloat();

    result = PyVTKSpecialObject_New("vtkucfloat", op);
    }

  return result;
}

static PyMethodDef Pyvtkucfloat_vtkucfloat_Methods[] = {
  {NULL, NULL, 0, NULL}
};

static PyObject *
Pyvtkucfloat_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
    {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
    }

  return Pyvtkucfloat_vtkucfloat(NULL, args);
}

static void Pyvtkucfloat_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkucfloat *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t Pyvtkucfloat_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject Pyvtkucfloat_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkucfloat", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  Pyvtkucfloat_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  Pyvtkucfloat_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  Pyvtkucfloat_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *Pyvtkucfloat_CCopy(const void *obj)
{
  if (obj)
    {
    return new vtkucfloat(*static_cast<const vtkucfloat*>(obj));
    }
  return 0;
}

extern "C" { VTK_ABI_EXPORT PyObject *Pyvtkucfloat_TypeNew(); }

PyObject *Pyvtkucfloat_TypeNew()
{
  PyVTKSpecialType_Add(
    &Pyvtkucfloat_Type,
    Pyvtkucfloat_Methods,
    Pyvtkucfloat_vtkucfloat_Methods,
    Pyvtkucfloat_Doc(), &Pyvtkucfloat_CCopy);

  PyTypeObject *pytype = &Pyvtkucfloat_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **Pyvtkucfloat_Doc()
{
  static const char *docstring[] = {
    "vtkucfloat - no description provided.\n\n",
    "\n\n",
    "V.vtkucfloat()\nC++: vtkucfloat()\n",
    NULL
  };

  return docstring;
}

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOpenGLVertexBufferObject_ClassNew(); }

#ifndef DECLARED_PyvtkOpenGLBufferObject_ClassNew
extern "C" { PyObject *PyvtkOpenGLBufferObject_ClassNew(); }
#define DECLARED_PyvtkOpenGLBufferObject_ClassNew
#endif

static const char **PyvtkOpenGLVertexBufferObject_Doc();


static PyObject *
PyvtkOpenGLVertexBufferObject_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexBufferObject *op = static_cast<vtkOpenGLVertexBufferObject *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkOpenGLVertexBufferObject::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexBufferObject_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexBufferObject *op = static_cast<vtkOpenGLVertexBufferObject *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOpenGLVertexBufferObject::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexBufferObject_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexBufferObject *op = static_cast<vtkOpenGLVertexBufferObject *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkOpenGLVertexBufferObject *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOpenGLVertexBufferObject::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexBufferObject_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkOpenGLVertexBufferObject *tempr = vtkOpenGLVertexBufferObject::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexBufferObject_CreateVBO(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateVBO");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexBufferObject *op = static_cast<vtkOpenGLVertexBufferObject *>(vp);

  vtkPoints *temp0 = NULL;
  unsigned int temp1;
  vtkDataArray *temp2 = NULL;
  vtkDataArray *temp3 = NULL;
  unsigned char *temp4 = NULL;
  unsigned char *save4 = NULL;
  unsigned char small4[8];
  int size4 = 0;
  int temp5;
  PyObject *result = NULL;

  if (op)
    {
    size4 = ap.GetArgSize(4);
    temp4 = small4;
    if (size4 > 4)
      {
      temp4 = new unsigned char[2*size4];
      }
    save4 = &temp4[size4];
    }

  if (op && ap.CheckArgCount(6) &&
      ap.GetVTKObject(temp0, "vtkPoints") &&
      ap.GetValue(temp1) &&
      ap.GetVTKObject(temp2, "vtkDataArray") &&
      ap.GetVTKObject(temp3, "vtkDataArray") &&
      ap.GetArray(temp4, size4) &&
      ap.GetValue(temp5))
    {
    ap.SaveArray(temp4, save4, size4);

    if (ap.IsBound())
      {
      op->CreateVBO(temp0, temp1, temp2, temp3, temp4, temp5);
      }
    else
      {
      op->vtkOpenGLVertexBufferObject::CreateVBO(temp0, temp1, temp2, temp3, temp4, temp5);
      }

    if (ap.ArrayHasChanged(temp4, save4, size4) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(4, temp4, size4);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  if (temp4 != small4)
    {
    delete [] temp4;
    }

  return result;
}


static PyObject *
PyvtkOpenGLVertexBufferObject_AppendVBO(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AppendVBO");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLVertexBufferObject *op = static_cast<vtkOpenGLVertexBufferObject *>(vp);

  vtkPoints *temp0 = NULL;
  unsigned int temp1;
  vtkDataArray *temp2 = NULL;
  vtkDataArray *temp3 = NULL;
  unsigned char *temp4 = NULL;
  unsigned char *save4 = NULL;
  unsigned char small4[8];
  int size4 = 0;
  int temp5;
  PyObject *result = NULL;

  if (op)
    {
    size4 = ap.GetArgSize(4);
    temp4 = small4;
    if (size4 > 4)
      {
      temp4 = new unsigned char[2*size4];
      }
    save4 = &temp4[size4];
    }

  if (op && ap.CheckArgCount(6) &&
      ap.GetVTKObject(temp0, "vtkPoints") &&
      ap.GetValue(temp1) &&
      ap.GetVTKObject(temp2, "vtkDataArray") &&
      ap.GetVTKObject(temp3, "vtkDataArray") &&
      ap.GetArray(temp4, size4) &&
      ap.GetValue(temp5))
    {
    ap.SaveArray(temp4, save4, size4);

    if (ap.IsBound())
      {
      op->AppendVBO(temp0, temp1, temp2, temp3, temp4, temp5);
      }
    else
      {
      op->vtkOpenGLVertexBufferObject::AppendVBO(temp0, temp1, temp2, temp3, temp4, temp5);
      }

    if (ap.ArrayHasChanged(temp4, save4, size4) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(4, temp4, size4);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  if (temp4 != small4)
    {
    delete [] temp4;
    }

  return result;
}

static PyMethodDef PyvtkOpenGLVertexBufferObject_Methods[] = {
  {"GetClassName", PyvtkOpenGLVertexBufferObject_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkOpenGLVertexBufferObject_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkOpenGLVertexBufferObject_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOpenGLVertexBufferObject\nC++: vtkOpenGLVertexBufferObject *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkOpenGLVertexBufferObject_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkOpenGLVertexBufferObject\nC++: vtkOpenGLVertexBufferObject *SafeDownCast(vtkObject* o)\n\n"},
  {"CreateVBO", PyvtkOpenGLVertexBufferObject_CreateVBO, METH_VARARGS,
   "V.CreateVBO(vtkPoints, int, vtkDataArray, vtkDataArray, [int,\n    ...], int)\nC++: void CreateVBO(vtkPoints *points, unsigned int numPoints,\n    vtkDataArray *normals, vtkDataArray *tcoords,\n    unsigned char *colors, int colorComponents)\n\n"},
  {"AppendVBO", PyvtkOpenGLVertexBufferObject_AppendVBO, METH_VARARGS,
   "V.AppendVBO(vtkPoints, int, vtkDataArray, vtkDataArray, [int,\n    ...], int)\nC++: void AppendVBO(vtkPoints *points, unsigned int numPoints,\n    vtkDataArray *normals, vtkDataArray *tcoords,\n    unsigned char *colors, int colorComponents)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOpenGLVertexBufferObject_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkOpenGLVertexBufferObject", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOpenGLVertexBufferObject_StaticNew()
{
  return vtkOpenGLVertexBufferObject::New();
}

PyObject *PyvtkOpenGLVertexBufferObject_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOpenGLVertexBufferObject_Type, PyvtkOpenGLVertexBufferObject_Methods,
    "vtkOpenGLVertexBufferObject",
    PyvtkOpenGLVertexBufferObject_Doc(), &PyvtkOpenGLVertexBufferObject_StaticNew);

  PyTypeObject *pytype = &PyvtkOpenGLVertexBufferObject_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkOpenGLBufferObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOpenGLVertexBufferObject_Doc()
{
  static const char *docstring[] = {
    "vtkOpenGLVertexBufferObject - no description provided.\n\n",
    "Superclass: vtkOpenGLBufferObject\n\n",
    "\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOpenGLVertexBufferObject(
  PyObject *dict)
{
  PyObject *o;
  o = Pyvtkucfloat_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkucfloat", o) != 0)
    {
    Py_DECREF(o);
    }

  o = PyvtkOpenGLVertexBufferObject_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOpenGLVertexBufferObject", o) != 0)
    {
    Py_DECREF(o);
    }

}

