// python wrapper for vtkOverrideInformationCollection
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkOverrideInformationCollection.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOverrideInformationCollection(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOverrideInformationCollection_ClassNew(); }

#ifndef DECLARED_PyvtkCollection_ClassNew
extern "C" { PyObject *PyvtkCollection_ClassNew(); }
#define DECLARED_PyvtkCollection_ClassNew
#endif

static const char **PyvtkOverrideInformationCollection_Doc();


static PyObject *
PyvtkOverrideInformationCollection_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOverrideInformationCollection *op = static_cast<vtkOverrideInformationCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkOverrideInformationCollection::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOverrideInformationCollection_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOverrideInformationCollection *op = static_cast<vtkOverrideInformationCollection *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOverrideInformationCollection::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOverrideInformationCollection_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOverrideInformationCollection *op = static_cast<vtkOverrideInformationCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkOverrideInformationCollection *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOverrideInformationCollection::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkOverrideInformationCollection_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkOverrideInformationCollection *tempr = vtkOverrideInformationCollection::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkOverrideInformationCollection_AddItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOverrideInformationCollection *op = static_cast<vtkOverrideInformationCollection *>(vp);

  vtkOverrideInformation *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkOverrideInformation"))
    {
    if (ap.IsBound())
      {
      op->AddItem(temp0);
      }
    else
      {
      op->vtkOverrideInformationCollection::AddItem(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkOverrideInformationCollection_GetNextItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNextItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOverrideInformationCollection *op = static_cast<vtkOverrideInformationCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkOverrideInformation *tempr = (ap.IsBound() ?
      op->GetNextItem() :
      op->vtkOverrideInformationCollection::GetNextItem());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkOverrideInformationCollection_Methods[] = {
  {"GetClassName", PyvtkOverrideInformationCollection_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkOverrideInformationCollection_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkOverrideInformationCollection_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOverrideInformationCollection\nC++: vtkOverrideInformationCollection *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkOverrideInformationCollection_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkOverrideInformationCollection\nC++: vtkOverrideInformationCollection *SafeDownCast(vtkObject* o)\n\n"},
  {"AddItem", PyvtkOverrideInformationCollection_AddItem, METH_VARARGS,
   "V.AddItem(vtkOverrideInformation)\nC++: void AddItem(vtkOverrideInformation *)\n\nAdd a OverrideInformation to the list.\n"},
  {"GetNextItem", PyvtkOverrideInformationCollection_GetNextItem, METH_VARARGS,
   "V.GetNextItem() -> vtkOverrideInformation\nC++: vtkOverrideInformation *GetNextItem()\n\nGet the next OverrideInformation in the list.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOverrideInformationCollection_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkOverrideInformationCollection", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOverrideInformationCollection_StaticNew()
{
  return vtkOverrideInformationCollection::New();
}

PyObject *PyvtkOverrideInformationCollection_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOverrideInformationCollection_Type, PyvtkOverrideInformationCollection_Methods,
    "vtkOverrideInformationCollection",
    PyvtkOverrideInformationCollection_Doc(), &PyvtkOverrideInformationCollection_StaticNew);

  PyTypeObject *pytype = &PyvtkOverrideInformationCollection_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkCollection_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOverrideInformationCollection_Doc()
{
  static const char *docstring[] = {
    "vtkOverrideInformationCollection - maintain a list of override\ninformation objects\n\n",
    "Superclass: vtkCollection\n\n",
    "vtkOverrideInformationCollection is an object that creates and\nmanipulates lists of objects of type vtkOverrideInformation.\n\nSee Also:\n\nvtkCollection\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOverrideInformationCollection(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOverrideInformationCollection_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOverrideInformationCollection", o) != 0)
    {
    Py_DECREF(o);
    }

}

