// python wrapper for vtkPCAAnalysisFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkPCAAnalysisFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPCAAnalysisFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPCAAnalysisFilter_ClassNew(); }

#ifndef DECLARED_PyvtkMultiBlockDataSetAlgorithm_ClassNew
extern "C" { PyObject *PyvtkMultiBlockDataSetAlgorithm_ClassNew(); }
#define DECLARED_PyvtkMultiBlockDataSetAlgorithm_ClassNew
#endif

static const char **PyvtkPCAAnalysisFilter_Doc();


static PyObject *
PyvtkPCAAnalysisFilter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPCAAnalysisFilter *op = static_cast<vtkPCAAnalysisFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPCAAnalysisFilter::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPCAAnalysisFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPCAAnalysisFilter *op = static_cast<vtkPCAAnalysisFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPCAAnalysisFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPCAAnalysisFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPCAAnalysisFilter *op = static_cast<vtkPCAAnalysisFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkPCAAnalysisFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPCAAnalysisFilter::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkPCAAnalysisFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkPCAAnalysisFilter *tempr = vtkPCAAnalysisFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPCAAnalysisFilter_GetEvals(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEvals");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPCAAnalysisFilter *op = static_cast<vtkPCAAnalysisFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkFloatArray *tempr = (ap.IsBound() ?
      op->GetEvals() :
      op->vtkPCAAnalysisFilter::GetEvals());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPCAAnalysisFilter_GetParameterisedShape(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterisedShape");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPCAAnalysisFilter *op = static_cast<vtkPCAAnalysisFilter *>(vp);

  vtkFloatArray *temp0 = NULL;
  vtkPointSet *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkFloatArray") &&
      ap.GetVTKObject(temp1, "vtkPointSet"))
    {
    if (ap.IsBound())
      {
      op->GetParameterisedShape(temp0, temp1);
      }
    else
      {
      op->vtkPCAAnalysisFilter::GetParameterisedShape(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPCAAnalysisFilter_GetShapeParameters(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShapeParameters");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPCAAnalysisFilter *op = static_cast<vtkPCAAnalysisFilter *>(vp);

  vtkPointSet *temp0 = NULL;
  vtkFloatArray *temp1 = NULL;
  int temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkPointSet") &&
      ap.GetVTKObject(temp1, "vtkFloatArray") &&
      ap.GetValue(temp2))
    {
    if (ap.IsBound())
      {
      op->GetShapeParameters(temp0, temp1, temp2);
      }
    else
      {
      op->vtkPCAAnalysisFilter::GetShapeParameters(temp0, temp1, temp2);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPCAAnalysisFilter_GetModesRequiredFor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetModesRequiredFor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPCAAnalysisFilter *op = static_cast<vtkPCAAnalysisFilter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->GetModesRequiredFor(temp0) :
      op->vtkPCAAnalysisFilter::GetModesRequiredFor(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkPCAAnalysisFilter_Methods[] = {
  {"GetClassName", PyvtkPCAAnalysisFilter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPCAAnalysisFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPCAAnalysisFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPCAAnalysisFilter\nC++: vtkPCAAnalysisFilter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPCAAnalysisFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPCAAnalysisFilter\nC++: vtkPCAAnalysisFilter *SafeDownCast(vtkObject* o)\n\n"},
  {"GetEvals", PyvtkPCAAnalysisFilter_GetEvals, METH_VARARGS,
   "V.GetEvals() -> vtkFloatArray\nC++: vtkFloatArray *GetEvals()\n\nGet the vector of eigenvalues sorted in descending order\n"},
  {"GetParameterisedShape", PyvtkPCAAnalysisFilter_GetParameterisedShape, METH_VARARGS,
   "V.GetParameterisedShape(vtkFloatArray, vtkPointSet)\nC++: void GetParameterisedShape(vtkFloatArray *b,\n    vtkPointSet *shape)\n\nFills the shape with:\n\nmean + b[0] * sqrt(eigenvalue[0]) * eigenvector[0]\n     + b[1] * sqrt(eigenvalue[1]) * eigenvector[1] ...\n     + b[sizeb-1] * sqrt(eigenvalue[bsize-1]) *\neigenvector[bsize-1]\n\nhere b are the parameters expressed in standard deviations bsize\nis the number of parameters in the b vector This function assumes\nthat shape is already allocated with the right size, it just\nmoves the points.\n"},
  {"GetShapeParameters", PyvtkPCAAnalysisFilter_GetShapeParameters, METH_VARARGS,
   "V.GetShapeParameters(vtkPointSet, vtkFloatArray, int)\nC++: void GetShapeParameters(vtkPointSet *shape, vtkFloatArray *b,\n     int bsize)\n\nReturn the bsize parameters b that best model the given shape (in\nstandard deviations). That is that the given shape will be\napproximated by:\n\nshape ~ mean + b[0] * sqrt(eigenvalue[0]) * eigenvector[0]\n             + b[1] * sqrt(eigenvalue[1]) * eigenvector[1]\n        ...\n             + b[bsize-1] * sqrt(eigenvalue[bsize-1]) *\neigenvector[bsize-1]\n"},
  {"GetModesRequiredFor", PyvtkPCAAnalysisFilter_GetModesRequiredFor, METH_VARARGS,
   "V.GetModesRequiredFor(float) -> int\nC++: int GetModesRequiredFor(double proportion)\n\nRetrieve how many modes are necessary to model the given\nproportion of the variation. proportion should be between 0 and 1\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPCAAnalysisFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersHybridPython.vtkPCAAnalysisFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPCAAnalysisFilter_StaticNew()
{
  return vtkPCAAnalysisFilter::New();
}

PyObject *PyvtkPCAAnalysisFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPCAAnalysisFilter_Type, PyvtkPCAAnalysisFilter_Methods,
    "vtkPCAAnalysisFilter",
    PyvtkPCAAnalysisFilter_Doc(), &PyvtkPCAAnalysisFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkPCAAnalysisFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMultiBlockDataSetAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPCAAnalysisFilter_Doc()
{
  static const char *docstring[] = {
    "vtkPCAAnalysisFilter - Performs principal component analysis of a set\nof aligned pointsets\n\n",
    "Superclass: vtkMultiBlockDataSetAlgorithm\n\n",
    "vtkPCAAnalysisFilter is a filter that takes as input a set of aligned\npointsets (any object derived from vtkPointSet) and performs a\nprincipal component analysis of the coordinates. This can be used to\nvisualise the major or minor modes of variation seen in a set of\nsimilar biological objects with corresponding landmarks.\nvtkPCAAnalysisFilter is designed to work with the output from the\nvtkProcrus",
    "tesAnalysisFilter vtkPCAAnalysisFilter requires a\nvtkMultiBlock input consisting of vtkPointSets as first level\nchildren.\n\nvtkPCAAnalysisFilter is an implementation of (for example):\n\nT. Cootes et al. : Active Shape Models - their training and\napplication. Computer Vision and Image Understanding, 61(1):38-59,\n1995.\n\nThe material can also be found in Tim Cootes' ever-changing online\nreport publishe",
    "d at his website: http://www.isbe.man.ac.uk/~bim/\n\nCaveats:\n\nAll of the input pointsets must have the same number of points.\n\nThanks:\n\nRasmus Paulsen and Tim Hutton who developed and contributed this\nclass\n\nSee Also:\n\nvtkProcrustesAlignmentFilter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPCAAnalysisFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPCAAnalysisFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPCAAnalysisFilter", o) != 0)
    {
    Py_DECREF(o);
    }

}

