// python wrapper for vtkPLYReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkPLYReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPLYReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPLYReader_ClassNew(); }

#ifndef DECLARED_PyvtkAbstractPolyDataReader_ClassNew
extern "C" { PyObject *PyvtkAbstractPolyDataReader_ClassNew(); }
#define DECLARED_PyvtkAbstractPolyDataReader_ClassNew
#endif

static const char **PyvtkPLYReader_Doc();


static PyObject *
PyvtkPLYReader_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPLYReader *op = static_cast<vtkPLYReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPLYReader::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPLYReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPLYReader *op = static_cast<vtkPLYReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPLYReader::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPLYReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPLYReader *op = static_cast<vtkPLYReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkPLYReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPLYReader::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkPLYReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkPLYReader *tempr = vtkPLYReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPLYReader_CanReadFile(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "CanReadFile");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = vtkPLYReader::CanReadFile(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkPLYReader_Methods[] = {
  {"GetClassName", PyvtkPLYReader_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPLYReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPLYReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPLYReader\nC++: vtkPLYReader *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPLYReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPLYReader\nC++: vtkPLYReader *SafeDownCast(vtkObject* o)\n\n"},
  {"CanReadFile", PyvtkPLYReader_CanReadFile, METH_VARARGS,
   "V.CanReadFile(string) -> int\nC++: static int CanReadFile(const char *filename)\n\nA simple, non-exhaustive check to see if a file is a valid ply\nfile.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPLYReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOPLYPython.vtkPLYReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPLYReader_StaticNew()
{
  return vtkPLYReader::New();
}

PyObject *PyvtkPLYReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPLYReader_Type, PyvtkPLYReader_Methods,
    "vtkPLYReader",
    PyvtkPLYReader_Doc(), &PyvtkPLYReader_StaticNew);

  PyTypeObject *pytype = &PyvtkPLYReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAbstractPolyDataReader_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPLYReader_Doc()
{
  static const char *docstring[] = {
    "vtkPLYReader - read Stanford University PLY polygonal file format\n\n",
    "Superclass: vtkAbstractPolyDataReader\n\n",
    "vtkPLYReader is a source object that reads polygonal data in Stanford\nUniversity PLY file format (see\nhttp://graphics.stanford.edu/data/3Dscanrep). It requires that the\nelements \"vertex\" and \"face\" are defined. The \"vertex\" element must\nhave the properties \"x\", \"y\", and \"z\". The \"face\" element must have\nthe property \"vertex_indices\" defined. Optionally, if the \"face\"\nelement has the properties \"in",
    "tensity\" and/or the triplet \"red\",\n\"green\", and \"blue\"; these are read and added as scalars to the\noutput data.\n\nSee Also:\n\nvtkPLYWriter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPLYReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPLYReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPLYReader", o) != 0)
    {
    Py_DECREF(o);
    }

}

