// python wrapper for vtkPTSReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkPTSReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPTSReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPTSReader_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkPTSReader_Doc();


static PyObject *
PyvtkPTSReader_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPTSReader::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPTSReader::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkPTSReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPTSReader::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkPTSReader *tempr = vtkPTSReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetFileName(temp0);
      }
    else
      {
      op->vtkPTSReader::SetFileName(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkPTSReader::GetFileName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_LimitReadToBoundsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LimitReadToBoundsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->LimitReadToBoundsOn();
      }
    else
      {
      op->vtkPTSReader::LimitReadToBoundsOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_LimitReadToBoundsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LimitReadToBoundsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->LimitReadToBoundsOff();
      }
    else
      {
      op->vtkPTSReader::LimitReadToBoundsOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_SetLimitReadToBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLimitReadToBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetLimitReadToBounds(temp0);
      }
    else
      {
      op->vtkPTSReader::SetLimitReadToBounds(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_GetLimitReadToBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLimitReadToBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->GetLimitReadToBounds() :
      op->vtkPTSReader::GetLimitReadToBounds());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_SetReadBounds_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetReadBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  double temp4;
  double temp5;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetValue(temp5))
    {
    if (ap.IsBound())
      {
      op->SetReadBounds(temp0, temp1, temp2, temp3, temp4, temp5);
      }
    else
      {
      op->vtkPTSReader::SetReadBounds(temp0, temp1, temp2, temp3, temp4, temp5);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkPTSReader_SetReadBounds_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetReadBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  double temp0[6];
  const int size0 = 6;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    if (ap.IsBound())
      {
      op->SetReadBounds(temp0);
      }
    else
      {
      op->vtkPTSReader::SetReadBounds(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkPTSReader_SetReadBounds(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 6:
      return PyvtkPTSReader_SetReadBounds_s1(self, args);
    case 1:
      return PyvtkPTSReader_SetReadBounds_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetReadBounds");
  return NULL;
}



static PyObject *
PyvtkPTSReader_GetReadBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReadBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  int sizer = 6;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetReadBounds() :
      op->vtkPTSReader::GetReadBounds());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_OutputDataTypeIsDoubleOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OutputDataTypeIsDoubleOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->OutputDataTypeIsDoubleOn();
      }
    else
      {
      op->vtkPTSReader::OutputDataTypeIsDoubleOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_OutputDataTypeIsDoubleOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OutputDataTypeIsDoubleOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->OutputDataTypeIsDoubleOff();
      }
    else
      {
      op->vtkPTSReader::OutputDataTypeIsDoubleOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_SetOutputDataTypeIsDouble(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutputDataTypeIsDouble");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetOutputDataTypeIsDouble(temp0);
      }
    else
      {
      op->vtkPTSReader::SetOutputDataTypeIsDouble(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_GetOutputDataTypeIsDouble(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputDataTypeIsDouble");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->GetOutputDataTypeIsDouble() :
      op->vtkPTSReader::GetOutputDataTypeIsDouble());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_LimitToMaxNumberOfPointsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LimitToMaxNumberOfPointsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->LimitToMaxNumberOfPointsOn();
      }
    else
      {
      op->vtkPTSReader::LimitToMaxNumberOfPointsOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_LimitToMaxNumberOfPointsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LimitToMaxNumberOfPointsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->LimitToMaxNumberOfPointsOff();
      }
    else
      {
      op->vtkPTSReader::LimitToMaxNumberOfPointsOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_SetLimitToMaxNumberOfPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLimitToMaxNumberOfPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetLimitToMaxNumberOfPoints(temp0);
      }
    else
      {
      op->vtkPTSReader::SetLimitToMaxNumberOfPoints(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_GetLimitToMaxNumberOfPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLimitToMaxNumberOfPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->GetLimitToMaxNumberOfPoints() :
      op->vtkPTSReader::GetLimitToMaxNumberOfPoints());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_SetMaxNumberOfPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaxNumberOfPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  vtkIdType temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetMaxNumberOfPoints(temp0);
      }
    else
      {
      op->vtkPTSReader::SetMaxNumberOfPoints(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_GetMaxNumberOfPointsMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaxNumberOfPointsMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetMaxNumberOfPointsMinValue() :
      op->vtkPTSReader::GetMaxNumberOfPointsMinValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_GetMaxNumberOfPointsMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaxNumberOfPointsMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetMaxNumberOfPointsMaxValue() :
      op->vtkPTSReader::GetMaxNumberOfPointsMaxValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPTSReader_GetMaxNumberOfPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaxNumberOfPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPTSReader *op = static_cast<vtkPTSReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetMaxNumberOfPoints() :
      op->vtkPTSReader::GetMaxNumberOfPoints());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkPTSReader_Methods[] = {
  {"GetClassName", PyvtkPTSReader_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPTSReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPTSReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPTSReader\nC++: vtkPTSReader *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPTSReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPTSReader\nC++: vtkPTSReader *SafeDownCast(vtkObject* o)\n\n"},
  {"SetFileName", PyvtkPTSReader_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: void SetFileName(const char *filename)\n\nSpecify file name.\n"},
  {"GetFileName", PyvtkPTSReader_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: char *GetFileName()\n\nSpecify file name.\n"},
  {"LimitReadToBoundsOn", PyvtkPTSReader_LimitReadToBoundsOn, METH_VARARGS,
   "V.LimitReadToBoundsOn()\nC++: void LimitReadToBoundsOn()\n\nBoolean value indicates whether or not to limit points read to a\nspecified (ReadBounds) region.\n"},
  {"LimitReadToBoundsOff", PyvtkPTSReader_LimitReadToBoundsOff, METH_VARARGS,
   "V.LimitReadToBoundsOff()\nC++: void LimitReadToBoundsOff()\n\nBoolean value indicates whether or not to limit points read to a\nspecified (ReadBounds) region.\n"},
  {"SetLimitReadToBounds", PyvtkPTSReader_SetLimitReadToBounds, METH_VARARGS,
   "V.SetLimitReadToBounds(bool)\nC++: void SetLimitReadToBounds(bool a)\n\nBoolean value indicates whether or not to limit points read to a\nspecified (ReadBounds) region.\n"},
  {"GetLimitReadToBounds", PyvtkPTSReader_GetLimitReadToBounds, METH_VARARGS,
   "V.GetLimitReadToBounds() -> bool\nC++: bool GetLimitReadToBounds()\n\nBoolean value indicates whether or not to limit points read to a\nspecified (ReadBounds) region.\n"},
  {"SetReadBounds", PyvtkPTSReader_SetReadBounds, METH_VARARGS,
   "V.SetReadBounds(float, float, float, float, float, float)\nC++: void SetReadBounds(double, double, double, double, double,\n    double)\nV.SetReadBounds((float, float, float, float, float, float))\nC++: void SetReadBounds(double a[6])\n\n"},
  {"GetReadBounds", PyvtkPTSReader_GetReadBounds, METH_VARARGS,
   "V.GetReadBounds() -> (float, float, float, float, float, float)\nC++: double *GetReadBounds()\n\n"},
  {"OutputDataTypeIsDoubleOn", PyvtkPTSReader_OutputDataTypeIsDoubleOn, METH_VARARGS,
   "V.OutputDataTypeIsDoubleOn()\nC++: void OutputDataTypeIsDoubleOn()\n\nThe output type defaults to float, but can instead be double.\n"},
  {"OutputDataTypeIsDoubleOff", PyvtkPTSReader_OutputDataTypeIsDoubleOff, METH_VARARGS,
   "V.OutputDataTypeIsDoubleOff()\nC++: void OutputDataTypeIsDoubleOff()\n\nThe output type defaults to float, but can instead be double.\n"},
  {"SetOutputDataTypeIsDouble", PyvtkPTSReader_SetOutputDataTypeIsDouble, METH_VARARGS,
   "V.SetOutputDataTypeIsDouble(bool)\nC++: void SetOutputDataTypeIsDouble(bool a)\n\nThe output type defaults to float, but can instead be double.\n"},
  {"GetOutputDataTypeIsDouble", PyvtkPTSReader_GetOutputDataTypeIsDouble, METH_VARARGS,
   "V.GetOutputDataTypeIsDouble() -> bool\nC++: bool GetOutputDataTypeIsDouble()\n\nThe output type defaults to float, but can instead be double.\n"},
  {"LimitToMaxNumberOfPointsOn", PyvtkPTSReader_LimitToMaxNumberOfPointsOn, METH_VARARGS,
   "V.LimitToMaxNumberOfPointsOn()\nC++: void LimitToMaxNumberOfPointsOn()\n\nBoolean value indicates whether or not to limit number of points\nread based on MaxNumbeOfPoints.\n"},
  {"LimitToMaxNumberOfPointsOff", PyvtkPTSReader_LimitToMaxNumberOfPointsOff, METH_VARARGS,
   "V.LimitToMaxNumberOfPointsOff()\nC++: void LimitToMaxNumberOfPointsOff()\n\nBoolean value indicates whether or not to limit number of points\nread based on MaxNumbeOfPoints.\n"},
  {"SetLimitToMaxNumberOfPoints", PyvtkPTSReader_SetLimitToMaxNumberOfPoints, METH_VARARGS,
   "V.SetLimitToMaxNumberOfPoints(bool)\nC++: void SetLimitToMaxNumberOfPoints(bool a)\n\nBoolean value indicates whether or not to limit number of points\nread based on MaxNumbeOfPoints.\n"},
  {"GetLimitToMaxNumberOfPoints", PyvtkPTSReader_GetLimitToMaxNumberOfPoints, METH_VARARGS,
   "V.GetLimitToMaxNumberOfPoints() -> bool\nC++: bool GetLimitToMaxNumberOfPoints()\n\nBoolean value indicates whether or not to limit number of points\nread based on MaxNumbeOfPoints.\n"},
  {"SetMaxNumberOfPoints", PyvtkPTSReader_SetMaxNumberOfPoints, METH_VARARGS,
   "V.SetMaxNumberOfPoints(int)\nC++: void SetMaxNumberOfPoints(vtkIdType)\n\nThe maximum number of points to load if LimitToMaxNumberOfPoints\nis on/true. Sets a temporary onRatio.\n"},
  {"GetMaxNumberOfPointsMinValue", PyvtkPTSReader_GetMaxNumberOfPointsMinValue, METH_VARARGS,
   "V.GetMaxNumberOfPointsMinValue() -> int\nC++: vtkIdType GetMaxNumberOfPointsMinValue()\n\nThe maximum number of points to load if LimitToMaxNumberOfPoints\nis on/true. Sets a temporary onRatio.\n"},
  {"GetMaxNumberOfPointsMaxValue", PyvtkPTSReader_GetMaxNumberOfPointsMaxValue, METH_VARARGS,
   "V.GetMaxNumberOfPointsMaxValue() -> int\nC++: vtkIdType GetMaxNumberOfPointsMaxValue()\n\nThe maximum number of points to load if LimitToMaxNumberOfPoints\nis on/true. Sets a temporary onRatio.\n"},
  {"GetMaxNumberOfPoints", PyvtkPTSReader_GetMaxNumberOfPoints, METH_VARARGS,
   "V.GetMaxNumberOfPoints() -> int\nC++: vtkIdType GetMaxNumberOfPoints()\n\nThe maximum number of points to load if LimitToMaxNumberOfPoints\nis on/true. Sets a temporary onRatio.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPTSReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOGeometryPython.vtkPTSReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPTSReader_StaticNew()
{
  return vtkPTSReader::New();
}

PyObject *PyvtkPTSReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPTSReader_Type, PyvtkPTSReader_Methods,
    "vtkPTSReader",
    PyvtkPTSReader_Doc(), &PyvtkPTSReader_StaticNew);

  PyTypeObject *pytype = &PyvtkPTSReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPTSReader_Doc()
{
  static const char *docstring[] = {
    "vtkPTSReader - Read ASCII PTS Files.\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "vtkPTSReader reads either a text file of\n points. The first line is the number of points. Point information is\n either x y z intensity or x y z intensity r g b\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPTSReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPTSReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPTSReader", o) != 0)
    {
    Py_DECREF(o);
    }

}

