// python wrapper for vtkParallelCoordinatesView
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkParallelCoordinatesView.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkParallelCoordinatesView(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkParallelCoordinatesView_ClassNew(); }

#ifndef DECLARED_PyvtkRenderView_ClassNew
extern "C" { PyObject *PyvtkRenderView_ClassNew(); }
#define DECLARED_PyvtkRenderView_ClassNew
#endif

static const char **PyvtkParallelCoordinatesView_Doc();


static PyObject *
PyvtkParallelCoordinatesView_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkParallelCoordinatesView::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkParallelCoordinatesView::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkParallelCoordinatesView *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkParallelCoordinatesView::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkParallelCoordinatesView *tempr = vtkParallelCoordinatesView::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetBrushMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBrushMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetBrushMode(temp0);
      }
    else
      {
      op->vtkParallelCoordinatesView::SetBrushMode(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetBrushModeToLasso(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBrushModeToLasso");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetBrushModeToLasso();
      }
    else
      {
      op->vtkParallelCoordinatesView::SetBrushModeToLasso();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetBrushModeToAngle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBrushModeToAngle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetBrushModeToAngle();
      }
    else
      {
      op->vtkParallelCoordinatesView::SetBrushModeToAngle();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetBrushModeToFunction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBrushModeToFunction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetBrushModeToFunction();
      }
    else
      {
      op->vtkParallelCoordinatesView::SetBrushModeToFunction();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetBrushModeToAxisThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBrushModeToAxisThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetBrushModeToAxisThreshold();
      }
    else
      {
      op->vtkParallelCoordinatesView::SetBrushModeToAxisThreshold();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_GetBrushMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBrushMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetBrushMode() :
      op->vtkParallelCoordinatesView::GetBrushMode());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetBrushOperator(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBrushOperator");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetBrushOperator(temp0);
      }
    else
      {
      op->vtkParallelCoordinatesView::SetBrushOperator(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetBrushOperatorToAdd(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBrushOperatorToAdd");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetBrushOperatorToAdd();
      }
    else
      {
      op->vtkParallelCoordinatesView::SetBrushOperatorToAdd();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetBrushOperatorToSubtract(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBrushOperatorToSubtract");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetBrushOperatorToSubtract();
      }
    else
      {
      op->vtkParallelCoordinatesView::SetBrushOperatorToSubtract();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetBrushOperatorToIntersect(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBrushOperatorToIntersect");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetBrushOperatorToIntersect();
      }
    else
      {
      op->vtkParallelCoordinatesView::SetBrushOperatorToIntersect();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetBrushOperatorToReplace(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBrushOperatorToReplace");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetBrushOperatorToReplace();
      }
    else
      {
      op->vtkParallelCoordinatesView::SetBrushOperatorToReplace();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_GetBrushOperator(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBrushOperator");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetBrushOperator() :
      op->vtkParallelCoordinatesView::GetBrushOperator());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetInspectMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInspectMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetInspectMode(temp0);
      }
    else
      {
      op->vtkParallelCoordinatesView::SetInspectMode(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetInspectModeToManipulateAxes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInspectModeToManipulateAxes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetInspectModeToManipulateAxes();
      }
    else
      {
      op->vtkParallelCoordinatesView::SetInspectModeToManipulateAxes();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetInpsectModeToSelectData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInpsectModeToSelectData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetInpsectModeToSelectData();
      }
    else
      {
      op->vtkParallelCoordinatesView::SetInpsectModeToSelectData();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_GetInspectMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInspectMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetInspectMode() :
      op->vtkParallelCoordinatesView::GetInspectMode());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetMaximumNumberOfBrushPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaximumNumberOfBrushPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetMaximumNumberOfBrushPoints(temp0);
      }
    else
      {
      op->vtkParallelCoordinatesView::SetMaximumNumberOfBrushPoints(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_GetMaximumNumberOfBrushPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumNumberOfBrushPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetMaximumNumberOfBrushPoints() :
      op->vtkParallelCoordinatesView::GetMaximumNumberOfBrushPoints());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_SetCurrentBrushClass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCurrentBrushClass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetCurrentBrushClass(temp0);
      }
    else
      {
      op->vtkParallelCoordinatesView::SetCurrentBrushClass(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_GetCurrentBrushClass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurrentBrushClass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetCurrentBrushClass() :
      op->vtkParallelCoordinatesView::GetCurrentBrushClass());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkParallelCoordinatesView_ApplyViewTheme(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ApplyViewTheme");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelCoordinatesView *op = static_cast<vtkParallelCoordinatesView *>(vp);

  vtkViewTheme *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkViewTheme"))
    {
    if (ap.IsBound())
      {
      op->ApplyViewTheme(temp0);
      }
    else
      {
      op->vtkParallelCoordinatesView::ApplyViewTheme(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkParallelCoordinatesView_Methods[] = {
  {"GetClassName", PyvtkParallelCoordinatesView_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkParallelCoordinatesView_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkParallelCoordinatesView_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkParallelCoordinatesView\nC++: vtkParallelCoordinatesView *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkParallelCoordinatesView_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkParallelCoordinatesView\nC++: vtkParallelCoordinatesView *SafeDownCast(vtkObject* o)\n\n"},
  {"SetBrushMode", PyvtkParallelCoordinatesView_SetBrushMode, METH_VARARGS,
   "V.SetBrushMode(int)\nC++: void SetBrushMode(int)\n\n"},
  {"SetBrushModeToLasso", PyvtkParallelCoordinatesView_SetBrushModeToLasso, METH_VARARGS,
   "V.SetBrushModeToLasso()\nC++: void SetBrushModeToLasso()\n\n"},
  {"SetBrushModeToAngle", PyvtkParallelCoordinatesView_SetBrushModeToAngle, METH_VARARGS,
   "V.SetBrushModeToAngle()\nC++: void SetBrushModeToAngle()\n\n"},
  {"SetBrushModeToFunction", PyvtkParallelCoordinatesView_SetBrushModeToFunction, METH_VARARGS,
   "V.SetBrushModeToFunction()\nC++: void SetBrushModeToFunction()\n\n"},
  {"SetBrushModeToAxisThreshold", PyvtkParallelCoordinatesView_SetBrushModeToAxisThreshold, METH_VARARGS,
   "V.SetBrushModeToAxisThreshold()\nC++: void SetBrushModeToAxisThreshold()\n\n"},
  {"GetBrushMode", PyvtkParallelCoordinatesView_GetBrushMode, METH_VARARGS,
   "V.GetBrushMode() -> int\nC++: int GetBrushMode()\n\n"},
  {"SetBrushOperator", PyvtkParallelCoordinatesView_SetBrushOperator, METH_VARARGS,
   "V.SetBrushOperator(int)\nC++: void SetBrushOperator(int)\n\n"},
  {"SetBrushOperatorToAdd", PyvtkParallelCoordinatesView_SetBrushOperatorToAdd, METH_VARARGS,
   "V.SetBrushOperatorToAdd()\nC++: void SetBrushOperatorToAdd()\n\n"},
  {"SetBrushOperatorToSubtract", PyvtkParallelCoordinatesView_SetBrushOperatorToSubtract, METH_VARARGS,
   "V.SetBrushOperatorToSubtract()\nC++: void SetBrushOperatorToSubtract()\n\n"},
  {"SetBrushOperatorToIntersect", PyvtkParallelCoordinatesView_SetBrushOperatorToIntersect, METH_VARARGS,
   "V.SetBrushOperatorToIntersect()\nC++: void SetBrushOperatorToIntersect()\n\n"},
  {"SetBrushOperatorToReplace", PyvtkParallelCoordinatesView_SetBrushOperatorToReplace, METH_VARARGS,
   "V.SetBrushOperatorToReplace()\nC++: void SetBrushOperatorToReplace()\n\n"},
  {"GetBrushOperator", PyvtkParallelCoordinatesView_GetBrushOperator, METH_VARARGS,
   "V.GetBrushOperator() -> int\nC++: int GetBrushOperator()\n\n"},
  {"SetInspectMode", PyvtkParallelCoordinatesView_SetInspectMode, METH_VARARGS,
   "V.SetInspectMode(int)\nC++: void SetInspectMode(int)\n\n"},
  {"SetInspectModeToManipulateAxes", PyvtkParallelCoordinatesView_SetInspectModeToManipulateAxes, METH_VARARGS,
   "V.SetInspectModeToManipulateAxes()\nC++: void SetInspectModeToManipulateAxes()\n\n"},
  {"SetInpsectModeToSelectData", PyvtkParallelCoordinatesView_SetInpsectModeToSelectData, METH_VARARGS,
   "V.SetInpsectModeToSelectData()\nC++: void SetInpsectModeToSelectData()\n\n"},
  {"GetInspectMode", PyvtkParallelCoordinatesView_GetInspectMode, METH_VARARGS,
   "V.GetInspectMode() -> int\nC++: int GetInspectMode()\n\n"},
  {"SetMaximumNumberOfBrushPoints", PyvtkParallelCoordinatesView_SetMaximumNumberOfBrushPoints, METH_VARARGS,
   "V.SetMaximumNumberOfBrushPoints(int)\nC++: void SetMaximumNumberOfBrushPoints(int)\n\n"},
  {"GetMaximumNumberOfBrushPoints", PyvtkParallelCoordinatesView_GetMaximumNumberOfBrushPoints, METH_VARARGS,
   "V.GetMaximumNumberOfBrushPoints() -> int\nC++: int GetMaximumNumberOfBrushPoints()\n\n"},
  {"SetCurrentBrushClass", PyvtkParallelCoordinatesView_SetCurrentBrushClass, METH_VARARGS,
   "V.SetCurrentBrushClass(int)\nC++: void SetCurrentBrushClass(int a)\n\n"},
  {"GetCurrentBrushClass", PyvtkParallelCoordinatesView_GetCurrentBrushClass, METH_VARARGS,
   "V.GetCurrentBrushClass() -> int\nC++: int GetCurrentBrushClass()\n\n"},
  {"ApplyViewTheme", PyvtkParallelCoordinatesView_ApplyViewTheme, METH_VARARGS,
   "V.ApplyViewTheme(vtkViewTheme)\nC++: virtual void ApplyViewTheme(vtkViewTheme *theme)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkParallelCoordinatesView_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkViewsInfovisPython.vtkParallelCoordinatesView", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkParallelCoordinatesView_StaticNew()
{
  return vtkParallelCoordinatesView::New();
}

PyObject *PyvtkParallelCoordinatesView_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkParallelCoordinatesView_Type, PyvtkParallelCoordinatesView_Methods,
    "vtkParallelCoordinatesView",
    PyvtkParallelCoordinatesView_Doc(), &PyvtkParallelCoordinatesView_StaticNew);

  PyTypeObject *pytype = &PyvtkParallelCoordinatesView_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkRenderView_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 13; c++)
    {
    static const struct { const char *name; int value; }
      constants[13] = {
        { "VTK_BRUSH_LASSO", vtkParallelCoordinatesView::VTK_BRUSH_LASSO },
        { "VTK_BRUSH_ANGLE", vtkParallelCoordinatesView::VTK_BRUSH_ANGLE },
        { "VTK_BRUSH_FUNCTION", vtkParallelCoordinatesView::VTK_BRUSH_FUNCTION },
        { "VTK_BRUSH_AXISTHRESHOLD", vtkParallelCoordinatesView::VTK_BRUSH_AXISTHRESHOLD },
        { "VTK_BRUSH_MODECOUNT", vtkParallelCoordinatesView::VTK_BRUSH_MODECOUNT },
        { "VTK_BRUSHOPERATOR_ADD", vtkParallelCoordinatesView::VTK_BRUSHOPERATOR_ADD },
        { "VTK_BRUSHOPERATOR_SUBTRACT", vtkParallelCoordinatesView::VTK_BRUSHOPERATOR_SUBTRACT },
        { "VTK_BRUSHOPERATOR_INTERSECT", vtkParallelCoordinatesView::VTK_BRUSHOPERATOR_INTERSECT },
        { "VTK_BRUSHOPERATOR_REPLACE", vtkParallelCoordinatesView::VTK_BRUSHOPERATOR_REPLACE },
        { "VTK_BRUSHOPERATOR_MODECOUNT", vtkParallelCoordinatesView::VTK_BRUSHOPERATOR_MODECOUNT },
        { "VTK_INSPECT_MANIPULATE_AXES", vtkParallelCoordinatesView::VTK_INSPECT_MANIPULATE_AXES },
        { "VTK_INSPECT_SELECT_DATA", vtkParallelCoordinatesView::VTK_INSPECT_SELECT_DATA },
        { "VTK_INSPECT_MODECOUNT", vtkParallelCoordinatesView::VTK_INSPECT_MODECOUNT },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
      {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
      }
    }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkParallelCoordinatesView_Doc()
{
  static const char *docstring[] = {
    "vtkParallelCoordinatesView - view to be used with\nvtkParallelCoordinatesRepresentation\n\n",
    "Superclass: vtkRenderView\n\n",
    "This class manages interaction with the\nvtkParallelCoordinatesRepresentation.  There are two inspection\nmodes: axis manipulation and line selection.  In axis manipulation\nmode, PC axes can be dragged and reordered with the LMB, axis ranges\ncan be increased/decreased by dragging up/down with the LMB, and RMB\ncontrols zoom and pan.\n\nIn line selection mode, there are three subclasses of selections:\nl",
    "asso, angle, and function selection.  Lasso selection lets the user\nbrush a line and select all PC lines that pass nearby.  Angle\nselection lets the user draw a representative line between axes and\nselect all lines that have similar orientation.  Function selection\nlets the user draw two  representative lines between a pair of axes\nand select all lines that match the linear interpolation of those\n",
    "lines.\n\nThere are several self-explanatory operators for combining\nselections: ADD, SUBTRACT REPLACE, and INTERSECT.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkParallelCoordinatesView(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkParallelCoordinatesView_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkParallelCoordinatesView", o) != 0)
    {
    Py_DECREF(o);
    }

}

