// python wrapper for vtkPixelExtentIO
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkPixelExtent.h"
#include "vtkPixelExtentIO.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPixelExtentIO(PyObject *); }

static const char **PyvtkPixelExtentIO_Doc();


static PyObject *
PyvtkPixelExtentIO_Write(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "Write");

  int temp0;
  char *temp1 = NULL;
  vtkPixelExtent *temp2 = NULL;
  PyObject *pobj2 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetSpecialObject(temp2, pobj2, "vtkPixelExtent"))
    {
    vtkPixelExtentIO::Write(temp0, temp1, *temp2);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  Py_XDECREF(pobj2);

  return result;
}

static PyMethodDef PyvtkPixelExtentIO_Methods[] = {
  {"Write", PyvtkPixelExtentIO_Write, METH_VARARGS,
   "V.Write(int, string, vtkPixelExtent)\nC++: static void Write(int commRank, const char *fileName,\n    const vtkPixelExtent &ext)\n\nWrite an extent per MPI rank to disk. All ranks write. It's\nassumed that each rank passes a unique filename.\n"},
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkPixelExtentIO_vtkPixelExtentIO_s1(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkPixelExtentIO");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
    {
    vtkPixelExtentIO *op = new vtkPixelExtentIO();

    result = PyVTKSpecialObject_New("vtkPixelExtentIO", op);
    }

  return result;
}

static PyObject *
PyvtkPixelExtentIO_vtkPixelExtentIO_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkPixelExtentIO");

  vtkPixelExtentIO *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkPixelExtentIO"))
    {
    vtkPixelExtentIO *op = new vtkPixelExtentIO(*temp0);

    result = PyVTKSpecialObject_New("vtkPixelExtentIO", op);
    }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkPixelExtentIO_vtkPixelExtentIO_Methods[] = {
  {NULL, PyvtkPixelExtentIO_vtkPixelExtentIO_s2, METH_VARARGS,
   "@W vtkPixelExtentIO"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkPixelExtentIO_vtkPixelExtentIO(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
    {
    case 0:
      return PyvtkPixelExtentIO_vtkPixelExtentIO_s1(self, args);
    case 1:
      return PyvtkPixelExtentIO_vtkPixelExtentIO_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "vtkPixelExtentIO");
  return NULL;
}


static PyObject *
PyvtkPixelExtentIO_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
    {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
    }

  return PyvtkPixelExtentIO_vtkPixelExtentIO(NULL, args);
}

static void PyvtkPixelExtentIO_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkPixelExtentIO *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkPixelExtentIO_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkPixelExtentIO_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOLegacyPython.vtkPixelExtentIO", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkPixelExtentIO_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkPixelExtentIO_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkPixelExtentIO_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkPixelExtentIO_CCopy(const void *obj)
{
  if (obj)
    {
    return new vtkPixelExtentIO(*static_cast<const vtkPixelExtentIO*>(obj));
    }
  return 0;
}

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPixelExtentIO_TypeNew(); }

PyObject *PyvtkPixelExtentIO_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkPixelExtentIO_Type,
    PyvtkPixelExtentIO_Methods,
    PyvtkPixelExtentIO_vtkPixelExtentIO_Methods,
    PyvtkPixelExtentIO_Doc(), &PyvtkPixelExtentIO_CCopy);

  PyTypeObject *pytype = &PyvtkPixelExtentIO_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPixelExtentIO_Doc()
{
  static const char *docstring[] = {
    "vtkPixelExtentIO -- I/O routines for vtkPixelExtent\n\n",
    "A small collection of I/O routines that can write vtkPixelExtent's or\ncollections of them to disk for visualization as unstructured grids.\n\n",
    "V.vtkPixelExtentIO()\nC++: vtkPixelExtentIO()\nV.vtkPixelExtentIO(vtkPixelExtentIO)\nC++: vtkPixelExtentIO(const &vtkPixelExtentIO)\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPixelExtentIO(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPixelExtentIO_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkPixelExtentIO", o) != 0)
    {
    Py_DECREF(o);
    }

}

