// python wrapper for vtkPolygonBuilder
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkPolygonBuilder.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPolygonBuilder(PyObject *); }

static const char **PyvtkPolygonBuilder_Doc();


static PyObject *
PyvtkPolygonBuilder_InsertTriangle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InsertTriangle");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPolygonBuilder *op = static_cast<vtkPolygonBuilder *>(vp);

  vtkIdType *temp0 = NULL;
  vtkIdType *save0 = NULL;
  vtkIdType small0[8];
  int size0 = 0;
  PyObject *result = NULL;

  size0 = ap.GetArgSize(0);
  temp0 = small0;
  if (size0 > 4)
    {
    temp0 = new vtkIdType[2*size0];
    }
  save0 = &temp0[size0];

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    ap.SaveArray(temp0, save0, size0);

    op->InsertTriangle(temp0);

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(0, temp0, size0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  if (temp0 != small0)
    {
    delete [] temp0;
    }

  return result;
}


static PyObject *
PyvtkPolygonBuilder_GetPolygons(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPolygons");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPolygonBuilder *op = static_cast<vtkPolygonBuilder *>(vp);

  vtkIdListCollection *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkIdListCollection"))
    {
    op->GetPolygons(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPolygonBuilder_Reset(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Reset");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPolygonBuilder *op = static_cast<vtkPolygonBuilder *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    op->Reset();

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkPolygonBuilder_Methods[] = {
  {"InsertTriangle", PyvtkPolygonBuilder_InsertTriangle, METH_VARARGS,
   "V.InsertTriangle([int, ...])\nC++: void InsertTriangle(vtkIdType *abc)\n\nInsert a triangle as a triplet of point IDs.\n"},
  {"GetPolygons", PyvtkPolygonBuilder_GetPolygons, METH_VARARGS,
   "V.GetPolygons(vtkIdListCollection)\nC++: void GetPolygons(vtkIdListCollection *polys)\n\nPopulate polys with lists of polygons, defined as sequential\nexternal vertices. It is the responsibility of the user to delete\nthese generated lists in order to avoid memory leaks.\n"},
  {"Reset", PyvtkPolygonBuilder_Reset, METH_VARARGS,
   "V.Reset()\nC++: void Reset()\n\nPrepare the builder for a new set of inputs.\n"},
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkPolygonBuilder_vtkPolygonBuilder_s1(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkPolygonBuilder");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
    {
    vtkPolygonBuilder *op = new vtkPolygonBuilder();

    result = PyVTKSpecialObject_New("vtkPolygonBuilder", op);
    }

  return result;
}

static PyObject *
PyvtkPolygonBuilder_vtkPolygonBuilder_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkPolygonBuilder");

  vtkPolygonBuilder *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkPolygonBuilder"))
    {
    vtkPolygonBuilder *op = new vtkPolygonBuilder(*temp0);

    result = PyVTKSpecialObject_New("vtkPolygonBuilder", op);
    }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkPolygonBuilder_vtkPolygonBuilder_Methods[] = {
  {NULL, PyvtkPolygonBuilder_vtkPolygonBuilder_s2, METH_VARARGS,
   "@W vtkPolygonBuilder"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkPolygonBuilder_vtkPolygonBuilder(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
    {
    case 0:
      return PyvtkPolygonBuilder_vtkPolygonBuilder_s1(self, args);
    case 1:
      return PyvtkPolygonBuilder_vtkPolygonBuilder_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "vtkPolygonBuilder");
  return NULL;
}


static PyObject *
PyvtkPolygonBuilder_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
    {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
    }

  return PyvtkPolygonBuilder_vtkPolygonBuilder(NULL, args);
}

static void PyvtkPolygonBuilder_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkPolygonBuilder *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkPolygonBuilder_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkPolygonBuilder_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonMiscPython.vtkPolygonBuilder", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkPolygonBuilder_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkPolygonBuilder_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkPolygonBuilder_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkPolygonBuilder_CCopy(const void *obj)
{
  if (obj)
    {
    return new vtkPolygonBuilder(*static_cast<const vtkPolygonBuilder*>(obj));
    }
  return 0;
}

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPolygonBuilder_TypeNew(); }

PyObject *PyvtkPolygonBuilder_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkPolygonBuilder_Type,
    PyvtkPolygonBuilder_Methods,
    PyvtkPolygonBuilder_vtkPolygonBuilder_Methods,
    PyvtkPolygonBuilder_Doc(), &PyvtkPolygonBuilder_CCopy);

  PyTypeObject *pytype = &PyvtkPolygonBuilder_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPolygonBuilder_Doc()
{
  static const char *docstring[] = {
    "vtkPolygonBuilder -builds a polygon from a set of abstract triangles\n(represented by index triplets)\n\n",
    "The polygon output is the boundary of the union of the triangles.\n It is assumed that the input triangles form a simple polygon. It is\n currently used to compute polygons for slicing.\n\n",
    "V.vtkPolygonBuilder()\nC++: vtkPolygonBuilder()\nV.vtkPolygonBuilder(vtkPolygonBuilder)\nC++: vtkPolygonBuilder(const &vtkPolygonBuilder)\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPolygonBuilder(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPolygonBuilder_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkPolygonBuilder", o) != 0)
    {
    Py_DECREF(o);
    }

}

