// python wrapper for vtkPropCollection
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkPropCollection.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPropCollection(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPropCollection_ClassNew(); }

#ifndef DECLARED_PyvtkCollection_ClassNew
extern "C" { PyObject *PyvtkCollection_ClassNew(); }
#define DECLARED_PyvtkCollection_ClassNew
#endif

static const char **PyvtkPropCollection_Doc();


static PyObject *
PyvtkPropCollection_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropCollection *op = static_cast<vtkPropCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPropCollection::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPropCollection_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropCollection *op = static_cast<vtkPropCollection *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPropCollection::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPropCollection_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropCollection *op = static_cast<vtkPropCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkPropCollection *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPropCollection::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkPropCollection_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkPropCollection *tempr = vtkPropCollection::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPropCollection_AddItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropCollection *op = static_cast<vtkPropCollection *>(vp);

  vtkProp *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkProp"))
    {
    if (ap.IsBound())
      {
      op->AddItem(temp0);
      }
    else
      {
      op->vtkPropCollection::AddItem(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPropCollection_GetNextProp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNextProp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropCollection *op = static_cast<vtkPropCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkProp *tempr = (ap.IsBound() ?
      op->GetNextProp() :
      op->vtkPropCollection::GetNextProp());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPropCollection_GetLastProp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastProp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropCollection *op = static_cast<vtkPropCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkProp *tempr = (ap.IsBound() ?
      op->GetLastProp() :
      op->vtkPropCollection::GetLastProp());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPropCollection_GetNumberOfPaths(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfPaths");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropCollection *op = static_cast<vtkPropCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfPaths() :
      op->vtkPropCollection::GetNumberOfPaths());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkPropCollection_Methods[] = {
  {"GetClassName", PyvtkPropCollection_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPropCollection_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPropCollection_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPropCollection\nC++: vtkPropCollection *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPropCollection_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPropCollection\nC++: vtkPropCollection *SafeDownCast(vtkObject* o)\n\n"},
  {"AddItem", PyvtkPropCollection_AddItem, METH_VARARGS,
   "V.AddItem(vtkProp)\nC++: void AddItem(vtkProp *a)\n\nAdd an Prop to the list.\n"},
  {"GetNextProp", PyvtkPropCollection_GetNextProp, METH_VARARGS,
   "V.GetNextProp() -> vtkProp\nC++: vtkProp *GetNextProp()\n\nGet the next Prop in the list.\n"},
  {"GetLastProp", PyvtkPropCollection_GetLastProp, METH_VARARGS,
   "V.GetLastProp() -> vtkProp\nC++: vtkProp *GetLastProp()\n\nGet the last Prop in the list.\n"},
  {"GetNumberOfPaths", PyvtkPropCollection_GetNumberOfPaths, METH_VARARGS,
   "V.GetNumberOfPaths() -> int\nC++: int GetNumberOfPaths()\n\nGet the number of paths contained in this list. (Recall that a\nvtkProp can consist of multiple parts.) Used in picking and other\nactivities to get the parts of composite entities like\nvtkAssembly or vtkPropAssembly.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPropCollection_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingCorePython.vtkPropCollection", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPropCollection_StaticNew()
{
  return vtkPropCollection::New();
}

PyObject *PyvtkPropCollection_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPropCollection_Type, PyvtkPropCollection_Methods,
    "vtkPropCollection",
    PyvtkPropCollection_Doc(), &PyvtkPropCollection_StaticNew);

  PyTypeObject *pytype = &PyvtkPropCollection_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkCollection_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPropCollection_Doc()
{
  static const char *docstring[] = {
    "vtkPropCollection - a list of Props\n\n",
    "Superclass: vtkCollection\n\n",
    "vtkPropCollection represents and provides methods to manipulate a\nlist of Props (i.e., vtkProp and subclasses). The list is unsorted\nand duplicate entries are not prevented.\n\nSee Also:\n\nvtkProp vtkCollection\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPropCollection(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPropCollection_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPropCollection", o) != 0)
    {
    Py_DECREF(o);
    }

}

