// python wrapper for vtkPropItem
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkPropItem.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPropItem(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPropItem_ClassNew(); }

#ifndef DECLARED_PyvtkAbstractContextItem_ClassNew
extern "C" { PyObject *PyvtkAbstractContextItem_ClassNew(); }
#define DECLARED_PyvtkAbstractContextItem_ClassNew
#endif

static const char **PyvtkPropItem_Doc();


static PyObject *
PyvtkPropItem_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropItem *op = static_cast<vtkPropItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPropItem::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPropItem_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropItem *op = static_cast<vtkPropItem *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPropItem::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPropItem_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropItem *op = static_cast<vtkPropItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkPropItem *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPropItem::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkPropItem_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkPropItem *tempr = vtkPropItem::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPropItem_Paint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Paint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropItem *op = static_cast<vtkPropItem *>(vp);

  vtkContext2D *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkContext2D"))
    {
    bool tempr = (ap.IsBound() ?
      op->Paint(temp0) :
      op->vtkPropItem::Paint(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkPropItem_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropItem *op = static_cast<vtkPropItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->ReleaseGraphicsResources();
      }
    else
      {
      op->vtkPropItem::ReleaseGraphicsResources();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPropItem_SetPropObject(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPropObject");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropItem *op = static_cast<vtkPropItem *>(vp);

  vtkProp *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkProp"))
    {
    if (ap.IsBound())
      {
      op->SetPropObject(temp0);
      }
    else
      {
      op->vtkPropItem::SetPropObject(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkPropItem_GetPropObject(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPropObject");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPropItem *op = static_cast<vtkPropItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkProp *tempr = (ap.IsBound() ?
      op->GetPropObject() :
      op->vtkPropItem::GetPropObject());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkPropItem_Methods[] = {
  {"GetClassName", PyvtkPropItem_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPropItem_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPropItem_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPropItem\nC++: vtkPropItem *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPropItem_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPropItem\nC++: vtkPropItem *SafeDownCast(vtkObject* o)\n\n"},
  {"Paint", PyvtkPropItem_Paint, METH_VARARGS,
   "V.Paint(vtkContext2D) -> bool\nC++: virtual bool Paint(vtkContext2D *painter)\n\n"},
  {"ReleaseGraphicsResources", PyvtkPropItem_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources()\nC++: virtual void ReleaseGraphicsResources()\n\n"},
  {"SetPropObject", PyvtkPropItem_SetPropObject, METH_VARARGS,
   "V.SetPropObject(vtkProp)\nC++: virtual void SetPropObject(vtkProp *PropObject)\n\nThe actor to render.\n"},
  {"GetPropObject", PyvtkPropItem_GetPropObject, METH_VARARGS,
   "V.GetPropObject() -> vtkProp\nC++: vtkProp *GetPropObject()\n\nThe actor to render.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPropItem_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingContext2DPython.vtkPropItem", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPropItem_StaticNew()
{
  return vtkPropItem::New();
}

PyObject *PyvtkPropItem_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPropItem_Type, PyvtkPropItem_Methods,
    "vtkPropItem",
    PyvtkPropItem_Doc(), &PyvtkPropItem_StaticNew);

  PyTypeObject *pytype = &PyvtkPropItem_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAbstractContextItem_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPropItem_Doc()
{
  static const char *docstring[] = {
    "vtkPropItem - Embed a vtkProp in a vtkContextScene.\n\n",
    "Superclass: vtkAbstractContextItem\n\n",
    "This class allows vtkProp objects to be drawn inside a\nvtkContextScene. This is especially useful for constructing layered\nscenes that need to ignore depth testing.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPropItem(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPropItem_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPropItem", o) != 0)
    {
    Py_DECREF(o);
    }

}

