// python wrapper for vtkProteinRibbonFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkProteinRibbonFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkProteinRibbonFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkProteinRibbonFilter_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkProteinRibbonFilter_Doc();


static PyObject *
PyvtkProteinRibbonFilter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProteinRibbonFilter *op = static_cast<vtkProteinRibbonFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkProteinRibbonFilter::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkProteinRibbonFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProteinRibbonFilter *op = static_cast<vtkProteinRibbonFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkProteinRibbonFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkProteinRibbonFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProteinRibbonFilter *op = static_cast<vtkProteinRibbonFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkProteinRibbonFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkProteinRibbonFilter::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkProteinRibbonFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkProteinRibbonFilter *tempr = vtkProteinRibbonFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkProteinRibbonFilter_GetCoilWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCoilWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProteinRibbonFilter *op = static_cast<vtkProteinRibbonFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    float tempr = (ap.IsBound() ?
      op->GetCoilWidth() :
      op->vtkProteinRibbonFilter::GetCoilWidth());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkProteinRibbonFilter_SetCoilWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCoilWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProteinRibbonFilter *op = static_cast<vtkProteinRibbonFilter *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetCoilWidth(temp0);
      }
    else
      {
      op->vtkProteinRibbonFilter::SetCoilWidth(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkProteinRibbonFilter_GetHelixWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHelixWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProteinRibbonFilter *op = static_cast<vtkProteinRibbonFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    float tempr = (ap.IsBound() ?
      op->GetHelixWidth() :
      op->vtkProteinRibbonFilter::GetHelixWidth());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkProteinRibbonFilter_SetHelixWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetHelixWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProteinRibbonFilter *op = static_cast<vtkProteinRibbonFilter *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetHelixWidth(temp0);
      }
    else
      {
      op->vtkProteinRibbonFilter::SetHelixWidth(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkProteinRibbonFilter_GetSubdivideFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSubdivideFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProteinRibbonFilter *op = static_cast<vtkProteinRibbonFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetSubdivideFactor() :
      op->vtkProteinRibbonFilter::GetSubdivideFactor());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkProteinRibbonFilter_SetSubdivideFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSubdivideFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProteinRibbonFilter *op = static_cast<vtkProteinRibbonFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetSubdivideFactor(temp0);
      }
    else
      {
      op->vtkProteinRibbonFilter::SetSubdivideFactor(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkProteinRibbonFilter_GetDrawSmallMoleculesAsSpheres(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDrawSmallMoleculesAsSpheres");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProteinRibbonFilter *op = static_cast<vtkProteinRibbonFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->GetDrawSmallMoleculesAsSpheres() :
      op->vtkProteinRibbonFilter::GetDrawSmallMoleculesAsSpheres());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkProteinRibbonFilter_SetDrawSmallMoleculesAsSpheres(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDrawSmallMoleculesAsSpheres");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProteinRibbonFilter *op = static_cast<vtkProteinRibbonFilter *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetDrawSmallMoleculesAsSpheres(temp0);
      }
    else
      {
      op->vtkProteinRibbonFilter::SetDrawSmallMoleculesAsSpheres(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkProteinRibbonFilter_GetSphereResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSphereResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProteinRibbonFilter *op = static_cast<vtkProteinRibbonFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetSphereResolution() :
      op->vtkProteinRibbonFilter::GetSphereResolution());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkProteinRibbonFilter_SetSphereResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSphereResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProteinRibbonFilter *op = static_cast<vtkProteinRibbonFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetSphereResolution(temp0);
      }
    else
      {
      op->vtkProteinRibbonFilter::SetSphereResolution(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkProteinRibbonFilter_Methods[] = {
  {"GetClassName", PyvtkProteinRibbonFilter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkProteinRibbonFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkProteinRibbonFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkProteinRibbonFilter\nC++: vtkProteinRibbonFilter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkProteinRibbonFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkProteinRibbonFilter\nC++: vtkProteinRibbonFilter *SafeDownCast(vtkObject* o)\n\n"},
  {"GetCoilWidth", PyvtkProteinRibbonFilter_GetCoilWidth, METH_VARARGS,
   "V.GetCoilWidth() -> float\nC++: float GetCoilWidth()\n\nWidth of the ribbon coil. Default is 0.3.\n"},
  {"SetCoilWidth", PyvtkProteinRibbonFilter_SetCoilWidth, METH_VARARGS,
   "V.SetCoilWidth(float)\nC++: void SetCoilWidth(float a)\n\nWidth of the ribbon coil. Default is 0.3.\n"},
  {"GetHelixWidth", PyvtkProteinRibbonFilter_GetHelixWidth, METH_VARARGS,
   "V.GetHelixWidth() -> float\nC++: float GetHelixWidth()\n\nWidth of the helix part of the ribbon. Default is 1.3.\n"},
  {"SetHelixWidth", PyvtkProteinRibbonFilter_SetHelixWidth, METH_VARARGS,
   "V.SetHelixWidth(float)\nC++: void SetHelixWidth(float a)\n\nWidth of the helix part of the ribbon. Default is 1.3.\n"},
  {"GetSubdivideFactor", PyvtkProteinRibbonFilter_GetSubdivideFactor, METH_VARARGS,
   "V.GetSubdivideFactor() -> int\nC++: int GetSubdivideFactor()\n\nSmoothing factor of the ribbon. Default is 20.\n"},
  {"SetSubdivideFactor", PyvtkProteinRibbonFilter_SetSubdivideFactor, METH_VARARGS,
   "V.SetSubdivideFactor(int)\nC++: void SetSubdivideFactor(int a)\n\nSmoothing factor of the ribbon. Default is 20.\n"},
  {"GetDrawSmallMoleculesAsSpheres", PyvtkProteinRibbonFilter_GetDrawSmallMoleculesAsSpheres, METH_VARARGS,
   "V.GetDrawSmallMoleculesAsSpheres() -> bool\nC++: bool GetDrawSmallMoleculesAsSpheres()\n\nIf enabled, small molecules (HETATMs) are drawn as spheres.\nDefault is true.\n"},
  {"SetDrawSmallMoleculesAsSpheres", PyvtkProteinRibbonFilter_SetDrawSmallMoleculesAsSpheres, METH_VARARGS,
   "V.SetDrawSmallMoleculesAsSpheres(bool)\nC++: void SetDrawSmallMoleculesAsSpheres(bool a)\n\nIf enabled, small molecules (HETATMs) are drawn as spheres.\nDefault is true.\n"},
  {"GetSphereResolution", PyvtkProteinRibbonFilter_GetSphereResolution, METH_VARARGS,
   "V.GetSphereResolution() -> int\nC++: int GetSphereResolution()\n\nResolution of the spheres for small molecules. Default is 20.\n"},
  {"SetSphereResolution", PyvtkProteinRibbonFilter_SetSphereResolution, METH_VARARGS,
   "V.SetSphereResolution(int)\nC++: void SetSphereResolution(int a)\n\nResolution of the spheres for small molecules. Default is 20.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkProteinRibbonFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkDomainsChemistryPython.vtkProteinRibbonFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkProteinRibbonFilter_StaticNew()
{
  return vtkProteinRibbonFilter::New();
}

PyObject *PyvtkProteinRibbonFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkProteinRibbonFilter_Type, PyvtkProteinRibbonFilter_Methods,
    "vtkProteinRibbonFilter",
    PyvtkProteinRibbonFilter_Doc(), &PyvtkProteinRibbonFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkProteinRibbonFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkProteinRibbonFilter_Doc()
{
  static const char *docstring[] = {
    "vtkProteinRibbonFilter - generates protein ribbons\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "vtkProteinRibbonFilter is a polydata algorithm that generates protein\nribbons.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkProteinRibbonFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkProteinRibbonFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkProteinRibbonFilter", o) != 0)
    {
    Py_DECREF(o);
    }

}

