// python wrapper for vtkRInterface
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkRInterface.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkRInterface(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkRInterface_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkRInterface_Doc();


static PyObject *
PyvtkRInterface_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkRInterface::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkRInterface::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkRInterface *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkRInterface::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkRInterface *tempr = vtkRInterface::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_EvalRcommand(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EvalRcommand");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  char *temp0 = NULL;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    int tempr = (ap.IsBound() ?
      op->EvalRcommand(temp0, temp1) :
      op->vtkRInterface::EvalRcommand(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_EvalRscript(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EvalRscript");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  char *temp0 = NULL;
  bool temp1 = true;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
    {
    int tempr = (ap.IsBound() ?
      op->EvalRscript(temp0, temp1) :
      op->vtkRInterface::EvalRscript(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_OutputBuffer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OutputBuffer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  char *temp0 = NULL;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    int tempr = (ap.IsBound() ?
      op->OutputBuffer(temp0, temp1) :
      op->vtkRInterface::OutputBuffer(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_AssignVTKDataArrayToRVariable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AssignVTKDataArrayToRVariable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  vtkDataArray *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkDataArray") &&
      ap.GetValue(temp1))
    {
    if (ap.IsBound())
      {
      op->AssignVTKDataArrayToRVariable(temp0, temp1);
      }
    else
      {
      op->vtkRInterface::AssignVTKDataArrayToRVariable(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_AssignVTKArrayToRVariable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AssignVTKArrayToRVariable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  vtkArray *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkArray") &&
      ap.GetValue(temp1))
    {
    if (ap.IsBound())
      {
      op->AssignVTKArrayToRVariable(temp0, temp1);
      }
    else
      {
      op->vtkRInterface::AssignVTKArrayToRVariable(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_AssignVTKTreeToRVariable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AssignVTKTreeToRVariable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  vtkTree *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkTree") &&
      ap.GetValue(temp1))
    {
    if (ap.IsBound())
      {
      op->AssignVTKTreeToRVariable(temp0, temp1);
      }
    else
      {
      op->vtkRInterface::AssignVTKTreeToRVariable(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_AssignRVariableToVTKTree(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AssignRVariableToVTKTree");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    vtkTree *tempr = (ap.IsBound() ?
      op->AssignRVariableToVTKTree(temp0) :
      op->vtkRInterface::AssignRVariableToVTKTree(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_AssignRVariableToVTKDataArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AssignRVariableToVTKDataArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    vtkDataArray *tempr = (ap.IsBound() ?
      op->AssignRVariableToVTKDataArray(temp0) :
      op->vtkRInterface::AssignRVariableToVTKDataArray(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_AssignRVariableToVTKArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AssignRVariableToVTKArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    vtkArray *tempr = (ap.IsBound() ?
      op->AssignRVariableToVTKArray(temp0) :
      op->vtkRInterface::AssignRVariableToVTKArray(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_AssignRVariableToVTKTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AssignRVariableToVTKTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    vtkTable *tempr = (ap.IsBound() ?
      op->AssignRVariableToVTKTable(temp0) :
      op->vtkRInterface::AssignRVariableToVTKTable(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRInterface_AssignVTKTableToRVariable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AssignVTKTableToRVariable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRInterface *op = static_cast<vtkRInterface *>(vp);

  vtkTable *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkTable") &&
      ap.GetValue(temp1))
    {
    if (ap.IsBound())
      {
      op->AssignVTKTableToRVariable(temp0, temp1);
      }
    else
      {
      op->vtkRInterface::AssignVTKTableToRVariable(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkRInterface_Methods[] = {
  {"GetClassName", PyvtkRInterface_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkRInterface_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkRInterface_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkRInterface\nC++: vtkRInterface *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkRInterface_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkRInterface\nC++: vtkRInterface *SafeDownCast(vtkObject* o)\n\n"},
  {"EvalRcommand", PyvtkRInterface_EvalRcommand, METH_VARARGS,
   "V.EvalRcommand(string, int) -> int\nC++: int EvalRcommand(const char *commandName, int param)\n\nEvaluate an R command on the embedded R interpreter that takes\none integer argument.\n"},
  {"EvalRscript", PyvtkRInterface_EvalRscript, METH_VARARGS,
   "V.EvalRscript(string, bool) -> int\nC++: int EvalRscript(const char *string, bool showRoutput=true)\n\nEvaluate an R script given in string on the embedded R\ninterpreter.  Set showRoutput to turn on and off output from R.\n"},
  {"OutputBuffer", PyvtkRInterface_OutputBuffer, METH_VARARGS,
   "V.OutputBuffer(string, int) -> int\nC++: int OutputBuffer(char *p, int n)\n\nProvide a character buffer in p of length n.  All output from the\nR interpreter instance will be written to p by default.\n"},
  {"AssignVTKDataArrayToRVariable", PyvtkRInterface_AssignVTKDataArrayToRVariable, METH_VARARGS,
   "V.AssignVTKDataArrayToRVariable(vtkDataArray, string)\nC++: void AssignVTKDataArrayToRVariable(vtkDataArray *da,\n    const char *RVariableName)\n\nCopies vtkDataArray da into the R interpreter instance as a\nvariable named RVariableName. If RVariableName already exists, it\nwill be overwritten.\n"},
  {"AssignVTKArrayToRVariable", PyvtkRInterface_AssignVTKArrayToRVariable, METH_VARARGS,
   "V.AssignVTKArrayToRVariable(vtkArray, string)\nC++: void AssignVTKArrayToRVariable(vtkArray *da,\n    const char *RVariableName)\n\nCopies vtkArray da into the R interpreter instance as a variable\nnamed RVariableName. If RVariableName already exists, it will be\noverwritten.\n"},
  {"AssignVTKTreeToRVariable", PyvtkRInterface_AssignVTKTreeToRVariable, METH_VARARGS,
   "V.AssignVTKTreeToRVariable(vtkTree, string)\nC++: void AssignVTKTreeToRVariable(vtkTree *tr,\n    const char *RVariableName)\n\nCopies vtkTree tr into the R interpreter instance as a variable\nnamed RVariableName. If RVariableName already exists, it will be\noverwritten.\n"},
  {"AssignRVariableToVTKTree", PyvtkRInterface_AssignRVariableToVTKTree, METH_VARARGS,
   "V.AssignRVariableToVTKTree(string) -> vtkTree\nC++: vtkTree *AssignRVariableToVTKTree(const char *RVariableName)\n\nCopies the R variable RVariableName to the returned vtkDataArray.\n If the operation fails, the method will return NULL.\n"},
  {"AssignRVariableToVTKDataArray", PyvtkRInterface_AssignRVariableToVTKDataArray, METH_VARARGS,
   "V.AssignRVariableToVTKDataArray(string) -> vtkDataArray\nC++: vtkDataArray *AssignRVariableToVTKDataArray(\n    const char *RVariableName)\n\nCopies the R variable RVariableName to the returned vtkDataArray.\n If the operation fails, the method will return NULL.\n"},
  {"AssignRVariableToVTKArray", PyvtkRInterface_AssignRVariableToVTKArray, METH_VARARGS,
   "V.AssignRVariableToVTKArray(string) -> vtkArray\nC++: vtkArray *AssignRVariableToVTKArray(\n    const char *RVariableName)\n\nCopies the R variable RVariableName to the returned vtkArray.  If\nthe operation fails, the method will return NULL.  The returned\nvtkArray is currently always a vtkDenseArray of type double.\n"},
  {"AssignRVariableToVTKTable", PyvtkRInterface_AssignRVariableToVTKTable, METH_VARARGS,
   "V.AssignRVariableToVTKTable(string) -> vtkTable\nC++: vtkTable *AssignRVariableToVTKTable(\n    const char *RVariableName)\n\nCopies the R matrix or R list in RVariableName to the returned\nvtkTable.  If the operation fails, the method will return NULL. \nIf RVariableName is an R list, each list entry must be a vector\nof the same length.\n"},
  {"AssignVTKTableToRVariable", PyvtkRInterface_AssignVTKTableToRVariable, METH_VARARGS,
   "V.AssignVTKTableToRVariable(vtkTable, string)\nC++: void AssignVTKTableToRVariable(vtkTable *table,\n    const char *RVariableName)\n\nCopies the vtkTable given in table to an R list structure name\nRVariableName.  The R list will be length of the number of\ncolumns in table.  Each member of the list will contain a column\nof table.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkRInterface_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersStatisticsGnuRPython.vtkRInterface", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkRInterface_StaticNew()
{
  return vtkRInterface::New();
}

PyObject *PyvtkRInterface_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkRInterface_Type, PyvtkRInterface_Methods,
    "vtkRInterface",
    PyvtkRInterface_Doc(), &PyvtkRInterface_StaticNew);

  PyTypeObject *pytype = &PyvtkRInterface_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkRInterface_Doc()
{
  static const char *docstring[] = {
    "vtkRInterface\n\n",
    "Superclass: vtkObject\n\n",
    "This class defines a VTK interface to an embedded GNU R intepreter\ninstance.  An instance of the R interpreter is created when this\nclass is instantiated.  Additional instances of this class will share\naccess the same R interpreter.  The R interpreter will be shutdown\nwhen the application using this class exits.\n\nSee Also:\n\n\n vtkRadapter vtkRcalculatorFilter\n\nThanks:\n\n\n Developed by Thomas Otahal ",
    "at Sandia National Laboratories.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkRInterface(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkRInterface_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkRInterface", o) != 0)
    {
    Py_DECREF(o);
    }

}

