// python wrapper for vtkROIStencilSource
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkROIStencilSource.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkROIStencilSource(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkROIStencilSource_ClassNew(); }

#ifndef DECLARED_PyvtkImageStencilSource_ClassNew
extern "C" { PyObject *PyvtkImageStencilSource_ClassNew(); }
#define DECLARED_PyvtkImageStencilSource_ClassNew
#endif

static const char **PyvtkROIStencilSource_Doc();


static PyObject *
PyvtkROIStencilSource_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkROIStencilSource::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkROIStencilSource::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkROIStencilSource *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkROIStencilSource::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkROIStencilSource *tempr = vtkROIStencilSource::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_GetShape(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShape");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetShape() :
      op->vtkROIStencilSource::GetShape());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_SetShape(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetShape");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetShape(temp0);
      }
    else
      {
      op->vtkROIStencilSource::SetShape(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_GetShapeMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShapeMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetShapeMinValue() :
      op->vtkROIStencilSource::GetShapeMinValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_GetShapeMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShapeMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetShapeMaxValue() :
      op->vtkROIStencilSource::GetShapeMaxValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_SetShapeToBox(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetShapeToBox");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetShapeToBox();
      }
    else
      {
      op->vtkROIStencilSource::SetShapeToBox();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_SetShapeToEllipsoid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetShapeToEllipsoid");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetShapeToEllipsoid();
      }
    else
      {
      op->vtkROIStencilSource::SetShapeToEllipsoid();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_SetShapeToCylinderX(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetShapeToCylinderX");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetShapeToCylinderX();
      }
    else
      {
      op->vtkROIStencilSource::SetShapeToCylinderX();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_SetShapeToCylinderY(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetShapeToCylinderY");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetShapeToCylinderY();
      }
    else
      {
      op->vtkROIStencilSource::SetShapeToCylinderY();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_SetShapeToCylinderZ(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetShapeToCylinderZ");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetShapeToCylinderZ();
      }
    else
      {
      op->vtkROIStencilSource::SetShapeToCylinderZ();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_GetShapeAsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShapeAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetShapeAsString() :
      op->vtkROIStencilSource::GetShapeAsString());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_GetBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  int sizer = 6;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetBounds() :
      op->vtkROIStencilSource::GetBounds());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkROIStencilSource_SetBounds_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  double temp4;
  double temp5;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetValue(temp5))
    {
    if (ap.IsBound())
      {
      op->SetBounds(temp0, temp1, temp2, temp3, temp4, temp5);
      }
    else
      {
      op->vtkROIStencilSource::SetBounds(temp0, temp1, temp2, temp3, temp4, temp5);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkROIStencilSource_SetBounds_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkROIStencilSource *op = static_cast<vtkROIStencilSource *>(vp);

  double temp0[6];
  const int size0 = 6;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    if (ap.IsBound())
      {
      op->SetBounds(temp0);
      }
    else
      {
      op->vtkROIStencilSource::SetBounds(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkROIStencilSource_SetBounds(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 6:
      return PyvtkROIStencilSource_SetBounds_s1(self, args);
    case 1:
      return PyvtkROIStencilSource_SetBounds_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetBounds");
  return NULL;
}


static PyMethodDef PyvtkROIStencilSource_Methods[] = {
  {"GetClassName", PyvtkROIStencilSource_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkROIStencilSource_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkROIStencilSource_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkROIStencilSource\nC++: vtkROIStencilSource *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkROIStencilSource_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkROIStencilSource\nC++: vtkROIStencilSource *SafeDownCast(vtkObject* o)\n\n"},
  {"GetShape", PyvtkROIStencilSource_GetShape, METH_VARARGS,
   "V.GetShape() -> int\nC++: int GetShape()\n\nThe shape of the region of interest.  Cylinders can be oriented\nalong the X, Y, or Z axes.  The default shape is \"Box\".\n"},
  {"SetShape", PyvtkROIStencilSource_SetShape, METH_VARARGS,
   "V.SetShape(int)\nC++: void SetShape(int)\n\nThe shape of the region of interest.  Cylinders can be oriented\nalong the X, Y, or Z axes.  The default shape is \"Box\".\n"},
  {"GetShapeMinValue", PyvtkROIStencilSource_GetShapeMinValue, METH_VARARGS,
   "V.GetShapeMinValue() -> int\nC++: int GetShapeMinValue()\n\nThe shape of the region of interest.  Cylinders can be oriented\nalong the X, Y, or Z axes.  The default shape is \"Box\".\n"},
  {"GetShapeMaxValue", PyvtkROIStencilSource_GetShapeMaxValue, METH_VARARGS,
   "V.GetShapeMaxValue() -> int\nC++: int GetShapeMaxValue()\n\nThe shape of the region of interest.  Cylinders can be oriented\nalong the X, Y, or Z axes.  The default shape is \"Box\".\n"},
  {"SetShapeToBox", PyvtkROIStencilSource_SetShapeToBox, METH_VARARGS,
   "V.SetShapeToBox()\nC++: void SetShapeToBox()\n\nThe shape of the region of interest.  Cylinders can be oriented\nalong the X, Y, or Z axes.  The default shape is \"Box\".\n"},
  {"SetShapeToEllipsoid", PyvtkROIStencilSource_SetShapeToEllipsoid, METH_VARARGS,
   "V.SetShapeToEllipsoid()\nC++: void SetShapeToEllipsoid()\n\nThe shape of the region of interest.  Cylinders can be oriented\nalong the X, Y, or Z axes.  The default shape is \"Box\".\n"},
  {"SetShapeToCylinderX", PyvtkROIStencilSource_SetShapeToCylinderX, METH_VARARGS,
   "V.SetShapeToCylinderX()\nC++: void SetShapeToCylinderX()\n\nThe shape of the region of interest.  Cylinders can be oriented\nalong the X, Y, or Z axes.  The default shape is \"Box\".\n"},
  {"SetShapeToCylinderY", PyvtkROIStencilSource_SetShapeToCylinderY, METH_VARARGS,
   "V.SetShapeToCylinderY()\nC++: void SetShapeToCylinderY()\n\nThe shape of the region of interest.  Cylinders can be oriented\nalong the X, Y, or Z axes.  The default shape is \"Box\".\n"},
  {"SetShapeToCylinderZ", PyvtkROIStencilSource_SetShapeToCylinderZ, METH_VARARGS,
   "V.SetShapeToCylinderZ()\nC++: void SetShapeToCylinderZ()\n\nThe shape of the region of interest.  Cylinders can be oriented\nalong the X, Y, or Z axes.  The default shape is \"Box\".\n"},
  {"GetShapeAsString", PyvtkROIStencilSource_GetShapeAsString, METH_VARARGS,
   "V.GetShapeAsString() -> string\nC++: virtual const char *GetShapeAsString()\n\nThe shape of the region of interest.  Cylinders can be oriented\nalong the X, Y, or Z axes.  The default shape is \"Box\".\n"},
  {"GetBounds", PyvtkROIStencilSource_GetBounds, METH_VARARGS,
   "V.GetBounds() -> (float, float, float, float, float, float)\nC++: double *GetBounds()\n\n"},
  {"SetBounds", PyvtkROIStencilSource_SetBounds, METH_VARARGS,
   "V.SetBounds(float, float, float, float, float, float)\nC++: void SetBounds(double, double, double, double, double,\n    double)\nV.SetBounds((float, float, float, float, float, float))\nC++: void SetBounds(double a[6])\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkROIStencilSource_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingStencilPython.vtkROIStencilSource", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkROIStencilSource_StaticNew()
{
  return vtkROIStencilSource::New();
}

PyObject *PyvtkROIStencilSource_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkROIStencilSource_Type, PyvtkROIStencilSource_Methods,
    "vtkROIStencilSource",
    PyvtkROIStencilSource_Doc(), &PyvtkROIStencilSource_StaticNew);

  PyTypeObject *pytype = &PyvtkROIStencilSource_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageStencilSource_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 5; c++)
    {
    static const struct { const char *name; int value; }
      constants[5] = {
        { "BOX", vtkROIStencilSource::BOX },
        { "ELLIPSOID", vtkROIStencilSource::ELLIPSOID },
        { "CYLINDERX", vtkROIStencilSource::CYLINDERX },
        { "CYLINDERY", vtkROIStencilSource::CYLINDERY },
        { "CYLINDERZ", vtkROIStencilSource::CYLINDERZ },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
      {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
      }
    }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkROIStencilSource_Doc()
{
  static const char *docstring[] = {
    "vtkROIStencilSource - create simple mask shapes\n\n",
    "Superclass: vtkImageStencilSource\n\n",
    "vtkROIStencilSource will create an image stencil with a simple shape\nlike a box, a sphere, or a cylinder.  Its output can be used with\nvtkImageStecil or other vtk classes that apply a stencil to an image.\n\nSee Also:\n\nvtkImplicitFunctionToImageStencil vtkLassoStencilSource\n\nThanks:\n\nThanks to David Gobbi for contributing this class to VTK.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkROIStencilSource(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkROIStencilSource_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkROIStencilSource", o) != 0)
    {
    Py_DECREF(o);
    }

}

