// python wrapper for vtkRRandomTableSource
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkRRandomTableSource.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkRRandomTableSource(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkRRandomTableSource_ClassNew(); }

#ifndef DECLARED_PyvtkTableAlgorithm_ClassNew
extern "C" { PyObject *PyvtkTableAlgorithm_ClassNew(); }
#define DECLARED_PyvtkTableAlgorithm_ClassNew
#endif

static const char **PyvtkRRandomTableSource_Doc();


static PyObject *
PyvtkRRandomTableSource_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRRandomTableSource *op = static_cast<vtkRRandomTableSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkRRandomTableSource::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRRandomTableSource_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRRandomTableSource *op = static_cast<vtkRRandomTableSource *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkRRandomTableSource::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRRandomTableSource_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRRandomTableSource *op = static_cast<vtkRRandomTableSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkRRandomTableSource *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkRRandomTableSource::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkRRandomTableSource_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkRRandomTableSource *tempr = vtkRRandomTableSource::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRRandomTableSource_SetNumberOfRows(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfRows");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRRandomTableSource *op = static_cast<vtkRRandomTableSource *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetNumberOfRows(temp0);
      }
    else
      {
      op->vtkRRandomTableSource::SetNumberOfRows(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkRRandomTableSource_GetNumberOfRows(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfRows");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRRandomTableSource *op = static_cast<vtkRRandomTableSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfRows() :
      op->vtkRRandomTableSource::GetNumberOfRows());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRRandomTableSource_GetNumberOfColumns(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfColumns");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRRandomTableSource *op = static_cast<vtkRRandomTableSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfColumns() :
      op->vtkRRandomTableSource::GetNumberOfColumns());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRRandomTableSource_ClearTableOutput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ClearTableOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRRandomTableSource *op = static_cast<vtkRRandomTableSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->ClearTableOutput();
      }
    else
      {
      op->vtkRRandomTableSource::ClearTableOutput();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkRRandomTableSource_SetRandGenSeed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRandGenSeed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRRandomTableSource *op = static_cast<vtkRRandomTableSource *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetRandGenSeed(temp0);
      }
    else
      {
      op->vtkRRandomTableSource::SetRandGenSeed(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkRRandomTableSource_SetStatisticalDistributionForColumn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStatisticalDistributionForColumn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRRandomTableSource *op = static_cast<vtkRRandomTableSource *>(vp);

  int temp0;
  double temp1;
  double temp2;
  double temp3;
  char *temp4 = NULL;
  int temp5;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetValue(temp5))
    {
    if (ap.IsBound())
      {
      op->SetStatisticalDistributionForColumn(temp0, temp1, temp2, temp3, temp4, temp5);
      }
    else
      {
      op->vtkRRandomTableSource::SetStatisticalDistributionForColumn(temp0, temp1, temp2, temp3, temp4, temp5);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkRRandomTableSource_Methods[] = {
  {"GetClassName", PyvtkRRandomTableSource_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkRRandomTableSource_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkRRandomTableSource_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkRRandomTableSource\nC++: vtkRRandomTableSource *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkRRandomTableSource_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkRRandomTableSource\nC++: vtkRRandomTableSource *SafeDownCast(vtkObject* o)\n\n"},
  {"SetNumberOfRows", PyvtkRRandomTableSource_SetNumberOfRows, METH_VARARGS,
   "V.SetNumberOfRows(int)\nC++: void SetNumberOfRows(int nrows)\n\nSet and Get the number of rows in the output table (random\nnumbers).\n"},
  {"GetNumberOfRows", PyvtkRRandomTableSource_GetNumberOfRows, METH_VARARGS,
   "V.GetNumberOfRows() -> int\nC++: int GetNumberOfRows()\n\nSet and Get the number of rows in the output table (random\nnumbers).\n"},
  {"GetNumberOfColumns", PyvtkRRandomTableSource_GetNumberOfColumns, METH_VARARGS,
   "V.GetNumberOfColumns() -> int\nC++: int GetNumberOfColumns()\n\nReturns number of columns in the output table.\n"},
  {"ClearTableOutput", PyvtkRRandomTableSource_ClearTableOutput, METH_VARARGS,
   "V.ClearTableOutput()\nC++: void ClearTableOutput()\n\nClears table output to zero output columns.  Number of table rows\nis unchanged.\n"},
  {"SetRandGenSeed", PyvtkRRandomTableSource_SetRandGenSeed, METH_VARARGS,
   "V.SetRandGenSeed(int)\nC++: void SetRandGenSeed(const int seed)\n\nSet the random seed used by Gnu R to generate output.  The\ndefault is to use the random seed provided by Gnu R based on the\ncurrent time.\n"},
  {"SetStatisticalDistributionForColumn", PyvtkRRandomTableSource_SetStatisticalDistributionForColumn, METH_VARARGS,
   "V.SetStatisticalDistributionForColumn(int, float, float, float,\n    string, int)\nC++: void SetStatisticalDistributionForColumn(int StatDistType,\n    double param1, double param2, double param3,\n    const char *ColumnName, int column_index)\n\nPython wrapped version of above method.  Use integer equivalent\nof StatDistType.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkRRandomTableSource_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersStatisticsGnuRPython.vtkRRandomTableSource", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkRRandomTableSource_StaticNew()
{
  return vtkRRandomTableSource::New();
}

PyObject *PyvtkRRandomTableSource_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkRRandomTableSource_Type, PyvtkRRandomTableSource_Methods,
    "vtkRRandomTableSource",
    PyvtkRRandomTableSource_Doc(), &PyvtkRRandomTableSource_StaticNew);

  PyTypeObject *pytype = &PyvtkRRandomTableSource_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTableAlgorithm_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 19; c++)
    {
    static const struct { const char *name; int value; }
      constants[19] = {
        { "WILCOXONRANKSUM", vtkRRandomTableSource::WILCOXONRANKSUM },
        { "WILCOXONSIGNEDRANK", vtkRRandomTableSource::WILCOXONSIGNEDRANK },
        { "LOGISTIC", vtkRRandomTableSource::LOGISTIC },
        { "WEIBULL", vtkRRandomTableSource::WEIBULL },
        { "POISSON", vtkRRandomTableSource::POISSON },
        { "NEGBINOMIAL", vtkRRandomTableSource::NEGBINOMIAL },
        { "HYPERGEOM", vtkRRandomTableSource::HYPERGEOM },
        { "GEOM", vtkRRandomTableSource::GEOM },
        { "EXP", vtkRRandomTableSource::EXP },
        { "CAUCHY", vtkRRandomTableSource::CAUCHY },
        { "T", vtkRRandomTableSource::T },
        { "F", vtkRRandomTableSource::F },
        { "LOGNORMAL", vtkRRandomTableSource::LOGNORMAL },
        { "GAMMA", vtkRRandomTableSource::GAMMA },
        { "UNIF", vtkRRandomTableSource::UNIF },
        { "BETA", vtkRRandomTableSource::BETA },
        { "BINOMIAL", vtkRRandomTableSource::BINOMIAL },
        { "NORMAL", vtkRRandomTableSource::NORMAL },
        { "CHISQUARE", vtkRRandomTableSource::CHISQUARE },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
      {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
      }
    }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkRRandomTableSource_Doc()
{
  static const char *docstring[] = {
    "vtkRRandomTableSource - Generates vtkTables with columns of random\nnumbers using Gnu R.\n\n",
    "Superclass: vtkTableAlgorithm\n\n",
    "Note - An installation of Gnu R is required to build and use this\nclass.\n\nvtkRRandomTableSource uses the Gnu R math C language API for\nstatistical distributions to generate vtkTables with columns of\nrandom numbers selected from a chosen distribution. The available\ndistributions are as follows:\n\n\n  Normal, Cauchy, F, Student T, Poisson, Chi-Square, Exponential,\nBinomial, Beta, Geometric,\n  Uniform,",
    " Gamma, Log-Normal, Logistic, Hyper-Geometric, Weibull,\nNegative Binomial, Wilcox\n\nThe default output for the class is a table of one column with ten\nrows of random numbers chosen from a Normal distribution of mean 0.0\nand standard deviation of 1.0.\n\nUse SetNumberOfRows() to set the number of rows (random numbers) in\nthe output table.\n\nSee comments for SetStatisticalDistributionForColumn() to set ",
    "the\ndistribution output for a particular column or all columns in the\noutput table.\n\nSee Also:\n\nvtkRInterface\n\nThanks:\n\nDeveloped by Thomas J. Otahal (tjotaha@sandia.gov) at Sandia National\nLaboratories.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkRRandomTableSource(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkRRandomTableSource_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkRRandomTableSource", o) != 0)
    {
    Py_DECREF(o);
    }

}

