// python wrapper for vtkRenderedSurfaceRepresentation
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkRenderedSurfaceRepresentation.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkRenderedSurfaceRepresentation(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkRenderedSurfaceRepresentation_ClassNew(); }

#ifndef DECLARED_PyvtkRenderedRepresentation_ClassNew
extern "C" { PyObject *PyvtkRenderedRepresentation_ClassNew(); }
#define DECLARED_PyvtkRenderedRepresentation_ClassNew
#endif

static const char **PyvtkRenderedSurfaceRepresentation_Doc();


static PyObject *
PyvtkRenderedSurfaceRepresentation_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderedSurfaceRepresentation *op = static_cast<vtkRenderedSurfaceRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkRenderedSurfaceRepresentation::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRenderedSurfaceRepresentation_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderedSurfaceRepresentation *op = static_cast<vtkRenderedSurfaceRepresentation *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkRenderedSurfaceRepresentation::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRenderedSurfaceRepresentation_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderedSurfaceRepresentation *op = static_cast<vtkRenderedSurfaceRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkRenderedSurfaceRepresentation *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkRenderedSurfaceRepresentation::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkRenderedSurfaceRepresentation_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkRenderedSurfaceRepresentation *tempr = vtkRenderedSurfaceRepresentation::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRenderedSurfaceRepresentation_SetCellColorArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCellColorArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderedSurfaceRepresentation *op = static_cast<vtkRenderedSurfaceRepresentation *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetCellColorArrayName(temp0);
      }
    else
      {
      op->vtkRenderedSurfaceRepresentation::SetCellColorArrayName(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkRenderedSurfaceRepresentation_GetCellColorArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCellColorArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderedSurfaceRepresentation *op = static_cast<vtkRenderedSurfaceRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetCellColorArrayName() :
      op->vtkRenderedSurfaceRepresentation::GetCellColorArrayName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkRenderedSurfaceRepresentation_ApplyViewTheme(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ApplyViewTheme");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderedSurfaceRepresentation *op = static_cast<vtkRenderedSurfaceRepresentation *>(vp);

  vtkViewTheme *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkViewTheme"))
    {
    if (ap.IsBound())
      {
      op->ApplyViewTheme(temp0);
      }
    else
      {
      op->vtkRenderedSurfaceRepresentation::ApplyViewTheme(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkRenderedSurfaceRepresentation_Methods[] = {
  {"GetClassName", PyvtkRenderedSurfaceRepresentation_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkRenderedSurfaceRepresentation_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkRenderedSurfaceRepresentation_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkRenderedSurfaceRepresentation\nC++: vtkRenderedSurfaceRepresentation *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkRenderedSurfaceRepresentation_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkRenderedSurfaceRepresentation\nC++: vtkRenderedSurfaceRepresentation *SafeDownCast(vtkObject* o)\n\n"},
  {"SetCellColorArrayName", PyvtkRenderedSurfaceRepresentation_SetCellColorArrayName, METH_VARARGS,
   "V.SetCellColorArrayName(string)\nC++: virtual void SetCellColorArrayName(const char *arrayName)\n\n"},
  {"GetCellColorArrayName", PyvtkRenderedSurfaceRepresentation_GetCellColorArrayName, METH_VARARGS,
   "V.GetCellColorArrayName() -> string\nC++: virtual const char *GetCellColorArrayName()\n\n"},
  {"ApplyViewTheme", PyvtkRenderedSurfaceRepresentation_ApplyViewTheme, METH_VARARGS,
   "V.ApplyViewTheme(vtkViewTheme)\nC++: virtual void ApplyViewTheme(vtkViewTheme *theme)\n\nApply a theme to this representation.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkRenderedSurfaceRepresentation_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkViewsInfovisPython.vtkRenderedSurfaceRepresentation", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkRenderedSurfaceRepresentation_StaticNew()
{
  return vtkRenderedSurfaceRepresentation::New();
}

PyObject *PyvtkRenderedSurfaceRepresentation_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkRenderedSurfaceRepresentation_Type, PyvtkRenderedSurfaceRepresentation_Methods,
    "vtkRenderedSurfaceRepresentation",
    PyvtkRenderedSurfaceRepresentation_Doc(), &PyvtkRenderedSurfaceRepresentation_StaticNew);

  PyTypeObject *pytype = &PyvtkRenderedSurfaceRepresentation_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkRenderedRepresentation_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkRenderedSurfaceRepresentation_Doc()
{
  static const char *docstring[] = {
    "vtkRenderedSurfaceRepresentation - Displays a geometric dataset as a\nsurface.\n\n",
    "Superclass: vtkRenderedRepresentation\n\n",
    "vtkRenderedSurfaceRepresentation is used to show a geometric dataset\nin a view. The representation uses a vtkGeometryFilter to convert the\ndataset to polygonal data (e.g. volumetric data is converted to its\nexternal surface). The representation may then be added to\nvtkRenderView.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkRenderedSurfaceRepresentation(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkRenderedSurfaceRepresentation_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkRenderedSurfaceRepresentation", o) != 0)
    {
    Py_DECREF(o);
    }

}

