// python wrapper for vtkResliceCursorThickLineRepresentation
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkResliceCursorThickLineRepresentation.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkResliceCursorThickLineRepresentation(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkResliceCursorThickLineRepresentation_ClassNew(); }

#ifndef DECLARED_PyvtkResliceCursorLineRepresentation_ClassNew
extern "C" { PyObject *PyvtkResliceCursorLineRepresentation_ClassNew(); }
#define DECLARED_PyvtkResliceCursorLineRepresentation_ClassNew
#endif

static const char **PyvtkResliceCursorThickLineRepresentation_Doc();


static PyObject *
PyvtkResliceCursorThickLineRepresentation_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkResliceCursorThickLineRepresentation *op = static_cast<vtkResliceCursorThickLineRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkResliceCursorThickLineRepresentation::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkResliceCursorThickLineRepresentation_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkResliceCursorThickLineRepresentation *op = static_cast<vtkResliceCursorThickLineRepresentation *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkResliceCursorThickLineRepresentation::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkResliceCursorThickLineRepresentation_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkResliceCursorThickLineRepresentation *op = static_cast<vtkResliceCursorThickLineRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkResliceCursorThickLineRepresentation *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkResliceCursorThickLineRepresentation::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkResliceCursorThickLineRepresentation_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkResliceCursorThickLineRepresentation *tempr = vtkResliceCursorThickLineRepresentation::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkResliceCursorThickLineRepresentation_CreateDefaultResliceAlgorithm(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateDefaultResliceAlgorithm");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkResliceCursorThickLineRepresentation *op = static_cast<vtkResliceCursorThickLineRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->CreateDefaultResliceAlgorithm();
      }
    else
      {
      op->vtkResliceCursorThickLineRepresentation::CreateDefaultResliceAlgorithm();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkResliceCursorThickLineRepresentation_SetResliceParameters(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetResliceParameters");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkResliceCursorThickLineRepresentation *op = static_cast<vtkResliceCursorThickLineRepresentation *>(vp);

  double temp0;
  double temp1;
  int temp2;
  int temp3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
    {
    if (ap.IsBound())
      {
      op->SetResliceParameters(temp0, temp1, temp2, temp3);
      }
    else
      {
      op->vtkResliceCursorThickLineRepresentation::SetResliceParameters(temp0, temp1, temp2, temp3);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkResliceCursorThickLineRepresentation_Methods[] = {
  {"GetClassName", PyvtkResliceCursorThickLineRepresentation_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\nStandard VTK methods.\n"},
  {"IsA", PyvtkResliceCursorThickLineRepresentation_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\nStandard VTK methods.\n"},
  {"NewInstance", PyvtkResliceCursorThickLineRepresentation_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkResliceCursorThickLineRepresentation\nC++: vtkResliceCursorThickLineRepresentation *NewInstance()\n\nStandard VTK methods.\n"},
  {"SafeDownCast", PyvtkResliceCursorThickLineRepresentation_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject)\n    -> vtkResliceCursorThickLineRepresentation\nC++: vtkResliceCursorThickLineRepresentation *SafeDownCast(\n    vtkObject* o)\n\nStandard VTK methods.\n"},
  {"CreateDefaultResliceAlgorithm", PyvtkResliceCursorThickLineRepresentation_CreateDefaultResliceAlgorithm, METH_VARARGS,
   "V.CreateDefaultResliceAlgorithm()\nC++: virtual void CreateDefaultResliceAlgorithm()\n\nINTERNAL - Do not use Create the thick reformat class. This\noverrides the superclass implementation and creates a\nvtkImageSlabReslice instead of a vtkImageReslice.\n"},
  {"SetResliceParameters", PyvtkResliceCursorThickLineRepresentation_SetResliceParameters, METH_VARARGS,
   "V.SetResliceParameters(float, float, int, int)\nC++: virtual void SetResliceParameters(double outputSpacingX,\n    double outputSpacingY, int extentX, int extentY)\n\nINTERNAL - Do not use Reslice parameters which are set from\nvtkResliceCursorWidget based on user interactions.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkResliceCursorThickLineRepresentation_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInteractionWidgetsPython.vtkResliceCursorThickLineRepresentation", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkResliceCursorThickLineRepresentation_StaticNew()
{
  return vtkResliceCursorThickLineRepresentation::New();
}

PyObject *PyvtkResliceCursorThickLineRepresentation_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkResliceCursorThickLineRepresentation_Type, PyvtkResliceCursorThickLineRepresentation_Methods,
    "vtkResliceCursorThickLineRepresentation",
    PyvtkResliceCursorThickLineRepresentation_Doc(), &PyvtkResliceCursorThickLineRepresentation_StaticNew);

  PyTypeObject *pytype = &PyvtkResliceCursorThickLineRepresentation_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkResliceCursorLineRepresentation_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkResliceCursorThickLineRepresentation_Doc()
{
  static const char *docstring[] = {
    "vtkResliceCursorThickLineRepresentation - represents a thick slab of\nthe reslice cursor widget\n\n",
    "Superclass: vtkResliceCursorLineRepresentation\n\n",
    "This class respresents a thick reslice cursor, that can be used to\nperform interactive thick slab MPR's through data. The class\ninternally uses vtkImageSlabReslice to do its reslicing. The slab\nthickness is set interactively from the widget. The slab resolution\n(ie the number of blend points) is set as the minimum spacing along\nany dimension from the dataset.\n\nSee Also:\n\nvtkImageSlabReslice vtkRes",
    "liceCursorLineRepresentation\nvtkResliceCursorWidget\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkResliceCursorThickLineRepresentation(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkResliceCursorThickLineRepresentation_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkResliceCursorThickLineRepresentation", o) != 0)
    {
    Py_DECREF(o);
    }

}

