// python wrapper for vtkSMPProgressObserver
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkSMPProgressObserver.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMPProgressObserver(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMPProgressObserver_ClassNew(); }

#ifndef DECLARED_PyvtkProgressObserver_ClassNew
extern "C" { PyObject *PyvtkProgressObserver_ClassNew(); }
#define DECLARED_PyvtkProgressObserver_ClassNew
#endif

static const char **PyvtkSMPProgressObserver_Doc();


static PyObject *
PyvtkSMPProgressObserver_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPProgressObserver *op = static_cast<vtkSMPProgressObserver *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkSMPProgressObserver::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkSMPProgressObserver_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPProgressObserver *op = static_cast<vtkSMPProgressObserver *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMPProgressObserver::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkSMPProgressObserver_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPProgressObserver *op = static_cast<vtkSMPProgressObserver *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkSMPProgressObserver *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMPProgressObserver::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkSMPProgressObserver_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkSMPProgressObserver *tempr = vtkSMPProgressObserver::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkSMPProgressObserver_UpdateProgress(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateProgress");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPProgressObserver *op = static_cast<vtkSMPProgressObserver *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->UpdateProgress(temp0);
      }
    else
      {
      op->vtkSMPProgressObserver::UpdateProgress(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkSMPProgressObserver_GetLocalObserver(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLocalObserver");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPProgressObserver *op = static_cast<vtkSMPProgressObserver *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkProgressObserver *tempr = (ap.IsBound() ?
      op->GetLocalObserver() :
      op->vtkSMPProgressObserver::GetLocalObserver());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkSMPProgressObserver_Methods[] = {
  {"GetClassName", PyvtkSMPProgressObserver_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkSMPProgressObserver_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkSMPProgressObserver_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMPProgressObserver\nC++: vtkSMPProgressObserver *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkSMPProgressObserver_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkSMPProgressObserver\nC++: vtkSMPProgressObserver *SafeDownCast(vtkObject* o)\n\n"},
  {"UpdateProgress", PyvtkSMPProgressObserver_UpdateProgress, METH_VARARGS,
   "V.UpdateProgress(float)\nC++: void UpdateProgress(double amount)\n\nPasses the progress event to a thread local ProgressObserver\ninstance.\n"},
  {"GetLocalObserver", PyvtkSMPProgressObserver_GetLocalObserver, METH_VARARGS,
   "V.GetLocalObserver() -> vtkProgressObserver\nC++: vtkProgressObserver *GetLocalObserver()\n\nReturns the progress observer local to the thread it was called\nfrom.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMPProgressObserver_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonExecutionModelPython.vtkSMPProgressObserver", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMPProgressObserver_StaticNew()
{
  return vtkSMPProgressObserver::New();
}

PyObject *PyvtkSMPProgressObserver_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMPProgressObserver_Type, PyvtkSMPProgressObserver_Methods,
    "vtkSMPProgressObserver",
    PyvtkSMPProgressObserver_Doc(), &PyvtkSMPProgressObserver_StaticNew);

  PyTypeObject *pytype = &PyvtkSMPProgressObserver_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkProgressObserver_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMPProgressObserver_Doc()
{
  static const char *docstring[] = {
    "vtkSMPProgressObserver - Progress observer that is thread safe\n\n",
    "Superclass: vtkProgressObserver\n\n",
    "vtkSMPProgressObserver is designed to handle progress events coming\nfrom an algorithm in a thread safe way. It does this by using thread\nlocal objects that it updates. To receive the progress information,\none has to listen to the local observer in the same thread. Since the\nexecution will be somewhat load balanced, it may be enough to do this\nonly on the main thread.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMPProgressObserver(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMPProgressObserver_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMPProgressObserver", o) != 0)
    {
    Py_DECREF(o);
    }

}

