// python wrapper for vtkShaderProgram
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkShaderProgram.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkShaderProgram(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkShaderProgram_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkShaderProgram_Doc();

static PyTypeObject PyvtkShaderProgram_NormalizeOption_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkShaderProgram.NormalizeOption", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkShaderProgram_NormalizeOption_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkShaderProgram_NormalizeOption_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkShaderProgram_NormalizeOption_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}


static PyObject *
PyvtkShaderProgram_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkShaderProgram::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkShaderProgram::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkShaderProgram *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkShaderProgram::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkShaderProgram *tempr = vtkShaderProgram::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_GetVertexShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVertexShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkShader *tempr = (ap.IsBound() ?
      op->GetVertexShader() :
      op->vtkShaderProgram::GetVertexShader());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetVertexShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVertexShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  vtkShader *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkShader"))
    {
    if (ap.IsBound())
      {
      op->SetVertexShader(temp0);
      }
    else
      {
      op->vtkShaderProgram::SetVertexShader(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_GetFragmentShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFragmentShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkShader *tempr = (ap.IsBound() ?
      op->GetFragmentShader() :
      op->vtkShaderProgram::GetFragmentShader());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetFragmentShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFragmentShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  vtkShader *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkShader"))
    {
    if (ap.IsBound())
      {
      op->SetFragmentShader(temp0);
      }
    else
      {
      op->vtkShaderProgram::SetFragmentShader(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_GetGeometryShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGeometryShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkShader *tempr = (ap.IsBound() ?
      op->GetGeometryShader() :
      op->vtkShaderProgram::GetGeometryShader());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetGeometryShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGeometryShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  vtkShader *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkShader"))
    {
    if (ap.IsBound())
      {
      op->SetGeometryShader(temp0);
      }
    else
      {
      op->vtkShaderProgram::SetGeometryShader(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_GetCompiled(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompiled");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->GetCompiled() :
      op->vtkShaderProgram::GetCompiled());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetCompiled(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCompiled");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetCompiled(temp0);
      }
    else
      {
      op->vtkShaderProgram::SetCompiled(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_CompiledOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CompiledOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->CompiledOn();
      }
    else
      {
      op->vtkShaderProgram::CompiledOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_CompiledOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CompiledOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->CompiledOff();
      }
    else
      {
      op->vtkShaderProgram::CompiledOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_GetMD5Hash(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMD5Hash");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    std::string tempr = (ap.IsBound() ?
      op->GetMD5Hash() :
      op->vtkShaderProgram::GetMD5Hash());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetMD5Hash(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMD5Hash");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  std::string temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetMD5Hash(temp0);
      }
    else
      {
      op->vtkShaderProgram::SetMD5Hash(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_isBound(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "isBound");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->isBound() :
      op->vtkShaderProgram::isBound());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
    {
    if (ap.IsBound())
      {
      op->ReleaseGraphicsResources(temp0);
      }
    else
      {
      op->vtkShaderProgram::ReleaseGraphicsResources(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_GetHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetHandle() :
      op->vtkShaderProgram::GetHandle());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_GetError(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetError");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    std::string tempr = (ap.IsBound() ?
      op->GetError() :
      op->vtkShaderProgram::GetError());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_EnableAttributeArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EnableAttributeArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    bool tempr = (ap.IsBound() ?
      op->EnableAttributeArray(temp0) :
      op->vtkShaderProgram::EnableAttributeArray(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_DisableAttributeArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DisableAttributeArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    bool tempr = (ap.IsBound() ?
      op->DisableAttributeArray(temp0) :
      op->vtkShaderProgram::DisableAttributeArray(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_UseAttributeArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseAttributeArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  int temp1;
  size_t temp2;
  int temp3;
  int temp4;
  typedef vtkShaderProgram::NormalizeOption temp5_type;
  temp5_type temp5;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetEnumValue(temp5, "vtkShaderProgram.NormalizeOption"))
    {
    bool tempr = (ap.IsBound() ?
      op->UseAttributeArray(temp0, temp1, temp2, temp3, temp4, temp5) :
      op->vtkShaderProgram::UseAttributeArray(temp0, temp1, temp2, temp3, temp4, temp5));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetUniformi(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformi");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    bool tempr = (ap.IsBound() ?
      op->SetUniformi(temp0, temp1) :
      op->vtkShaderProgram::SetUniformi(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetUniformf(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformf");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  float temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    bool tempr = (ap.IsBound() ?
      op->SetUniformf(temp0, temp1) :
      op->vtkShaderProgram::SetUniformf(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetUniform2i(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform2i");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  int temp1[2];
  const int size1 = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
    {
    bool tempr = (ap.IsBound() ?
      op->SetUniform2i(temp0, temp1) :
      op->vtkShaderProgram::SetUniform2i(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetUniform2f(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform2f");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  float temp1[2];
  const int size1 = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
    {
    bool tempr = (ap.IsBound() ?
      op->SetUniform2f(temp0, temp1) :
      op->vtkShaderProgram::SetUniform2f(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetUniform3f(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform3f");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  float temp1[3];
  const int size1 = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
    {
    bool tempr = (ap.IsBound() ?
      op->SetUniform3f(temp0, temp1) :
      op->vtkShaderProgram::SetUniform3f(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetUniform4f(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform4f");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  float temp1[4];
  const int size1 = 4;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
    {
    bool tempr = (ap.IsBound() ?
      op->SetUniform4f(temp0, temp1) :
      op->vtkShaderProgram::SetUniform4f(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetUniform3uc(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform3uc");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  unsigned char temp1[3];
  const int size1 = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
    {
    bool tempr = (ap.IsBound() ?
      op->SetUniform3uc(temp0, temp1) :
      op->vtkShaderProgram::SetUniform3uc(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetUniform4uc(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform4uc");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  unsigned char temp1[4];
  const int size1 = 4;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
    {
    bool tempr = (ap.IsBound() ?
      op->SetUniform4uc(temp0, temp1) :
      op->vtkShaderProgram::SetUniform4uc(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetUniformMatrix_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  vtkMatrix3x3 *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkMatrix3x3"))
    {
    bool tempr = (ap.IsBound() ?
      op->SetUniformMatrix(temp0, temp1) :
      op->vtkShaderProgram::SetUniformMatrix(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyObject *
PyvtkShaderProgram_SetUniformMatrix_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  vtkMatrix4x4 *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkMatrix4x4"))
    {
    bool tempr = (ap.IsBound() ?
      op->SetUniformMatrix(temp0, temp1) :
      op->vtkShaderProgram::SetUniformMatrix(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkShaderProgram_SetUniformMatrix_Methods[] = {
  {NULL, PyvtkShaderProgram_SetUniformMatrix_s1, METH_VARARGS,
   "@zV *vtkMatrix3x3"},
  {NULL, PyvtkShaderProgram_SetUniformMatrix_s2, METH_VARARGS,
   "@zV *vtkMatrix4x4"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkShaderProgram_SetUniformMatrix(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkShaderProgram_SetUniformMatrix_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 2:
      return vtkPythonOverload::CallMethod(methods, self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetUniformMatrix");
  return NULL;
}



static PyObject *
PyvtkShaderProgram_SetUniformMatrix3x3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformMatrix3x3");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  float *temp1 = NULL;
  float *save1 = NULL;
  float small1[8];
  int size1 = 0;
  PyObject *result = NULL;

  if (op)
    {
    size1 = ap.GetArgSize(1);
    temp1 = small1;
    if (size1 > 4)
      {
      temp1 = new float[2*size1];
      }
    save1 = &temp1[size1];
    }

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
    {
    ap.SaveArray(temp1, save1, size1);

    bool tempr = (ap.IsBound() ?
      op->SetUniformMatrix3x3(temp0, temp1) :
      op->vtkShaderProgram::SetUniformMatrix3x3(temp0, temp1));

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(1, temp1, size1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  if (temp1 != small1)
    {
    delete [] temp1;
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetUniformMatrix4x4(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformMatrix4x4");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  float *temp1 = NULL;
  float *save1 = NULL;
  float small1[8];
  int size1 = 0;
  PyObject *result = NULL;

  if (op)
    {
    size1 = ap.GetArgSize(1);
    temp1 = small1;
    if (size1 > 4)
      {
      temp1 = new float[2*size1];
      }
    save1 = &temp1[size1];
    }

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
    {
    ap.SaveArray(temp1, save1, size1);

    bool tempr = (ap.IsBound() ?
      op->SetUniformMatrix4x4(temp0, temp1) :
      op->vtkShaderProgram::SetUniformMatrix4x4(temp0, temp1));

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(1, temp1, size1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  if (temp1 != small1)
    {
    delete [] temp1;
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetUniform1iv(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform1iv");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  int temp1;
  int *temp2 = NULL;
  int small2[4];
  int size2 = 0;
  PyObject *result = NULL;

  if (op)
    {
    size2 = ap.GetArgSize(2);
    temp2 = small2;
    if (size2 > 4)
      {
      temp2 = new int[size2];
      }
    }

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
    {
    bool tempr = (ap.IsBound() ?
      op->SetUniform1iv(temp0, temp1, temp2) :
      op->vtkShaderProgram::SetUniform1iv(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  if (temp2 != small2)
    {
    delete [] temp2;
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetUniform1fv(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform1fv");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  int temp1;
  float *temp2 = NULL;
  float small2[4];
  int size2 = 0;
  PyObject *result = NULL;

  if (op)
    {
    size2 = ap.GetArgSize(2);
    temp2 = small2;
    if (size2 > 4)
      {
      temp2 = new float[size2];
      }
    }

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
    {
    bool tempr = (ap.IsBound() ?
      op->SetUniform1fv(temp0, temp1, temp2) :
      op->vtkShaderProgram::SetUniform1fv(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  if (temp2 != small2)
    {
    delete [] temp2;
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetUniformMatrix4x4v(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformMatrix4x4v");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  int temp1;
  float *temp2 = NULL;
  float *save2 = NULL;
  float small2[8];
  int size2 = 0;
  PyObject *result = NULL;

  if (op)
    {
    size2 = ap.GetArgSize(2);
    temp2 = small2;
    if (size2 > 4)
      {
      temp2 = new float[2*size2];
      }
    save2 = &temp2[size2];
    }

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
    {
    ap.SaveArray(temp2, save2, size2);

    bool tempr = (ap.IsBound() ?
      op->SetUniformMatrix4x4v(temp0, temp1, temp2) :
      op->vtkShaderProgram::SetUniformMatrix4x4v(temp0, temp1, temp2));

    if (ap.ArrayHasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(2, temp2, size2);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  if (temp2 != small2)
    {
    delete [] temp2;
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_SetNumberOfOutputs(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfOutputs");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetNumberOfOutputs(temp0);
      }
    else
      {
      op->vtkShaderProgram::SetNumberOfOutputs(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_Substitute(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "Substitute");

  std::string temp0;
  std::string temp1;
  std::string temp2;
  bool temp3 = true;
  PyObject *result = NULL;

  if (ap.CheckArgCount(3, 4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      (ap.NoArgsLeft() || ap.GetValue(temp3)))
    {
    bool tempr = vtkShaderProgram::Substitute(temp0, temp1, temp2, temp3);

    if (!ap.ErrorOccurred())
      {
      ap.SetArgValue(0, temp0);
      }
    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkShaderProgram_IsUniformUsed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsUniformUsed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShaderProgram *op = static_cast<vtkShaderProgram *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    bool tempr = (ap.IsBound() ?
      op->IsUniformUsed(temp0) :
      op->vtkShaderProgram::IsUniformUsed(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkShaderProgram_Methods[] = {
  {"GetClassName", PyvtkShaderProgram_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkShaderProgram_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkShaderProgram_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkShaderProgram\nC++: vtkShaderProgram *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkShaderProgram_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkShaderProgram\nC++: vtkShaderProgram *SafeDownCast(vtkObject* o)\n\n"},
  {"GetVertexShader", PyvtkShaderProgram_GetVertexShader, METH_VARARGS,
   "V.GetVertexShader() -> vtkShader\nC++: vtkShader *GetVertexShader()\n\nGet the vertex shader for this program\n"},
  {"SetVertexShader", PyvtkShaderProgram_SetVertexShader, METH_VARARGS,
   "V.SetVertexShader(vtkShader)\nC++: void SetVertexShader(vtkShader *)\n\nGet the vertex shader for this program\n"},
  {"GetFragmentShader", PyvtkShaderProgram_GetFragmentShader, METH_VARARGS,
   "V.GetFragmentShader() -> vtkShader\nC++: vtkShader *GetFragmentShader()\n\nGet the fragment shader for this program\n"},
  {"SetFragmentShader", PyvtkShaderProgram_SetFragmentShader, METH_VARARGS,
   "V.SetFragmentShader(vtkShader)\nC++: void SetFragmentShader(vtkShader *)\n\nGet the fragment shader for this program\n"},
  {"GetGeometryShader", PyvtkShaderProgram_GetGeometryShader, METH_VARARGS,
   "V.GetGeometryShader() -> vtkShader\nC++: vtkShader *GetGeometryShader()\n\nGet the geometry shader for this program\n"},
  {"SetGeometryShader", PyvtkShaderProgram_SetGeometryShader, METH_VARARGS,
   "V.SetGeometryShader(vtkShader)\nC++: void SetGeometryShader(vtkShader *)\n\nGet the geometry shader for this program\n"},
  {"GetCompiled", PyvtkShaderProgram_GetCompiled, METH_VARARGS,
   "V.GetCompiled() -> bool\nC++: bool GetCompiled()\n\nSet/Get flag for if this program is compiled\n"},
  {"SetCompiled", PyvtkShaderProgram_SetCompiled, METH_VARARGS,
   "V.SetCompiled(bool)\nC++: void SetCompiled(bool a)\n\nSet/Get flag for if this program is compiled\n"},
  {"CompiledOn", PyvtkShaderProgram_CompiledOn, METH_VARARGS,
   "V.CompiledOn()\nC++: void CompiledOn()\n\nSet/Get flag for if this program is compiled\n"},
  {"CompiledOff", PyvtkShaderProgram_CompiledOff, METH_VARARGS,
   "V.CompiledOff()\nC++: void CompiledOff()\n\nSet/Get flag for if this program is compiled\n"},
  {"GetMD5Hash", PyvtkShaderProgram_GetMD5Hash, METH_VARARGS,
   "V.GetMD5Hash() -> string\nC++: std::string GetMD5Hash()\n\nSet/Get the md5 hash of this program\n"},
  {"SetMD5Hash", PyvtkShaderProgram_SetMD5Hash, METH_VARARGS,
   "V.SetMD5Hash(string)\nC++: void SetMD5Hash(const std::string &hash)\n\nSet/Get the md5 hash of this program\n"},
  {"isBound", PyvtkShaderProgram_isBound, METH_VARARGS,
   "V.isBound() -> bool\nC++: bool isBound()\n\n"},
  {"ReleaseGraphicsResources", PyvtkShaderProgram_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: void ReleaseGraphicsResources(vtkWindow *win)\n\nrelease any graphics resources this class is using.\n"},
  {"GetHandle", PyvtkShaderProgram_GetHandle, METH_VARARGS,
   "V.GetHandle() -> int\nC++: int GetHandle()\n\n"},
  {"GetError", PyvtkShaderProgram_GetError, METH_VARARGS,
   "V.GetError() -> string\nC++: std::string GetError()\n\n"},
  {"EnableAttributeArray", PyvtkShaderProgram_EnableAttributeArray, METH_VARARGS,
   "V.EnableAttributeArray(string) -> bool\nC++: bool EnableAttributeArray(const char *name)\n\n"},
  {"DisableAttributeArray", PyvtkShaderProgram_DisableAttributeArray, METH_VARARGS,
   "V.DisableAttributeArray(string) -> bool\nC++: bool DisableAttributeArray(const char *name)\n\n"},
  {"UseAttributeArray", PyvtkShaderProgram_UseAttributeArray, METH_VARARGS,
   "V.UseAttributeArray(string, int, int, int, int, NormalizeOption)\n    -> bool\nC++: bool UseAttributeArray(const char *name, int offset,\n    size_t stride, int elementType, int elementTupleSize,\n    NormalizeOption normalize)\n\n"},
  {"SetUniformi", PyvtkShaderProgram_SetUniformi, METH_VARARGS,
   "V.SetUniformi(string, int) -> bool\nC++: bool SetUniformi(const char *name, int v)\n\n"},
  {"SetUniformf", PyvtkShaderProgram_SetUniformf, METH_VARARGS,
   "V.SetUniformf(string, float) -> bool\nC++: bool SetUniformf(const char *name, float v)\n\n"},
  {"SetUniform2i", PyvtkShaderProgram_SetUniform2i, METH_VARARGS,
   "V.SetUniform2i(string, (int, int)) -> bool\nC++: bool SetUniform2i(const char *name, const int v[2])\n\n"},
  {"SetUniform2f", PyvtkShaderProgram_SetUniform2f, METH_VARARGS,
   "V.SetUniform2f(string, (float, float)) -> bool\nC++: bool SetUniform2f(const char *name, const float v[2])\n\n"},
  {"SetUniform3f", PyvtkShaderProgram_SetUniform3f, METH_VARARGS,
   "V.SetUniform3f(string, (float, float, float)) -> bool\nC++: bool SetUniform3f(const char *name, const float v[3])\n\n"},
  {"SetUniform4f", PyvtkShaderProgram_SetUniform4f, METH_VARARGS,
   "V.SetUniform4f(string, (float, float, float, float)) -> bool\nC++: bool SetUniform4f(const char *name, const float v[4])\n\n"},
  {"SetUniform3uc", PyvtkShaderProgram_SetUniform3uc, METH_VARARGS,
   "V.SetUniform3uc(string, (int, int, int)) -> bool\nC++: bool SetUniform3uc(const char *name,\n    const unsigned char v[3])\n\n"},
  {"SetUniform4uc", PyvtkShaderProgram_SetUniform4uc, METH_VARARGS,
   "V.SetUniform4uc(string, (int, int, int, int)) -> bool\nC++: bool SetUniform4uc(const char *name,\n    const unsigned char v[4])\n\n"},
  {"SetUniformMatrix", PyvtkShaderProgram_SetUniformMatrix, METH_VARARGS,
   "V.SetUniformMatrix(string, vtkMatrix3x3) -> bool\nC++: bool SetUniformMatrix(const char *name, vtkMatrix3x3 *v)\nV.SetUniformMatrix(string, vtkMatrix4x4) -> bool\nC++: bool SetUniformMatrix(const char *name, vtkMatrix4x4 *v)\n\n"},
  {"SetUniformMatrix3x3", PyvtkShaderProgram_SetUniformMatrix3x3, METH_VARARGS,
   "V.SetUniformMatrix3x3(string, [float, ...]) -> bool\nC++: bool SetUniformMatrix3x3(const char *name, float *v)\n\n"},
  {"SetUniformMatrix4x4", PyvtkShaderProgram_SetUniformMatrix4x4, METH_VARARGS,
   "V.SetUniformMatrix4x4(string, [float, ...]) -> bool\nC++: bool SetUniformMatrix4x4(const char *name, float *v)\n\n"},
  {"SetUniform1iv", PyvtkShaderProgram_SetUniform1iv, METH_VARARGS,
   "V.SetUniform1iv(string, int, (int, ...)) -> bool\nC++: bool SetUniform1iv(const char *name, const int count,\n    const int *f)\n\n"},
  {"SetUniform1fv", PyvtkShaderProgram_SetUniform1fv, METH_VARARGS,
   "V.SetUniform1fv(string, int, (float, ...)) -> bool\nC++: bool SetUniform1fv(const char *name, const int count,\n    const float *f)\n\n"},
  {"SetUniformMatrix4x4v", PyvtkShaderProgram_SetUniformMatrix4x4v, METH_VARARGS,
   "V.SetUniformMatrix4x4v(string, int, [float, ...]) -> bool\nC++: bool SetUniformMatrix4x4v(const char *name, const int count,\n    float *v)\n\n"},
  {"SetNumberOfOutputs", PyvtkShaderProgram_SetNumberOfOutputs, METH_VARARGS,
   "V.SetNumberOfOutputs(int)\nC++: void SetNumberOfOutputs(unsigned int a)\n\n"},
  {"Substitute", PyvtkShaderProgram_Substitute, METH_VARARGS,
   "V.Substitute(string, string, string, bool) -> bool\nC++: static bool Substitute(std::string &source,\n    const std::string &search, const std::string replace,\n    bool all=true)\n\nperform in place string substitutions, indicate if a substitution\nwas done this is useful for building up shader strings which\ntypically involve lots of string substitutions. Return true if a\nsubstitution was done.\n"},
  {"IsUniformUsed", PyvtkShaderProgram_IsUniformUsed, METH_VARARGS,
   "V.IsUniformUsed(string) -> bool\nC++: bool IsUniformUsed(const char *)\n\nmethods to inquire as to what uniforms/attributes are used by\nthis shader.  This can save some compute time if the uniforms or\nattributes are expensive to compute\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkShaderProgram_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkShaderProgram", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkShaderProgram_StaticNew()
{
  return vtkShaderProgram::New();
}

PyObject *PyvtkShaderProgram_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkShaderProgram_Type, PyvtkShaderProgram_Methods,
    "vtkShaderProgram",
    PyvtkShaderProgram_Doc(), &PyvtkShaderProgram_StaticNew);

  PyTypeObject *pytype = &PyvtkShaderProgram_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkShaderProgram_NormalizeOption_Type);
  PyvtkShaderProgram_NormalizeOption_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkShaderProgram_NormalizeOption_Type);

  o = (PyObject *)&PyvtkShaderProgram_NormalizeOption_Type;
  if (PyDict_SetItemString(d, "NormalizeOption", o) != 0)
    {
    Py_DECREF(o);
    }

  for (int c = 0; c < 2; c++)
    {
    typedef vtkShaderProgram::NormalizeOption cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[2] = {
        { "Normalize", vtkShaderProgram::Normalize },
        { "NoNormalize", vtkShaderProgram::NoNormalize },
      };

    o = PyvtkShaderProgram_NormalizeOption_FromEnum(constants[c].value);
    if (o)
      {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
      }
    }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkShaderProgram_Doc()
{
  static const char *docstring[] = {
    "vtkShaderProgram - a glsl shader program\n\n",
    "Superclass: vtkObject\n\n",
    "This class contains the vertex, fragment, geometry shaders that\ncombine to make a shader program\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkShaderProgram(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkShaderProgram_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkShaderProgram", o) != 0)
    {
    Py_DECREF(o);
    }

}

