// python wrapper for vtkSimplePointsReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkSimplePointsReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSimplePointsReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSimplePointsReader_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkSimplePointsReader_Doc();


static PyObject *
PyvtkSimplePointsReader_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimplePointsReader *op = static_cast<vtkSimplePointsReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkSimplePointsReader::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkSimplePointsReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimplePointsReader *op = static_cast<vtkSimplePointsReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSimplePointsReader::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkSimplePointsReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimplePointsReader *op = static_cast<vtkSimplePointsReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkSimplePointsReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSimplePointsReader::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkSimplePointsReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkSimplePointsReader *tempr = vtkSimplePointsReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkSimplePointsReader_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimplePointsReader *op = static_cast<vtkSimplePointsReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetFileName(temp0);
      }
    else
      {
      op->vtkSimplePointsReader::SetFileName(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkSimplePointsReader_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSimplePointsReader *op = static_cast<vtkSimplePointsReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkSimplePointsReader::GetFileName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkSimplePointsReader_Methods[] = {
  {"GetClassName", PyvtkSimplePointsReader_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkSimplePointsReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkSimplePointsReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSimplePointsReader\nC++: vtkSimplePointsReader *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkSimplePointsReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkSimplePointsReader\nC++: vtkSimplePointsReader *SafeDownCast(vtkObject* o)\n\n"},
  {"SetFileName", PyvtkSimplePointsReader_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: void SetFileName(char *)\n\nSet/Get the name of the file from which to read points.\n"},
  {"GetFileName", PyvtkSimplePointsReader_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: char *GetFileName()\n\nSet/Get the name of the file from which to read points.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSimplePointsReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOLegacyPython.vtkSimplePointsReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSimplePointsReader_StaticNew()
{
  return vtkSimplePointsReader::New();
}

PyObject *PyvtkSimplePointsReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSimplePointsReader_Type, PyvtkSimplePointsReader_Methods,
    "vtkSimplePointsReader",
    PyvtkSimplePointsReader_Doc(), &PyvtkSimplePointsReader_StaticNew);

  PyTypeObject *pytype = &PyvtkSimplePointsReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSimplePointsReader_Doc()
{
  static const char *docstring[] = {
    "vtkSimplePointsReader - Read a list of points from a file.\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "vtkSimplePointsReader is a source object that reads a list of points\nfrom a file.  Each point is specified by three floating-point values\nin ASCII format.  There is one point per line of the file.  A vertex\ncell is created for each point in the output.  This reader is meant\nas an example of how to write a reader in VTK.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSimplePointsReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSimplePointsReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSimplePointsReader", o) != 0)
    {
    Py_DECREF(o);
    }

}

