// python wrapper for vtkSliceAndDiceLayoutStrategy
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkSliceAndDiceLayoutStrategy.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSliceAndDiceLayoutStrategy(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSliceAndDiceLayoutStrategy_ClassNew(); }

#ifndef DECLARED_PyvtkTreeMapLayoutStrategy_ClassNew
extern "C" { PyObject *PyvtkTreeMapLayoutStrategy_ClassNew(); }
#define DECLARED_PyvtkTreeMapLayoutStrategy_ClassNew
#endif

static const char **PyvtkSliceAndDiceLayoutStrategy_Doc();


static PyObject *
PyvtkSliceAndDiceLayoutStrategy_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceAndDiceLayoutStrategy *op = static_cast<vtkSliceAndDiceLayoutStrategy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkSliceAndDiceLayoutStrategy::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkSliceAndDiceLayoutStrategy_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceAndDiceLayoutStrategy *op = static_cast<vtkSliceAndDiceLayoutStrategy *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSliceAndDiceLayoutStrategy::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkSliceAndDiceLayoutStrategy_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceAndDiceLayoutStrategy *op = static_cast<vtkSliceAndDiceLayoutStrategy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkSliceAndDiceLayoutStrategy *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSliceAndDiceLayoutStrategy::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkSliceAndDiceLayoutStrategy_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkSliceAndDiceLayoutStrategy *tempr = vtkSliceAndDiceLayoutStrategy::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkSliceAndDiceLayoutStrategy_Layout(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Layout");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceAndDiceLayoutStrategy *op = static_cast<vtkSliceAndDiceLayoutStrategy *>(vp);

  vtkTree *temp0 = NULL;
  vtkDataArray *temp1 = NULL;
  vtkDataArray *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkTree") &&
      ap.GetVTKObject(temp1, "vtkDataArray") &&
      ap.GetVTKObject(temp2, "vtkDataArray"))
    {
    if (ap.IsBound())
      {
      op->Layout(temp0, temp1, temp2);
      }
    else
      {
      op->vtkSliceAndDiceLayoutStrategy::Layout(temp0, temp1, temp2);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkSliceAndDiceLayoutStrategy_Methods[] = {
  {"GetClassName", PyvtkSliceAndDiceLayoutStrategy_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkSliceAndDiceLayoutStrategy_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkSliceAndDiceLayoutStrategy_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSliceAndDiceLayoutStrategy\nC++: vtkSliceAndDiceLayoutStrategy *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkSliceAndDiceLayoutStrategy_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkSliceAndDiceLayoutStrategy\nC++: vtkSliceAndDiceLayoutStrategy *SafeDownCast(vtkObject* o)\n\n"},
  {"Layout", PyvtkSliceAndDiceLayoutStrategy_Layout, METH_VARARGS,
   "V.Layout(vtkTree, vtkDataArray, vtkDataArray)\nC++: void Layout(vtkTree *inputTree, vtkDataArray *coordsArray,\n    vtkDataArray *sizeArray)\n\nPerform the layout of a tree and place the results as 4-tuples in\ncoordsArray (Xmin, Xmax, Ymin, Ymax).\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSliceAndDiceLayoutStrategy_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInfovisLayoutPython.vtkSliceAndDiceLayoutStrategy", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSliceAndDiceLayoutStrategy_StaticNew()
{
  return vtkSliceAndDiceLayoutStrategy::New();
}

PyObject *PyvtkSliceAndDiceLayoutStrategy_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSliceAndDiceLayoutStrategy_Type, PyvtkSliceAndDiceLayoutStrategy_Methods,
    "vtkSliceAndDiceLayoutStrategy",
    PyvtkSliceAndDiceLayoutStrategy_Doc(), &PyvtkSliceAndDiceLayoutStrategy_StaticNew);

  PyTypeObject *pytype = &PyvtkSliceAndDiceLayoutStrategy_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTreeMapLayoutStrategy_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSliceAndDiceLayoutStrategy_Doc()
{
  static const char *docstring[] = {
    "vtkSliceAndDiceLayoutStrategy - a horizontal and vertical slicing\ntree map layout\n\n",
    "Superclass: vtkTreeMapLayoutStrategy\n\n",
    "Lays out a tree-map alternating between horizontal and vertical\nslices, taking into account the relative size of each vertex.\n\nThanks:\n\nSlice and dice algorithm comes from: Shneiderman, B. 1992. Tree\nvisualization with tree-maps: 2-d space-filling approach. ACM Trans.\nGraph. 11, 1 (Jan. 1992), 92-99.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSliceAndDiceLayoutStrategy(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSliceAndDiceLayoutStrategy_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSliceAndDiceLayoutStrategy", o) != 0)
    {
    Py_DECREF(o);
    }

}

