// python wrapper for vtkStreamLine
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkStreamLine.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkStreamLine(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkStreamLine_ClassNew(); }

#ifndef DECLARED_PyvtkStreamer_ClassNew
extern "C" { PyObject *PyvtkStreamer_ClassNew(); }
#define DECLARED_PyvtkStreamer_ClassNew
#endif

static const char **PyvtkStreamLine_Doc();


static PyObject *
PyvtkStreamLine_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamLine *op = static_cast<vtkStreamLine *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkStreamLine::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkStreamLine_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamLine *op = static_cast<vtkStreamLine *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkStreamLine::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkStreamLine_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamLine *op = static_cast<vtkStreamLine *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkStreamLine *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkStreamLine::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkStreamLine_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkStreamLine *tempr = vtkStreamLine::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkStreamLine_SetStepLength(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStepLength");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamLine *op = static_cast<vtkStreamLine *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetStepLength(temp0);
      }
    else
      {
      op->vtkStreamLine::SetStepLength(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkStreamLine_GetStepLengthMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStepLengthMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamLine *op = static_cast<vtkStreamLine *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetStepLengthMinValue() :
      op->vtkStreamLine::GetStepLengthMinValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkStreamLine_GetStepLengthMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStepLengthMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamLine *op = static_cast<vtkStreamLine *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetStepLengthMaxValue() :
      op->vtkStreamLine::GetStepLengthMaxValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkStreamLine_GetStepLength(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStepLength");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamLine *op = static_cast<vtkStreamLine *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetStepLength() :
      op->vtkStreamLine::GetStepLength());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkStreamLine_Methods[] = {
  {"GetClassName", PyvtkStreamLine_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkStreamLine_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkStreamLine_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkStreamLine\nC++: vtkStreamLine *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkStreamLine_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkStreamLine\nC++: vtkStreamLine *SafeDownCast(vtkObject* o)\n\n"},
  {"SetStepLength", PyvtkStreamLine_SetStepLength, METH_VARARGS,
   "V.SetStepLength(float)\nC++: void SetStepLength(double)\n\nSpecify the length of a line segment. The length is expressed in\nterms of elapsed time. Smaller values result in smoother\nappearing streamlines, but greater numbers of line primitives.\n"},
  {"GetStepLengthMinValue", PyvtkStreamLine_GetStepLengthMinValue, METH_VARARGS,
   "V.GetStepLengthMinValue() -> float\nC++: double GetStepLengthMinValue()\n\nSpecify the length of a line segment. The length is expressed in\nterms of elapsed time. Smaller values result in smoother\nappearing streamlines, but greater numbers of line primitives.\n"},
  {"GetStepLengthMaxValue", PyvtkStreamLine_GetStepLengthMaxValue, METH_VARARGS,
   "V.GetStepLengthMaxValue() -> float\nC++: double GetStepLengthMaxValue()\n\nSpecify the length of a line segment. The length is expressed in\nterms of elapsed time. Smaller values result in smoother\nappearing streamlines, but greater numbers of line primitives.\n"},
  {"GetStepLength", PyvtkStreamLine_GetStepLength, METH_VARARGS,
   "V.GetStepLength() -> float\nC++: double GetStepLength()\n\nSpecify the length of a line segment. The length is expressed in\nterms of elapsed time. Smaller values result in smoother\nappearing streamlines, but greater numbers of line primitives.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkStreamLine_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersFlowPathsPython.vtkStreamLine", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkStreamLine_StaticNew()
{
  return vtkStreamLine::New();
}

PyObject *PyvtkStreamLine_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkStreamLine_Type, PyvtkStreamLine_Methods,
    "vtkStreamLine",
    PyvtkStreamLine_Doc(), &PyvtkStreamLine_StaticNew);

  PyTypeObject *pytype = &PyvtkStreamLine_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkStreamer_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkStreamLine_Doc()
{
  static const char *docstring[] = {
    "vtkStreamLine - generate streamline in arbitrary dataset\n\n",
    "Superclass: vtkStreamer\n\n",
    "vtkStreamLine is a filter that generates a streamline for an\narbitrary dataset. A streamline is a line that is everywhere tangent\nto the vector field. Scalar values also are calculated along the\nstreamline and can be used to color the line. Streamlines are\ncalculated by integrating from a starting point through the vector\nfield. Integration can be performed forward in time (see where the\nline goes",
    "), backward in time (see where the line came from), or in\nboth directions. It also is possible to compute vorticity along the\nstreamline. Vorticity is the projection (i.e., dot product) of the\nflow rotation on the velocity vector, i.e., the rotation of flow\naround the streamline.\n\nvtkStreamLine defines the instance variable StepLength. This\nparameter controls the time increment used to generate in",
    "dividual\npoints along the streamline(s). Smaller values result in more line\nprimitives but smoother streamlines. The StepLength instance variable\nis defined in terms of time (i.e., the distance that the particle\ntravels in the specified time period). Thus, the line segments will\nbe smaller in areas of low velocity and larger in regions of high\nvelocity. (NOTE: This is different than the Integratio",
    "nStepLength\ndefined by the superclass vtkStreamer. IntegrationStepLength is used\nto control integration step size and is expressed as a fraction of\nthe cell length.) The StepLength instance variable is important\nbecause subclasses of vtkStreamLine (e.g., vtkDashedStreamLine)\ndepend on this value to build their representation.\n\nSee Also:\n\nvtkStreamer vtkDashedStreamLine vtkStreamPoints\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkStreamLine(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkStreamLine_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkStreamLine", o) != 0)
    {
    Py_DECREF(o);
    }

}

