// python wrapper for vtkStringToCategory
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkInformationVector.h"
#include "vtkStringToCategory.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkStringToCategory(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkStringToCategory_ClassNew(); }

#ifndef DECLARED_PyvtkDataObjectAlgorithm_ClassNew
extern "C" { PyObject *PyvtkDataObjectAlgorithm_ClassNew(); }
#define DECLARED_PyvtkDataObjectAlgorithm_ClassNew
#endif

static const char **PyvtkStringToCategory_Doc();


static PyObject *
PyvtkStringToCategory_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringToCategory *op = static_cast<vtkStringToCategory *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkStringToCategory::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkStringToCategory_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringToCategory *op = static_cast<vtkStringToCategory *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkStringToCategory::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkStringToCategory_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringToCategory *op = static_cast<vtkStringToCategory *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkStringToCategory *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkStringToCategory::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkStringToCategory_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkStringToCategory *tempr = vtkStringToCategory::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkStringToCategory_SetCategoryArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCategoryArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringToCategory *op = static_cast<vtkStringToCategory *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetCategoryArrayName(temp0);
      }
    else
      {
      op->vtkStringToCategory::SetCategoryArrayName(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkStringToCategory_GetCategoryArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCategoryArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringToCategory *op = static_cast<vtkStringToCategory *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    char *tempr = (ap.IsBound() ?
      op->GetCategoryArrayName() :
      op->vtkStringToCategory::GetCategoryArrayName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkStringToCategory_Methods[] = {
  {"GetClassName", PyvtkStringToCategory_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkStringToCategory_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkStringToCategory_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkStringToCategory\nC++: vtkStringToCategory *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkStringToCategory_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkStringToCategory\nC++: vtkStringToCategory *SafeDownCast(vtkObject* o)\n\n"},
  {"SetCategoryArrayName", PyvtkStringToCategory_SetCategoryArrayName, METH_VARARGS,
   "V.SetCategoryArrayName(string)\nC++: void SetCategoryArrayName(char *)\n\nThe name to give to the output vtkIntArray of category values.\n"},
  {"GetCategoryArrayName", PyvtkStringToCategory_GetCategoryArrayName, METH_VARARGS,
   "V.GetCategoryArrayName() -> string\nC++: char *GetCategoryArrayName()\n\nThe name to give to the output vtkIntArray of category values.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkStringToCategory_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInfovisCorePython.vtkStringToCategory", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkStringToCategory_StaticNew()
{
  return vtkStringToCategory::New();
}

PyObject *PyvtkStringToCategory_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkStringToCategory_Type, PyvtkStringToCategory_Methods,
    "vtkStringToCategory",
    PyvtkStringToCategory_Doc(), &PyvtkStringToCategory_StaticNew);

  PyTypeObject *pytype = &PyvtkStringToCategory_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataObjectAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkStringToCategory_Doc()
{
  static const char *docstring[] = {
    "vtkStringToCategory - Creates a category array from a string array\n\n",
    "Superclass: vtkDataObjectAlgorithm\n\n",
    "vtkStringToCategory creates an integer array named \"category\" based\non the values in a string array.  You may use this filter to create\nan array that you may use to color points/cells by the values in a\nstring array.  Currently there is not support to color by a string\narray directly. The category values will range from zero to N-1,\nwhere N is the number of distinct strings in the string array.  S",
    "et\nthe string array to process with SetInputArrayToProcess(0,0,0,...). \nThe array may be in the point, cell, or field data of the data\nobject.\n\nThe list of unique strings, in the order they are mapped, can also be\nretrieved from output port 1. They are in a vtkTable, stored in the\n\"Strings\" column as a vtkStringArray.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkStringToCategory(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkStringToCategory_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkStringToCategory", o) != 0)
    {
    Py_DECREF(o);
    }

}

