// python wrapper for vtkStructuredPoints
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkStructuredPoints.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkStructuredPoints(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkStructuredPoints_ClassNew(); }

#ifndef DECLARED_PyvtkImageData_ClassNew
extern "C" { PyObject *PyvtkImageData_ClassNew(); }
#define DECLARED_PyvtkImageData_ClassNew
#endif

static const char **PyvtkStructuredPoints_Doc();


static PyObject *
PyvtkStructuredPoints_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredPoints *op = static_cast<vtkStructuredPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkStructuredPoints::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkStructuredPoints_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredPoints *op = static_cast<vtkStructuredPoints *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkStructuredPoints::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkStructuredPoints_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredPoints *op = static_cast<vtkStructuredPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkStructuredPoints *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkStructuredPoints::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkStructuredPoints_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkStructuredPoints *tempr = vtkStructuredPoints::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkStructuredPoints_GetDataObjectType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDataObjectType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredPoints *op = static_cast<vtkStructuredPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetDataObjectType() :
      op->vtkStructuredPoints::GetDataObjectType());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkStructuredPoints_Methods[] = {
  {"GetClassName", PyvtkStructuredPoints_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkStructuredPoints_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkStructuredPoints_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkStructuredPoints\nC++: vtkStructuredPoints *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkStructuredPoints_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkStructuredPoints\nC++: vtkStructuredPoints *SafeDownCast(vtkObject* o)\n\n"},
  {"GetDataObjectType", PyvtkStructuredPoints_GetDataObjectType, METH_VARARGS,
   "V.GetDataObjectType() -> int\nC++: int GetDataObjectType()\n\nTo simplify filter superclasses,\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkStructuredPoints_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonDataModelPython.vtkStructuredPoints", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkStructuredPoints_StaticNew()
{
  return vtkStructuredPoints::New();
}

PyObject *PyvtkStructuredPoints_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkStructuredPoints_Type, PyvtkStructuredPoints_Methods,
    "vtkStructuredPoints",
    PyvtkStructuredPoints_Doc(), &PyvtkStructuredPoints_StaticNew);

  PyTypeObject *pytype = &PyvtkStructuredPoints_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageData_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkStructuredPoints_Doc()
{
  static const char *docstring[] = {
    "vtkStructuredPoints - A subclass of ImageData.\n\n",
    "Superclass: vtkImageData\n\n",
    "StructuredPoints is a subclass of ImageData that requires the data\nextent to exactly match the update extent. Normall image data allows\nthat the data extent may be larger than the update extent.\nStructuredPoints also defines the origin differently that\nvtkImageData. For structured points the origin is the location of\nfirst point. Whereas images define the origin as the location of\npoint 0, 0, 0. I",
    "mage Origin is stored in ivar, and structured points\nhave special methods for setting/getting the origin/extents.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkStructuredPoints(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkStructuredPoints_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkStructuredPoints", o) != 0)
    {
    Py_DECREF(o);
    }

}

