// python wrapper for vtkTableToDatabaseWriter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkTableToDatabaseWriter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTableToDatabaseWriter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTableToDatabaseWriter_ClassNew(); }

#ifndef DECLARED_PyvtkWriter_ClassNew
extern "C" { PyObject *PyvtkWriter_ClassNew(); }
#define DECLARED_PyvtkWriter_ClassNew
#endif

static const char **PyvtkTableToDatabaseWriter_Doc();


static PyObject *
PyvtkTableToDatabaseWriter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToDatabaseWriter *op = static_cast<vtkTableToDatabaseWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTableToDatabaseWriter::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTableToDatabaseWriter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToDatabaseWriter *op = static_cast<vtkTableToDatabaseWriter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTableToDatabaseWriter::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTableToDatabaseWriter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToDatabaseWriter *op = static_cast<vtkTableToDatabaseWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTableToDatabaseWriter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTableToDatabaseWriter::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkTableToDatabaseWriter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkTableToDatabaseWriter *tempr = vtkTableToDatabaseWriter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTableToDatabaseWriter_SetDatabase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDatabase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToDatabaseWriter *op = static_cast<vtkTableToDatabaseWriter *>(vp);

  vtkSQLDatabase *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSQLDatabase"))
    {
    bool tempr = (ap.IsBound() ?
      op->SetDatabase(temp0) :
      op->vtkTableToDatabaseWriter::SetDatabase(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTableToDatabaseWriter_SetTableName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTableName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToDatabaseWriter *op = static_cast<vtkTableToDatabaseWriter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    bool tempr = (ap.IsBound() ?
      op->SetTableName(temp0) :
      op->vtkTableToDatabaseWriter::SetTableName(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTableToDatabaseWriter_TableNameIsNew(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "TableNameIsNew");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToDatabaseWriter *op = static_cast<vtkTableToDatabaseWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->TableNameIsNew() :
      op->vtkTableToDatabaseWriter::TableNameIsNew());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTableToDatabaseWriter_GetDatabase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDatabase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToDatabaseWriter *op = static_cast<vtkTableToDatabaseWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkSQLDatabase *tempr = (ap.IsBound() ?
      op->GetDatabase() :
      op->vtkTableToDatabaseWriter::GetDatabase());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTableToDatabaseWriter_GetInput_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToDatabaseWriter *op = static_cast<vtkTableToDatabaseWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTable *tempr = (ap.IsBound() ?
      op->GetInput() :
      op->vtkTableToDatabaseWriter::GetInput());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyObject *
PyvtkTableToDatabaseWriter_GetInput_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToDatabaseWriter *op = static_cast<vtkTableToDatabaseWriter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    vtkTable *tempr = (ap.IsBound() ?
      op->GetInput(temp0) :
      op->vtkTableToDatabaseWriter::GetInput(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyObject *
PyvtkTableToDatabaseWriter_GetInput(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 0:
      return PyvtkTableToDatabaseWriter_GetInput_s1(self, args);
    case 1:
      return PyvtkTableToDatabaseWriter_GetInput_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "GetInput");
  return NULL;
}


static PyMethodDef PyvtkTableToDatabaseWriter_Methods[] = {
  {"GetClassName", PyvtkTableToDatabaseWriter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTableToDatabaseWriter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTableToDatabaseWriter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTableToDatabaseWriter\nC++: vtkTableToDatabaseWriter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTableToDatabaseWriter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTableToDatabaseWriter\nC++: vtkTableToDatabaseWriter *SafeDownCast(vtkObject* o)\n\n"},
  {"SetDatabase", PyvtkTableToDatabaseWriter_SetDatabase, METH_VARARGS,
   "V.SetDatabase(vtkSQLDatabase) -> bool\nC++: bool SetDatabase(vtkSQLDatabase *db)\n\nSet the database.  Must already be open.\n"},
  {"SetTableName", PyvtkTableToDatabaseWriter_SetTableName, METH_VARARGS,
   "V.SetTableName(string) -> bool\nC++: bool SetTableName(const char *name)\n\nSet the name of the new SQL table that you'd this writer to\ncreate. Returns false if the specified table already exists in\nthe database.\n"},
  {"TableNameIsNew", PyvtkTableToDatabaseWriter_TableNameIsNew, METH_VARARGS,
   "V.TableNameIsNew() -> bool\nC++: bool TableNameIsNew()\n\nCheck if the currently specified table name exists in the\ndatabase.\n"},
  {"GetDatabase", PyvtkTableToDatabaseWriter_GetDatabase, METH_VARARGS,
   "V.GetDatabase() -> vtkSQLDatabase\nC++: vtkSQLDatabase *GetDatabase()\n\n"},
  {"GetInput", PyvtkTableToDatabaseWriter_GetInput, METH_VARARGS,
   "V.GetInput() -> vtkTable\nC++: vtkTable *GetInput()\nV.GetInput(int) -> vtkTable\nC++: vtkTable *GetInput(int port)\n\nGet the input to this writer.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTableToDatabaseWriter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOSQLPython.vtkTableToDatabaseWriter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkTableToDatabaseWriter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTableToDatabaseWriter_Type, PyvtkTableToDatabaseWriter_Methods,
    "vtkTableToDatabaseWriter",
    PyvtkTableToDatabaseWriter_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkTableToDatabaseWriter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkWriter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTableToDatabaseWriter_Doc()
{
  static const char *docstring[] = {
    "vtkTableToDatabaseWriter\n\n",
    "Superclass: vtkWriter\n\n",
    "vtkTableToDatabaseWriter abstract parent class that reads a vtkTable\nand inserts it into an SQL database.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTableToDatabaseWriter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTableToDatabaseWriter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTableToDatabaseWriter", o) != 0)
    {
    Py_DECREF(o);
    }

}

