// python wrapper for vtkTableToSQLiteWriter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkTableToSQLiteWriter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTableToSQLiteWriter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTableToSQLiteWriter_ClassNew(); }

#ifndef DECLARED_PyvtkTableToDatabaseWriter_ClassNew
extern "C" { PyObject *PyvtkTableToDatabaseWriter_ClassNew(); }
#define DECLARED_PyvtkTableToDatabaseWriter_ClassNew
#endif

static const char **PyvtkTableToSQLiteWriter_Doc();


static PyObject *
PyvtkTableToSQLiteWriter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToSQLiteWriter *op = static_cast<vtkTableToSQLiteWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTableToSQLiteWriter::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTableToSQLiteWriter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToSQLiteWriter *op = static_cast<vtkTableToSQLiteWriter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTableToSQLiteWriter::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTableToSQLiteWriter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToSQLiteWriter *op = static_cast<vtkTableToSQLiteWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTableToSQLiteWriter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTableToSQLiteWriter::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkTableToSQLiteWriter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkTableToSQLiteWriter *tempr = vtkTableToSQLiteWriter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTableToSQLiteWriter_GetInput_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToSQLiteWriter *op = static_cast<vtkTableToSQLiteWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTable *tempr = (ap.IsBound() ?
      op->GetInput() :
      op->vtkTableToSQLiteWriter::GetInput());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyObject *
PyvtkTableToSQLiteWriter_GetInput_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTableToSQLiteWriter *op = static_cast<vtkTableToSQLiteWriter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    vtkTable *tempr = (ap.IsBound() ?
      op->GetInput(temp0) :
      op->vtkTableToSQLiteWriter::GetInput(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyObject *
PyvtkTableToSQLiteWriter_GetInput(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 0:
      return PyvtkTableToSQLiteWriter_GetInput_s1(self, args);
    case 1:
      return PyvtkTableToSQLiteWriter_GetInput_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "GetInput");
  return NULL;
}


static PyMethodDef PyvtkTableToSQLiteWriter_Methods[] = {
  {"GetClassName", PyvtkTableToSQLiteWriter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTableToSQLiteWriter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTableToSQLiteWriter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTableToSQLiteWriter\nC++: vtkTableToSQLiteWriter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTableToSQLiteWriter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTableToSQLiteWriter\nC++: vtkTableToSQLiteWriter *SafeDownCast(vtkObject* o)\n\n"},
  {"GetInput", PyvtkTableToSQLiteWriter_GetInput, METH_VARARGS,
   "V.GetInput() -> vtkTable\nC++: vtkTable *GetInput()\nV.GetInput(int) -> vtkTable\nC++: vtkTable *GetInput(int port)\n\nGet the input to this writer.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTableToSQLiteWriter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOSQLPython.vtkTableToSQLiteWriter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTableToSQLiteWriter_StaticNew()
{
  return vtkTableToSQLiteWriter::New();
}

PyObject *PyvtkTableToSQLiteWriter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTableToSQLiteWriter_Type, PyvtkTableToSQLiteWriter_Methods,
    "vtkTableToSQLiteWriter",
    PyvtkTableToSQLiteWriter_Doc(), &PyvtkTableToSQLiteWriter_StaticNew);

  PyTypeObject *pytype = &PyvtkTableToSQLiteWriter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTableToDatabaseWriter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTableToSQLiteWriter_Doc()
{
  static const char *docstring[] = {
    "vtkTableToSQLiteWriter - store a vtkTable in an SQLite database\n\n",
    "Superclass: vtkTableToDatabaseWriter\n\n",
    "vtkTableToSQLiteWriter reads a vtkTable and inserts it into an SQLite\ndatabase.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTableToSQLiteWriter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTableToSQLiteWriter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTableToSQLiteWriter", o) != 0)
    {
    Py_DECREF(o);
    }

}

