// python wrapper for vtkTensorProbeWidget
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkTensorProbeWidget.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTensorProbeWidget(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTensorProbeWidget_ClassNew(); }

#ifndef DECLARED_PyvtkAbstractWidget_ClassNew
extern "C" { PyObject *PyvtkAbstractWidget_ClassNew(); }
#define DECLARED_PyvtkAbstractWidget_ClassNew
#endif

static const char **PyvtkTensorProbeWidget_Doc();


static PyObject *
PyvtkTensorProbeWidget_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensorProbeWidget *op = static_cast<vtkTensorProbeWidget *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTensorProbeWidget::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTensorProbeWidget_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensorProbeWidget *op = static_cast<vtkTensorProbeWidget *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTensorProbeWidget::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTensorProbeWidget_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensorProbeWidget *op = static_cast<vtkTensorProbeWidget *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTensorProbeWidget *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTensorProbeWidget::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkTensorProbeWidget_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkTensorProbeWidget *tempr = vtkTensorProbeWidget::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTensorProbeWidget_SetRepresentation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensorProbeWidget *op = static_cast<vtkTensorProbeWidget *>(vp);

  vtkTensorProbeRepresentation *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkTensorProbeRepresentation"))
    {
    if (ap.IsBound())
      {
      op->SetRepresentation(temp0);
      }
    else
      {
      op->vtkTensorProbeWidget::SetRepresentation(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTensorProbeWidget_GetTensorProbeRepresentation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTensorProbeRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensorProbeWidget *op = static_cast<vtkTensorProbeWidget *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTensorProbeRepresentation *tempr = (ap.IsBound() ?
      op->GetTensorProbeRepresentation() :
      op->vtkTensorProbeWidget::GetTensorProbeRepresentation());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTensorProbeWidget_CreateDefaultRepresentation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateDefaultRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensorProbeWidget *op = static_cast<vtkTensorProbeWidget *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->CreateDefaultRepresentation();
      }
    else
      {
      op->vtkTensorProbeWidget::CreateDefaultRepresentation();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkTensorProbeWidget_Methods[] = {
  {"GetClassName", PyvtkTensorProbeWidget_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\nStandard VTK class macros.\n"},
  {"IsA", PyvtkTensorProbeWidget_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\nStandard VTK class macros.\n"},
  {"NewInstance", PyvtkTensorProbeWidget_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTensorProbeWidget\nC++: vtkTensorProbeWidget *NewInstance()\n\nStandard VTK class macros.\n"},
  {"SafeDownCast", PyvtkTensorProbeWidget_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTensorProbeWidget\nC++: vtkTensorProbeWidget *SafeDownCast(vtkObject* o)\n\nStandard VTK class macros.\n"},
  {"SetRepresentation", PyvtkTensorProbeWidget_SetRepresentation, METH_VARARGS,
   "V.SetRepresentation(vtkTensorProbeRepresentation)\nC++: void SetRepresentation(vtkTensorProbeRepresentation *r)\n\nSpecify an instance of vtkWidgetRepresentation used to represent\nthis widget in the scene. Note that the representation is a\nsubclass of vtkProp so it can be added to the renderer\nindependent of the widget.\n"},
  {"GetTensorProbeRepresentation", PyvtkTensorProbeWidget_GetTensorProbeRepresentation, METH_VARARGS,
   "V.GetTensorProbeRepresentation() -> vtkTensorProbeRepresentation\nC++: vtkTensorProbeRepresentation *GetTensorProbeRepresentation()\n\nReturn the representation as a vtkTensorProbeRepresentation.\n"},
  {"CreateDefaultRepresentation", PyvtkTensorProbeWidget_CreateDefaultRepresentation, METH_VARARGS,
   "V.CreateDefaultRepresentation()\nC++: virtual void CreateDefaultRepresentation()\n\nSee vtkWidgetRepresentation for details.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTensorProbeWidget_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInteractionWidgetsPython.vtkTensorProbeWidget", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTensorProbeWidget_StaticNew()
{
  return vtkTensorProbeWidget::New();
}

PyObject *PyvtkTensorProbeWidget_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTensorProbeWidget_Type, PyvtkTensorProbeWidget_Methods,
    "vtkTensorProbeWidget",
    PyvtkTensorProbeWidget_Doc(), &PyvtkTensorProbeWidget_StaticNew);

  PyTypeObject *pytype = &PyvtkTensorProbeWidget_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAbstractWidget_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTensorProbeWidget_Doc()
{
  static const char *docstring[] = {
    "vtkTensorProbeWidget - a widget to probe tensors on a polyline\n\n",
    "Superclass: vtkAbstractWidget\n\n",
    "The class is used to probe tensors on a trajectory. The\nrepresentation (vtkTensorProbeRepresentation) is free to choose its\nown method of rendering the tensors. For instance\nvtkEllipsoidTensorProbeRepresentation renders the tensors as\nellipsoids. The interactions of the widget are controlled by the left\nmouse button. A left click on the tensor selects it. It can dragged\naround the trajectory to pr",
    "obe the tensors on it.\n\nFor instance dragging the ellipsoid around with\nvtkEllipsoidTensorProbeRepresentation will manifest itself with the\nellipsoid shape changing as needed along the trajectory.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTensorProbeWidget(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTensorProbeWidget_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTensorProbeWidget", o) != 0)
    {
    Py_DECREF(o);
    }

}

