// python wrapper for vtkTensor
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkTensor.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTensor(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTensor_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkTensor_Doc();


static PyObject *
PyvtkTensor_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensor *op = static_cast<vtkTensor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTensor::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTensor_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensor *op = static_cast<vtkTensor *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTensor::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTensor_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensor *op = static_cast<vtkTensor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTensor *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTensor::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkTensor_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkTensor *tempr = vtkTensor::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTensor_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensor *op = static_cast<vtkTensor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->Initialize();
      }
    else
      {
      op->vtkTensor::Initialize();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTensor_GetComponent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetComponent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensor *op = static_cast<vtkTensor *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    double tempr = (ap.IsBound() ?
      op->GetComponent(temp0, temp1) :
      op->vtkTensor::GetComponent(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTensor_SetComponent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetComponent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensor *op = static_cast<vtkTensor *>(vp);

  int temp0;
  int temp1;
  double temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
    {
    if (ap.IsBound())
      {
      op->SetComponent(temp0, temp1, temp2);
      }
    else
      {
      op->vtkTensor::SetComponent(temp0, temp1, temp2);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTensor_AddComponent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddComponent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensor *op = static_cast<vtkTensor *>(vp);

  int temp0;
  int temp1;
  double temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
    {
    if (ap.IsBound())
      {
      op->AddComponent(temp0, temp1, temp2);
      }
    else
      {
      op->vtkTensor::AddComponent(temp0, temp1, temp2);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTensor_GetColumn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetColumn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensor *op = static_cast<vtkTensor *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetColumn(temp0) :
      op->vtkTensor::GetColumn(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTensor_DeepCopy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DeepCopy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTensor *op = static_cast<vtkTensor *>(vp);

  vtkTensor *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkTensor"))
    {
    if (ap.IsBound())
      {
      op->DeepCopy(temp0);
      }
    else
      {
      op->vtkTensor::DeepCopy(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkTensor_Methods[] = {
  {"GetClassName", PyvtkTensor_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTensor_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTensor_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTensor\nC++: vtkTensor *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTensor_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTensor\nC++: vtkTensor *SafeDownCast(vtkObject* o)\n\n"},
  {"Initialize", PyvtkTensor_Initialize, METH_VARARGS,
   "V.Initialize()\nC++: void Initialize()\n\nInitialize tensor components to 0.0.\n"},
  {"GetComponent", PyvtkTensor_GetComponent, METH_VARARGS,
   "V.GetComponent(int, int) -> float\nC++: double GetComponent(int i, int j)\n\nGet the tensor component (i,j).\n"},
  {"SetComponent", PyvtkTensor_SetComponent, METH_VARARGS,
   "V.SetComponent(int, int, float)\nC++: void SetComponent(int i, int j, double v)\n\nSet the value of the tensor component (i,j).\n"},
  {"AddComponent", PyvtkTensor_AddComponent, METH_VARARGS,
   "V.AddComponent(int, int, float)\nC++: void AddComponent(int i, int j, double v)\n\nAdd to the value of the tensor component at location (i,j).\n"},
  {"GetColumn", PyvtkTensor_GetColumn, METH_VARARGS,
   "V.GetColumn(int) -> (float, ...)\nC++: double *GetColumn(int j)\n\nReturn column vector from tensor. (Assumes 2D matrix form and\n0-offset.)\n"},
  {"DeepCopy", PyvtkTensor_DeepCopy, METH_VARARGS,
   "V.DeepCopy(vtkTensor)\nC++: void DeepCopy(vtkTensor *t)\n\nDeep copy of one tensor to another tensor.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTensor_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonDataModelPython.vtkTensor", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTensor_StaticNew()
{
  return vtkTensor::New();
}

PyObject *PyvtkTensor_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTensor_Type, PyvtkTensor_Methods,
    "vtkTensor",
    PyvtkTensor_Doc(), &PyvtkTensor_StaticNew);

  PyTypeObject *pytype = &PyvtkTensor_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTensor_Doc()
{
  static const char *docstring[] = {
    "vtkTensor - supporting class to enable assignment and referencing of\ntensors\n\n",
    "Superclass: vtkObject\n\n",
    "vtkTensor is a floating point representation of an nxn tensor.\nvtkTensor provides methods for assignment and reference of tensor\ncomponents. It does it in such a way as to minimize data copying.\n\nCaveats:\n\nvtkTensor performs its operations using pointer reference. You are\nresponsible for supplying data storage (if necessary) if local copies\nof data are being made.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTensor(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTensor_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTensor", o) != 0)
    {
    Py_DECREF(o);
    }

}

