// python wrapper for vtkTestingInteractor
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkTestingInteractor.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTestingInteractor(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTestingInteractor_ClassNew(); }

#ifndef DECLARED_PyvtkRenderWindowInteractor_ClassNew
extern "C" { PyObject *PyvtkRenderWindowInteractor_ClassNew(); }
#define DECLARED_PyvtkRenderWindowInteractor_ClassNew
#endif

static const char **PyvtkTestingInteractor_Doc();


static PyObject *
PyvtkTestingInteractor_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTestingInteractor *op = static_cast<vtkTestingInteractor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTestingInteractor::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTestingInteractor_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTestingInteractor *op = static_cast<vtkTestingInteractor *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTestingInteractor::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTestingInteractor_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTestingInteractor *op = static_cast<vtkTestingInteractor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTestingInteractor *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTestingInteractor::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkTestingInteractor_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkTestingInteractor *tempr = vtkTestingInteractor::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTestingInteractor_Start(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Start");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTestingInteractor *op = static_cast<vtkTestingInteractor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->Start();
      }
    else
      {
      op->vtkTestingInteractor::Start();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkTestingInteractor_Methods[] = {
  {"GetClassName", PyvtkTestingInteractor_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\nType and printing information.\n"},
  {"IsA", PyvtkTestingInteractor_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\nType and printing information.\n"},
  {"NewInstance", PyvtkTestingInteractor_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTestingInteractor\nC++: vtkTestingInteractor *NewInstance()\n\nType and printing information.\n"},
  {"SafeDownCast", PyvtkTestingInteractor_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTestingInteractor\nC++: vtkTestingInteractor *SafeDownCast(vtkObject* o)\n\nType and printing information.\n"},
  {"Start", PyvtkTestingInteractor_Start, METH_VARARGS,
   "V.Start()\nC++: virtual void Start()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTestingInteractor_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkTestingRenderingPython.vtkTestingInteractor", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTestingInteractor_StaticNew()
{
  return vtkTestingInteractor::New();
}

PyObject *PyvtkTestingInteractor_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTestingInteractor_Type, PyvtkTestingInteractor_Methods,
    "vtkTestingInteractor",
    PyvtkTestingInteractor_Doc(), &PyvtkTestingInteractor_StaticNew);

  PyTypeObject *pytype = &PyvtkTestingInteractor_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkRenderWindowInteractor_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTestingInteractor_Doc()
{
  static const char *docstring[] = {
    "vtkTestingInteractor - A RenderWindowInteractor for testing\n\n",
    "Superclass: vtkRenderWindowInteractor\n\n",
    "Provides a Start() method that passes arguments to a test for\nregression testing and returns. This permits programs that run as\ntests to exit gracefully during the test run without needing\ninteraction.\n\nSee Also:\n\nvtkTestingObjectFactory\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTestingInteractor(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTestingInteractor_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTestingInteractor", o) != 0)
    {
    Py_DECREF(o);
    }

}

