// python wrapper for vtkTextCodecFactory
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkTextCodecFactory.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTextCodecFactory(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTextCodecFactory_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkTextCodecFactory_Doc();


static PyObject *
PyvtkTextCodecFactory_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTextCodecFactory *op = static_cast<vtkTextCodecFactory *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTextCodecFactory::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTextCodecFactory_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTextCodecFactory *op = static_cast<vtkTextCodecFactory *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTextCodecFactory::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTextCodecFactory_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTextCodecFactory *op = static_cast<vtkTextCodecFactory *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTextCodecFactory *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTextCodecFactory::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkTextCodecFactory_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkTextCodecFactory *tempr = vtkTextCodecFactory::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTextCodecFactory_UnRegisterAllCreateCallbacks(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "UnRegisterAllCreateCallbacks");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
    {
    vtkTextCodecFactory::UnRegisterAllCreateCallbacks();

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTextCodecFactory_CodecForName(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "CodecForName");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    vtkTextCodec *tempr = vtkTextCodecFactory::CodecForName(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTextCodecFactory_Initialize(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "Initialize");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
    {
    vtkTextCodecFactory::Initialize();

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkTextCodecFactory_Methods[] = {
  {"GetClassName", PyvtkTextCodecFactory_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTextCodecFactory_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTextCodecFactory_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTextCodecFactory\nC++: vtkTextCodecFactory *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTextCodecFactory_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTextCodecFactory\nC++: vtkTextCodecFactory *SafeDownCast(vtkObject* o)\n\n"},
  {"UnRegisterAllCreateCallbacks", PyvtkTextCodecFactory_UnRegisterAllCreateCallbacks, METH_VARARGS,
   "V.UnRegisterAllCreateCallbacks()\nC++: static void UnRegisterAllCreateCallbacks()\n\nProvides mechanism to register/unregister additional callbacks to\ncreate concrete subclasses of vtkTextCodecFactory to handle\ndifferent protocols. The registered callbacks are tried in the\norder they are registered.\n"},
  {"CodecForName", PyvtkTextCodecFactory_CodecForName, METH_VARARGS,
   "V.CodecForName(string) -> vtkTextCodec\nC++: static vtkTextCodec *CodecForName(const char *CodecName)\n\nGiven a codec/storage name try to find one of our registered\ncodecs that can handle it.  This is non-deterministic, very messy\nand should not be your first thing to try. The registered\ncallbacks are tried in the order they are registered.\n"},
  {"Initialize", PyvtkTextCodecFactory_Initialize, METH_VARARGS,
   "V.Initialize()\nC++: static void Initialize()\n\nInitialize core text codecs - needed for the static compilation\ncase.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTextCodecFactory_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOCorePython.vtkTextCodecFactory", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTextCodecFactory_StaticNew()
{
  return vtkTextCodecFactory::New();
}

PyObject *PyvtkTextCodecFactory_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTextCodecFactory_Type, PyvtkTextCodecFactory_Methods,
    "vtkTextCodecFactory",
    PyvtkTextCodecFactory_Doc(), &PyvtkTextCodecFactory_StaticNew);

  PyTypeObject *pytype = &PyvtkTextCodecFactory_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTextCodecFactory_Doc()
{
  static const char *docstring[] = {
    "vtkTextCodecFactory - maintain a list of text codecs and return\ninstances\n\n",
    "Superclass: vtkObject\n\n",
    "A single class to hold registered codecs and return instances of them\nbased on either a decriptive name (UTF16 or latin-1) or by asking who\ncan handle a given std::vector<unsigned char>\n\nThanks:\n\nThanks to Tim Shed from Sandia National Laboratories for his work on\nthe concepts and to Marcus Hanwell and Jeff Baumes of Kitware for\nkeeping me out of the weeds\n\nSee Also:\n\nvtkTextCodec\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTextCodecFactory(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTextCodecFactory_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTextCodecFactory", o) != 0)
    {
    Py_DECREF(o);
    }

}

