// python wrapper for vtkTextPropertyCollection
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkTextPropertyCollection.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTextPropertyCollection(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTextPropertyCollection_ClassNew(); }

#ifndef DECLARED_PyvtkCollection_ClassNew
extern "C" { PyObject *PyvtkCollection_ClassNew(); }
#define DECLARED_PyvtkCollection_ClassNew
#endif

static const char **PyvtkTextPropertyCollection_Doc();


static PyObject *
PyvtkTextPropertyCollection_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTextPropertyCollection *op = static_cast<vtkTextPropertyCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTextPropertyCollection::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTextPropertyCollection_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTextPropertyCollection *op = static_cast<vtkTextPropertyCollection *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTextPropertyCollection::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTextPropertyCollection_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTextPropertyCollection *op = static_cast<vtkTextPropertyCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTextPropertyCollection *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTextPropertyCollection::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkTextPropertyCollection_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkTextPropertyCollection *tempr = vtkTextPropertyCollection::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTextPropertyCollection_AddItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTextPropertyCollection *op = static_cast<vtkTextPropertyCollection *>(vp);

  vtkTextProperty *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkTextProperty"))
    {
    if (ap.IsBound())
      {
      op->AddItem(temp0);
      }
    else
      {
      op->vtkTextPropertyCollection::AddItem(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTextPropertyCollection_GetNextItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNextItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTextPropertyCollection *op = static_cast<vtkTextPropertyCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTextProperty *tempr = (ap.IsBound() ?
      op->GetNextItem() :
      op->vtkTextPropertyCollection::GetNextItem());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTextPropertyCollection_GetItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTextPropertyCollection *op = static_cast<vtkTextPropertyCollection *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    vtkTextProperty *tempr = (ap.IsBound() ?
      op->GetItem(temp0) :
      op->vtkTextPropertyCollection::GetItem(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTextPropertyCollection_GetLastItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTextPropertyCollection *op = static_cast<vtkTextPropertyCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTextProperty *tempr = (ap.IsBound() ?
      op->GetLastItem() :
      op->vtkTextPropertyCollection::GetLastItem());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkTextPropertyCollection_Methods[] = {
  {"GetClassName", PyvtkTextPropertyCollection_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTextPropertyCollection_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTextPropertyCollection_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTextPropertyCollection\nC++: vtkTextPropertyCollection *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTextPropertyCollection_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTextPropertyCollection\nC++: vtkTextPropertyCollection *SafeDownCast(vtkObject* o)\n\n"},
  {"AddItem", PyvtkTextPropertyCollection_AddItem, METH_VARARGS,
   "V.AddItem(vtkTextProperty)\nC++: void AddItem(vtkTextProperty *a)\n\nAdd a vtkTextProperty to the list.\n"},
  {"GetNextItem", PyvtkTextPropertyCollection_GetNextItem, METH_VARARGS,
   "V.GetNextItem() -> vtkTextProperty\nC++: vtkTextProperty *GetNextItem()\n\nGet the next vtkTextProperty in the list.\n"},
  {"GetItem", PyvtkTextPropertyCollection_GetItem, METH_VARARGS,
   "V.GetItem(int) -> vtkTextProperty\nC++: vtkTextProperty *GetItem(int idx)\n\nGet the vtkTextProperty at the specified index.\n"},
  {"GetLastItem", PyvtkTextPropertyCollection_GetLastItem, METH_VARARGS,
   "V.GetLastItem() -> vtkTextProperty\nC++: vtkTextProperty *GetLastItem()\n\nGet the last TextProperty in the list.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTextPropertyCollection_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingCorePython.vtkTextPropertyCollection", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTextPropertyCollection_StaticNew()
{
  return vtkTextPropertyCollection::New();
}

PyObject *PyvtkTextPropertyCollection_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTextPropertyCollection_Type, PyvtkTextPropertyCollection_Methods,
    "vtkTextPropertyCollection",
    PyvtkTextPropertyCollection_Doc(), &PyvtkTextPropertyCollection_StaticNew);

  PyTypeObject *pytype = &PyvtkTextPropertyCollection_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkCollection_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTextPropertyCollection_Doc()
{
  static const char *docstring[] = {
    "vtkTextPropertyCollection - a list of vtkTextProperty objects.\n\n",
    "Superclass: vtkCollection\n\n",
    "vtkTextPropertyCollection represents and provides methods to\nmanipulate a list of TextProperty objects. The list is unsorted and\nduplicate entries are not prevented.\n\nSee Also:\n\nvtkTextProperty vtkCollection\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTextPropertyCollection(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTextPropertyCollection_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTextPropertyCollection", o) != 0)
    {
    Py_DECREF(o);
    }

}

