// python wrapper for vtkTransposeTable
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkTransposeTable.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTransposeTable(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTransposeTable_ClassNew(); }

#ifndef DECLARED_PyvtkTableAlgorithm_ClassNew
extern "C" { PyObject *PyvtkTableAlgorithm_ClassNew(); }
#define DECLARED_PyvtkTableAlgorithm_ClassNew
#endif

static const char **PyvtkTransposeTable_Doc();


static PyObject *
PyvtkTransposeTable_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTransposeTable *op = static_cast<vtkTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTransposeTable::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTransposeTable_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTransposeTable *op = static_cast<vtkTransposeTable *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTransposeTable::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTransposeTable_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTransposeTable *op = static_cast<vtkTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTransposeTable *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTransposeTable::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkTransposeTable_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkTransposeTable *tempr = vtkTransposeTable::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTransposeTable_GetAddIdColumn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAddIdColumn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTransposeTable *op = static_cast<vtkTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->GetAddIdColumn() :
      op->vtkTransposeTable::GetAddIdColumn());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTransposeTable_SetAddIdColumn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAddIdColumn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTransposeTable *op = static_cast<vtkTransposeTable *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetAddIdColumn(temp0);
      }
    else
      {
      op->vtkTransposeTable::SetAddIdColumn(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTransposeTable_AddIdColumnOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddIdColumnOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTransposeTable *op = static_cast<vtkTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->AddIdColumnOn();
      }
    else
      {
      op->vtkTransposeTable::AddIdColumnOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTransposeTable_AddIdColumnOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddIdColumnOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTransposeTable *op = static_cast<vtkTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->AddIdColumnOff();
      }
    else
      {
      op->vtkTransposeTable::AddIdColumnOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTransposeTable_GetUseIdColumn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseIdColumn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTransposeTable *op = static_cast<vtkTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->GetUseIdColumn() :
      op->vtkTransposeTable::GetUseIdColumn());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTransposeTable_SetUseIdColumn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseIdColumn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTransposeTable *op = static_cast<vtkTransposeTable *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetUseIdColumn(temp0);
      }
    else
      {
      op->vtkTransposeTable::SetUseIdColumn(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTransposeTable_UseIdColumnOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseIdColumnOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTransposeTable *op = static_cast<vtkTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->UseIdColumnOn();
      }
    else
      {
      op->vtkTransposeTable::UseIdColumnOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTransposeTable_UseIdColumnOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseIdColumnOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTransposeTable *op = static_cast<vtkTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->UseIdColumnOff();
      }
    else
      {
      op->vtkTransposeTable::UseIdColumnOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTransposeTable_GetIdColumnName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIdColumnName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTransposeTable *op = static_cast<vtkTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    char *tempr = (ap.IsBound() ?
      op->GetIdColumnName() :
      op->vtkTransposeTable::GetIdColumnName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTransposeTable_SetIdColumnName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIdColumnName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTransposeTable *op = static_cast<vtkTransposeTable *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetIdColumnName(temp0);
      }
    else
      {
      op->vtkTransposeTable::SetIdColumnName(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkTransposeTable_Methods[] = {
  {"GetClassName", PyvtkTransposeTable_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTransposeTable_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTransposeTable_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTransposeTable\nC++: vtkTransposeTable *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTransposeTable_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTransposeTable\nC++: vtkTransposeTable *SafeDownCast(vtkObject* o)\n\n"},
  {"GetAddIdColumn", PyvtkTransposeTable_GetAddIdColumn, METH_VARARGS,
   "V.GetAddIdColumn() -> bool\nC++: bool GetAddIdColumn()\n\nThis flag indicates if a column must be inserted at index 0 with\nthe names (ids) of the input columns. Default: true\n"},
  {"SetAddIdColumn", PyvtkTransposeTable_SetAddIdColumn, METH_VARARGS,
   "V.SetAddIdColumn(bool)\nC++: void SetAddIdColumn(bool a)\n\nThis flag indicates if a column must be inserted at index 0 with\nthe names (ids) of the input columns. Default: true\n"},
  {"AddIdColumnOn", PyvtkTransposeTable_AddIdColumnOn, METH_VARARGS,
   "V.AddIdColumnOn()\nC++: void AddIdColumnOn()\n\nThis flag indicates if a column must be inserted at index 0 with\nthe names (ids) of the input columns. Default: true\n"},
  {"AddIdColumnOff", PyvtkTransposeTable_AddIdColumnOff, METH_VARARGS,
   "V.AddIdColumnOff()\nC++: void AddIdColumnOff()\n\nThis flag indicates if a column must be inserted at index 0 with\nthe names (ids) of the input columns. Default: true\n"},
  {"GetUseIdColumn", PyvtkTransposeTable_GetUseIdColumn, METH_VARARGS,
   "V.GetUseIdColumn() -> bool\nC++: bool GetUseIdColumn()\n\nThis flag indicates if the output column must be named using the\nnames listed in the index 0 column. Default: false\n"},
  {"SetUseIdColumn", PyvtkTransposeTable_SetUseIdColumn, METH_VARARGS,
   "V.SetUseIdColumn(bool)\nC++: void SetUseIdColumn(bool a)\n\nThis flag indicates if the output column must be named using the\nnames listed in the index 0 column. Default: false\n"},
  {"UseIdColumnOn", PyvtkTransposeTable_UseIdColumnOn, METH_VARARGS,
   "V.UseIdColumnOn()\nC++: void UseIdColumnOn()\n\nThis flag indicates if the output column must be named using the\nnames listed in the index 0 column. Default: false\n"},
  {"UseIdColumnOff", PyvtkTransposeTable_UseIdColumnOff, METH_VARARGS,
   "V.UseIdColumnOff()\nC++: void UseIdColumnOff()\n\nThis flag indicates if the output column must be named using the\nnames listed in the index 0 column. Default: false\n"},
  {"GetIdColumnName", PyvtkTransposeTable_GetIdColumnName, METH_VARARGS,
   "V.GetIdColumnName() -> string\nC++: char *GetIdColumnName()\n\nGet/Set the name of the id column added by option AddIdColumn.\nDefault: ColName\n"},
  {"SetIdColumnName", PyvtkTransposeTable_SetIdColumnName, METH_VARARGS,
   "V.SetIdColumnName(string)\nC++: void SetIdColumnName(char *)\n\nGet/Set the name of the id column added by option AddIdColumn.\nDefault: ColName\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTransposeTable_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersCorePython.vtkTransposeTable", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTransposeTable_StaticNew()
{
  return vtkTransposeTable::New();
}

PyObject *PyvtkTransposeTable_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTransposeTable_Type, PyvtkTransposeTable_Methods,
    "vtkTransposeTable",
    PyvtkTransposeTable_Doc(), &PyvtkTransposeTable_StaticNew);

  PyTypeObject *pytype = &PyvtkTransposeTable_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTableAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTransposeTable_Doc()
{
  static const char *docstring[] = {
    "vtkTransposeTable - Transpose an input table.\n\n",
    "Superclass: vtkTableAlgorithm\n\n",
    "This algorithm allows to transpose a vtkTable as a matrix. Columns\nbecome rows and vice versa. A new column can be added to the result\ntable at index 0 to collect the name of the initial columns (when\nAddIdColumn is true). Such a column can be used to name the columns\nof the result. Note that columns of the output table will have a\nvariant type is the columns of the initial table are not consistan",
    "t.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTransposeTable(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTransposeTable_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTransposeTable", o) != 0)
    {
    Py_DECREF(o);
    }

}

