// python wrapper for vtkTreeBFSIterator
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkTreeBFSIterator.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTreeBFSIterator(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTreeBFSIterator_ClassNew(); }

#ifndef DECLARED_PyvtkTreeIterator_ClassNew
extern "C" { PyObject *PyvtkTreeIterator_ClassNew(); }
#define DECLARED_PyvtkTreeIterator_ClassNew
#endif

static const char **PyvtkTreeBFSIterator_Doc();


static PyObject *
PyvtkTreeBFSIterator_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeBFSIterator *op = static_cast<vtkTreeBFSIterator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTreeBFSIterator::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeBFSIterator_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeBFSIterator *op = static_cast<vtkTreeBFSIterator *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTreeBFSIterator::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeBFSIterator_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeBFSIterator *op = static_cast<vtkTreeBFSIterator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTreeBFSIterator *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTreeBFSIterator::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkTreeBFSIterator_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkTreeBFSIterator *tempr = vtkTreeBFSIterator::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkTreeBFSIterator_Methods[] = {
  {"GetClassName", PyvtkTreeBFSIterator_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTreeBFSIterator_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTreeBFSIterator_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTreeBFSIterator\nC++: vtkTreeBFSIterator *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTreeBFSIterator_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTreeBFSIterator\nC++: vtkTreeBFSIterator *SafeDownCast(vtkObject* o)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTreeBFSIterator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonDataModelPython.vtkTreeBFSIterator", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTreeBFSIterator_StaticNew()
{
  return vtkTreeBFSIterator::New();
}

PyObject *PyvtkTreeBFSIterator_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTreeBFSIterator_Type, PyvtkTreeBFSIterator_Methods,
    "vtkTreeBFSIterator",
    PyvtkTreeBFSIterator_Doc(), &PyvtkTreeBFSIterator_StaticNew);

  PyTypeObject *pytype = &PyvtkTreeBFSIterator_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTreeIterator_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTreeBFSIterator_Doc()
{
  static const char *docstring[] = {
    "vtkTreeBFSIterator - breadth first search iterator through a vtkTree\n\n",
    "Superclass: vtkTreeIterator\n\n",
    "vtkTreeBFSIterator performs a breadth first search traversal of a\ntree.\n\nAfter setting up the iterator, the normal mode of operation is to set\nup a while(iter->HasNext())loop, with the statement vtkIdType vertex\n= iter->Next()inside the loop.\n\nThanks:\n\nThanks to David Doria for submitting this class.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTreeBFSIterator(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTreeBFSIterator_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTreeBFSIterator", o) != 0)
    {
    Py_DECREF(o);
    }

}

