// python wrapper for vtkTreeMapView
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkTreeMapView.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTreeMapView(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTreeMapView_ClassNew(); }

#ifndef DECLARED_PyvtkTreeAreaView_ClassNew
extern "C" { PyObject *PyvtkTreeAreaView_ClassNew(); }
#define DECLARED_PyvtkTreeAreaView_ClassNew
#endif

static const char **PyvtkTreeMapView_Doc();


static PyObject *
PyvtkTreeMapView_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapView *op = static_cast<vtkTreeMapView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTreeMapView::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeMapView_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapView *op = static_cast<vtkTreeMapView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTreeMapView::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeMapView_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapView *op = static_cast<vtkTreeMapView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTreeMapView *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTreeMapView::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkTreeMapView_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkTreeMapView *tempr = vtkTreeMapView::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeMapView_SetLayoutStrategy_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapView *op = static_cast<vtkTreeMapView *>(vp);

  vtkAreaLayoutStrategy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAreaLayoutStrategy"))
    {
    if (ap.IsBound())
      {
      op->SetLayoutStrategy(temp0);
      }
    else
      {
      op->vtkTreeMapView::SetLayoutStrategy(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkTreeMapView_SetLayoutStrategy_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapView *op = static_cast<vtkTreeMapView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetLayoutStrategy(temp0);
      }
    else
      {
      op->vtkTreeMapView::SetLayoutStrategy(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkTreeMapView_SetLayoutStrategy_Methods[] = {
  {NULL, PyvtkTreeMapView_SetLayoutStrategy_s1, METH_VARARGS,
   "@V *vtkAreaLayoutStrategy"},
  {NULL, PyvtkTreeMapView_SetLayoutStrategy_s2, METH_VARARGS,
   "@z"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkTreeMapView_SetLayoutStrategy(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkTreeMapView_SetLayoutStrategy_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetLayoutStrategy");
  return NULL;
}



static PyObject *
PyvtkTreeMapView_SetLayoutStrategyToBox(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToBox");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapView *op = static_cast<vtkTreeMapView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetLayoutStrategyToBox();
      }
    else
      {
      op->vtkTreeMapView::SetLayoutStrategyToBox();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTreeMapView_SetLayoutStrategyToSliceAndDice(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToSliceAndDice");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapView *op = static_cast<vtkTreeMapView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetLayoutStrategyToSliceAndDice();
      }
    else
      {
      op->vtkTreeMapView::SetLayoutStrategyToSliceAndDice();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTreeMapView_SetLayoutStrategyToSquarify(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToSquarify");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapView *op = static_cast<vtkTreeMapView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->SetLayoutStrategyToSquarify();
      }
    else
      {
      op->vtkTreeMapView::SetLayoutStrategyToSquarify();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTreeMapView_SetFontSizeRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFontSizeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapView *op = static_cast<vtkTreeMapView *>(vp);

  int temp0;
  int temp1;
  int temp2 = 4;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
    {
    if (ap.IsBound())
      {
      op->SetFontSizeRange(temp0, temp1, temp2);
      }
    else
      {
      op->vtkTreeMapView::SetFontSizeRange(temp0, temp1, temp2);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTreeMapView_GetFontSizeRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFontSizeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapView *op = static_cast<vtkTreeMapView *>(vp);

  int temp0[3];
  int save0[3];
  const int size0 = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
      {
      op->GetFontSizeRange(temp0);
      }
    else
      {
      op->vtkTreeMapView::GetFontSizeRange(temp0);
      }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
      {
      ap.SetArray(0, temp0, size0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkTreeMapView_Methods[] = {
  {"GetClassName", PyvtkTreeMapView_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTreeMapView_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTreeMapView_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTreeMapView\nC++: vtkTreeMapView *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTreeMapView_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTreeMapView\nC++: vtkTreeMapView *SafeDownCast(vtkObject* o)\n\n"},
  {"SetLayoutStrategy", PyvtkTreeMapView_SetLayoutStrategy, METH_VARARGS,
   "V.SetLayoutStrategy(vtkAreaLayoutStrategy)\nC++: virtual void SetLayoutStrategy(vtkAreaLayoutStrategy *s)\nV.SetLayoutStrategy(string)\nC++: virtual void SetLayoutStrategy(const char *name)\n\nSets the treemap layout strategy\n"},
  {"SetLayoutStrategyToBox", PyvtkTreeMapView_SetLayoutStrategyToBox, METH_VARARGS,
   "V.SetLayoutStrategyToBox()\nC++: virtual void SetLayoutStrategyToBox()\n\nSets the treemap layout strategy\n"},
  {"SetLayoutStrategyToSliceAndDice", PyvtkTreeMapView_SetLayoutStrategyToSliceAndDice, METH_VARARGS,
   "V.SetLayoutStrategyToSliceAndDice()\nC++: virtual void SetLayoutStrategyToSliceAndDice()\n\nSets the treemap layout strategy\n"},
  {"SetLayoutStrategyToSquarify", PyvtkTreeMapView_SetLayoutStrategyToSquarify, METH_VARARGS,
   "V.SetLayoutStrategyToSquarify()\nC++: virtual void SetLayoutStrategyToSquarify()\n\nSets the treemap layout strategy\n"},
  {"SetFontSizeRange", PyvtkTreeMapView_SetFontSizeRange, METH_VARARGS,
   "V.SetFontSizeRange(int, int, int)\nC++: virtual void SetFontSizeRange(const int maxSize,\n    const int minSize, const int delta=4)\n\nThe sizes of the fonts used for labeling.\n"},
  {"GetFontSizeRange", PyvtkTreeMapView_GetFontSizeRange, METH_VARARGS,
   "V.GetFontSizeRange([int, int, int])\nC++: virtual void GetFontSizeRange(int range[3])\n\nThe sizes of the fonts used for labeling.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTreeMapView_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkViewsInfovisPython.vtkTreeMapView", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTreeMapView_StaticNew()
{
  return vtkTreeMapView::New();
}

PyObject *PyvtkTreeMapView_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTreeMapView_Type, PyvtkTreeMapView_Methods,
    "vtkTreeMapView",
    PyvtkTreeMapView_Doc(), &PyvtkTreeMapView_StaticNew);

  PyTypeObject *pytype = &PyvtkTreeMapView_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTreeAreaView_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTreeMapView_Doc()
{
  static const char *docstring[] = {
    "vtkTreeMapView - Displays a tree as a tree map.\n\n",
    "Superclass: vtkTreeAreaView\n\n",
    "vtkTreeMapView shows a vtkTree in a tree map, where each vertex in\nthe tree is represented by a box.  Child boxes are contained within\nthe parent box, and may be colored and sized by various parameters.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTreeMapView(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTreeMapView_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTreeMapView", o) != 0)
    {
    Py_DECREF(o);
    }

}

