// python wrapper for vtkTreeRingToPolyData
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkTreeRingToPolyData.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTreeRingToPolyData(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTreeRingToPolyData_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkTreeRingToPolyData_Doc();


static PyObject *
PyvtkTreeRingToPolyData_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingToPolyData *op = static_cast<vtkTreeRingToPolyData *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTreeRingToPolyData::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingToPolyData_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingToPolyData *op = static_cast<vtkTreeRingToPolyData *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTreeRingToPolyData::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingToPolyData_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingToPolyData *op = static_cast<vtkTreeRingToPolyData *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTreeRingToPolyData *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTreeRingToPolyData::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingToPolyData_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkTreeRingToPolyData *tempr = vtkTreeRingToPolyData::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingToPolyData_SetSectorsArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSectorsArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingToPolyData *op = static_cast<vtkTreeRingToPolyData *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetSectorsArrayName(temp0);
      }
    else
      {
      op->vtkTreeRingToPolyData::SetSectorsArrayName(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingToPolyData_SetShrinkPercentage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetShrinkPercentage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingToPolyData *op = static_cast<vtkTreeRingToPolyData *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetShrinkPercentage(temp0);
      }
    else
      {
      op->vtkTreeRingToPolyData::SetShrinkPercentage(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingToPolyData_GetShrinkPercentage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShrinkPercentage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingToPolyData *op = static_cast<vtkTreeRingToPolyData *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetShrinkPercentage() :
      op->vtkTreeRingToPolyData::GetShrinkPercentage());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingToPolyData_FillInputPortInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FillInputPortInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingToPolyData *op = static_cast<vtkTreeRingToPolyData *>(vp);

  int temp0;
  vtkInformation *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkInformation"))
    {
    int tempr = (ap.IsBound() ?
      op->FillInputPortInformation(temp0, temp1) :
      op->vtkTreeRingToPolyData::FillInputPortInformation(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkTreeRingToPolyData_Methods[] = {
  {"GetClassName", PyvtkTreeRingToPolyData_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTreeRingToPolyData_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTreeRingToPolyData_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTreeRingToPolyData\nC++: vtkTreeRingToPolyData *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTreeRingToPolyData_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTreeRingToPolyData\nC++: vtkTreeRingToPolyData *SafeDownCast(vtkObject* o)\n\n"},
  {"SetSectorsArrayName", PyvtkTreeRingToPolyData_SetSectorsArrayName, METH_VARARGS,
   "V.SetSectorsArrayName(string)\nC++: virtual void SetSectorsArrayName(const char *name)\n\nThe field containing quadruples of the form (start angle, end\nangle, inner radius, outer radius) representing the bounds of the\nrectangles for each vertex. This field may be added to the tree\nusing vtkTreeRingLayout. This array must be set.\n"},
  {"SetShrinkPercentage", PyvtkTreeRingToPolyData_SetShrinkPercentage, METH_VARARGS,
   "V.SetShrinkPercentage(float)\nC++: void SetShrinkPercentage(double a)\n\nDefine a shrink percentage for each of the sectors.\n"},
  {"GetShrinkPercentage", PyvtkTreeRingToPolyData_GetShrinkPercentage, METH_VARARGS,
   "V.GetShrinkPercentage() -> float\nC++: double GetShrinkPercentage()\n\nDefine a shrink percentage for each of the sectors.\n"},
  {"FillInputPortInformation", PyvtkTreeRingToPolyData_FillInputPortInformation, METH_VARARGS,
   "V.FillInputPortInformation(int, vtkInformation) -> int\nC++: int FillInputPortInformation(int port, vtkInformation *info)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTreeRingToPolyData_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInfovisLayoutPython.vtkTreeRingToPolyData", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTreeRingToPolyData_StaticNew()
{
  return vtkTreeRingToPolyData::New();
}

PyObject *PyvtkTreeRingToPolyData_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTreeRingToPolyData_Type, PyvtkTreeRingToPolyData_Methods,
    "vtkTreeRingToPolyData",
    PyvtkTreeRingToPolyData_Doc(), &PyvtkTreeRingToPolyData_StaticNew);

  PyTypeObject *pytype = &PyvtkTreeRingToPolyData_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTreeRingToPolyData_Doc()
{
  static const char *docstring[] = {
    "vtkTreeRingToPolyData - converts a tree to a polygonal data\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "This algorithm requires that the vtkTreeRingLayout filter has already\nbeen applied to the data in order to create the quadruple array\n(start angle, end angle, inner radius, outer radius) of bounds for\neach vertex of the tree.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTreeRingToPolyData(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTreeRingToPolyData_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTreeRingToPolyData", o) != 0)
    {
    Py_DECREF(o);
    }

}

