// python wrapper for vtkTreeRingView
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkTreeRingView.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTreeRingView(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTreeRingView_ClassNew(); }

#ifndef DECLARED_PyvtkTreeAreaView_ClassNew
extern "C" { PyObject *PyvtkTreeAreaView_ClassNew(); }
#define DECLARED_PyvtkTreeAreaView_ClassNew
#endif

static const char **PyvtkTreeRingView_Doc();


static PyObject *
PyvtkTreeRingView_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTreeRingView::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTreeRingView::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkTreeRingView *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTreeRingView::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkTreeRingView *tempr = vtkTreeRingView::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_SetRootAngles(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRootAngles");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  double temp0;
  double temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
    {
    if (ap.IsBound())
      {
      op->SetRootAngles(temp0, temp1);
      }
    else
      {
      op->vtkTreeRingView::SetRootAngles(temp0, temp1);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_SetRootAtCenter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRootAtCenter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetRootAtCenter(temp0);
      }
    else
      {
      op->vtkTreeRingView::SetRootAtCenter(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_GetRootAtCenter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRootAtCenter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    bool tempr = (ap.IsBound() ?
      op->GetRootAtCenter() :
      op->vtkTreeRingView::GetRootAtCenter());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_RootAtCenterOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RootAtCenterOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->RootAtCenterOn();
      }
    else
      {
      op->vtkTreeRingView::RootAtCenterOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_RootAtCenterOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RootAtCenterOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->RootAtCenterOff();
      }
    else
      {
      op->vtkTreeRingView::RootAtCenterOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_SetLayerThickness(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayerThickness");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetLayerThickness(temp0);
      }
    else
      {
      op->vtkTreeRingView::SetLayerThickness(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_GetLayerThickness(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLayerThickness");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetLayerThickness() :
      op->vtkTreeRingView::GetLayerThickness());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_SetInteriorRadius(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInteriorRadius");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetInteriorRadius(temp0);
      }
    else
      {
      op->vtkTreeRingView::SetInteriorRadius(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_GetInteriorRadius(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInteriorRadius");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetInteriorRadius() :
      op->vtkTreeRingView::GetInteriorRadius());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_SetInteriorLogSpacingValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInteriorLogSpacingValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetInteriorLogSpacingValue(temp0);
      }
    else
      {
      op->vtkTreeRingView::SetInteriorLogSpacingValue(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkTreeRingView_GetInteriorLogSpacingValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInteriorLogSpacingValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeRingView *op = static_cast<vtkTreeRingView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetInteriorLogSpacingValue() :
      op->vtkTreeRingView::GetInteriorLogSpacingValue());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkTreeRingView_Methods[] = {
  {"GetClassName", PyvtkTreeRingView_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTreeRingView_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTreeRingView_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTreeRingView\nC++: vtkTreeRingView *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTreeRingView_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTreeRingView\nC++: vtkTreeRingView *SafeDownCast(vtkObject* o)\n\n"},
  {"SetRootAngles", PyvtkTreeRingView_SetRootAngles, METH_VARARGS,
   "V.SetRootAngles(float, float)\nC++: void SetRootAngles(double start, double end)\n\nSet the root angles for laying out the hierarchy.\n"},
  {"SetRootAtCenter", PyvtkTreeRingView_SetRootAtCenter, METH_VARARGS,
   "V.SetRootAtCenter(bool)\nC++: virtual void SetRootAtCenter(bool value)\n\nSets whether the root is at the center or around the outside.\n"},
  {"GetRootAtCenter", PyvtkTreeRingView_GetRootAtCenter, METH_VARARGS,
   "V.GetRootAtCenter() -> bool\nC++: virtual bool GetRootAtCenter()\n\nSets whether the root is at the center or around the outside.\n"},
  {"RootAtCenterOn", PyvtkTreeRingView_RootAtCenterOn, METH_VARARGS,
   "V.RootAtCenterOn()\nC++: void RootAtCenterOn()\n\nSets whether the root is at the center or around the outside.\n"},
  {"RootAtCenterOff", PyvtkTreeRingView_RootAtCenterOff, METH_VARARGS,
   "V.RootAtCenterOff()\nC++: void RootAtCenterOff()\n\nSets whether the root is at the center or around the outside.\n"},
  {"SetLayerThickness", PyvtkTreeRingView_SetLayerThickness, METH_VARARGS,
   "V.SetLayerThickness(float)\nC++: virtual void SetLayerThickness(double thickness)\n\nSet the thickness of each layer.\n"},
  {"GetLayerThickness", PyvtkTreeRingView_GetLayerThickness, METH_VARARGS,
   "V.GetLayerThickness() -> float\nC++: virtual double GetLayerThickness()\n\nSet the thickness of each layer.\n"},
  {"SetInteriorRadius", PyvtkTreeRingView_SetInteriorRadius, METH_VARARGS,
   "V.SetInteriorRadius(float)\nC++: virtual void SetInteriorRadius(double thickness)\n\nSet the interior radius of the tree (i.e. the size of the \"hole\"\nin the center).\n"},
  {"GetInteriorRadius", PyvtkTreeRingView_GetInteriorRadius, METH_VARARGS,
   "V.GetInteriorRadius() -> float\nC++: virtual double GetInteriorRadius()\n\nSet the interior radius of the tree (i.e. the size of the \"hole\"\nin the center).\n"},
  {"SetInteriorLogSpacingValue", PyvtkTreeRingView_SetInteriorLogSpacingValue, METH_VARARGS,
   "V.SetInteriorLogSpacingValue(float)\nC++: virtual void SetInteriorLogSpacingValue(double thickness)\n\nSet the log spacing factor for the invisible interior tree used\nfor routing edges of the overlaid graph.\n"},
  {"GetInteriorLogSpacingValue", PyvtkTreeRingView_GetInteriorLogSpacingValue, METH_VARARGS,
   "V.GetInteriorLogSpacingValue() -> float\nC++: virtual double GetInteriorLogSpacingValue()\n\nSet the log spacing factor for the invisible interior tree used\nfor routing edges of the overlaid graph.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTreeRingView_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkViewsInfovisPython.vtkTreeRingView", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTreeRingView_StaticNew()
{
  return vtkTreeRingView::New();
}

PyObject *PyvtkTreeRingView_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTreeRingView_Type, PyvtkTreeRingView_Methods,
    "vtkTreeRingView",
    PyvtkTreeRingView_Doc(), &PyvtkTreeRingView_StaticNew);

  PyTypeObject *pytype = &PyvtkTreeRingView_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTreeAreaView_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTreeRingView_Doc()
{
  static const char *docstring[] = {
    "vtkTreeRingView - Displays a tree in concentric rings.\n\n",
    "Superclass: vtkTreeAreaView\n\n",
    "Accepts a graph and a hierarchy - currently a tree - and provides a\nhierarchy-aware display.  Currently, this means displaying the\nhierarchy using a tree ring layout, then rendering the graph vertices\nas leaves of the tree with curved graph edges between leaves.\n\n.SEE ALSO vtkGraphLayoutView\n\nThanks:\n\nThanks to Jason Shepherd for implementing this class\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTreeRingView(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTreeRingView_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTreeRingView", o) != 0)
    {
    Py_DECREF(o);
    }

}

