// python wrapper for vtkWarpTo
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkWarpTo.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkWarpTo(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkWarpTo_ClassNew(); }

#ifndef DECLARED_PyvtkPointSetAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPointSetAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPointSetAlgorithm_ClassNew
#endif

static const char **PyvtkWarpTo_Doc();


static PyObject *
PyvtkWarpTo_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWarpTo *op = static_cast<vtkWarpTo *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkWarpTo::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkWarpTo_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWarpTo *op = static_cast<vtkWarpTo *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkWarpTo::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkWarpTo_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWarpTo *op = static_cast<vtkWarpTo *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkWarpTo *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkWarpTo::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkWarpTo_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkWarpTo *tempr = vtkWarpTo::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkWarpTo_SetScaleFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScaleFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWarpTo *op = static_cast<vtkWarpTo *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetScaleFactor(temp0);
      }
    else
      {
      op->vtkWarpTo::SetScaleFactor(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkWarpTo_GetScaleFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScaleFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWarpTo *op = static_cast<vtkWarpTo *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double tempr = (ap.IsBound() ?
      op->GetScaleFactor() :
      op->vtkWarpTo::GetScaleFactor());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkWarpTo_GetPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWarpTo *op = static_cast<vtkWarpTo *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    double *tempr = (ap.IsBound() ?
      op->GetPosition() :
      op->vtkWarpTo::GetPosition());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildTuple(tempr, sizer);
      }
    }

  return result;
}


static PyObject *
PyvtkWarpTo_SetPosition_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWarpTo *op = static_cast<vtkWarpTo *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
    {
    if (ap.IsBound())
      {
      op->SetPosition(temp0, temp1, temp2);
      }
    else
      {
      op->vtkWarpTo::SetPosition(temp0, temp1, temp2);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkWarpTo_SetPosition_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWarpTo *op = static_cast<vtkWarpTo *>(vp);

  double temp0[3];
  const int size0 = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
    {
    if (ap.IsBound())
      {
      op->SetPosition(temp0);
      }
    else
      {
      op->vtkWarpTo::SetPosition(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyObject *
PyvtkWarpTo_SetPosition(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
    {
    case 3:
      return PyvtkWarpTo_SetPosition_s1(self, args);
    case 1:
      return PyvtkWarpTo_SetPosition_s2(self, args);
    }

  vtkPythonArgs::ArgCountError(nargs, "SetPosition");
  return NULL;
}



static PyObject *
PyvtkWarpTo_SetAbsolute(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAbsolute");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWarpTo *op = static_cast<vtkWarpTo *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetAbsolute(temp0);
      }
    else
      {
      op->vtkWarpTo::SetAbsolute(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkWarpTo_GetAbsolute(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAbsolute");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWarpTo *op = static_cast<vtkWarpTo *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    int tempr = (ap.IsBound() ?
      op->GetAbsolute() :
      op->vtkWarpTo::GetAbsolute());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkWarpTo_AbsoluteOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AbsoluteOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWarpTo *op = static_cast<vtkWarpTo *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->AbsoluteOn();
      }
    else
      {
      op->vtkWarpTo::AbsoluteOn();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkWarpTo_AbsoluteOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AbsoluteOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWarpTo *op = static_cast<vtkWarpTo *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    if (ap.IsBound())
      {
      op->AbsoluteOff();
      }
    else
      {
      op->vtkWarpTo::AbsoluteOff();
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkWarpTo_FillInputPortInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FillInputPortInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWarpTo *op = static_cast<vtkWarpTo *>(vp);

  int temp0;
  vtkInformation *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkInformation"))
    {
    int tempr = (ap.IsBound() ?
      op->FillInputPortInformation(temp0, temp1) :
      op->vtkWarpTo::FillInputPortInformation(temp0, temp1));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkWarpTo_Methods[] = {
  {"GetClassName", PyvtkWarpTo_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkWarpTo_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkWarpTo_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkWarpTo\nC++: vtkWarpTo *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkWarpTo_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkWarpTo\nC++: vtkWarpTo *SafeDownCast(vtkObject* o)\n\n"},
  {"SetScaleFactor", PyvtkWarpTo_SetScaleFactor, METH_VARARGS,
   "V.SetScaleFactor(float)\nC++: void SetScaleFactor(double a)\n\nSet/Get the value to scale displacement.\n"},
  {"GetScaleFactor", PyvtkWarpTo_GetScaleFactor, METH_VARARGS,
   "V.GetScaleFactor() -> float\nC++: double GetScaleFactor()\n\nSet/Get the value to scale displacement.\n"},
  {"GetPosition", PyvtkWarpTo_GetPosition, METH_VARARGS,
   "V.GetPosition() -> (float, float, float)\nC++: double *GetPosition()\n\nSet/Get the position to warp towards.\n"},
  {"SetPosition", PyvtkWarpTo_SetPosition, METH_VARARGS,
   "V.SetPosition(float, float, float)\nC++: void SetPosition(double, double, double)\nV.SetPosition((float, float, float))\nC++: void SetPosition(double a[3])\n\n"},
  {"SetAbsolute", PyvtkWarpTo_SetAbsolute, METH_VARARGS,
   "V.SetAbsolute(int)\nC++: void SetAbsolute(int a)\n\nSet/Get the Absolute ivar. Turning Absolute on causes scale\nfactor of the new position to be one unit away from Position.\n"},
  {"GetAbsolute", PyvtkWarpTo_GetAbsolute, METH_VARARGS,
   "V.GetAbsolute() -> int\nC++: int GetAbsolute()\n\nSet/Get the Absolute ivar. Turning Absolute on causes scale\nfactor of the new position to be one unit away from Position.\n"},
  {"AbsoluteOn", PyvtkWarpTo_AbsoluteOn, METH_VARARGS,
   "V.AbsoluteOn()\nC++: void AbsoluteOn()\n\nSet/Get the Absolute ivar. Turning Absolute on causes scale\nfactor of the new position to be one unit away from Position.\n"},
  {"AbsoluteOff", PyvtkWarpTo_AbsoluteOff, METH_VARARGS,
   "V.AbsoluteOff()\nC++: void AbsoluteOff()\n\nSet/Get the Absolute ivar. Turning Absolute on causes scale\nfactor of the new position to be one unit away from Position.\n"},
  {"FillInputPortInformation", PyvtkWarpTo_FillInputPortInformation, METH_VARARGS,
   "V.FillInputPortInformation(int, vtkInformation) -> int\nC++: int FillInputPortInformation(int port, vtkInformation *info)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkWarpTo_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersGeneralPython.vtkWarpTo", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkWarpTo_StaticNew()
{
  return vtkWarpTo::New();
}

PyObject *PyvtkWarpTo_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkWarpTo_Type, PyvtkWarpTo_Methods,
    "vtkWarpTo",
    PyvtkWarpTo_Doc(), &PyvtkWarpTo_StaticNew);

  PyTypeObject *pytype = &PyvtkWarpTo_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPointSetAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkWarpTo_Doc()
{
  static const char *docstring[] = {
    "vtkWarpTo - deform geometry by warping towards a point\n\n",
    "Superclass: vtkPointSetAlgorithm\n\n",
    "vtkWarpTo is a filter that modifies point coordinates by moving the\npoints towards a user specified position.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkWarpTo(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkWarpTo_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkWarpTo", o) != 0)
    {
    Py_DECREF(o);
    }

}

