// python wrapper for vtkXMLUniformGridAMRReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkIndent.h"
#include "vtkXMLUniformGridAMRReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkXMLUniformGridAMRReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkXMLUniformGridAMRReader_ClassNew(); }

#ifndef DECLARED_PyvtkXMLCompositeDataReader_ClassNew
extern "C" { PyObject *PyvtkXMLCompositeDataReader_ClassNew(); }
#define DECLARED_PyvtkXMLCompositeDataReader_ClassNew
#endif

static const char **PyvtkXMLUniformGridAMRReader_Doc();


static PyObject *
PyvtkXMLUniformGridAMRReader_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLUniformGridAMRReader *op = static_cast<vtkXMLUniformGridAMRReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkXMLUniformGridAMRReader::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkXMLUniformGridAMRReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLUniformGridAMRReader *op = static_cast<vtkXMLUniformGridAMRReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkXMLUniformGridAMRReader::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkXMLUniformGridAMRReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLUniformGridAMRReader *op = static_cast<vtkXMLUniformGridAMRReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkXMLUniformGridAMRReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkXMLUniformGridAMRReader::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkXMLUniformGridAMRReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkXMLUniformGridAMRReader *tempr = vtkXMLUniformGridAMRReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkXMLUniformGridAMRReader_SetMaximumLevelsToReadByDefault(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaximumLevelsToReadByDefault");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLUniformGridAMRReader *op = static_cast<vtkXMLUniformGridAMRReader *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    if (ap.IsBound())
      {
      op->SetMaximumLevelsToReadByDefault(temp0);
      }
    else
      {
      op->vtkXMLUniformGridAMRReader::SetMaximumLevelsToReadByDefault(temp0);
      }

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkXMLUniformGridAMRReader_GetMaximumLevelsToReadByDefault(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumLevelsToReadByDefault");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLUniformGridAMRReader *op = static_cast<vtkXMLUniformGridAMRReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    unsigned int tempr = (ap.IsBound() ?
      op->GetMaximumLevelsToReadByDefault() :
      op->vtkXMLUniformGridAMRReader::GetMaximumLevelsToReadByDefault());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}

static PyMethodDef PyvtkXMLUniformGridAMRReader_Methods[] = {
  {"GetClassName", PyvtkXMLUniformGridAMRReader_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkXMLUniformGridAMRReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkXMLUniformGridAMRReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkXMLUniformGridAMRReader\nC++: vtkXMLUniformGridAMRReader *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkXMLUniformGridAMRReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkXMLUniformGridAMRReader\nC++: vtkXMLUniformGridAMRReader *SafeDownCast(vtkObject* o)\n\n"},
  {"SetMaximumLevelsToReadByDefault", PyvtkXMLUniformGridAMRReader_SetMaximumLevelsToReadByDefault, METH_VARARGS,
   "V.SetMaximumLevelsToReadByDefault(int)\nC++: void SetMaximumLevelsToReadByDefault(unsigned int a)\n\nThis reader supports demand-driven heavy data reading i.e.\ndownstream pipeline can request specific blocks from the AMR\nusing vtkCompositeDataPipeline::UPDATE_COMPOSITE_INDICES() key in\nRequestUpdateExtent() pass. However, when down-stream doesn't\nprovide any specific keys, the default behavior can be setup to\nread at-most N levels by default. The number of levels read can\nbe set using this method. Set this to 0 to imply no limit.\nDefault is 0.\n"},
  {"GetMaximumLevelsToReadByDefault", PyvtkXMLUniformGridAMRReader_GetMaximumLevelsToReadByDefault, METH_VARARGS,
   "V.GetMaximumLevelsToReadByDefault() -> int\nC++: unsigned int GetMaximumLevelsToReadByDefault()\n\nThis reader supports demand-driven heavy data reading i.e.\ndownstream pipeline can request specific blocks from the AMR\nusing vtkCompositeDataPipeline::UPDATE_COMPOSITE_INDICES() key in\nRequestUpdateExtent() pass. However, when down-stream doesn't\nprovide any specific keys, the default behavior can be setup to\nread at-most N levels by default. The number of levels read can\nbe set using this method. Set this to 0 to imply no limit.\nDefault is 0.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkXMLUniformGridAMRReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOXMLPython.vtkXMLUniformGridAMRReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkXMLUniformGridAMRReader_StaticNew()
{
  return vtkXMLUniformGridAMRReader::New();
}

PyObject *PyvtkXMLUniformGridAMRReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkXMLUniformGridAMRReader_Type, PyvtkXMLUniformGridAMRReader_Methods,
    "vtkXMLUniformGridAMRReader",
    PyvtkXMLUniformGridAMRReader_Doc(), &PyvtkXMLUniformGridAMRReader_StaticNew);

  PyTypeObject *pytype = &PyvtkXMLUniformGridAMRReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkXMLCompositeDataReader_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkXMLUniformGridAMRReader_Doc()
{
  static const char *docstring[] = {
    "vtkXMLUniformGridAMRReader - Reader for amr datasets\n(vtkOverlappingAMR\n\n",
    "Superclass: vtkXMLCompositeDataReader\n\n",
    "vtkXMLUniformGridAMRReader reads the VTK XML data files for all types\nof amr datasets including vtkOverlappingAMR, vtkNonOverlappingAMR and\nthe legacy vtkHierarchicalBoxDataSet. The reader uses information in\nthe file to determine what type of dataset is actually being read and\ncreates the output-data object accordingly.\n\nThis reader can only read files with version 1.1 or greater. Older\nversions ",
    "can be converted to the newer versions using\nvtkXMLHierarchicalBoxDataFileConverter.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkXMLUniformGridAMRReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkXMLUniformGridAMRReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkXMLUniformGridAMRReader", o) != 0)
    {
    Py_DECREF(o);
    }

}

