// python wrapper for vtkXMLUtilities
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <sstream>
#include "vtkXMLDataElement.h"
#include "vtkXMLUtilities.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkXMLUtilities(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkXMLUtilities_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkXMLUtilities_Doc();


static PyObject *
PyvtkXMLUtilities_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLUtilities *op = static_cast<vtkXMLUtilities *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkXMLUtilities::GetClassName());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkXMLUtilities_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLUtilities *op = static_cast<vtkXMLUtilities *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
    {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkXMLUtilities::IsA(temp0));

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildValue(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkXMLUtilities_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLUtilities *op = static_cast<vtkXMLUtilities *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
    {
    vtkXMLUtilities *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkXMLUtilities::NewInstance());

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
        {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
        }
      }
    }

  return result;
}


static PyObject *
PyvtkXMLUtilities_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
    {
    vtkXMLUtilities *tempr = vtkXMLUtilities::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkXMLUtilities_ReadElementFromString(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ReadElementFromString");

  char *temp0 = NULL;
  int temp1 = VTK_ENCODING_NONE;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
    {
    vtkXMLDataElement *tempr = vtkXMLUtilities::ReadElementFromString(temp0, temp1);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkXMLUtilities_ReadElementFromFile(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ReadElementFromFile");

  char *temp0 = NULL;
  int temp1 = VTK_ENCODING_NONE;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
    {
    vtkXMLDataElement *tempr = vtkXMLUtilities::ReadElementFromFile(temp0, temp1);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildVTKObject(tempr);
      }
    }

  return result;
}


static PyObject *
PyvtkXMLUtilities_FactorElements(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "FactorElements");

  vtkXMLDataElement *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkXMLDataElement"))
    {
    vtkXMLUtilities::FactorElements(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}


static PyObject *
PyvtkXMLUtilities_UnFactorElements(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "UnFactorElements");

  vtkXMLDataElement *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkXMLDataElement"))
    {
    vtkXMLUtilities::UnFactorElements(temp0);

    if (!ap.ErrorOccurred())
      {
      result = ap.BuildNone();
      }
    }

  return result;
}

static PyMethodDef PyvtkXMLUtilities_Methods[] = {
  {"GetClassName", PyvtkXMLUtilities_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkXMLUtilities_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkXMLUtilities_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkXMLUtilities\nC++: vtkXMLUtilities *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkXMLUtilities_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkXMLUtilities\nC++: vtkXMLUtilities *SafeDownCast(vtkObject* o)\n\n"},
  {"ReadElementFromString", PyvtkXMLUtilities_ReadElementFromString, METH_VARARGS,
   "V.ReadElementFromString(string, int) -> vtkXMLDataElement\nC++: static vtkXMLDataElement *ReadElementFromString(\n    const char *str, int encoding=VTK_ENCODING_NONE)\n\nRead a vtkXMLDataElement from a stream, string or file. The\n'encoding' parameter will be used to set the internal encoding of\nthe attributes of the data elements created by those functions\n(conversion from the XML stream encoding to that new encoding\nwill be performed automatically). If set to VTK_ENCODING_NONE,\nthe encoding won't be changed and will default to the default\nvtkXMLDataElement encoding. Return the root element on success,\nNULL otherwise. Note that you have to call Delete() on the\nelement returned by that function to ensure it is freed properly.\n"},
  {"ReadElementFromFile", PyvtkXMLUtilities_ReadElementFromFile, METH_VARARGS,
   "V.ReadElementFromFile(string, int) -> vtkXMLDataElement\nC++: static vtkXMLDataElement *ReadElementFromFile(\n    const char *filename, int encoding=VTK_ENCODING_NONE)\n\nRead a vtkXMLDataElement from a stream, string or file. The\n'encoding' parameter will be used to set the internal encoding of\nthe attributes of the data elements created by those functions\n(conversion from the XML stream encoding to that new encoding\nwill be performed automatically). If set to VTK_ENCODING_NONE,\nthe encoding won't be changed and will default to the default\nvtkXMLDataElement encoding. Return the root element on success,\nNULL otherwise. Note that you have to call Delete() on the\nelement returned by that function to ensure it is freed properly.\n"},
  {"FactorElements", PyvtkXMLUtilities_FactorElements, METH_VARARGS,
   "V.FactorElements(vtkXMLDataElement)\nC++: static void FactorElements(vtkXMLDataElement *tree)\n\nFactor and unfactor a tree. This operation looks for duplicate\nelements in the tree, and replace them with references to a pool\nof elements. Unfactoring a non-factored element is harmless.\n"},
  {"UnFactorElements", PyvtkXMLUtilities_UnFactorElements, METH_VARARGS,
   "V.UnFactorElements(vtkXMLDataElement)\nC++: static void UnFactorElements(vtkXMLDataElement *tree)\n\nFactor and unfactor a tree. This operation looks for duplicate\nelements in the tree, and replace them with references to a pool\nof elements. Unfactoring a non-factored element is harmless.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkXMLUtilities_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOXMLParserPython.vtkXMLUtilities", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkXMLUtilities_StaticNew()
{
  return vtkXMLUtilities::New();
}

PyObject *PyvtkXMLUtilities_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkXMLUtilities_Type, PyvtkXMLUtilities_Methods,
    "vtkXMLUtilities",
    PyvtkXMLUtilities_Doc(), &PyvtkXMLUtilities_StaticNew);

  PyTypeObject *pytype = &PyvtkXMLUtilities_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
    {
    return (PyObject *)pytype;
    }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkXMLUtilities_Doc()
{
  static const char *docstring[] = {
    "vtkXMLUtilities - XML utilities.\n\n",
    "Superclass: vtkObject\n\n",
    "vtkXMLUtilities provides XML-related convenience functions.\n\nSee Also:\n\nvtkXMLDataElement\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkXMLUtilities(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkXMLUtilities_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkXMLUtilities", o) != 0)
    {
    Py_DECREF(o);
    }

}

